/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         sqlparse
#define yylex           sqllex
#define yyerror         sqlerror
#define yydebug         sqldebug
#define yynerrs         sqlnerrs

/* First part of user prologue.  */
#line 9 "sql_parser.y"

#include "monetdb_config.h"
#include <sql_mem.h>
#include "sql_parser.h"
#include "sql_symbol.h"
#include "sql_datetime.h"
#include "sql_decimal.h"	/* for decimal_from_str() */
#include "sql_semantic.h"	/* for sql_add_param() & sql_add_arg() */
#include "sql_env.h"
#include "rel_sequence.h"	/* for sql_next_seq_name() */
#ifdef HAVE_HGE
#include "mal.h"		/* for have_hge */
#endif

#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#define SA 	m->sa
#define _symbol_create(t,d)         symbol_create( SA, t, d)
#define _symbol_create_list(t,d)    symbol_create_list( SA, t, d)
#define _symbol_create_int(t,d)     symbol_create_int( SA, t, d)
#define _symbol_create_lng(t,d)     symbol_create_lng( SA, t, d)
#define _symbol_create_symbol(t,d)  symbol_create_symbol( SA, t, d)
#define _symbol_create_hexa(t,d)    symbol_create_hexa( SA, t, d)
#define _newAtomNode(d)		    newAtomNode( SA, d)

#define L()                  dlist_create( SA )

#define append_list(l,d)     dlist_append_list( SA, l, d)
#define append_int(l,d)      dlist_append_int( SA, l, d)
#define append_lng(l,d)      dlist_append_lng( SA, l, d)
#define append_symbol(l,d)   dlist_append_symbol( SA, l, d)
#define append_string(l,d)   dlist_append_string( SA, l, d)
#define append_type(l,d)     dlist_append_type( SA, l, d)

#define _atom_string(t, v)   atom_string(SA, t, v)

#define YYMALLOC GDKmalloc
#define YYFREE GDKfree

#define YY_parse_LSP_NEEDED	/* needed for bison++ 1.21.11-3 */

#define SET_Z(info)(info = info | 0x02)
#define SET_M(info)(info = info | 0x01)

#ifdef HAVE_HGE
#define MAX_DEC_DIGITS (have_hge ? 38 : 18)
#define MAX_HEX_DIGITS (have_hge ? 32 : 16)
#else
#define MAX_DEC_DIGITS 18
#define MAX_HEX_DIGITS 16
#endif

static inline int
UTF8_strlen(const char *val)
{
	const unsigned char *s = (const unsigned char *) val;
	int pos = 0;

	while (*s) {
		int c = *s++;

		pos++;
		if (c < 0xC0)
			continue;
		if (*s++ < 0x80)
			return int_nil;
		if (c < 0xE0)
			continue;
		if (*s++ < 0x80)
			return int_nil;
		if (c < 0xF0)
			continue;
		if (*s++ < 0x80)
			return int_nil;
		if (c < 0xF8)
			continue;
		if (*s++ < 0x80)
			return int_nil;
		if (c < 0xFC)
			continue;
		if (*s++ < 0x80)
			return int_nil;
	}
	return pos;
}


#line 166 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_SQL_Y_TAB_H_INCLUDED
# define YY_SQL_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int sqldebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    STRING = 258,                  /* STRING  */
    IDENT = 259,                   /* IDENT  */
    aTYPE = 260,                   /* aTYPE  */
    ALIAS = 261,                   /* ALIAS  */
    AGGR = 262,                    /* AGGR  */
    AGGR2 = 263,                   /* AGGR2  */
    RANK = 264,                    /* RANK  */
    sqlINT = 265,                  /* sqlINT  */
    OIDNUM = 266,                  /* OIDNUM  */
    HEXADECIMAL = 267,             /* HEXADECIMAL  */
    INTNUM = 268,                  /* INTNUM  */
    APPROXNUM = 269,               /* APPROXNUM  */
    USING = 270,                   /* USING  */
    GLOBAL = 271,                  /* GLOBAL  */
    CAST = 272,                    /* CAST  */
    CONVERT = 273,                 /* CONVERT  */
    CHARACTER = 274,               /* CHARACTER  */
    VARYING = 275,                 /* VARYING  */
    LARGE = 276,                   /* LARGE  */
    OBJECT = 277,                  /* OBJECT  */
    VARCHAR = 278,                 /* VARCHAR  */
    CLOB = 279,                    /* CLOB  */
    sqlTEXT = 280,                 /* sqlTEXT  */
    BINARY = 281,                  /* BINARY  */
    sqlBLOB = 282,                 /* sqlBLOB  */
    sqlDECIMAL = 283,              /* sqlDECIMAL  */
    sqlFLOAT = 284,                /* sqlFLOAT  */
    TINYINT = 285,                 /* TINYINT  */
    SMALLINT = 286,                /* SMALLINT  */
    BIGINT = 287,                  /* BIGINT  */
    HUGEINT = 288,                 /* HUGEINT  */
    sqlINTEGER = 289,              /* sqlINTEGER  */
    sqlDOUBLE = 290,               /* sqlDOUBLE  */
    sqlREAL = 291,                 /* sqlREAL  */
    PRECISION = 292,               /* PRECISION  */
    PARTIAL = 293,                 /* PARTIAL  */
    SIMPLE = 294,                  /* SIMPLE  */
    ACTION = 295,                  /* ACTION  */
    CASCADE = 296,                 /* CASCADE  */
    RESTRICT = 297,                /* RESTRICT  */
    BOOL_FALSE = 298,              /* BOOL_FALSE  */
    BOOL_TRUE = 299,               /* BOOL_TRUE  */
    CURRENT_DATE = 300,            /* CURRENT_DATE  */
    CURRENT_TIMESTAMP = 301,       /* CURRENT_TIMESTAMP  */
    CURRENT_TIME = 302,            /* CURRENT_TIME  */
    LOCALTIMESTAMP = 303,          /* LOCALTIMESTAMP  */
    LOCALTIME = 304,               /* LOCALTIME  */
    LEX_ERROR = 305,               /* LEX_ERROR  */
    GEOMETRY = 306,                /* GEOMETRY  */
    GEOMETRYSUBTYPE = 307,         /* GEOMETRYSUBTYPE  */
    GEOMETRYA = 308,               /* GEOMETRYA  */
    USER = 309,                    /* USER  */
    CURRENT_USER = 310,            /* CURRENT_USER  */
    SESSION_USER = 311,            /* SESSION_USER  */
    LOCAL = 312,                   /* LOCAL  */
    LOCKED = 313,                  /* LOCKED  */
    BEST = 314,                    /* BEST  */
    EFFORT = 315,                  /* EFFORT  */
    CURRENT_ROLE = 316,            /* CURRENT_ROLE  */
    sqlSESSION = 317,              /* sqlSESSION  */
    sqlDELETE = 318,               /* sqlDELETE  */
    UPDATE = 319,                  /* UPDATE  */
    SELECT = 320,                  /* SELECT  */
    INSERT = 321,                  /* INSERT  */
    LATERAL = 322,                 /* LATERAL  */
    LEFT = 323,                    /* LEFT  */
    RIGHT = 324,                   /* RIGHT  */
    FULL = 325,                    /* FULL  */
    OUTER = 326,                   /* OUTER  */
    NATURAL = 327,                 /* NATURAL  */
    CROSS = 328,                   /* CROSS  */
    JOIN = 329,                    /* JOIN  */
    INNER = 330,                   /* INNER  */
    COMMIT = 331,                  /* COMMIT  */
    ROLLBACK = 332,                /* ROLLBACK  */
    SAVEPOINT = 333,               /* SAVEPOINT  */
    RELEASE = 334,                 /* RELEASE  */
    WORK = 335,                    /* WORK  */
    CHAIN = 336,                   /* CHAIN  */
    NO = 337,                      /* NO  */
    PRESERVE = 338,                /* PRESERVE  */
    ROWS = 339,                    /* ROWS  */
    START = 340,                   /* START  */
    TRANSACTION = 341,             /* TRANSACTION  */
    READ = 342,                    /* READ  */
    WRITE = 343,                   /* WRITE  */
    ONLY = 344,                    /* ONLY  */
    ISOLATION = 345,               /* ISOLATION  */
    LEVEL = 346,                   /* LEVEL  */
    UNCOMMITTED = 347,             /* UNCOMMITTED  */
    COMMITTED = 348,               /* COMMITTED  */
    sqlREPEATABLE = 349,           /* sqlREPEATABLE  */
    SERIALIZABLE = 350,            /* SERIALIZABLE  */
    DIAGNOSTICS = 351,             /* DIAGNOSTICS  */
    sqlSIZE = 352,                 /* sqlSIZE  */
    STORAGE = 353,                 /* STORAGE  */
    ASYMMETRIC = 354,              /* ASYMMETRIC  */
    SYMMETRIC = 355,               /* SYMMETRIC  */
    ORDER = 356,                   /* ORDER  */
    ORDERED = 357,                 /* ORDERED  */
    BY = 358,                      /* BY  */
    IMPRINTS = 359,                /* IMPRINTS  */
    EXISTS = 360,                  /* EXISTS  */
    ESCAPE = 361,                  /* ESCAPE  */
    HAVING = 362,                  /* HAVING  */
    sqlGROUP = 363,                /* sqlGROUP  */
    sqlNULL = 364,                 /* sqlNULL  */
    FROM = 365,                    /* FROM  */
    FOR = 366,                     /* FOR  */
    MATCH = 367,                   /* MATCH  */
    EXTRACT = 368,                 /* EXTRACT  */
    SEQUENCE = 369,                /* SEQUENCE  */
    INCREMENT = 370,               /* INCREMENT  */
    RESTART = 371,                 /* RESTART  */
    MAXVALUE = 372,                /* MAXVALUE  */
    MINVALUE = 373,                /* MINVALUE  */
    CYCLE = 374,                   /* CYCLE  */
    NOMAXVALUE = 375,              /* NOMAXVALUE  */
    NOMINVALUE = 376,              /* NOMINVALUE  */
    NOCYCLE = 377,                 /* NOCYCLE  */
    NEXT = 378,                    /* NEXT  */
    VALUE = 379,                   /* VALUE  */
    CACHE = 380,                   /* CACHE  */
    GENERATED = 381,               /* GENERATED  */
    ALWAYS = 382,                  /* ALWAYS  */
    IDENTITY = 383,                /* IDENTITY  */
    SERIAL = 384,                  /* SERIAL  */
    BIGSERIAL = 385,               /* BIGSERIAL  */
    AUTO_INCREMENT = 386,          /* AUTO_INCREMENT  */
    SCOLON = 387,                  /* SCOLON  */
    AT = 388,                      /* AT  */
    XMLCOMMENT = 389,              /* XMLCOMMENT  */
    XMLCONCAT = 390,               /* XMLCONCAT  */
    XMLDOCUMENT = 391,             /* XMLDOCUMENT  */
    XMLELEMENT = 392,              /* XMLELEMENT  */
    XMLATTRIBUTES = 393,           /* XMLATTRIBUTES  */
    XMLFOREST = 394,               /* XMLFOREST  */
    XMLPARSE = 395,                /* XMLPARSE  */
    STRIP = 396,                   /* STRIP  */
    WHITESPACE = 397,              /* WHITESPACE  */
    XMLPI = 398,                   /* XMLPI  */
    XMLQUERY = 399,                /* XMLQUERY  */
    PASSING = 400,                 /* PASSING  */
    XMLTEXT = 401,                 /* XMLTEXT  */
    NIL = 402,                     /* NIL  */
    REF = 403,                     /* REF  */
    ABSENT = 404,                  /* ABSENT  */
    EMPTY = 405,                   /* EMPTY  */
    DOCUMENT = 406,                /* DOCUMENT  */
    ELEMENT = 407,                 /* ELEMENT  */
    CONTENT = 408,                 /* CONTENT  */
    XMLNAMESPACES = 409,           /* XMLNAMESPACES  */
    NAMESPACE = 410,               /* NAMESPACE  */
    XMLVALIDATE = 411,             /* XMLVALIDATE  */
    RETURNING = 412,               /* RETURNING  */
    LOCATION = 413,                /* LOCATION  */
    ID = 414,                      /* ID  */
    ACCORDING = 415,               /* ACCORDING  */
    XMLSCHEMA = 416,               /* XMLSCHEMA  */
    URI = 417,                     /* URI  */
    XMLAGG = 418,                  /* XMLAGG  */
    FILTER = 419,                  /* FILTER  */
    UNION = 420,                   /* UNION  */
    EXCEPT = 421,                  /* EXCEPT  */
    INTERSECT = 422,               /* INTERSECT  */
    CORRESPONDING = 423,           /* CORRESPONDING  */
    UNIONJOIN = 424,               /* UNIONJOIN  */
    DATA = 425,                    /* DATA  */
    FILTER_FUNC = 426,             /* FILTER_FUNC  */
    NOT = 427,                     /* NOT  */
    ALL = 428,                     /* ALL  */
    ANY = 429,                     /* ANY  */
    NOT_BETWEEN = 430,             /* NOT_BETWEEN  */
    BETWEEN = 431,                 /* BETWEEN  */
    NOT_IN = 432,                  /* NOT_IN  */
    sqlIN = 433,                   /* sqlIN  */
    NOT_LIKE = 434,                /* NOT_LIKE  */
    LIKE = 435,                    /* LIKE  */
    NOT_ILIKE = 436,               /* NOT_ILIKE  */
    ILIKE = 437,                   /* ILIKE  */
    OR = 438,                      /* OR  */
    SOME = 439,                    /* SOME  */
    AND = 440,                     /* AND  */
    COMPARISON = 441,              /* COMPARISON  */
    LEFT_SHIFT = 442,              /* LEFT_SHIFT  */
    RIGHT_SHIFT = 443,             /* RIGHT_SHIFT  */
    LEFT_SHIFT_ASSIGN = 444,       /* LEFT_SHIFT_ASSIGN  */
    RIGHT_SHIFT_ASSIGN = 445,      /* RIGHT_SHIFT_ASSIGN  */
    CONCATSTRING = 446,            /* CONCATSTRING  */
    SUBSTRING = 447,               /* SUBSTRING  */
    POSITION = 448,                /* POSITION  */
    SPLIT_PART = 449,              /* SPLIT_PART  */
    UMINUS = 450,                  /* UMINUS  */
    GEOM_OVERLAP = 451,            /* GEOM_OVERLAP  */
    GEOM_OVERLAP_OR_ABOVE = 452,   /* GEOM_OVERLAP_OR_ABOVE  */
    GEOM_OVERLAP_OR_BELOW = 453,   /* GEOM_OVERLAP_OR_BELOW  */
    GEOM_OVERLAP_OR_LEFT = 454,    /* GEOM_OVERLAP_OR_LEFT  */
    GEOM_OVERLAP_OR_RIGHT = 455,   /* GEOM_OVERLAP_OR_RIGHT  */
    GEOM_BELOW = 456,              /* GEOM_BELOW  */
    GEOM_ABOVE = 457,              /* GEOM_ABOVE  */
    GEOM_DIST = 458,               /* GEOM_DIST  */
    GEOM_MBR_EQUAL = 459,          /* GEOM_MBR_EQUAL  */
    TEMP = 460,                    /* TEMP  */
    TEMPORARY = 461,               /* TEMPORARY  */
    STREAM = 462,                  /* STREAM  */
    MERGE = 463,                   /* MERGE  */
    REMOTE = 464,                  /* REMOTE  */
    REPLICA = 465,                 /* REPLICA  */
    ASC = 466,                     /* ASC  */
    DESC = 467,                    /* DESC  */
    AUTHORIZATION = 468,           /* AUTHORIZATION  */
    CHECK = 469,                   /* CHECK  */
    CONSTRAINT = 470,              /* CONSTRAINT  */
    CREATE = 471,                  /* CREATE  */
    TYPE = 472,                    /* TYPE  */
    PROCEDURE = 473,               /* PROCEDURE  */
    FUNCTION = 474,                /* FUNCTION  */
    sqlLOADER = 475,               /* sqlLOADER  */
    AGGREGATE = 476,               /* AGGREGATE  */
    RETURNS = 477,                 /* RETURNS  */
    EXTERNAL = 478,                /* EXTERNAL  */
    sqlNAME = 479,                 /* sqlNAME  */
    DECLARE = 480,                 /* DECLARE  */
    CALL = 481,                    /* CALL  */
    LANGUAGE = 482,                /* LANGUAGE  */
    ANALYZE = 483,                 /* ANALYZE  */
    MINMAX = 484,                  /* MINMAX  */
    SQL_EXPLAIN = 485,             /* SQL_EXPLAIN  */
    SQL_PLAN = 486,                /* SQL_PLAN  */
    SQL_DEBUG = 487,               /* SQL_DEBUG  */
    SQL_TRACE = 488,               /* SQL_TRACE  */
    PREP = 489,                    /* PREP  */
    PREPARE = 490,                 /* PREPARE  */
    EXEC = 491,                    /* EXEC  */
    EXECUTE = 492,                 /* EXECUTE  */
    DEFAULT = 493,                 /* DEFAULT  */
    DISTINCT = 494,                /* DISTINCT  */
    DROP = 495,                    /* DROP  */
    FOREIGN = 496,                 /* FOREIGN  */
    RENAME = 497,                  /* RENAME  */
    ENCRYPTED = 498,               /* ENCRYPTED  */
    UNENCRYPTED = 499,             /* UNENCRYPTED  */
    PASSWORD = 500,                /* PASSWORD  */
    GRANT = 501,                   /* GRANT  */
    REVOKE = 502,                  /* REVOKE  */
    ROLE = 503,                    /* ROLE  */
    ADMIN = 504,                   /* ADMIN  */
    INTO = 505,                    /* INTO  */
    IS = 506,                      /* IS  */
    KEY = 507,                     /* KEY  */
    ON = 508,                      /* ON  */
    OPTION = 509,                  /* OPTION  */
    OPTIONS = 510,                 /* OPTIONS  */
    PATH = 511,                    /* PATH  */
    PRIMARY = 512,                 /* PRIMARY  */
    PRIVILEGES = 513,              /* PRIVILEGES  */
    PUBLIC = 514,                  /* PUBLIC  */
    REFERENCES = 515,              /* REFERENCES  */
    SCHEMA = 516,                  /* SCHEMA  */
    SET = 517,                     /* SET  */
    AUTO_COMMIT = 518,             /* AUTO_COMMIT  */
    RETURN = 519,                  /* RETURN  */
    ALTER = 520,                   /* ALTER  */
    ADD = 521,                     /* ADD  */
    TABLE = 522,                   /* TABLE  */
    COLUMN = 523,                  /* COLUMN  */
    TO = 524,                      /* TO  */
    UNIQUE = 525,                  /* UNIQUE  */
    VALUES = 526,                  /* VALUES  */
    VIEW = 527,                    /* VIEW  */
    WHERE = 528,                   /* WHERE  */
    WITH = 529,                    /* WITH  */
    sqlDATE = 530,                 /* sqlDATE  */
    TIME = 531,                    /* TIME  */
    TIMESTAMP = 532,               /* TIMESTAMP  */
    INTERVAL = 533,                /* INTERVAL  */
    YEAR = 534,                    /* YEAR  */
    MONTH = 535,                   /* MONTH  */
    DAY = 536,                     /* DAY  */
    HOUR = 537,                    /* HOUR  */
    MINUTE = 538,                  /* MINUTE  */
    SECOND = 539,                  /* SECOND  */
    ZONE = 540,                    /* ZONE  */
    LIMIT = 541,                   /* LIMIT  */
    OFFSET = 542,                  /* OFFSET  */
    SAMPLE = 543,                  /* SAMPLE  */
    CASE = 544,                    /* CASE  */
    WHEN = 545,                    /* WHEN  */
    THEN = 546,                    /* THEN  */
    ELSE = 547,                    /* ELSE  */
    NULLIF = 548,                  /* NULLIF  */
    COALESCE = 549,                /* COALESCE  */
    IF = 550,                      /* IF  */
    ELSEIF = 551,                  /* ELSEIF  */
    WHILE = 552,                   /* WHILE  */
    DO = 553,                      /* DO  */
    ATOMIC = 554,                  /* ATOMIC  */
    BEGIN = 555,                   /* BEGIN  */
    END = 556,                     /* END  */
    COPY = 557,                    /* COPY  */
    RECORDS = 558,                 /* RECORDS  */
    DELIMITERS = 559,              /* DELIMITERS  */
    STDIN = 560,                   /* STDIN  */
    STDOUT = 561,                  /* STDOUT  */
    FWF = 562,                     /* FWF  */
    INDEX = 563,                   /* INDEX  */
    REPLACE = 564,                 /* REPLACE  */
    AS = 565,                      /* AS  */
    TRIGGER = 566,                 /* TRIGGER  */
    OF = 567,                      /* OF  */
    BEFORE = 568,                  /* BEFORE  */
    AFTER = 569,                   /* AFTER  */
    ROW = 570,                     /* ROW  */
    STATEMENT = 571,               /* STATEMENT  */
    sqlNEW = 572,                  /* sqlNEW  */
    OLD = 573,                     /* OLD  */
    EACH = 574,                    /* EACH  */
    REFERENCING = 575,             /* REFERENCING  */
    OVER = 576,                    /* OVER  */
    PARTITION = 577,               /* PARTITION  */
    CURRENT = 578,                 /* CURRENT  */
    EXCLUDE = 579,                 /* EXCLUDE  */
    FOLLOWING = 580,               /* FOLLOWING  */
    PRECEDING = 581,               /* PRECEDING  */
    OTHERS = 582,                  /* OTHERS  */
    TIES = 583,                    /* TIES  */
    RANGE = 584,                   /* RANGE  */
    UNBOUNDED = 585,               /* UNBOUNDED  */
    X_BODY = 586                   /* X_BODY  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define STRING 258
#define IDENT 259
#define aTYPE 260
#define ALIAS 261
#define AGGR 262
#define AGGR2 263
#define RANK 264
#define sqlINT 265
#define OIDNUM 266
#define HEXADECIMAL 267
#define INTNUM 268
#define APPROXNUM 269
#define USING 270
#define GLOBAL 271
#define CAST 272
#define CONVERT 273
#define CHARACTER 274
#define VARYING 275
#define LARGE 276
#define OBJECT 277
#define VARCHAR 278
#define CLOB 279
#define sqlTEXT 280
#define BINARY 281
#define sqlBLOB 282
#define sqlDECIMAL 283
#define sqlFLOAT 284
#define TINYINT 285
#define SMALLINT 286
#define BIGINT 287
#define HUGEINT 288
#define sqlINTEGER 289
#define sqlDOUBLE 290
#define sqlREAL 291
#define PRECISION 292
#define PARTIAL 293
#define SIMPLE 294
#define ACTION 295
#define CASCADE 296
#define RESTRICT 297
#define BOOL_FALSE 298
#define BOOL_TRUE 299
#define CURRENT_DATE 300
#define CURRENT_TIMESTAMP 301
#define CURRENT_TIME 302
#define LOCALTIMESTAMP 303
#define LOCALTIME 304
#define LEX_ERROR 305
#define GEOMETRY 306
#define GEOMETRYSUBTYPE 307
#define GEOMETRYA 308
#define USER 309
#define CURRENT_USER 310
#define SESSION_USER 311
#define LOCAL 312
#define LOCKED 313
#define BEST 314
#define EFFORT 315
#define CURRENT_ROLE 316
#define sqlSESSION 317
#define sqlDELETE 318
#define UPDATE 319
#define SELECT 320
#define INSERT 321
#define LATERAL 322
#define LEFT 323
#define RIGHT 324
#define FULL 325
#define OUTER 326
#define NATURAL 327
#define CROSS 328
#define JOIN 329
#define INNER 330
#define COMMIT 331
#define ROLLBACK 332
#define SAVEPOINT 333
#define RELEASE 334
#define WORK 335
#define CHAIN 336
#define NO 337
#define PRESERVE 338
#define ROWS 339
#define START 340
#define TRANSACTION 341
#define READ 342
#define WRITE 343
#define ONLY 344
#define ISOLATION 345
#define LEVEL 346
#define UNCOMMITTED 347
#define COMMITTED 348
#define sqlREPEATABLE 349
#define SERIALIZABLE 350
#define DIAGNOSTICS 351
#define sqlSIZE 352
#define STORAGE 353
#define ASYMMETRIC 354
#define SYMMETRIC 355
#define ORDER 356
#define ORDERED 357
#define BY 358
#define IMPRINTS 359
#define EXISTS 360
#define ESCAPE 361
#define HAVING 362
#define sqlGROUP 363
#define sqlNULL 364
#define FROM 365
#define FOR 366
#define MATCH 367
#define EXTRACT 368
#define SEQUENCE 369
#define INCREMENT 370
#define RESTART 371
#define MAXVALUE 372
#define MINVALUE 373
#define CYCLE 374
#define NOMAXVALUE 375
#define NOMINVALUE 376
#define NOCYCLE 377
#define NEXT 378
#define VALUE 379
#define CACHE 380
#define GENERATED 381
#define ALWAYS 382
#define IDENTITY 383
#define SERIAL 384
#define BIGSERIAL 385
#define AUTO_INCREMENT 386
#define SCOLON 387
#define AT 388
#define XMLCOMMENT 389
#define XMLCONCAT 390
#define XMLDOCUMENT 391
#define XMLELEMENT 392
#define XMLATTRIBUTES 393
#define XMLFOREST 394
#define XMLPARSE 395
#define STRIP 396
#define WHITESPACE 397
#define XMLPI 398
#define XMLQUERY 399
#define PASSING 400
#define XMLTEXT 401
#define NIL 402
#define REF 403
#define ABSENT 404
#define EMPTY 405
#define DOCUMENT 406
#define ELEMENT 407
#define CONTENT 408
#define XMLNAMESPACES 409
#define NAMESPACE 410
#define XMLVALIDATE 411
#define RETURNING 412
#define LOCATION 413
#define ID 414
#define ACCORDING 415
#define XMLSCHEMA 416
#define URI 417
#define XMLAGG 418
#define FILTER 419
#define UNION 420
#define EXCEPT 421
#define INTERSECT 422
#define CORRESPONDING 423
#define UNIONJOIN 424
#define DATA 425
#define FILTER_FUNC 426
#define NOT 427
#define ALL 428
#define ANY 429
#define NOT_BETWEEN 430
#define BETWEEN 431
#define NOT_IN 432
#define sqlIN 433
#define NOT_LIKE 434
#define LIKE 435
#define NOT_ILIKE 436
#define ILIKE 437
#define OR 438
#define SOME 439
#define AND 440
#define COMPARISON 441
#define LEFT_SHIFT 442
#define RIGHT_SHIFT 443
#define LEFT_SHIFT_ASSIGN 444
#define RIGHT_SHIFT_ASSIGN 445
#define CONCATSTRING 446
#define SUBSTRING 447
#define POSITION 448
#define SPLIT_PART 449
#define UMINUS 450
#define GEOM_OVERLAP 451
#define GEOM_OVERLAP_OR_ABOVE 452
#define GEOM_OVERLAP_OR_BELOW 453
#define GEOM_OVERLAP_OR_LEFT 454
#define GEOM_OVERLAP_OR_RIGHT 455
#define GEOM_BELOW 456
#define GEOM_ABOVE 457
#define GEOM_DIST 458
#define GEOM_MBR_EQUAL 459
#define TEMP 460
#define TEMPORARY 461
#define STREAM 462
#define MERGE 463
#define REMOTE 464
#define REPLICA 465
#define ASC 466
#define DESC 467
#define AUTHORIZATION 468
#define CHECK 469
#define CONSTRAINT 470
#define CREATE 471
#define TYPE 472
#define PROCEDURE 473
#define FUNCTION 474
#define sqlLOADER 475
#define AGGREGATE 476
#define RETURNS 477
#define EXTERNAL 478
#define sqlNAME 479
#define DECLARE 480
#define CALL 481
#define LANGUAGE 482
#define ANALYZE 483
#define MINMAX 484
#define SQL_EXPLAIN 485
#define SQL_PLAN 486
#define SQL_DEBUG 487
#define SQL_TRACE 488
#define PREP 489
#define PREPARE 490
#define EXEC 491
#define EXECUTE 492
#define DEFAULT 493
#define DISTINCT 494
#define DROP 495
#define FOREIGN 496
#define RENAME 497
#define ENCRYPTED 498
#define UNENCRYPTED 499
#define PASSWORD 500
#define GRANT 501
#define REVOKE 502
#define ROLE 503
#define ADMIN 504
#define INTO 505
#define IS 506
#define KEY 507
#define ON 508
#define OPTION 509
#define OPTIONS 510
#define PATH 511
#define PRIMARY 512
#define PRIVILEGES 513
#define PUBLIC 514
#define REFERENCES 515
#define SCHEMA 516
#define SET 517
#define AUTO_COMMIT 518
#define RETURN 519
#define ALTER 520
#define ADD 521
#define TABLE 522
#define COLUMN 523
#define TO 524
#define UNIQUE 525
#define VALUES 526
#define VIEW 527
#define WHERE 528
#define WITH 529
#define sqlDATE 530
#define TIME 531
#define TIMESTAMP 532
#define INTERVAL 533
#define YEAR 534
#define MONTH 535
#define DAY 536
#define HOUR 537
#define MINUTE 538
#define SECOND 539
#define ZONE 540
#define LIMIT 541
#define OFFSET 542
#define SAMPLE 543
#define CASE 544
#define WHEN 545
#define THEN 546
#define ELSE 547
#define NULLIF 548
#define COALESCE 549
#define IF 550
#define ELSEIF 551
#define WHILE 552
#define DO 553
#define ATOMIC 554
#define BEGIN 555
#define END 556
#define COPY 557
#define RECORDS 558
#define DELIMITERS 559
#define STDIN 560
#define STDOUT 561
#define FWF 562
#define INDEX 563
#define REPLACE 564
#define AS 565
#define TRIGGER 566
#define OF 567
#define BEFORE 568
#define AFTER 569
#define ROW 570
#define STATEMENT 571
#define sqlNEW 572
#define OLD 573
#define EACH 574
#define REFERENCING 575
#define OVER 576
#define PARTITION 577
#define CURRENT 578
#define EXCLUDE 579
#define FOLLOWING 580
#define PRECEDING 581
#define OTHERS 582
#define TIES 583
#define RANGE 584
#define UNBOUNDED 585
#define X_BODY 586

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 111 "sql_parser.y"

	int		i_val,bval;
	lng		l_val,operation;
	double		fval;
	char *		sval;
	symbol*		sym;
	dlist*		l;
	sql_subtype	type;

#line 891 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int sqlparse (mvc *m);

#endif /* !YY_SQL_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_STRING = 3,                     /* STRING  */
  YYSYMBOL_IDENT = 4,                      /* IDENT  */
  YYSYMBOL_aTYPE = 5,                      /* aTYPE  */
  YYSYMBOL_ALIAS = 6,                      /* ALIAS  */
  YYSYMBOL_AGGR = 7,                       /* AGGR  */
  YYSYMBOL_AGGR2 = 8,                      /* AGGR2  */
  YYSYMBOL_RANK = 9,                       /* RANK  */
  YYSYMBOL_sqlINT = 10,                    /* sqlINT  */
  YYSYMBOL_OIDNUM = 11,                    /* OIDNUM  */
  YYSYMBOL_HEXADECIMAL = 12,               /* HEXADECIMAL  */
  YYSYMBOL_INTNUM = 13,                    /* INTNUM  */
  YYSYMBOL_APPROXNUM = 14,                 /* APPROXNUM  */
  YYSYMBOL_USING = 15,                     /* USING  */
  YYSYMBOL_GLOBAL = 16,                    /* GLOBAL  */
  YYSYMBOL_CAST = 17,                      /* CAST  */
  YYSYMBOL_CONVERT = 18,                   /* CONVERT  */
  YYSYMBOL_CHARACTER = 19,                 /* CHARACTER  */
  YYSYMBOL_VARYING = 20,                   /* VARYING  */
  YYSYMBOL_LARGE = 21,                     /* LARGE  */
  YYSYMBOL_OBJECT = 22,                    /* OBJECT  */
  YYSYMBOL_VARCHAR = 23,                   /* VARCHAR  */
  YYSYMBOL_CLOB = 24,                      /* CLOB  */
  YYSYMBOL_sqlTEXT = 25,                   /* sqlTEXT  */
  YYSYMBOL_BINARY = 26,                    /* BINARY  */
  YYSYMBOL_sqlBLOB = 27,                   /* sqlBLOB  */
  YYSYMBOL_sqlDECIMAL = 28,                /* sqlDECIMAL  */
  YYSYMBOL_sqlFLOAT = 29,                  /* sqlFLOAT  */
  YYSYMBOL_TINYINT = 30,                   /* TINYINT  */
  YYSYMBOL_SMALLINT = 31,                  /* SMALLINT  */
  YYSYMBOL_BIGINT = 32,                    /* BIGINT  */
  YYSYMBOL_HUGEINT = 33,                   /* HUGEINT  */
  YYSYMBOL_sqlINTEGER = 34,                /* sqlINTEGER  */
  YYSYMBOL_sqlDOUBLE = 35,                 /* sqlDOUBLE  */
  YYSYMBOL_sqlREAL = 36,                   /* sqlREAL  */
  YYSYMBOL_PRECISION = 37,                 /* PRECISION  */
  YYSYMBOL_PARTIAL = 38,                   /* PARTIAL  */
  YYSYMBOL_SIMPLE = 39,                    /* SIMPLE  */
  YYSYMBOL_ACTION = 40,                    /* ACTION  */
  YYSYMBOL_CASCADE = 41,                   /* CASCADE  */
  YYSYMBOL_RESTRICT = 42,                  /* RESTRICT  */
  YYSYMBOL_BOOL_FALSE = 43,                /* BOOL_FALSE  */
  YYSYMBOL_BOOL_TRUE = 44,                 /* BOOL_TRUE  */
  YYSYMBOL_CURRENT_DATE = 45,              /* CURRENT_DATE  */
  YYSYMBOL_CURRENT_TIMESTAMP = 46,         /* CURRENT_TIMESTAMP  */
  YYSYMBOL_CURRENT_TIME = 47,              /* CURRENT_TIME  */
  YYSYMBOL_LOCALTIMESTAMP = 48,            /* LOCALTIMESTAMP  */
  YYSYMBOL_LOCALTIME = 49,                 /* LOCALTIME  */
  YYSYMBOL_LEX_ERROR = 50,                 /* LEX_ERROR  */
  YYSYMBOL_GEOMETRY = 51,                  /* GEOMETRY  */
  YYSYMBOL_GEOMETRYSUBTYPE = 52,           /* GEOMETRYSUBTYPE  */
  YYSYMBOL_GEOMETRYA = 53,                 /* GEOMETRYA  */
  YYSYMBOL_USER = 54,                      /* USER  */
  YYSYMBOL_CURRENT_USER = 55,              /* CURRENT_USER  */
  YYSYMBOL_SESSION_USER = 56,              /* SESSION_USER  */
  YYSYMBOL_LOCAL = 57,                     /* LOCAL  */
  YYSYMBOL_LOCKED = 58,                    /* LOCKED  */
  YYSYMBOL_BEST = 59,                      /* BEST  */
  YYSYMBOL_EFFORT = 60,                    /* EFFORT  */
  YYSYMBOL_CURRENT_ROLE = 61,              /* CURRENT_ROLE  */
  YYSYMBOL_sqlSESSION = 62,                /* sqlSESSION  */
  YYSYMBOL_sqlDELETE = 63,                 /* sqlDELETE  */
  YYSYMBOL_UPDATE = 64,                    /* UPDATE  */
  YYSYMBOL_SELECT = 65,                    /* SELECT  */
  YYSYMBOL_INSERT = 66,                    /* INSERT  */
  YYSYMBOL_LATERAL = 67,                   /* LATERAL  */
  YYSYMBOL_LEFT = 68,                      /* LEFT  */
  YYSYMBOL_RIGHT = 69,                     /* RIGHT  */
  YYSYMBOL_FULL = 70,                      /* FULL  */
  YYSYMBOL_OUTER = 71,                     /* OUTER  */
  YYSYMBOL_NATURAL = 72,                   /* NATURAL  */
  YYSYMBOL_CROSS = 73,                     /* CROSS  */
  YYSYMBOL_JOIN = 74,                      /* JOIN  */
  YYSYMBOL_INNER = 75,                     /* INNER  */
  YYSYMBOL_COMMIT = 76,                    /* COMMIT  */
  YYSYMBOL_ROLLBACK = 77,                  /* ROLLBACK  */
  YYSYMBOL_SAVEPOINT = 78,                 /* SAVEPOINT  */
  YYSYMBOL_RELEASE = 79,                   /* RELEASE  */
  YYSYMBOL_WORK = 80,                      /* WORK  */
  YYSYMBOL_CHAIN = 81,                     /* CHAIN  */
  YYSYMBOL_NO = 82,                        /* NO  */
  YYSYMBOL_PRESERVE = 83,                  /* PRESERVE  */
  YYSYMBOL_ROWS = 84,                      /* ROWS  */
  YYSYMBOL_START = 85,                     /* START  */
  YYSYMBOL_TRANSACTION = 86,               /* TRANSACTION  */
  YYSYMBOL_READ = 87,                      /* READ  */
  YYSYMBOL_WRITE = 88,                     /* WRITE  */
  YYSYMBOL_ONLY = 89,                      /* ONLY  */
  YYSYMBOL_ISOLATION = 90,                 /* ISOLATION  */
  YYSYMBOL_LEVEL = 91,                     /* LEVEL  */
  YYSYMBOL_UNCOMMITTED = 92,               /* UNCOMMITTED  */
  YYSYMBOL_COMMITTED = 93,                 /* COMMITTED  */
  YYSYMBOL_sqlREPEATABLE = 94,             /* sqlREPEATABLE  */
  YYSYMBOL_SERIALIZABLE = 95,              /* SERIALIZABLE  */
  YYSYMBOL_DIAGNOSTICS = 96,               /* DIAGNOSTICS  */
  YYSYMBOL_sqlSIZE = 97,                   /* sqlSIZE  */
  YYSYMBOL_STORAGE = 98,                   /* STORAGE  */
  YYSYMBOL_ASYMMETRIC = 99,                /* ASYMMETRIC  */
  YYSYMBOL_SYMMETRIC = 100,                /* SYMMETRIC  */
  YYSYMBOL_ORDER = 101,                    /* ORDER  */
  YYSYMBOL_ORDERED = 102,                  /* ORDERED  */
  YYSYMBOL_BY = 103,                       /* BY  */
  YYSYMBOL_IMPRINTS = 104,                 /* IMPRINTS  */
  YYSYMBOL_EXISTS = 105,                   /* EXISTS  */
  YYSYMBOL_ESCAPE = 106,                   /* ESCAPE  */
  YYSYMBOL_HAVING = 107,                   /* HAVING  */
  YYSYMBOL_sqlGROUP = 108,                 /* sqlGROUP  */
  YYSYMBOL_sqlNULL = 109,                  /* sqlNULL  */
  YYSYMBOL_FROM = 110,                     /* FROM  */
  YYSYMBOL_FOR = 111,                      /* FOR  */
  YYSYMBOL_MATCH = 112,                    /* MATCH  */
  YYSYMBOL_EXTRACT = 113,                  /* EXTRACT  */
  YYSYMBOL_SEQUENCE = 114,                 /* SEQUENCE  */
  YYSYMBOL_INCREMENT = 115,                /* INCREMENT  */
  YYSYMBOL_RESTART = 116,                  /* RESTART  */
  YYSYMBOL_MAXVALUE = 117,                 /* MAXVALUE  */
  YYSYMBOL_MINVALUE = 118,                 /* MINVALUE  */
  YYSYMBOL_CYCLE = 119,                    /* CYCLE  */
  YYSYMBOL_NOMAXVALUE = 120,               /* NOMAXVALUE  */
  YYSYMBOL_NOMINVALUE = 121,               /* NOMINVALUE  */
  YYSYMBOL_NOCYCLE = 122,                  /* NOCYCLE  */
  YYSYMBOL_NEXT = 123,                     /* NEXT  */
  YYSYMBOL_VALUE = 124,                    /* VALUE  */
  YYSYMBOL_CACHE = 125,                    /* CACHE  */
  YYSYMBOL_GENERATED = 126,                /* GENERATED  */
  YYSYMBOL_ALWAYS = 127,                   /* ALWAYS  */
  YYSYMBOL_IDENTITY = 128,                 /* IDENTITY  */
  YYSYMBOL_SERIAL = 129,                   /* SERIAL  */
  YYSYMBOL_BIGSERIAL = 130,                /* BIGSERIAL  */
  YYSYMBOL_AUTO_INCREMENT = 131,           /* AUTO_INCREMENT  */
  YYSYMBOL_SCOLON = 132,                   /* SCOLON  */
  YYSYMBOL_AT = 133,                       /* AT  */
  YYSYMBOL_XMLCOMMENT = 134,               /* XMLCOMMENT  */
  YYSYMBOL_XMLCONCAT = 135,                /* XMLCONCAT  */
  YYSYMBOL_XMLDOCUMENT = 136,              /* XMLDOCUMENT  */
  YYSYMBOL_XMLELEMENT = 137,               /* XMLELEMENT  */
  YYSYMBOL_XMLATTRIBUTES = 138,            /* XMLATTRIBUTES  */
  YYSYMBOL_XMLFOREST = 139,                /* XMLFOREST  */
  YYSYMBOL_XMLPARSE = 140,                 /* XMLPARSE  */
  YYSYMBOL_STRIP = 141,                    /* STRIP  */
  YYSYMBOL_WHITESPACE = 142,               /* WHITESPACE  */
  YYSYMBOL_XMLPI = 143,                    /* XMLPI  */
  YYSYMBOL_XMLQUERY = 144,                 /* XMLQUERY  */
  YYSYMBOL_PASSING = 145,                  /* PASSING  */
  YYSYMBOL_XMLTEXT = 146,                  /* XMLTEXT  */
  YYSYMBOL_NIL = 147,                      /* NIL  */
  YYSYMBOL_REF = 148,                      /* REF  */
  YYSYMBOL_ABSENT = 149,                   /* ABSENT  */
  YYSYMBOL_EMPTY = 150,                    /* EMPTY  */
  YYSYMBOL_DOCUMENT = 151,                 /* DOCUMENT  */
  YYSYMBOL_ELEMENT = 152,                  /* ELEMENT  */
  YYSYMBOL_CONTENT = 153,                  /* CONTENT  */
  YYSYMBOL_XMLNAMESPACES = 154,            /* XMLNAMESPACES  */
  YYSYMBOL_NAMESPACE = 155,                /* NAMESPACE  */
  YYSYMBOL_XMLVALIDATE = 156,              /* XMLVALIDATE  */
  YYSYMBOL_RETURNING = 157,                /* RETURNING  */
  YYSYMBOL_LOCATION = 158,                 /* LOCATION  */
  YYSYMBOL_ID = 159,                       /* ID  */
  YYSYMBOL_ACCORDING = 160,                /* ACCORDING  */
  YYSYMBOL_XMLSCHEMA = 161,                /* XMLSCHEMA  */
  YYSYMBOL_URI = 162,                      /* URI  */
  YYSYMBOL_XMLAGG = 163,                   /* XMLAGG  */
  YYSYMBOL_FILTER = 164,                   /* FILTER  */
  YYSYMBOL_UNION = 165,                    /* UNION  */
  YYSYMBOL_EXCEPT = 166,                   /* EXCEPT  */
  YYSYMBOL_INTERSECT = 167,                /* INTERSECT  */
  YYSYMBOL_CORRESPONDING = 168,            /* CORRESPONDING  */
  YYSYMBOL_UNIONJOIN = 169,                /* UNIONJOIN  */
  YYSYMBOL_DATA = 170,                     /* DATA  */
  YYSYMBOL_171_ = 171,                     /* '('  */
  YYSYMBOL_172_ = 172,                     /* ')'  */
  YYSYMBOL_FILTER_FUNC = 173,              /* FILTER_FUNC  */
  YYSYMBOL_NOT = 174,                      /* NOT  */
  YYSYMBOL_175_ = 175,                     /* '='  */
  YYSYMBOL_ALL = 176,                      /* ALL  */
  YYSYMBOL_ANY = 177,                      /* ANY  */
  YYSYMBOL_NOT_BETWEEN = 178,              /* NOT_BETWEEN  */
  YYSYMBOL_BETWEEN = 179,                  /* BETWEEN  */
  YYSYMBOL_NOT_IN = 180,                   /* NOT_IN  */
  YYSYMBOL_sqlIN = 181,                    /* sqlIN  */
  YYSYMBOL_NOT_LIKE = 182,                 /* NOT_LIKE  */
  YYSYMBOL_LIKE = 183,                     /* LIKE  */
  YYSYMBOL_NOT_ILIKE = 184,                /* NOT_ILIKE  */
  YYSYMBOL_ILIKE = 185,                    /* ILIKE  */
  YYSYMBOL_OR = 186,                       /* OR  */
  YYSYMBOL_SOME = 187,                     /* SOME  */
  YYSYMBOL_AND = 188,                      /* AND  */
  YYSYMBOL_COMPARISON = 189,               /* COMPARISON  */
  YYSYMBOL_190_ = 190,                     /* '+'  */
  YYSYMBOL_191_ = 191,                     /* '-'  */
  YYSYMBOL_192_ = 192,                     /* '&'  */
  YYSYMBOL_193_ = 193,                     /* '|'  */
  YYSYMBOL_194_ = 194,                     /* '^'  */
  YYSYMBOL_LEFT_SHIFT = 195,               /* LEFT_SHIFT  */
  YYSYMBOL_RIGHT_SHIFT = 196,              /* RIGHT_SHIFT  */
  YYSYMBOL_LEFT_SHIFT_ASSIGN = 197,        /* LEFT_SHIFT_ASSIGN  */
  YYSYMBOL_RIGHT_SHIFT_ASSIGN = 198,       /* RIGHT_SHIFT_ASSIGN  */
  YYSYMBOL_CONCATSTRING = 199,             /* CONCATSTRING  */
  YYSYMBOL_SUBSTRING = 200,                /* SUBSTRING  */
  YYSYMBOL_POSITION = 201,                 /* POSITION  */
  YYSYMBOL_SPLIT_PART = 202,               /* SPLIT_PART  */
  YYSYMBOL_UMINUS = 203,                   /* UMINUS  */
  YYSYMBOL_204_ = 204,                     /* '*'  */
  YYSYMBOL_205_ = 205,                     /* '/'  */
  YYSYMBOL_206_ = 206,                     /* '%'  */
  YYSYMBOL_207_ = 207,                     /* '~'  */
  YYSYMBOL_GEOM_OVERLAP = 208,             /* GEOM_OVERLAP  */
  YYSYMBOL_GEOM_OVERLAP_OR_ABOVE = 209,    /* GEOM_OVERLAP_OR_ABOVE  */
  YYSYMBOL_GEOM_OVERLAP_OR_BELOW = 210,    /* GEOM_OVERLAP_OR_BELOW  */
  YYSYMBOL_GEOM_OVERLAP_OR_LEFT = 211,     /* GEOM_OVERLAP_OR_LEFT  */
  YYSYMBOL_GEOM_OVERLAP_OR_RIGHT = 212,    /* GEOM_OVERLAP_OR_RIGHT  */
  YYSYMBOL_GEOM_BELOW = 213,               /* GEOM_BELOW  */
  YYSYMBOL_GEOM_ABOVE = 214,               /* GEOM_ABOVE  */
  YYSYMBOL_GEOM_DIST = 215,                /* GEOM_DIST  */
  YYSYMBOL_GEOM_MBR_EQUAL = 216,           /* GEOM_MBR_EQUAL  */
  YYSYMBOL_TEMP = 217,                     /* TEMP  */
  YYSYMBOL_TEMPORARY = 218,                /* TEMPORARY  */
  YYSYMBOL_STREAM = 219,                   /* STREAM  */
  YYSYMBOL_MERGE = 220,                    /* MERGE  */
  YYSYMBOL_REMOTE = 221,                   /* REMOTE  */
  YYSYMBOL_REPLICA = 222,                  /* REPLICA  */
  YYSYMBOL_ASC = 223,                      /* ASC  */
  YYSYMBOL_DESC = 224,                     /* DESC  */
  YYSYMBOL_AUTHORIZATION = 225,            /* AUTHORIZATION  */
  YYSYMBOL_CHECK = 226,                    /* CHECK  */
  YYSYMBOL_CONSTRAINT = 227,               /* CONSTRAINT  */
  YYSYMBOL_CREATE = 228,                   /* CREATE  */
  YYSYMBOL_TYPE = 229,                     /* TYPE  */
  YYSYMBOL_PROCEDURE = 230,                /* PROCEDURE  */
  YYSYMBOL_FUNCTION = 231,                 /* FUNCTION  */
  YYSYMBOL_sqlLOADER = 232,                /* sqlLOADER  */
  YYSYMBOL_AGGREGATE = 233,                /* AGGREGATE  */
  YYSYMBOL_RETURNS = 234,                  /* RETURNS  */
  YYSYMBOL_EXTERNAL = 235,                 /* EXTERNAL  */
  YYSYMBOL_sqlNAME = 236,                  /* sqlNAME  */
  YYSYMBOL_DECLARE = 237,                  /* DECLARE  */
  YYSYMBOL_CALL = 238,                     /* CALL  */
  YYSYMBOL_LANGUAGE = 239,                 /* LANGUAGE  */
  YYSYMBOL_ANALYZE = 240,                  /* ANALYZE  */
  YYSYMBOL_MINMAX = 241,                   /* MINMAX  */
  YYSYMBOL_SQL_EXPLAIN = 242,              /* SQL_EXPLAIN  */
  YYSYMBOL_SQL_PLAN = 243,                 /* SQL_PLAN  */
  YYSYMBOL_SQL_DEBUG = 244,                /* SQL_DEBUG  */
  YYSYMBOL_SQL_TRACE = 245,                /* SQL_TRACE  */
  YYSYMBOL_PREP = 246,                     /* PREP  */
  YYSYMBOL_PREPARE = 247,                  /* PREPARE  */
  YYSYMBOL_EXEC = 248,                     /* EXEC  */
  YYSYMBOL_EXECUTE = 249,                  /* EXECUTE  */
  YYSYMBOL_DEFAULT = 250,                  /* DEFAULT  */
  YYSYMBOL_DISTINCT = 251,                 /* DISTINCT  */
  YYSYMBOL_DROP = 252,                     /* DROP  */
  YYSYMBOL_FOREIGN = 253,                  /* FOREIGN  */
  YYSYMBOL_RENAME = 254,                   /* RENAME  */
  YYSYMBOL_ENCRYPTED = 255,                /* ENCRYPTED  */
  YYSYMBOL_UNENCRYPTED = 256,              /* UNENCRYPTED  */
  YYSYMBOL_PASSWORD = 257,                 /* PASSWORD  */
  YYSYMBOL_GRANT = 258,                    /* GRANT  */
  YYSYMBOL_REVOKE = 259,                   /* REVOKE  */
  YYSYMBOL_ROLE = 260,                     /* ROLE  */
  YYSYMBOL_ADMIN = 261,                    /* ADMIN  */
  YYSYMBOL_INTO = 262,                     /* INTO  */
  YYSYMBOL_IS = 263,                       /* IS  */
  YYSYMBOL_KEY = 264,                      /* KEY  */
  YYSYMBOL_ON = 265,                       /* ON  */
  YYSYMBOL_OPTION = 266,                   /* OPTION  */
  YYSYMBOL_OPTIONS = 267,                  /* OPTIONS  */
  YYSYMBOL_PATH = 268,                     /* PATH  */
  YYSYMBOL_PRIMARY = 269,                  /* PRIMARY  */
  YYSYMBOL_PRIVILEGES = 270,               /* PRIVILEGES  */
  YYSYMBOL_PUBLIC = 271,                   /* PUBLIC  */
  YYSYMBOL_REFERENCES = 272,               /* REFERENCES  */
  YYSYMBOL_SCHEMA = 273,                   /* SCHEMA  */
  YYSYMBOL_SET = 274,                      /* SET  */
  YYSYMBOL_AUTO_COMMIT = 275,              /* AUTO_COMMIT  */
  YYSYMBOL_RETURN = 276,                   /* RETURN  */
  YYSYMBOL_ALTER = 277,                    /* ALTER  */
  YYSYMBOL_ADD = 278,                      /* ADD  */
  YYSYMBOL_TABLE = 279,                    /* TABLE  */
  YYSYMBOL_COLUMN = 280,                   /* COLUMN  */
  YYSYMBOL_TO = 281,                       /* TO  */
  YYSYMBOL_UNIQUE = 282,                   /* UNIQUE  */
  YYSYMBOL_VALUES = 283,                   /* VALUES  */
  YYSYMBOL_VIEW = 284,                     /* VIEW  */
  YYSYMBOL_WHERE = 285,                    /* WHERE  */
  YYSYMBOL_WITH = 286,                     /* WITH  */
  YYSYMBOL_sqlDATE = 287,                  /* sqlDATE  */
  YYSYMBOL_TIME = 288,                     /* TIME  */
  YYSYMBOL_TIMESTAMP = 289,                /* TIMESTAMP  */
  YYSYMBOL_INTERVAL = 290,                 /* INTERVAL  */
  YYSYMBOL_YEAR = 291,                     /* YEAR  */
  YYSYMBOL_MONTH = 292,                    /* MONTH  */
  YYSYMBOL_DAY = 293,                      /* DAY  */
  YYSYMBOL_HOUR = 294,                     /* HOUR  */
  YYSYMBOL_MINUTE = 295,                   /* MINUTE  */
  YYSYMBOL_SECOND = 296,                   /* SECOND  */
  YYSYMBOL_ZONE = 297,                     /* ZONE  */
  YYSYMBOL_LIMIT = 298,                    /* LIMIT  */
  YYSYMBOL_OFFSET = 299,                   /* OFFSET  */
  YYSYMBOL_SAMPLE = 300,                   /* SAMPLE  */
  YYSYMBOL_CASE = 301,                     /* CASE  */
  YYSYMBOL_WHEN = 302,                     /* WHEN  */
  YYSYMBOL_THEN = 303,                     /* THEN  */
  YYSYMBOL_ELSE = 304,                     /* ELSE  */
  YYSYMBOL_NULLIF = 305,                   /* NULLIF  */
  YYSYMBOL_COALESCE = 306,                 /* COALESCE  */
  YYSYMBOL_IF = 307,                       /* IF  */
  YYSYMBOL_ELSEIF = 308,                   /* ELSEIF  */
  YYSYMBOL_WHILE = 309,                    /* WHILE  */
  YYSYMBOL_DO = 310,                       /* DO  */
  YYSYMBOL_ATOMIC = 311,                   /* ATOMIC  */
  YYSYMBOL_BEGIN = 312,                    /* BEGIN  */
  YYSYMBOL_END = 313,                      /* END  */
  YYSYMBOL_COPY = 314,                     /* COPY  */
  YYSYMBOL_RECORDS = 315,                  /* RECORDS  */
  YYSYMBOL_DELIMITERS = 316,               /* DELIMITERS  */
  YYSYMBOL_STDIN = 317,                    /* STDIN  */
  YYSYMBOL_STDOUT = 318,                   /* STDOUT  */
  YYSYMBOL_FWF = 319,                      /* FWF  */
  YYSYMBOL_INDEX = 320,                    /* INDEX  */
  YYSYMBOL_REPLACE = 321,                  /* REPLACE  */
  YYSYMBOL_AS = 322,                       /* AS  */
  YYSYMBOL_TRIGGER = 323,                  /* TRIGGER  */
  YYSYMBOL_OF = 324,                       /* OF  */
  YYSYMBOL_BEFORE = 325,                   /* BEFORE  */
  YYSYMBOL_AFTER = 326,                    /* AFTER  */
  YYSYMBOL_ROW = 327,                      /* ROW  */
  YYSYMBOL_STATEMENT = 328,                /* STATEMENT  */
  YYSYMBOL_sqlNEW = 329,                   /* sqlNEW  */
  YYSYMBOL_OLD = 330,                      /* OLD  */
  YYSYMBOL_EACH = 331,                     /* EACH  */
  YYSYMBOL_REFERENCING = 332,              /* REFERENCING  */
  YYSYMBOL_OVER = 333,                     /* OVER  */
  YYSYMBOL_PARTITION = 334,                /* PARTITION  */
  YYSYMBOL_CURRENT = 335,                  /* CURRENT  */
  YYSYMBOL_EXCLUDE = 336,                  /* EXCLUDE  */
  YYSYMBOL_FOLLOWING = 337,                /* FOLLOWING  */
  YYSYMBOL_PRECEDING = 338,                /* PRECEDING  */
  YYSYMBOL_OTHERS = 339,                   /* OTHERS  */
  YYSYMBOL_TIES = 340,                     /* TIES  */
  YYSYMBOL_RANGE = 341,                    /* RANGE  */
  YYSYMBOL_UNBOUNDED = 342,                /* UNBOUNDED  */
  YYSYMBOL_X_BODY = 343,                   /* X_BODY  */
  YYSYMBOL_344_ = 344,                     /* ','  */
  YYSYMBOL_345_ = 345,                     /* '.'  */
  YYSYMBOL_346_ = 346,                     /* ':'  */
  YYSYMBOL_347_ = 347,                     /* '['  */
  YYSYMBOL_348_ = 348,                     /* ']'  */
  YYSYMBOL_349_ = 349,                     /* '?'  */
  YYSYMBOL_YYACCEPT = 350,                 /* $accept  */
  YYSYMBOL_sqlstmt = 351,                  /* sqlstmt  */
  YYSYMBOL_352_1 = 352,                    /* $@1  */
  YYSYMBOL_353_2 = 353,                    /* $@2  */
  YYSYMBOL_354_3 = 354,                    /* $@3  */
  YYSYMBOL_355_4 = 355,                    /* $@4  */
  YYSYMBOL_356_5 = 356,                    /* $@5  */
  YYSYMBOL_prepare = 357,                  /* prepare  */
  YYSYMBOL_execute = 358,                  /* execute  */
  YYSYMBOL_create = 359,                   /* create  */
  YYSYMBOL_create_or_replace = 360,        /* create_or_replace  */
  YYSYMBOL_if_exists = 361,                /* if_exists  */
  YYSYMBOL_if_not_exists = 362,            /* if_not_exists  */
  YYSYMBOL_drop = 363,                     /* drop  */
  YYSYMBOL_set = 364,                      /* set  */
  YYSYMBOL_declare = 365,                  /* declare  */
  YYSYMBOL_sql = 366,                      /* sql  */
  YYSYMBOL_opt_minmax = 367,               /* opt_minmax  */
  YYSYMBOL_declare_statement = 368,        /* declare_statement  */
  YYSYMBOL_variable_list = 369,            /* variable_list  */
  YYSYMBOL_set_statement = 370,            /* set_statement  */
  YYSYMBOL_schema = 371,                   /* schema  */
  YYSYMBOL_schema_name_clause = 372,       /* schema_name_clause  */
  YYSYMBOL_authorization_identifier = 373, /* authorization_identifier  */
  YYSYMBOL_opt_schema_default_char_set = 374, /* opt_schema_default_char_set  */
  YYSYMBOL_opt_schema_element_list = 375,  /* opt_schema_element_list  */
  YYSYMBOL_schema_element_list = 376,      /* schema_element_list  */
  YYSYMBOL_schema_element = 377,           /* schema_element  */
  YYSYMBOL_opt_grantor = 378,              /* opt_grantor  */
  YYSYMBOL_grantor = 379,                  /* grantor  */
  YYSYMBOL_grant = 380,                    /* grant  */
  YYSYMBOL_authid_list = 381,              /* authid_list  */
  YYSYMBOL_opt_with_grant = 382,           /* opt_with_grant  */
  YYSYMBOL_opt_with_admin = 383,           /* opt_with_admin  */
  YYSYMBOL_opt_from_grantor = 384,         /* opt_from_grantor  */
  YYSYMBOL_revoke = 385,                   /* revoke  */
  YYSYMBOL_opt_grant_for = 386,            /* opt_grant_for  */
  YYSYMBOL_opt_admin_for = 387,            /* opt_admin_for  */
  YYSYMBOL_privileges = 388,               /* privileges  */
  YYSYMBOL_global_privileges = 389,        /* global_privileges  */
  YYSYMBOL_global_privilege = 390,         /* global_privilege  */
  YYSYMBOL_object_name = 391,              /* object_name  */
  YYSYMBOL_object_privileges = 392,        /* object_privileges  */
  YYSYMBOL_operation_commalist = 393,      /* operation_commalist  */
  YYSYMBOL_operation = 394,                /* operation  */
  YYSYMBOL_grantee_commalist = 395,        /* grantee_commalist  */
  YYSYMBOL_grantee = 396,                  /* grantee  */
  YYSYMBOL_alter_statement = 397,          /* alter_statement  */
  YYSYMBOL_passwd_schema = 398,            /* passwd_schema  */
  YYSYMBOL_alter_table_element = 399,      /* alter_table_element  */
  YYSYMBOL_drop_table_element = 400,       /* drop_table_element  */
  YYSYMBOL_opt_column = 401,               /* opt_column  */
  YYSYMBOL_create_statement = 402,         /* create_statement  */
  YYSYMBOL_seq_def = 403,                  /* seq_def  */
  YYSYMBOL_opt_seq_params = 404,           /* opt_seq_params  */
  YYSYMBOL_opt_alt_seq_params = 405,       /* opt_alt_seq_params  */
  YYSYMBOL_opt_seq_param = 406,            /* opt_seq_param  */
  YYSYMBOL_opt_alt_seq_param = 407,        /* opt_alt_seq_param  */
  YYSYMBOL_opt_seq_common_param = 408,     /* opt_seq_common_param  */
  YYSYMBOL_index_def = 409,                /* index_def  */
  YYSYMBOL_opt_index_type = 410,           /* opt_index_type  */
  YYSYMBOL_role_def = 411,                 /* role_def  */
  YYSYMBOL_opt_encrypted = 412,            /* opt_encrypted  */
  YYSYMBOL_table_opt_storage = 413,        /* table_opt_storage  */
  YYSYMBOL_table_def = 414,                /* table_def  */
  YYSYMBOL_opt_temp = 415,                 /* opt_temp  */
  YYSYMBOL_opt_on_commit = 416,            /* opt_on_commit  */
  YYSYMBOL_table_content_source = 417,     /* table_content_source  */
  YYSYMBOL_as_subquery_clause = 418,       /* as_subquery_clause  */
  YYSYMBOL_with_or_without_data = 419,     /* with_or_without_data  */
  YYSYMBOL_table_element_list = 420,       /* table_element_list  */
  YYSYMBOL_add_table_element = 421,        /* add_table_element  */
  YYSYMBOL_table_element = 422,            /* table_element  */
  YYSYMBOL_serial_or_bigserial = 423,      /* serial_or_bigserial  */
  YYSYMBOL_column_def = 424,               /* column_def  */
  YYSYMBOL_opt_column_def_opt_list = 425,  /* opt_column_def_opt_list  */
  YYSYMBOL_column_def_opt_list = 426,      /* column_def_opt_list  */
  YYSYMBOL_column_options = 427,           /* column_options  */
  YYSYMBOL_column_option_list = 428,       /* column_option_list  */
  YYSYMBOL_column_option = 429,            /* column_option  */
  YYSYMBOL_default = 430,                  /* default  */
  YYSYMBOL_default_value = 431,            /* default_value  */
  YYSYMBOL_column_constraint = 432,        /* column_constraint  */
  YYSYMBOL_generated_column = 433,         /* generated_column  */
  YYSYMBOL_serial_opt_params = 434,        /* serial_opt_params  */
  YYSYMBOL_table_constraint = 435,         /* table_constraint  */
  YYSYMBOL_opt_constraint_name = 436,      /* opt_constraint_name  */
  YYSYMBOL_ref_action = 437,               /* ref_action  */
  YYSYMBOL_ref_on_update = 438,            /* ref_on_update  */
  YYSYMBOL_ref_on_delete = 439,            /* ref_on_delete  */
  YYSYMBOL_opt_ref_action = 440,           /* opt_ref_action  */
  YYSYMBOL_opt_match_type = 441,           /* opt_match_type  */
  YYSYMBOL_opt_match = 442,                /* opt_match  */
  YYSYMBOL_column_constraint_type = 443,   /* column_constraint_type  */
  YYSYMBOL_table_constraint_type = 444,    /* table_constraint_type  */
  YYSYMBOL_domain_constraint_type = 445,   /* domain_constraint_type  */
  YYSYMBOL_ident_commalist = 446,          /* ident_commalist  */
  YYSYMBOL_like_table = 447,               /* like_table  */
  YYSYMBOL_view_def = 448,                 /* view_def  */
  YYSYMBOL_query_expression_def = 449,     /* query_expression_def  */
  YYSYMBOL_query_expression = 450,         /* query_expression  */
  YYSYMBOL_opt_with_check_option = 451,    /* opt_with_check_option  */
  YYSYMBOL_opt_column_list = 452,          /* opt_column_list  */
  YYSYMBOL_column_commalist_parens = 453,  /* column_commalist_parens  */
  YYSYMBOL_type_def = 454,                 /* type_def  */
  YYSYMBOL_external_function_name = 455,   /* external_function_name  */
  YYSYMBOL_function_body = 456,            /* function_body  */
  YYSYMBOL_func_def = 457,                 /* func_def  */
  YYSYMBOL_routine_body = 458,             /* routine_body  */
  YYSYMBOL_procedure_statement_list = 459, /* procedure_statement_list  */
  YYSYMBOL_trigger_procedure_statement_list = 460, /* trigger_procedure_statement_list  */
  YYSYMBOL_procedure_statement = 461,      /* procedure_statement  */
  YYSYMBOL_trigger_procedure_statement = 462, /* trigger_procedure_statement  */
  YYSYMBOL_control_statement = 463,        /* control_statement  */
  YYSYMBOL_call_statement = 464,           /* call_statement  */
  YYSYMBOL_call_procedure_statement = 465, /* call_procedure_statement  */
  YYSYMBOL_routine_invocation = 466,       /* routine_invocation  */
  YYSYMBOL_routine_name = 467,             /* routine_name  */
  YYSYMBOL_argument_list = 468,            /* argument_list  */
  YYSYMBOL_return_statement = 469,         /* return_statement  */
  YYSYMBOL_return_value = 470,             /* return_value  */
  YYSYMBOL_case_statement = 471,           /* case_statement  */
  YYSYMBOL_when_statement = 472,           /* when_statement  */
  YYSYMBOL_when_statements = 473,          /* when_statements  */
  YYSYMBOL_when_search_statement = 474,    /* when_search_statement  */
  YYSYMBOL_when_search_statements = 475,   /* when_search_statements  */
  YYSYMBOL_case_opt_else_statement = 476,  /* case_opt_else_statement  */
  YYSYMBOL_if_statement = 477,             /* if_statement  */
  YYSYMBOL_if_opt_else = 478,              /* if_opt_else  */
  YYSYMBOL_while_statement = 479,          /* while_statement  */
  YYSYMBOL_opt_begin_label = 480,          /* opt_begin_label  */
  YYSYMBOL_opt_end_label = 481,            /* opt_end_label  */
  YYSYMBOL_table_function_column_list = 482, /* table_function_column_list  */
  YYSYMBOL_func_data_type = 483,           /* func_data_type  */
  YYSYMBOL_opt_paramlist = 484,            /* opt_paramlist  */
  YYSYMBOL_paramlist = 485,                /* paramlist  */
  YYSYMBOL_trigger_def = 486,              /* trigger_def  */
  YYSYMBOL_trigger_action_time = 487,      /* trigger_action_time  */
  YYSYMBOL_trigger_event = 488,            /* trigger_event  */
  YYSYMBOL_opt_referencing_list = 489,     /* opt_referencing_list  */
  YYSYMBOL_old_or_new_values_alias_list = 490, /* old_or_new_values_alias_list  */
  YYSYMBOL_old_or_new_values_alias = 491,  /* old_or_new_values_alias  */
  YYSYMBOL_opt_as = 492,                   /* opt_as  */
  YYSYMBOL_opt_row = 493,                  /* opt_row  */
  YYSYMBOL_triggered_action = 494,         /* triggered_action  */
  YYSYMBOL_opt_for_each = 495,             /* opt_for_each  */
  YYSYMBOL_row_or_statement = 496,         /* row_or_statement  */
  YYSYMBOL_opt_when = 497,                 /* opt_when  */
  YYSYMBOL_triggered_statement = 498,      /* triggered_statement  */
  YYSYMBOL_routine_designator = 499,       /* routine_designator  */
  YYSYMBOL_drop_statement = 500,           /* drop_statement  */
  YYSYMBOL_opt_typelist = 501,             /* opt_typelist  */
  YYSYMBOL_typelist = 502,                 /* typelist  */
  YYSYMBOL_drop_action = 503,              /* drop_action  */
  YYSYMBOL_update_statement = 504,         /* update_statement  */
  YYSYMBOL_transaction_statement = 505,    /* transaction_statement  */
  YYSYMBOL__transaction_stmt = 506,        /* _transaction_stmt  */
  YYSYMBOL_transaction_mode_list = 507,    /* transaction_mode_list  */
  YYSYMBOL__transaction_mode_list = 508,   /* _transaction_mode_list  */
  YYSYMBOL_transaction_mode = 509,         /* transaction_mode  */
  YYSYMBOL_iso_level = 510,                /* iso_level  */
  YYSYMBOL_opt_work = 511,                 /* opt_work  */
  YYSYMBOL_opt_chain = 512,                /* opt_chain  */
  YYSYMBOL_opt_to_savepoint = 513,         /* opt_to_savepoint  */
  YYSYMBOL_copyfrom_stmt = 514,            /* copyfrom_stmt  */
  YYSYMBOL_opt_fwf_widths = 515,           /* opt_fwf_widths  */
  YYSYMBOL_fwf_widthlist = 516,            /* fwf_widthlist  */
  YYSYMBOL_opt_header_list = 517,          /* opt_header_list  */
  YYSYMBOL_header_list = 518,              /* header_list  */
  YYSYMBOL_header = 519,                   /* header  */
  YYSYMBOL_opt_seps = 520,                 /* opt_seps  */
  YYSYMBOL_opt_using = 521,                /* opt_using  */
  YYSYMBOL_opt_nr = 522,                   /* opt_nr  */
  YYSYMBOL_opt_null_string = 523,          /* opt_null_string  */
  YYSYMBOL_opt_locked = 524,               /* opt_locked  */
  YYSYMBOL_opt_best_effort = 525,          /* opt_best_effort  */
  YYSYMBOL_opt_constraint = 526,           /* opt_constraint  */
  YYSYMBOL_string_commalist = 527,         /* string_commalist  */
  YYSYMBOL_string_commalist_contents = 528, /* string_commalist_contents  */
  YYSYMBOL_delete_stmt = 529,              /* delete_stmt  */
  YYSYMBOL_update_stmt = 530,              /* update_stmt  */
  YYSYMBOL_insert_stmt = 531,              /* insert_stmt  */
  YYSYMBOL_values_or_query_spec = 532,     /* values_or_query_spec  */
  YYSYMBOL_row_commalist = 533,            /* row_commalist  */
  YYSYMBOL_atom_commalist = 534,           /* atom_commalist  */
  YYSYMBOL_value_commalist = 535,          /* value_commalist  */
  YYSYMBOL_null = 536,                     /* null  */
  YYSYMBOL_simple_atom = 537,              /* simple_atom  */
  YYSYMBOL_insert_atom = 538,              /* insert_atom  */
  YYSYMBOL_value = 539,                    /* value  */
  YYSYMBOL_opt_distinct = 540,             /* opt_distinct  */
  YYSYMBOL_assignment_commalist = 541,     /* assignment_commalist  */
  YYSYMBOL_assignment = 542,               /* assignment  */
  YYSYMBOL_opt_where_clause = 543,         /* opt_where_clause  */
  YYSYMBOL_joined_table = 544,             /* joined_table  */
  YYSYMBOL_join_type = 545,                /* join_type  */
  YYSYMBOL_opt_outer = 546,                /* opt_outer  */
  YYSYMBOL_outer_join_type = 547,          /* outer_join_type  */
  YYSYMBOL_join_spec = 548,                /* join_spec  */
  YYSYMBOL_with_query = 549,               /* with_query  */
  YYSYMBOL_with_list = 550,                /* with_list  */
  YYSYMBOL_with_list_element = 551,        /* with_list_element  */
  YYSYMBOL_with_query_expression = 552,    /* with_query_expression  */
  YYSYMBOL_simple_select = 553,            /* simple_select  */
  YYSYMBOL_select_statement_single_row = 554, /* select_statement_single_row  */
  YYSYMBOL_select_no_parens_orderby = 555, /* select_no_parens_orderby  */
  YYSYMBOL_select_target_list = 556,       /* select_target_list  */
  YYSYMBOL_target_specification = 557,     /* target_specification  */
  YYSYMBOL_select_no_parens = 558,         /* select_no_parens  */
  YYSYMBOL_set_distinct = 559,             /* set_distinct  */
  YYSYMBOL_opt_corresponding = 560,        /* opt_corresponding  */
  YYSYMBOL_selection = 561,                /* selection  */
  YYSYMBOL_table_exp = 562,                /* table_exp  */
  YYSYMBOL_opt_from_clause = 563,          /* opt_from_clause  */
  YYSYMBOL_table_ref_commalist = 564,      /* table_ref_commalist  */
  YYSYMBOL_table_ref = 565,                /* table_ref  */
  YYSYMBOL_566_6 = 566,                    /* $@6  */
  YYSYMBOL_table_name = 567,               /* table_name  */
  YYSYMBOL_opt_table_name = 568,           /* opt_table_name  */
  YYSYMBOL_opt_group_by_clause = 569,      /* opt_group_by_clause  */
  YYSYMBOL_column_ref_commalist = 570,     /* column_ref_commalist  */
  YYSYMBOL_opt_having_clause = 571,        /* opt_having_clause  */
  YYSYMBOL_search_condition = 572,         /* search_condition  */
  YYSYMBOL_and_exp = 573,                  /* and_exp  */
  YYSYMBOL_opt_order_by_clause = 574,      /* opt_order_by_clause  */
  YYSYMBOL_opt_limit = 575,                /* opt_limit  */
  YYSYMBOL_opt_offset = 576,               /* opt_offset  */
  YYSYMBOL_opt_sample = 577,               /* opt_sample  */
  YYSYMBOL_sort_specification_list = 578,  /* sort_specification_list  */
  YYSYMBOL_ordering_spec = 579,            /* ordering_spec  */
  YYSYMBOL_opt_asc_desc = 580,             /* opt_asc_desc  */
  YYSYMBOL_predicate = 581,                /* predicate  */
  YYSYMBOL_pred_exp = 582,                 /* pred_exp  */
  YYSYMBOL_comparison_predicate = 583,     /* comparison_predicate  */
  YYSYMBOL_between_predicate = 584,        /* between_predicate  */
  YYSYMBOL_opt_bounds = 585,               /* opt_bounds  */
  YYSYMBOL_like_predicate = 586,           /* like_predicate  */
  YYSYMBOL_like_exp = 587,                 /* like_exp  */
  YYSYMBOL_test_for_null = 588,            /* test_for_null  */
  YYSYMBOL_in_predicate = 589,             /* in_predicate  */
  YYSYMBOL_pred_exp_list = 590,            /* pred_exp_list  */
  YYSYMBOL_all_or_any_predicate = 591,     /* all_or_any_predicate  */
  YYSYMBOL_any_all_some = 592,             /* any_all_some  */
  YYSYMBOL_existence_test = 593,           /* existence_test  */
  YYSYMBOL_filter_arg_list = 594,          /* filter_arg_list  */
  YYSYMBOL_filter_args = 595,              /* filter_args  */
  YYSYMBOL_filter_exp = 596,               /* filter_exp  */
  YYSYMBOL_subquery_with_orderby = 597,    /* subquery_with_orderby  */
  YYSYMBOL_subquery = 598,                 /* subquery  */
  YYSYMBOL_simple_scalar_exp = 599,        /* simple_scalar_exp  */
  YYSYMBOL_scalar_exp = 600,               /* scalar_exp  */
  YYSYMBOL_value_exp = 601,                /* value_exp  */
  YYSYMBOL_param = 602,                    /* param  */
  YYSYMBOL_window_function = 603,          /* window_function  */
  YYSYMBOL_window_function_type = 604,     /* window_function_type  */
  YYSYMBOL_window_specification = 605,     /* window_specification  */
  YYSYMBOL_window_partition_clause = 606,  /* window_partition_clause  */
  YYSYMBOL_window_order_clause = 607,      /* window_order_clause  */
  YYSYMBOL_window_frame_clause = 608,      /* window_frame_clause  */
  YYSYMBOL_window_frame_units = 609,       /* window_frame_units  */
  YYSYMBOL_window_frame_extent = 610,      /* window_frame_extent  */
  YYSYMBOL_window_frame_start = 611,       /* window_frame_start  */
  YYSYMBOL_window_frame_preceding = 612,   /* window_frame_preceding  */
  YYSYMBOL_window_frame_between = 613,     /* window_frame_between  */
  YYSYMBOL_window_frame_end = 614,         /* window_frame_end  */
  YYSYMBOL_window_frame_following = 615,   /* window_frame_following  */
  YYSYMBOL_window_frame_exclusion = 616,   /* window_frame_exclusion  */
  YYSYMBOL_var_ref = 617,                  /* var_ref  */
  YYSYMBOL_func_ref = 618,                 /* func_ref  */
  YYSYMBOL_qfunc = 619,                    /* qfunc  */
  YYSYMBOL_func_ident = 620,               /* func_ident  */
  YYSYMBOL_datetime_funcs = 621,           /* datetime_funcs  */
  YYSYMBOL_opt_brackets = 622,             /* opt_brackets  */
  YYSYMBOL_string_funcs = 623,             /* string_funcs  */
  YYSYMBOL_column_exp_commalist = 624,     /* column_exp_commalist  */
  YYSYMBOL_column_exp = 625,               /* column_exp  */
  YYSYMBOL_opt_alias_name = 626,           /* opt_alias_name  */
  YYSYMBOL_atom = 627,                     /* atom  */
  YYSYMBOL_qrank = 628,                    /* qrank  */
  YYSYMBOL_qaggr = 629,                    /* qaggr  */
  YYSYMBOL_qaggr2 = 630,                   /* qaggr2  */
  YYSYMBOL_aggr_ref = 631,                 /* aggr_ref  */
  YYSYMBOL_opt_sign = 632,                 /* opt_sign  */
  YYSYMBOL_tz = 633,                       /* tz  */
  YYSYMBOL_time_precision = 634,           /* time_precision  */
  YYSYMBOL_timestamp_precision = 635,      /* timestamp_precision  */
  YYSYMBOL_datetime_type = 636,            /* datetime_type  */
  YYSYMBOL_non_second_datetime_field = 637, /* non_second_datetime_field  */
  YYSYMBOL_datetime_field = 638,           /* datetime_field  */
  YYSYMBOL_start_field = 639,              /* start_field  */
  YYSYMBOL_end_field = 640,                /* end_field  */
  YYSYMBOL_single_datetime_field = 641,    /* single_datetime_field  */
  YYSYMBOL_interval_qualifier = 642,       /* interval_qualifier  */
  YYSYMBOL_interval_type = 643,            /* interval_type  */
  YYSYMBOL_user = 644,                     /* user  */
  YYSYMBOL_literal = 645,                  /* literal  */
  YYSYMBOL_interval_expression = 646,      /* interval_expression  */
  YYSYMBOL_qname = 647,                    /* qname  */
  YYSYMBOL_column_ref = 648,               /* column_ref  */
  YYSYMBOL_cast_exp = 649,                 /* cast_exp  */
  YYSYMBOL_cast_value = 650,               /* cast_value  */
  YYSYMBOL_case_exp = 651,                 /* case_exp  */
  YYSYMBOL_scalar_exp_list = 652,          /* scalar_exp_list  */
  YYSYMBOL_case_scalar_exp_list = 653,     /* case_scalar_exp_list  */
  YYSYMBOL_when_value = 654,               /* when_value  */
  YYSYMBOL_when_value_list = 655,          /* when_value_list  */
  YYSYMBOL_when_search = 656,              /* when_search  */
  YYSYMBOL_when_search_list = 657,         /* when_search_list  */
  YYSYMBOL_case_opt_else = 658,            /* case_opt_else  */
  YYSYMBOL_case_scalar_exp = 659,          /* case_scalar_exp  */
  YYSYMBOL_nonzero = 660,                  /* nonzero  */
  YYSYMBOL_nonzerolng = 661,               /* nonzerolng  */
  YYSYMBOL_poslng = 662,                   /* poslng  */
  YYSYMBOL_posint = 663,                   /* posint  */
  YYSYMBOL_data_type = 664,                /* data_type  */
  YYSYMBOL_subgeometry_type = 665,         /* subgeometry_type  */
  YYSYMBOL_type_alias = 666,               /* type_alias  */
  YYSYMBOL_varchar = 667,                  /* varchar  */
  YYSYMBOL_clob = 668,                     /* clob  */
  YYSYMBOL_blob = 669,                     /* blob  */
  YYSYMBOL_column = 670,                   /* column  */
  YYSYMBOL_authid = 671,                   /* authid  */
  YYSYMBOL_restricted_ident = 672,         /* restricted_ident  */
  YYSYMBOL_ident = 673,                    /* ident  */
  YYSYMBOL_non_reserved_word = 674,        /* non_reserved_word  */
  YYSYMBOL_name_commalist = 675,           /* name_commalist  */
  YYSYMBOL_lngval = 676,                   /* lngval  */
  YYSYMBOL_intval = 677,                   /* intval  */
  YYSYMBOL_string = 678,                   /* string  */
  YYSYMBOL_exec = 679,                     /* exec  */
  YYSYMBOL_exec_ref = 680,                 /* exec_ref  */
  YYSYMBOL_opt_path_specification = 681,   /* opt_path_specification  */
  YYSYMBOL_path_specification = 682,       /* path_specification  */
  YYSYMBOL_schema_name_list = 683,         /* schema_name_list  */
  YYSYMBOL_XML_value_expression = 684,     /* XML_value_expression  */
  YYSYMBOL_XML_value_expression_list = 685, /* XML_value_expression_list  */
  YYSYMBOL_XML_primary = 686,              /* XML_primary  */
  YYSYMBOL_XML_value_function = 687,       /* XML_value_function  */
  YYSYMBOL_XML_comment = 688,              /* XML_comment  */
  YYSYMBOL_XML_concatenation = 689,        /* XML_concatenation  */
  YYSYMBOL_XML_document = 690,             /* XML_document  */
  YYSYMBOL_XML_element = 691,              /* XML_element  */
  YYSYMBOL_opt_comma_XML_namespace_declaration_attributes_element_content = 692, /* opt_comma_XML_namespace_declaration_attributes_element_content  */
  YYSYMBOL_XML_element_name = 693,         /* XML_element_name  */
  YYSYMBOL_XML_attributes = 694,           /* XML_attributes  */
  YYSYMBOL_XML_attribute_list = 695,       /* XML_attribute_list  */
  YYSYMBOL_XML_attribute = 696,            /* XML_attribute  */
  YYSYMBOL_opt_XML_attribute_name = 697,   /* opt_XML_attribute_name  */
  YYSYMBOL_XML_attribute_value = 698,      /* XML_attribute_value  */
  YYSYMBOL_XML_attribute_name = 699,       /* XML_attribute_name  */
  YYSYMBOL_XML_element_content_and_option = 700, /* XML_element_content_and_option  */
  YYSYMBOL_XML_element_content_list = 701, /* XML_element_content_list  */
  YYSYMBOL_XML_element_content = 702,      /* XML_element_content  */
  YYSYMBOL_opt_XML_content_option = 703,   /* opt_XML_content_option  */
  YYSYMBOL_XML_content_option = 704,       /* XML_content_option  */
  YYSYMBOL_XML_forest = 705,               /* XML_forest  */
  YYSYMBOL_opt_XML_namespace_declaration_and_comma = 706, /* opt_XML_namespace_declaration_and_comma  */
  YYSYMBOL_forest_element_list = 707,      /* forest_element_list  */
  YYSYMBOL_forest_element = 708,           /* forest_element  */
  YYSYMBOL_forest_element_value = 709,     /* forest_element_value  */
  YYSYMBOL_opt_forest_element_name = 710,  /* opt_forest_element_name  */
  YYSYMBOL_forest_element_name = 711,      /* forest_element_name  */
  YYSYMBOL_XML_parse = 712,                /* XML_parse  */
  YYSYMBOL_XML_whitespace_option = 713,    /* XML_whitespace_option  */
  YYSYMBOL_XML_PI = 714,                   /* XML_PI  */
  YYSYMBOL_XML_PI_target = 715,            /* XML_PI_target  */
  YYSYMBOL_opt_comma_string_value_expression = 716, /* opt_comma_string_value_expression  */
  YYSYMBOL_XML_query = 717,                /* XML_query  */
  YYSYMBOL_XQuery_expression = 718,        /* XQuery_expression  */
  YYSYMBOL_opt_XML_query_argument_list = 719, /* opt_XML_query_argument_list  */
  YYSYMBOL_XML_query_default_passing_mechanism = 720, /* XML_query_default_passing_mechanism  */
  YYSYMBOL_XML_query_argument_list = 721,  /* XML_query_argument_list  */
  YYSYMBOL_XML_query_argument = 722,       /* XML_query_argument  */
  YYSYMBOL_XML_query_context_item = 723,   /* XML_query_context_item  */
  YYSYMBOL_XML_query_variable = 724,       /* XML_query_variable  */
  YYSYMBOL_opt_XML_query_returning_mechanism = 725, /* opt_XML_query_returning_mechanism  */
  YYSYMBOL_XML_query_empty_handling_option = 726, /* XML_query_empty_handling_option  */
  YYSYMBOL_XML_text = 727,                 /* XML_text  */
  YYSYMBOL_XML_validate = 728,             /* XML_validate  */
  YYSYMBOL_document_or_content_or_sequence = 729, /* document_or_content_or_sequence  */
  YYSYMBOL_document_or_content = 730,      /* document_or_content  */
  YYSYMBOL_opt_XML_returning_clause = 731, /* opt_XML_returning_clause  */
  YYSYMBOL_XML_namespace_declaration = 732, /* XML_namespace_declaration  */
  YYSYMBOL_XML_namespace_declaration_item_list = 733, /* XML_namespace_declaration_item_list  */
  YYSYMBOL_XML_namespace_declaration_item = 734, /* XML_namespace_declaration_item  */
  YYSYMBOL_XML_namespace_prefix = 735,     /* XML_namespace_prefix  */
  YYSYMBOL_XML_namespace_URI = 736,        /* XML_namespace_URI  */
  YYSYMBOL_XML_regular_namespace_declaration_item = 737, /* XML_regular_namespace_declaration_item  */
  YYSYMBOL_XML_default_namespace_declaration_item = 738, /* XML_default_namespace_declaration_item  */
  YYSYMBOL_opt_XML_passing_mechanism = 739, /* opt_XML_passing_mechanism  */
  YYSYMBOL_XML_passing_mechanism = 740,    /* XML_passing_mechanism  */
  YYSYMBOL_opt_XML_valid_according_to_clause = 741, /* opt_XML_valid_according_to_clause  */
  YYSYMBOL_XML_valid_according_to_clause = 742, /* XML_valid_according_to_clause  */
  YYSYMBOL_XML_valid_according_to_what = 743, /* XML_valid_according_to_what  */
  YYSYMBOL_XML_valid_according_to_URI = 744, /* XML_valid_according_to_URI  */
  YYSYMBOL_XML_valid_target_namespace_URI = 745, /* XML_valid_target_namespace_URI  */
  YYSYMBOL_XML_URI = 746,                  /* XML_URI  */
  YYSYMBOL_opt_XML_valid_schema_location = 747, /* opt_XML_valid_schema_location  */
  YYSYMBOL_XML_valid_schema_location_URI = 748, /* XML_valid_schema_location_URI  */
  YYSYMBOL_XML_valid_according_to_identifier = 749, /* XML_valid_according_to_identifier  */
  YYSYMBOL_registered_XML_Schema_name = 750, /* registered_XML_Schema_name  */
  YYSYMBOL_opt_XML_valid_element_clause = 751, /* opt_XML_valid_element_clause  */
  YYSYMBOL_XML_valid_element_clause = 752, /* XML_valid_element_clause  */
  YYSYMBOL_opt_XML_valid_element_name_specification = 753, /* opt_XML_valid_element_name_specification  */
  YYSYMBOL_XML_valid_element_name_specification = 754, /* XML_valid_element_name_specification  */
  YYSYMBOL_XML_valid_element_namespace_specification = 755, /* XML_valid_element_namespace_specification  */
  YYSYMBOL_XML_valid_element_namespace_URI = 756, /* XML_valid_element_namespace_URI  */
  YYSYMBOL_XML_valid_element_name = 757,   /* XML_valid_element_name  */
  YYSYMBOL_XML_aggregate = 758             /* XML_aggregate  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 120 "sql_parser.y"

extern int sqllex( YYSTYPE *yylval, void *m );
/* enable to activate debugging support
int yydebug=1;
*/

#line 1679 "y.tab.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  228
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   16758

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  350
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  409
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1131
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2103

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   586


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   206,   192,     2,
     171,   172,   204,   190,   344,   191,   345,   205,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   346,     2,
       2,   175,     2,   349,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   347,     2,   348,   194,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   193,     2,   207,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   173,   174,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   619,   619,   630,   630,   644,   644,   659,   659,   674,
     674,   684,   684,   690,   691,   692,   693,   694,   699,   700,
     704,   705,   710,   713,   714,   718,   719,   722,   723,   727,
     730,   733,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   752,   756,   757,   761,   763,   767,   772,   781,   786,
     791,   799,   807,   815,   823,   829,   837,   846,   855,   859,
     863,   870,   873,   874,   878,   879,   883,   884,   888,   888,
     888,   888,   888,   891,   892,   896,   897,   901,   910,   921,
     922,   927,   928,   932,   933,   938,   939,   943,   951,   961,
     962,   966,   967,   971,   975,   982,   983,   988,   989,   993,
     994,   995,  1006,  1007,  1008,  1012,  1013,  1018,  1019,  1020,
    1021,  1022,  1023,  1027,  1028,  1033,  1034,  1040,  1046,  1051,
    1056,  1061,  1066,  1071,  1076,  1081,  1086,  1099,  1105,  1111,
    1121,  1126,  1130,  1134,  1136,  1144,  1152,  1157,  1162,  1171,
    1172,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1199,
    1210,  1227,  1237,  1238,  1242,  1243,  1247,  1248,  1249,  1253,
    1254,  1255,  1256,  1257,  1261,  1262,  1263,  1264,  1265,  1266,
    1267,  1268,  1275,  1285,  1286,  1287,  1288,  1308,  1313,  1324,
    1325,  1326,  1330,  1331,  1335,  1347,  1354,  1365,  1376,  1390,
    1401,  1417,  1418,  1419,  1420,  1421,  1422,  1426,  1427,  1428,
    1429,  1433,  1434,  1438,  1448,  1449,  1450,  1454,  1456,  1460,
    1460,  1461,  1461,  1461,  1464,  1465,  1469,  1477,  1530,  1531,
    1535,  1537,  1542,  1551,  1553,  1557,  1557,  1557,  1560,  1564,
    1568,  1577,  1606,  1644,  1645,  1650,  1661,  1662,  1666,  1667,
    1668,  1669,  1670,  1674,  1678,  1682,  1683,  1684,  1685,  1686,
    1690,  1691,  1692,  1693,  1697,  1698,  1702,  1703,  1704,  1705,
    1706,  1716,  1720,  1722,  1724,  1739,  1743,  1745,  1750,  1754,
    1766,  1767,  1771,  1772,  1776,  1777,  1781,  1782,  1786,  1790,
    1798,  1803,  1804,  1809,  1823,  1837,  1883,  1897,  1911,  1956,
    1969,  1982,  2006,  2008,  2012,  2030,  2031,  2036,  2037,  2042,
    2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,
    2053,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2068,
    2069,  2070,  2071,  2072,  2073,  2086,  2090,  2094,  2103,  2106,
    2107,  2108,  2114,  2118,  2119,  2120,  2125,  2131,  2139,  2147,
    2149,  2154,  2162,  2164,  2169,  2170,  2177,  2191,  2192,  2194,
    2205,  2226,  2227,  2231,  2232,  2237,  2241,  2249,  2251,  2256,
    2257,  2261,  2265,  2270,  2319,  2333,  2334,  2339,  2340,  2341,
    2342,  2346,  2347,  2351,  2352,  2358,  2359,  2360,  2361,  2364,
    2366,  2369,  2371,  2375,  2383,  2384,  2388,  2389,  2393,  2394,
    2398,  2400,  2406,  2412,  2418,  2424,  2430,  2439,  2445,  2450,
    2458,  2466,  2474,  2482,  2490,  2496,  2501,  2502,  2503,  2504,
    2508,  2509,  2510,  2514,  2517,  2522,  2523,  2524,  2529,  2530,
    2535,  2536,  2537,  2538,  2542,  2549,  2551,  2553,  2555,  2559,
    2561,  2563,  2568,  2569,  2573,  2575,  2581,  2582,  2583,  2584,
    2588,  2589,  2590,  2591,  2595,  2596,  2600,  2601,  2602,  2606,
    2607,  2611,  2625,  2639,  2644,  2655,  2662,  2674,  2675,  2680,
    2681,  2687,  2688,  2692,  2693,  2697,  2701,  2710,  2714,  2719,
    2724,  2733,  2734,  2738,  2739,  2740,  2741,  2743,  2748,  2749,
    2753,  2754,  2758,  2759,  2763,  2764,  2768,  2769,  2773,  2774,
    2779,  2788,  2830,  2838,  2849,  2850,  2852,  2854,  2859,  2860,
    2865,  2866,  2871,  2872,  2877,  2894,  2898,  2902,  2903,  2907,
    2908,  2909,  2913,  2914,  2919,  2924,  2932,  2933,  2939,  2941,
    2946,  2954,  2962,  2973,  2974,  2975,  2979,  2980,  2984,  2985,
    2986,  2990,  2991,  3011,  3015,  3025,  3026,  3030,  3042,  3047,
    3049,  3053,  3064,  3075,  3106,  3107,  3112,  3116,  3125,  3134,
    3142,  3143,  3147,  3148,  3149,  3154,  3155,  3157,  3162,  3166,
    3176,  3177,  3181,  3182,  3187,  3191,  3197,  3203,  3213,  3225,
    3230,  3234,  3233,  3246,  3251,  3256,  3261,  3269,  3270,  3274,
    3275,  3279,  3281,  3287,  3288,  3293,  3298,  3302,  3307,  3311,
    3312,  3317,  3318,  3322,  3326,  3327,  3331,  3335,  3336,  3340,
    3344,  3348,  3349,  3354,  3363,  3364,  3365,  3369,  3370,  3371,
    3372,  3373,  3374,  3375,  3376,  3377,  3381,  3398,  3402,  3409,
    3419,  3426,  3436,  3437,  3438,  3442,  3449,  3456,  3463,  3473,
    3477,  3493,  3494,  3498,  3504,  3510,  3515,  3523,  3525,  3530,
    3538,  3548,  3549,  3550,  3554,  3558,  3559,  3563,  3567,  3577,
    3578,  3580,  3585,  3586,  3588,  3594,  3595,  3602,  3609,  3616,
    3623,  3630,  3637,  3644,  3651,  3658,  3665,  3672,  3678,  3685,
    3692,  3699,  3706,  3713,  3720,  3727,  3733,  3740,  3747,  3754,
    3761,  3763,  3785,  3789,  3790,  3794,  3795,  3797,  3799,  3800,
    3801,  3802,  3803,  3804,  3805,  3806,  3807,  3808,  3809,  3810,
    3811,  3815,  3885,  3891,  3892,  3896,  3901,  3902,  3907,  3908,
    3913,  3914,  3919,  3920,  3924,  3925,  3929,  3930,  3931,  3935,
    3939,  3944,  3945,  3946,  3950,  3954,  3955,  3956,  3957,  3958,
    3962,  3966,  3970,  3998,  3999,  4004,  4005,  4006,  4007,  4011,
    4018,  4023,  4028,  4033,  4038,  4046,  4047,  4051,  4061,  4071,
    4078,  4085,  4092,  4099,  4112,  4113,  4118,  4123,  4128,  4133,
    4141,  4142,  4146,  4168,  4169,  4174,  4175,  4180,  4181,  4187,
    4193,  4199,  4205,  4211,  4217,  4224,  4228,  4229,  4230,  4234,
    4235,  4246,  4248,  4252,  4254,  4258,  4259,  4265,  4274,  4275,
    4276,  4277,  4278,  4282,  4283,  4287,  4293,  4296,  4302,  4305,
    4311,  4314,  4319,  4339,  4340,  4341,  4345,  4351,  4415,  4446,
    4509,  4548,  4565,  4581,  4597,  4613,  4614,  4631,  4648,  4665,
    4686,  4690,  4697,  4742,  4743,  4747,  4758,  4761,  4765,  4773,
    4779,  4787,  4791,  4796,  4798,  4804,  4812,  4814,  4819,  4823,
    4829,  4837,  4839,  4844,  4852,  4854,  4859,  4860,  4864,  4869,
    4880,  4891,  4901,  4911,  4913,  4918,  4919,  4921,  4923,  4932,
    4933,  4942,  4943,  4944,  4945,  4946,  4948,  4949,  4962,  4980,
    4981,  4995,  5015,  5016,  5017,  5018,  5019,  5020,  5021,  5023,
    5024,  5026,  5038,  5052,  5066,  5073,  5088,  5103,  5110,  5136,
    5153,  5173,  5188,  5189,  5193,  5194,  5195,  5198,  5199,  5202,
    5204,  5207,  5208,  5209,  5210,  5211,  5212,  5216,  5217,  5218,
    5219,  5220,  5221,  5222,  5223,  5227,  5228,  5229,  5230,  5231,
    5232,  5233,  5234,  5235,  5236,  5237,  5238,  5239,  5241,  5242,
    5243,  5244,  5245,  5246,  5247,  5248,  5249,  5250,  5251,  5252,
    5253,  5254,  5256,  5257,  5258,  5259,  5260,  5261,  5262,  5263,
    5264,  5265,  5266,  5267,  5268,  5269,  5270,  5272,  5273,  5274,
    5275,  5276,  5277,  5278,  5279,  5280,  5281,  5283,  5284,  5285,
    5286,  5287,  5288,  5289,  5290,  5291,  5292,  5293,  5294,  5295,
    5296,  5297,  5298,  5299,  5300,  5301,  5302,  5303,  5304,  5305,
    5306,  5310,  5311,  5316,  5339,  5360,  5392,  5394,  5402,  5409,
    5414,  5429,  5430,  5434,  5437,  5440,  5444,  5446,  5451,  5455,
    5456,  5457,  5458,  5459,  5460,  5461,  5462,  5463,  5464,  5468,
    5476,  5484,  5491,  5505,  5506,  5510,  5514,  5518,  5522,  5526,
    5530,  5537,  5541,  5545,  5546,  5556,  5564,  5565,  5569,  5573,
    5577,  5584,  5586,  5591,  5595,  5596,  5600,  5601,  5602,  5603,
    5604,  5608,  5621,  5622,  5626,  5628,  5633,  5639,  5643,  5644,
    5648,  5653,  5662,  5663,  5667,  5678,  5682,  5683,  5688,  5698,
    5701,  5703,  5707,  5711,  5712,  5716,  5717,  5721,  5725,  5728,
    5730,  5734,  5735,  5739,  5747,  5756,  5757,  5761,  5762,  5766,
    5767,  5768,  5783,  5787,  5788,  5798,  5799,  5803,  5807,  5811,
    5821,  5825,  5828,  5830,  5834,  5835,  5838,  5840,  5844,  5849,
    5850,  5854,  5855,  5859,  5863,  5866,  5868,  5872,  5876,  5880,
    5883,  5885,  5889,  5890,  5894,  5896,  5900,  5904,  5905,  5909,
    5913,  5917
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "STRING", "IDENT",
  "aTYPE", "ALIAS", "AGGR", "AGGR2", "RANK", "sqlINT", "OIDNUM",
  "HEXADECIMAL", "INTNUM", "APPROXNUM", "USING", "GLOBAL", "CAST",
  "CONVERT", "CHARACTER", "VARYING", "LARGE", "OBJECT", "VARCHAR", "CLOB",
  "sqlTEXT", "BINARY", "sqlBLOB", "sqlDECIMAL", "sqlFLOAT", "TINYINT",
  "SMALLINT", "BIGINT", "HUGEINT", "sqlINTEGER", "sqlDOUBLE", "sqlREAL",
  "PRECISION", "PARTIAL", "SIMPLE", "ACTION", "CASCADE", "RESTRICT",
  "BOOL_FALSE", "BOOL_TRUE", "CURRENT_DATE", "CURRENT_TIMESTAMP",
  "CURRENT_TIME", "LOCALTIMESTAMP", "LOCALTIME", "LEX_ERROR", "GEOMETRY",
  "GEOMETRYSUBTYPE", "GEOMETRYA", "USER", "CURRENT_USER", "SESSION_USER",
  "LOCAL", "LOCKED", "BEST", "EFFORT", "CURRENT_ROLE", "sqlSESSION",
  "sqlDELETE", "UPDATE", "SELECT", "INSERT", "LATERAL", "LEFT", "RIGHT",
  "FULL", "OUTER", "NATURAL", "CROSS", "JOIN", "INNER", "COMMIT",
  "ROLLBACK", "SAVEPOINT", "RELEASE", "WORK", "CHAIN", "NO", "PRESERVE",
  "ROWS", "START", "TRANSACTION", "READ", "WRITE", "ONLY", "ISOLATION",
  "LEVEL", "UNCOMMITTED", "COMMITTED", "sqlREPEATABLE", "SERIALIZABLE",
  "DIAGNOSTICS", "sqlSIZE", "STORAGE", "ASYMMETRIC", "SYMMETRIC", "ORDER",
  "ORDERED", "BY", "IMPRINTS", "EXISTS", "ESCAPE", "HAVING", "sqlGROUP",
  "sqlNULL", "FROM", "FOR", "MATCH", "EXTRACT", "SEQUENCE", "INCREMENT",
  "RESTART", "MAXVALUE", "MINVALUE", "CYCLE", "NOMAXVALUE", "NOMINVALUE",
  "NOCYCLE", "NEXT", "VALUE", "CACHE", "GENERATED", "ALWAYS", "IDENTITY",
  "SERIAL", "BIGSERIAL", "AUTO_INCREMENT", "SCOLON", "AT", "XMLCOMMENT",
  "XMLCONCAT", "XMLDOCUMENT", "XMLELEMENT", "XMLATTRIBUTES", "XMLFOREST",
  "XMLPARSE", "STRIP", "WHITESPACE", "XMLPI", "XMLQUERY", "PASSING",
  "XMLTEXT", "NIL", "REF", "ABSENT", "EMPTY", "DOCUMENT", "ELEMENT",
  "CONTENT", "XMLNAMESPACES", "NAMESPACE", "XMLVALIDATE", "RETURNING",
  "LOCATION", "ID", "ACCORDING", "XMLSCHEMA", "URI", "XMLAGG", "FILTER",
  "UNION", "EXCEPT", "INTERSECT", "CORRESPONDING", "UNIONJOIN", "DATA",
  "'('", "')'", "FILTER_FUNC", "NOT", "'='", "ALL", "ANY", "NOT_BETWEEN",
  "BETWEEN", "NOT_IN", "sqlIN", "NOT_LIKE", "LIKE", "NOT_ILIKE", "ILIKE",
  "OR", "SOME", "AND", "COMPARISON", "'+'", "'-'", "'&'", "'|'", "'^'",
  "LEFT_SHIFT", "RIGHT_SHIFT", "LEFT_SHIFT_ASSIGN", "RIGHT_SHIFT_ASSIGN",
  "CONCATSTRING", "SUBSTRING", "POSITION", "SPLIT_PART", "UMINUS", "'*'",
  "'/'", "'%'", "'~'", "GEOM_OVERLAP", "GEOM_OVERLAP_OR_ABOVE",
  "GEOM_OVERLAP_OR_BELOW", "GEOM_OVERLAP_OR_LEFT", "GEOM_OVERLAP_OR_RIGHT",
  "GEOM_BELOW", "GEOM_ABOVE", "GEOM_DIST", "GEOM_MBR_EQUAL", "TEMP",
  "TEMPORARY", "STREAM", "MERGE", "REMOTE", "REPLICA", "ASC", "DESC",
  "AUTHORIZATION", "CHECK", "CONSTRAINT", "CREATE", "TYPE", "PROCEDURE",
  "FUNCTION", "sqlLOADER", "AGGREGATE", "RETURNS", "EXTERNAL", "sqlNAME",
  "DECLARE", "CALL", "LANGUAGE", "ANALYZE", "MINMAX", "SQL_EXPLAIN",
  "SQL_PLAN", "SQL_DEBUG", "SQL_TRACE", "PREP", "PREPARE", "EXEC",
  "EXECUTE", "DEFAULT", "DISTINCT", "DROP", "FOREIGN", "RENAME",
  "ENCRYPTED", "UNENCRYPTED", "PASSWORD", "GRANT", "REVOKE", "ROLE",
  "ADMIN", "INTO", "IS", "KEY", "ON", "OPTION", "OPTIONS", "PATH",
  "PRIMARY", "PRIVILEGES", "PUBLIC", "REFERENCES", "SCHEMA", "SET",
  "AUTO_COMMIT", "RETURN", "ALTER", "ADD", "TABLE", "COLUMN", "TO",
  "UNIQUE", "VALUES", "VIEW", "WHERE", "WITH", "sqlDATE", "TIME",
  "TIMESTAMP", "INTERVAL", "YEAR", "MONTH", "DAY", "HOUR", "MINUTE",
  "SECOND", "ZONE", "LIMIT", "OFFSET", "SAMPLE", "CASE", "WHEN", "THEN",
  "ELSE", "NULLIF", "COALESCE", "IF", "ELSEIF", "WHILE", "DO", "ATOMIC",
  "BEGIN", "END", "COPY", "RECORDS", "DELIMITERS", "STDIN", "STDOUT",
  "FWF", "INDEX", "REPLACE", "AS", "TRIGGER", "OF", "BEFORE", "AFTER",
  "ROW", "STATEMENT", "sqlNEW", "OLD", "EACH", "REFERENCING", "OVER",
  "PARTITION", "CURRENT", "EXCLUDE", "FOLLOWING", "PRECEDING", "OTHERS",
  "TIES", "RANGE", "UNBOUNDED", "X_BODY", "','", "'.'", "':'", "'['",
  "']'", "'?'", "$accept", "sqlstmt", "$@1", "$@2", "$@3", "$@4", "$@5",
  "prepare", "execute", "create", "create_or_replace", "if_exists",
  "if_not_exists", "drop", "set", "declare", "sql", "opt_minmax",
  "declare_statement", "variable_list", "set_statement", "schema",
  "schema_name_clause", "authorization_identifier",
  "opt_schema_default_char_set", "opt_schema_element_list",
  "schema_element_list", "schema_element", "opt_grantor", "grantor",
  "grant", "authid_list", "opt_with_grant", "opt_with_admin",
  "opt_from_grantor", "revoke", "opt_grant_for", "opt_admin_for",
  "privileges", "global_privileges", "global_privilege", "object_name",
  "object_privileges", "operation_commalist", "operation",
  "grantee_commalist", "grantee", "alter_statement", "passwd_schema",
  "alter_table_element", "drop_table_element", "opt_column",
  "create_statement", "seq_def", "opt_seq_params", "opt_alt_seq_params",
  "opt_seq_param", "opt_alt_seq_param", "opt_seq_common_param",
  "index_def", "opt_index_type", "role_def", "opt_encrypted",
  "table_opt_storage", "table_def", "opt_temp", "opt_on_commit",
  "table_content_source", "as_subquery_clause", "with_or_without_data",
  "table_element_list", "add_table_element", "table_element",
  "serial_or_bigserial", "column_def", "opt_column_def_opt_list",
  "column_def_opt_list", "column_options", "column_option_list",
  "column_option", "default", "default_value", "column_constraint",
  "generated_column", "serial_opt_params", "table_constraint",
  "opt_constraint_name", "ref_action", "ref_on_update", "ref_on_delete",
  "opt_ref_action", "opt_match_type", "opt_match",
  "column_constraint_type", "table_constraint_type",
  "domain_constraint_type", "ident_commalist", "like_table", "view_def",
  "query_expression_def", "query_expression", "opt_with_check_option",
  "opt_column_list", "column_commalist_parens", "type_def",
  "external_function_name", "function_body", "func_def", "routine_body",
  "procedure_statement_list", "trigger_procedure_statement_list",
  "procedure_statement", "trigger_procedure_statement",
  "control_statement", "call_statement", "call_procedure_statement",
  "routine_invocation", "routine_name", "argument_list",
  "return_statement", "return_value", "case_statement", "when_statement",
  "when_statements", "when_search_statement", "when_search_statements",
  "case_opt_else_statement", "if_statement", "if_opt_else",
  "while_statement", "opt_begin_label", "opt_end_label",
  "table_function_column_list", "func_data_type", "opt_paramlist",
  "paramlist", "trigger_def", "trigger_action_time", "trigger_event",
  "opt_referencing_list", "old_or_new_values_alias_list",
  "old_or_new_values_alias", "opt_as", "opt_row", "triggered_action",
  "opt_for_each", "row_or_statement", "opt_when", "triggered_statement",
  "routine_designator", "drop_statement", "opt_typelist", "typelist",
  "drop_action", "update_statement", "transaction_statement",
  "_transaction_stmt", "transaction_mode_list", "_transaction_mode_list",
  "transaction_mode", "iso_level", "opt_work", "opt_chain",
  "opt_to_savepoint", "copyfrom_stmt", "opt_fwf_widths", "fwf_widthlist",
  "opt_header_list", "header_list", "header", "opt_seps", "opt_using",
  "opt_nr", "opt_null_string", "opt_locked", "opt_best_effort",
  "opt_constraint", "string_commalist", "string_commalist_contents",
  "delete_stmt", "update_stmt", "insert_stmt", "values_or_query_spec",
  "row_commalist", "atom_commalist", "value_commalist", "null",
  "simple_atom", "insert_atom", "value", "opt_distinct",
  "assignment_commalist", "assignment", "opt_where_clause", "joined_table",
  "join_type", "opt_outer", "outer_join_type", "join_spec", "with_query",
  "with_list", "with_list_element", "with_query_expression",
  "simple_select", "select_statement_single_row",
  "select_no_parens_orderby", "select_target_list", "target_specification",
  "select_no_parens", "set_distinct", "opt_corresponding", "selection",
  "table_exp", "opt_from_clause", "table_ref_commalist", "table_ref",
  "$@6", "table_name", "opt_table_name", "opt_group_by_clause",
  "column_ref_commalist", "opt_having_clause", "search_condition",
  "and_exp", "opt_order_by_clause", "opt_limit", "opt_offset",
  "opt_sample", "sort_specification_list", "ordering_spec", "opt_asc_desc",
  "predicate", "pred_exp", "comparison_predicate", "between_predicate",
  "opt_bounds", "like_predicate", "like_exp", "test_for_null",
  "in_predicate", "pred_exp_list", "all_or_any_predicate", "any_all_some",
  "existence_test", "filter_arg_list", "filter_args", "filter_exp",
  "subquery_with_orderby", "subquery", "simple_scalar_exp", "scalar_exp",
  "value_exp", "param", "window_function", "window_function_type",
  "window_specification", "window_partition_clause", "window_order_clause",
  "window_frame_clause", "window_frame_units", "window_frame_extent",
  "window_frame_start", "window_frame_preceding", "window_frame_between",
  "window_frame_end", "window_frame_following", "window_frame_exclusion",
  "var_ref", "func_ref", "qfunc", "func_ident", "datetime_funcs",
  "opt_brackets", "string_funcs", "column_exp_commalist", "column_exp",
  "opt_alias_name", "atom", "qrank", "qaggr", "qaggr2", "aggr_ref",
  "opt_sign", "tz", "time_precision", "timestamp_precision",
  "datetime_type", "non_second_datetime_field", "datetime_field",
  "start_field", "end_field", "single_datetime_field",
  "interval_qualifier", "interval_type", "user", "literal",
  "interval_expression", "qname", "column_ref", "cast_exp", "cast_value",
  "case_exp", "scalar_exp_list", "case_scalar_exp_list", "when_value",
  "when_value_list", "when_search", "when_search_list", "case_opt_else",
  "case_scalar_exp", "nonzero", "nonzerolng", "poslng", "posint",
  "data_type", "subgeometry_type", "type_alias", "varchar", "clob", "blob",
  "column", "authid", "restricted_ident", "ident", "non_reserved_word",
  "name_commalist", "lngval", "intval", "string", "exec", "exec_ref",
  "opt_path_specification", "path_specification", "schema_name_list",
  "XML_value_expression", "XML_value_expression_list", "XML_primary",
  "XML_value_function", "XML_comment", "XML_concatenation", "XML_document",
  "XML_element",
  "opt_comma_XML_namespace_declaration_attributes_element_content",
  "XML_element_name", "XML_attributes", "XML_attribute_list",
  "XML_attribute", "opt_XML_attribute_name", "XML_attribute_value",
  "XML_attribute_name", "XML_element_content_and_option",
  "XML_element_content_list", "XML_element_content",
  "opt_XML_content_option", "XML_content_option", "XML_forest",
  "opt_XML_namespace_declaration_and_comma", "forest_element_list",
  "forest_element", "forest_element_value", "opt_forest_element_name",
  "forest_element_name", "XML_parse", "XML_whitespace_option", "XML_PI",
  "XML_PI_target", "opt_comma_string_value_expression", "XML_query",
  "XQuery_expression", "opt_XML_query_argument_list",
  "XML_query_default_passing_mechanism", "XML_query_argument_list",
  "XML_query_argument", "XML_query_context_item", "XML_query_variable",
  "opt_XML_query_returning_mechanism", "XML_query_empty_handling_option",
  "XML_text", "XML_validate", "document_or_content_or_sequence",
  "document_or_content", "opt_XML_returning_clause",
  "XML_namespace_declaration", "XML_namespace_declaration_item_list",
  "XML_namespace_declaration_item", "XML_namespace_prefix",
  "XML_namespace_URI", "XML_regular_namespace_declaration_item",
  "XML_default_namespace_declaration_item", "opt_XML_passing_mechanism",
  "XML_passing_mechanism", "opt_XML_valid_according_to_clause",
  "XML_valid_according_to_clause", "XML_valid_according_to_what",
  "XML_valid_according_to_URI", "XML_valid_target_namespace_URI",
  "XML_URI", "opt_XML_valid_schema_location",
  "XML_valid_schema_location_URI", "XML_valid_according_to_identifier",
  "registered_XML_Schema_name", "opt_XML_valid_element_clause",
  "XML_valid_element_clause", "opt_XML_valid_element_name_specification",
  "XML_valid_element_name_specification",
  "XML_valid_element_namespace_specification",
  "XML_valid_element_namespace_URI", "XML_valid_element_name",
  "XML_aggregate", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    40,    41,   426,   427,    61,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
      43,    45,    38,   124,    94,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    42,    47,    37,   126,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,    44,    46,    58,    91,    93,    63
};
#endif

#define YYPACT_NINF (-1788)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1103)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   16444,   332, -1788,    59, 15735,   -54,   -70,   394,   394, 15735,
     417,   440, -1788,    80,   347, -1788, 13383, 15735, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788,   790,   167,   779,
     131, 15735,   265,   536, -1788,   986,  1363,   804,   694, 11913,
   11619,   413, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788,   711,   450, -1788,
   15735, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788,   330,   321, -1788, -1788, -1788,  3857,
   15735, -1788,   501,   501, -1788, 15735,   817,   -54,   997,   379,
   -1788, -1788, -1788, -1788,   558, -1788,   436,   579,  2754,  2754,
   16444, 16444, -1788, -1788, -1788, -1788, -1788, -1788, -1788,   579,
     579, -1788,   468,   579,   319, -1788,  -128,   511, -1788,   493,
     594,   538, -1788, -1788, -1788,   600,   624,   614,  1206,   807,
     817, 14559, 15735, 15735,    -8, -1788,   579, -1788,    61,   641,
     908,   668, -1788,    60, -1788, -1788,  -145, -1788, -1788,  2754,
   -1788, -1788,   767, -1788,   -60, 15735,   826, -1788, -1788, 15735,
   -1788, -1788,   676,   691,   704,   709, 15735, 15735,   684,   684,
   -1788, 15735, 15735,   678, -1788, -1788,   730, -1788,   795, 15735,
   15735, 15735, 15735, 15735, 15735,   798,   863, 15735, 15735, 15735,
   15735, 15735, 15735,   726,   726,   726, 15735, 15735,  1153, -1788,
   -1788, -1788,   815, 15735, 15735, 15735,   761,   888,   900,   916,
     823,   832,   687,   801, -1788,  1125, -1788, -1788,  1002,   225,
     225,   225,   867, -1788,   894, 14853, 15735,  1185,  1185,  1185,
    1199,  1037,  1058,  1060, -1788, -1788, -1788, -1788, -1788,  1063,
    1082,  1203, -1788, -1788, -1788,  1084,  1084,  1084,  1084,  1084,
   -1788,  1087, -1788,  1091,  1136, 15735,  1095,  1103,  1105,  1115,
    1157,  1164,  1166,  1175,  1177,  1179,  1186,  2158,  4204,  8526,
    8526,  1189,  1190,  1192, -1788,  8526,  1185,   100,   107,   105,
    6570,  1193,  1195,  4204, -1788, -1788,   421,   -84,  1168, -1788,
     958, -1788, -1788, -1788, -1788, -1788, -1788, -1788, 15735, -1788,
   -1788, -1788, 10666, -1788, -1788, -1788,   991, -1788,  1022, -1788,
   -1788,  1026, -1788, -1788,  1201,  1204,  1207,  1041, -1788, -1788,
   -1788, -1788, -1788, -1788,  1185,  1185,   -51, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
     325,  1119, -1788,  1096, -1788,  1117,  1295,  1290, -1788,  1045,
   -1788,  3857, -1788, -1788,  6896, 13383,  1098, -1788,  1268,  1275,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,    92,  1206,
      92,  1094, 12207,   712,  1298,  1299,  1301,   -15,   817, -1788,
     965,  -108,   885,   642, 15735, -1788, -1788,  1097,  1244,   856,
   15735, -1788,    42,  1159, 15735,   908,  1128,  1286,  4898, -1788,
   -1788,  1144, -1788, -1788,   643,   684,   684,   684,   684,  1197,
    1150,  1271, 16029, 15735,   579,   897, 15735,   684, 15735,  1276,
    1277,  1278,  1279, -1788, -1788, 15735,  1225, 15735, 15735, 15735,
   15735,  1153,  1287,  1287,  1287,  1287, -1788,  1354, 15735, 15735,
   15735, -1788, -1788, -1788, -1788, -1788, 15735,    67, -1788, -1788,
      37,  1087, 15735,  4204, 15735,  1289,  1293, -1788,   498, -1788,
   -1788, -1788,  1302,  1303, -1788, -1788, -1788, -1788, -1788,  1429,
   -1788,  1304, -1788, -1788, -1788,  1305,  1307,   988, 15735, -1788,
   -1788, -1788,  1308,  1310,  1311,  1313,  8526, -1788, -1788,  1318,
    1318,  1318,    39,  1171,  4204, -1788,  1297,    11, -1788,  1312,
   -1788,  1143, -1788, -1788, -1788,  4204,  4204,  1467,  1319, -1788,
   -1788, -1788, -1788, -1788,   376, -1788,  1089,  1379, -1788,  8526,
    8526,  8526,  1256,  1340,   931,  1259,  1495,  8526,   778,  8526,
    2158,  1328,  1329,  1015,   573,   934,    82, -1788,   -42,   958,
    2158,  1100,  1100,  8526,  8526,  8526,  1321, -1788,   986,  1214,
     986,  1214, -1788, -1788,  1185,  4204, 10046, -1788,   783,  8526,
    8526,   958,   481,  8830, 15735, -1788,   894,  4204, 15735, -1788,
    4204,  3163,  1137,  1137,  1332,  1334,  8526,  8526,  8526,  8526,
    3163,  1160,  8526,  8526,  8526,  8526,  8526,  8526,  8526,  8526,
    8526,  8526,  8526,  8526,  8526,  8526,  8526,  8526,  8526,  8526,
    8526,  8526,  8526,  8526,  8526,  8526,   567,  1335,  1309,  3857,
    1336,  5224,  8526, -1788, -1788, 12501, 13971,  1226,  1328, -1788,
     337, -1788, -1788,  1430,  1434, -1788, -1788, -1788,   877,   986,
     817,  1404, -1788, -1788, 12488,   222, -1788, -1788,    68,  1274,
   -1788, -1788, -1788,  -138, -1788, -1788, -1788,   235, -1788,   798,
   15735, -1788, -1788, -1788, -1788, -1788, -1788,    92,    92, -1788,
   -1788, -1788,  1260,  1235,  1246,   965, -1788,  1417,  1237,   908,
     908, -1788, -1788, -1788, -1788,   908,  2599,   885, -1788, -1788,
     589,    81,  1241,   959, -1788,  1356, -1788,  1418,    45,    45,
   15735,   579,  1223,   908, -1788,  2158, -1788,   266, -1788, -1788,
     955,   965,  1253,  2599,   643, -1788, -1788, 15735, 15735, 15735,
   15735,  1314,  1280, -1788,  1441, 15735,  1315,  1322,    13,  1229,
   -1788, -1788,   990,  1284, 15735,  1381, 15147, 15147, 15147, 15147,
    1287, 15735,  1153,  1153,  1153,  1153, -1788,  1805, -1788, -1788,
   -1788, -1788, -1788,  1153,  1153,  1153, -1788, -1788, -1788,  1053,
   -1788, -1788, -1788,  1382,  1125,   986,   986, -1788,  1542,   986,
     986,   986, -1788,   477,  1214,  1214, -1788, -1788, -1788, -1788,
   -1788,  1307,  1305,  1288, -1788, -1788, -1788,   986,   986,   986,
     986,  1228, -1788, 11606,  1468,    80,    80,    80, -1788, -1788,
   -1788,    39,  1098,  1382,  1087, 14853,   894,  4204, 15735,  1382,
    1248,  1231, -1788, -1788, -1788, -1788,  1466, 15735, 12488,   692,
   12488, -1788,   -46, -1788,  1421, 15735,  1408,  8526,  1243, -1788,
   -1788,  8526, 15735, -1788,  1443,   692, -1788,  8526, -1788,  1488,
    1018,  8526,   270, -1788, -1788, -1788,  1065,  4204, 13677,  1755,
   11900,  2908,  1419,  1316,  1185,  1425,  1185,   988,   -69,  8526,
   -1788,   830,  8526, -1788,  1285,  8818,  1249,   274,  4204, -1788,
   12795,  2634, -1788, -1788,  1255,   878, 16323, 16323, 16323,   -38,
      29, -1788, -1788,  1482,  1168, -1788,   958, -1788, -1788, -1788,
    1493,  4204, -1788, -1788,  4204,  4204,  7222,  7222, -1788, 10970,
   -1788, -1788, -1788, -1788,  1087, -1788, 12488,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1086,  1086,  1086,
    1321,   912,   912,   912,   912,  1469,  1469,  1469,  1469,  1469,
   -1788,  1492,  1269, -1788, -1788, -1788,  8526,  1433,  8526, 12488,
    1435,   -33,  1262,  1438,  1439,  1442, -1788,   -20, -1788,  1272,
   -1788, -1788, 15735,  1156,  1530, -1788, -1788, -1788, -1788, -1788,
    8526, -1788, -1788, -1788, -1788, -1788,  1357,    92,  1509,  1362,
    1509, -1788,    33,    33,  1185, 15735, 15735,  1367,   908,   371,
   -1788, -1788, -1788, -1788, -1788, 15735, 15735, -1788, -1788, 15735,
    1536,  1163, -1788, 15735, 15735, 15441,   418, -1788, 13383, -1788,
    1517,  1317,  1517,   579,  1518, -1788, -1788, -1788,  7222,  1370,
     908, -1788, -1788,  1458,  1458,  1458,  1458, 15735,   969, -1788,
   -1788, -1788,  1612,  1364, 15735,  1403, 14265,  1540, -1788,  1324,
      61, -1788,  1320, -1788,  1374, 15735,  1458, 15147, -1788,  1471,
    1306,  2599,  1477,  1491,  1496, -1788,  1153, -1788, -1788, -1788,
   -1788, -1788,  1498,  1341, -1788, -1788, -1788, -1788,  1507, -1788,
    1512, -1788,  1515,   282,  1516,  1345, -1788,   290, -1788, -1788,
   -1788, -1788,  1360,  1148,  1521,  1346,  1522,  1524,  1525,  8526,
   -1788, -1788, -1788,  1489, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788,  1382, -1788,  2599,  2599,  8526, -1788,   697,
    1526,  8526,  1527,  1529, -1788,  1359,  7548, 12488,  -161, -1788,
    1342, -1788,   647, -1788,  1361,  1562,  1421,  1532,  1546,  1421,
    1296,   293, -1788, -1788, -1788,  1541,  1543,  1544,   958,  8526,
    8526,  8526,  8526, -1788,  1410, -1788, -1788, -1788, -1788,  8526,
    9423, -1788,  1398, 12488, -1788,  8526,  8526, -1788,  8526,   958,
   16323, 16323,  2634,  1328,  1545,  1550,  1552,  1004,    80,  8830,
   -1788, -1788, -1788,  1129,  1639, -1788,  8830,  1642,  1647, 15735,
   -1788,  1554, -1788, -1788, -1788, 13383, 15735, -1788,  1624,  1621,
    1493,  1378,  1473,   297,   301,  1185, -1788, -1788,  1628,  1560,
    1632,  1563, -1788,  1564, -1788, 13089,  8526, 15735, -1788, -1788,
   -1788, -1788, -1788,  1486, -1788,   969, -1788,  1490, -1788, -1788,
   -1788,  1722, -1788, -1788,  1185, -1788, -1788, -1788,  1153,  1153,
    1153, -1788, -1788, -1788,  -110, -1788, 15735, -1788, -1788, -1788,
     564,  1715, -1788,  1432, -1788,  1185, -1788,  1645,    51, -1788,
    1185, -1788, -1788, -1788,  1494, -1788, -1788, -1788, -1788, -1788,
    1484, 15735,   734, -1788, -1788, 13383, 15735,   314, -1788, -1788,
   -1788, -1788,   252, 15735, -1788,    61,  1474, 15735, 15735,  1591,
    1499,  1598,  9435, 15735, -1788,  1537,  1534,  1547, -1788, -1788,
    2599, -1788, -1788, -1788, -1788,   986, -1788,   986, -1788,   986,
    1307, -1788, -1788, -1788,   986, -1788, -1788, -1788, -1788, 15735,
    1602,  1603, 12196, -1788, -1788, -1788, -1788, -1788, -1788,  5550,
    1421,  1513,  8526, 12488,   340, -1788,  1454, -1788, -1788,   752,
    8526,  1421, 15735, -1788,  1635,  1636,  1608,  8526,  1421,   608,
    8526, -1788,  1562, -1788,  1501,  1611, -1788,  1613, -1788,  8526,
    8526,  7222,  7222, 11283,  2371, 12784,  9111, -1788, -1788,  8526,
   -1788, 13372, -1788, -1788, -1788, -1788,   355, -1788, -1788, -1788,
     419,   878,  1710,  8830,   383,  8830, -1788, -1788,  1615, 15735,
      19, -1788, 15735,  4204, -1788,  4204,  4204, -1788, -1788, -1788,
   15735, -1788,  1684,     7, -1788, -1788,  1616,  1617, -1788, -1788,
   -1788, -1788,  1460,  1519, -1788, -1788, -1788,  1548,   559, -1788,
    1528,  1533,   579, -1788, -1788, -1788, -1788,   713, -1788,  1185,
    1447,   397,  1185,  1625,  1625,  1455, -1788,  1565,  1799, 15735,
   -1788,  1462, -1788,  1173,   522, -1788,   734, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, 14265,  1549,  1801,  1535,
    1581, -1788,  1464,  1480, 15735,  1737, -1788,  1579,   -54,   417,
     440,  1582, 13383,  3510,  7874,  4204,  1504, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788,  1510, -1788, -1788, -1788, -1788,  1476,  2599,
    2521,  1821,  2521, -1788,  1654, -1788,  1655,  1670, -1788,  1671,
     368, -1788,  1502, -1788, -1788, -1788,  1675, 12488,  1505, -1788,
     206, -1788,  1508,  1676, -1788, -1788, -1788,  7548, 15735,  1586,
    1588,  1589,  1590, -1788, -1788,  1687, -1788, -1788, -1788, -1788,
   -1788,   739,  1688, -1788, -1788,   -16,  1520, -1788, -1788, -1788,
     331, -1788,  1700, -1788, -1788, -1788,   391,   393,   398,  8526,
   -1788, -1788,  8526, -1788,  8526, -1788, -1788, -1788, 16323,  8830,
   -1788,   579,  4204, -1788,   383, 15735,   402,  1531,  1382,  1673,
    1673,  1531,  8526, -1788, -1788, -1788,  4551, -1788, -1788,  1606,
    1593, -1788,   447, -1788,  1759,  8526,   579,   579, -1788,  1742,
   -1788,  8526, -1788,   713, -1788, -1788, -1788, -1788,   743, -1788,
    1185,  1788,   405, 15735,    45,    45,  1185,  1185, -1788, -1788,
   15735, -1788, -1788,  1585,  1701, -1788,    53, -1788,  1607,   943,
    1763,   430,    69,  1641,  3857, 15735, -1788,  1707, -1788,  1711,
   -1788, -1788,  1382,  4204, -1788,   864, 10357,   291, -1788, 10679,
    4204, -1788, -1788,  1712,  9746, -1788,    49,   706, -1788, -1788,
   -1788, -1788, -1788, 15735, 15735,  8526,  8526,  8526, -1788,  8200,
   -1788, -1788, -1788, -1788,  1772,    58,  1775,  1776, -1788, -1788,
   15735, -1788, -1788,  8526,  1622,  1629,  1714,   375, -1788, -1788,
   -1788, 13666, 13960, 14259, -1788, -1788, -1788,  1382, -1788,   435,
   -1788,  1228,  5876,  1566,  1551,  1557,  1567, -1788, -1788, -1788,
    1185, 15735, -1788, -1788, -1788, -1788,  2806,  1618, -1788,  1576,
   -1788, -1788, -1788,  1790,  1731,  1643, 15735, -1788, -1788, -1788,
    1561,  1681, -1788, -1788,   445, -1788,  1906,  1517,  1517, -1788,
    1637, -1788,   356,  1743, -1788, -1788,   354,   494,   943, -1788,
    1584, -1788,  1620, -1788,  1833,  1835, -1788, 15735,  1662, -1788,
    1580,  8526,    79,   357, -1788, -1788,  1614,  8526, -1788,   889,
   -1788, 10679,  1794,   197, 15735,  1693,  1926, -1788, -1788, -1788,
   -1788,  1695,  1929, -1788,  1592, 12488,   449, -1788,  1619, -1788,
   -1788,  1594, -1788, -1788,  1781, -1788, -1788, -1788,  1562, -1788,
    1785,  1789, -1788,  1787, 15735,  1940,   705, -1788, -1788, -1788,
   -1788, -1788, -1788,  1756, -1788, -1788, -1788,    83, -1788, -1788,
   -1788, 15735,  1844, -1788,  4204, -1788,   579,  1185, -1788, -1788,
   15735, -1788,  1915,  1915, 15735,   470, -1788, -1788,  1432, -1788,
    1432,  1432,  1432, -1788,   961,  1803, 10983, -1788, -1788, -1788,
   15735,   475, 12488,  1804, -1788, 10057,  1674,  9734, -1788,  1666,
    9124,  1849,  1672, -1788,   479,  2599, 15735,    49, 15735,    49,
   -1788,  8526, 15735, -1788,  8526, -1788, -1788, -1788, -1788,  1825,
   -1788, -1788, -1788,  1825, -1788,  1829, 15735,  1940, -1788, -1788,
   -1788,  1834,  6223,  1648, -1788,  1664, -1788,   579,  1818,   652,
    1880, -1788, -1788, -1788,  1934,  1934, -1788, -1788,   356, 15735,
   15735, 15735, 15735, -1788, -1788, -1788,  4204,  1683, -1788, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
    8526, -1788, 10057,  1863, -1788, -1788,  1696, -1788,  4204,  1685,
    1686, -1788, 10368, -1788, 15735, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788,  1940, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788,  1669,  1663,  1677, -1788, -1788, -1788,
   -1788,  1880,   643, -1788, -1788,   657,  1736,  1946,  1788,  1788,
   -1788, -1788, -1788, -1788, -1788,   655, -1788, 12488, -1788, 10057,
   -1788, 10057,   385,  1702, -1788,  1698,  2599, -1788, -1788, -1788,
   -1788, -1788,  1736,   510, -1788, -1788, -1788, -1788,  1227,  1745,
    1747, -1788, -1788, -1788,  1689, -1788, 11294, -1788, -1788, 15735,
   -1788, -1788, -1788,    77,    77,  1950, -1788,  1951, -1788,  1846,
   -1788, -1788,  1886,  9124, -1788, -1788, -1788, -1788,  1979,   338,
   -1788, -1788,   908, -1788, -1788, -1788, -1788, -1788,   484, -1788,
   -1788,   908, -1788
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,    17,     0,     0,   509,     0,   445,   445,     0,
       0,     0,    15,     0,    22,    31,     0,     0,     7,     5,
       9,    11,    19,    18,    21,    20,    29,     0,    89,    30,
       0,     0,   473,     0,     3,     0,    23,     0,     0,     0,
       0,     0,    38,    39,    32,    33,    34,    37,    35,   147,
     146,   144,   145,    41,   148,    36,   419,   418,   424,   423,
     420,   422,   421,   533,   551,   539,   540,   589,     0,    16,
       0,   907,   908,   910,   911,   912,   913,   915,   917,   964,
     920,   928,   989,   951,   925,   966,   939,   950,   944,   923,
     988,   956,   945,   934,   935,   936,   932,   926,   942,   967,
     968,   969,   970,   971,   972,   973,   974,   975,   976,   977,
     978,   979,   980,   981,   982,   983,   943,   909,   985,   984,
     930,   924,   916,   949,   986,   987,   961,   937,   962,   963,
     957,   958,   959,   960,   933,   918,   922,   948,   946,   919,
     921,   938,   965,   941,   931,   952,   953,   954,   955,   927,
     990,   929,   947,   940,     0,   823,   914,   510,   511,     0,
       0,   444,   448,   448,   426,     0,   432,   509,     0,     0,
     738,   736,   737,   326,     0,   733,   735,   276,     0,     0,
       0,     0,   901,   902,   903,   904,   905,   906,   108,   276,
     276,   107,   103,   276,     0,   112,     0,     0,    93,    95,
       0,   104,   105,    79,   900,     0,     0,     0,     0,     0,
     432,     0,     0,     0,     0,   536,   276,   993,     0,     0,
       0,     0,   270,     0,   273,   272,     0,   851,     1,     0,
     995,   994,     0,   998,     0,     0,     0,   174,   175,     0,
     192,   191,     0,     0,     0,     0,     0,     0,    27,    27,
     173,     0,     0,     0,   141,   142,     0,   143,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    25,    25,    25,     0,     0,   415,   803,
     805,   804,   951,     0,   922,   938,   953,     0,     0,     0,
     985,   984,    27,    44,    45,     0,   266,     2,     0,   552,
     552,   552,   591,    13,   516,     0,     0,   996,   907,   908,
     910,   911,   912,   913,   809,   808,   807,   810,   811,     0,
       0,     0,   897,   820,   821,   745,   745,   745,   745,   745,
     687,     0,   504,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   756,     0,   952,   953,   954,   955,
       0,     0,     0,     0,   701,   700,   560,   760,   586,   617,
     588,   607,   608,   609,   610,   611,   612,   613,     0,   614,
     684,   683,   615,   655,   699,   688,     0,   690,   692,   694,
     695,   558,   754,   685,     0,     0,     0,   691,   686,   762,
     815,   689,   697,   696,     0,     0,   826,   806,   698,  1009,
    1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,   775,
     494,     0,   425,   449,   427,     0,     0,     0,   429,   433,
     434,     0,   550,    24,     0,     0,   597,   277,     0,     0,
      10,    12,   109,   110,   102,   111,    97,    98,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   432,   431,
     179,     0,     0,     0,     0,   534,   538,     0,     0,   589,
       0,   475,     0,     0,     0,     0,   474,     0,     0,   196,
     195,     0,   194,   193,     0,    27,    27,    27,    27,     0,
      73,     0,     0,     0,   276,     0,     0,    27,     0,     0,
       0,     0,     0,   407,   150,     0,     0,     0,     0,     0,
       0,   415,   410,   410,   410,   410,   406,     0,     0,     0,
       0,   408,   409,   417,   416,   398,     0,     0,    53,    51,
       0,     0,     0,     0,     0,   882,   877,   891,   853,   892,
     894,   895,   866,   869,   861,   862,   864,   865,   863,   872,
     874,   884,   888,   887,   785,   782,   784,     0,     0,   875,
     876,    46,   879,   854,   855,   859,     0,   553,   554,   555,
     555,   555,     0,   594,     0,   490,     0,   560,   512,     0,
     899,   824,   997,   819,   817,     0,     0,     0,     0,   740,
     742,   741,   744,   743,     0,   644,     0,     0,   730,     0,
       0,     0,     0,  1052,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   588,     0,   692,   826,   616,
       0,   680,   681,     0,     0,     0,   675,   812,     0,   780,
       0,   780,   776,   777,     0,     0,     0,   844,   846,     0,
       0,   645,     0,     0,     0,   541,   516,     0,     0,   759,
       0,     0,   622,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   818,   816,     0,     0,     0,     0,   497,
     494,   492,   446,     0,     0,   428,   437,   436,     0,     0,
       0,   560,   731,   836,   505,     0,   734,   735,     0,    42,
       8,     6,   115,    83,   113,   116,    80,    81,    96,   983,
     941,    94,   101,   100,   106,    90,    92,     0,     0,   430,
     181,   180,     0,     0,     0,   179,   124,     0,   160,     0,
       0,   170,   168,   166,   171,     0,     0,   151,   154,   163,
     140,     0,   140,   140,   535,     0,   271,     0,   467,   467,
       0,   276,     0,     0,     4,     0,   999,     0,   507,   502,
     508,   179,     0,     0,   149,   152,   158,     0,     0,     0,
       0,     0,     0,   177,     0,   930,    62,    58,   276,     0,
     365,   366,     0,     0,     0,     0,   361,   361,   361,   361,
     410,     0,   415,   415,   415,   415,   405,     0,   395,   392,
     396,   394,    26,   415,   415,   415,    50,   278,    54,   778,
      55,    49,    52,    48,     0,     0,     0,   893,     0,     0,
       0,     0,   873,     0,   780,   780,   788,   789,   790,   791,
     792,   784,   782,     0,   801,   802,   267,     0,     0,     0,
       0,   590,   601,   604,   556,     0,     0,     0,   593,   592,
     850,     0,   597,   517,     0,     0,   516,     0,     0,   831,
       0,     0,   898,   746,   794,   793,     0,     0,     0,   655,
    1008,  1006,  1089,  1005,  1089,     0,     0,     0,     0,  1087,
    1088,     0,     0,  1069,  1070,   655,  1086,     0,  1085,   589,
       0,     0,     0,   654,   652,   682,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     841,   846,     0,   845,     0,     0,     0,     0,     0,   647,
       0,     0,   571,   570,   561,   562,   569,   577,   577,   823,
     560,   544,   546,   579,   585,   761,   587,   643,   641,   642,
     619,     0,   623,   624,     0,     0,     0,     0,   625,   629,
     627,   626,   628,   618,     0,   648,   671,   656,   657,   662,
     672,   661,   676,   677,   678,   679,   752,   658,   659,   660,
     673,   663,   668,   666,   664,   665,   667,   669,   670,   674,
     632,     0,   706,   758,   755,   703,     0,     0,   933,   848,
       0,   826,     0,   911,   912,   913,   757,   827,   495,   496,
     493,   447,     0,     0,     0,   443,   438,   439,   435,   732,
       0,   599,   600,   598,    43,    40,     0,     0,    85,     0,
      85,    99,    85,    85,     0,     0,     0,     0,     0,     0,
     167,   165,   169,   159,   155,     0,     0,   139,   120,     0,
       0,     0,   119,     0,     0,   236,     0,   537,     0,   472,
     478,     0,   478,   276,     0,   476,   477,  1000,     0,     0,
       0,   156,   153,   276,   276,   276,   276,     0,     0,    28,
      59,    61,     0,  1001,     0,     0,   236,   182,   202,     0,
       0,   368,   369,   367,     0,     0,   276,   361,   360,     0,
     359,     0,     0,     0,     0,   393,   415,   402,   399,   403,
     401,   412,     0,   413,    57,   397,   404,    47,     0,   849,
       0,   896,     0,     0,     0,   849,   889,     0,   890,   786,
     787,   799,   798,     0,     0,   849,     0,     0,     0,     0,
     605,   606,   603,     0,   547,   548,   549,   596,   595,   543,
     515,   513,   491,   514,   825,     0,     0,     0,   693,     0,
       0,     0,     0,     0,  1031,  1023,     0,  1057,  1044,  1054,
    1058,  1053,   655,  1065,  1066,     0,  1089,     0,  1106,  1089,
     652,     0,   506,   500,   653,     0,     0,     0,   638,     0,
       0,     0,     0,   781,     0,   813,   783,   814,   822,     0,
       0,   842,     0,   847,   835,     0,     0,   833,     0,   646,
       0,   577,     0,     0,   570,     0,     0,   523,     0,     0,
     528,   529,   530,   523,     0,   524,     0,     0,   526,   929,
     567,   576,   578,   565,   564,     0,     0,   542,     0,   583,
     640,     0,     0,     0,     0,     0,   639,   631,     0,     0,
     708,     0,   769,     0,   773,     0,     0,     0,   450,   440,
     441,   442,   837,     0,   114,     0,    78,     0,    77,    87,
      88,     0,   125,   128,     0,   164,   162,   161,   415,   415,
     415,   122,   123,   121,     0,   118,     0,   117,   209,   210,
       0,     0,   453,   379,   456,     0,   455,     0,     0,   503,
       0,   157,   186,   187,     0,   188,   279,    75,    76,    74,
       0,     0,    64,  1002,    60,     0,     0,     0,   211,   207,
     212,   213,   899,     0,   184,     0,   274,     0,     0,     0,
     197,     0,   351,     0,   363,     0,     0,     0,   400,   411,
       0,   883,   878,   856,   867,     0,   870,     0,   885,     0,
     784,   796,   800,   880,     0,   857,   858,   860,   602,     0,
       0,     0,     0,  1091,  1090,  1019,  1007,  1020,  1021,     0,
    1089,   966,     0,  1098,     0,  1093,     0,  1095,  1096,     0,
       0,  1089,     0,  1056,     0,     0,     0,     0,  1089,     0,
       0,  1072,  1079,  1083,     0,     0,  1107,     0,   498,     0,
       0,     0,     0,     0,     0,     0,     0,   779,   843,     0,
     834,     0,   838,   839,   568,   566,     0,   518,   651,   649,
       0,   563,     0,     0,   523,     0,   527,   525,   574,     0,
     824,   545,     0,     0,   559,     0,     0,   633,   634,   630,
       0,   702,     0,   710,   772,   771,     0,     0,   828,    84,
      86,    82,     0,   127,   137,   138,   136,     0,     0,   237,
       0,     0,     0,   235,   214,   215,   217,   218,   380,     0,
     468,     0,     0,   461,   461,   486,   488,     0,     0,     0,
     991,  1004,  1003,    23,     0,    56,    65,    66,    68,    69,
      72,    70,    71,   185,   268,   201,   236,     0,     0,   204,
       0,   269,   370,   371,     0,     0,   190,     0,   509,   925,
     939,     0,     0,     0,     0,     0,   295,   307,   308,   301,
     302,   303,   306,   304,   290,   292,   309,   320,   319,   324,
     323,   322,   321,     0,   305,   300,   299,   310,     0,     0,
       0,     0,     0,   414,     0,   852,     0,     0,   797,     0,
       0,   581,   826,   829,   830,   739,     0,  1043,  1028,  1030,
    1044,  1041,  1024,     0,  1101,  1100,  1092,     0,     0,     0,
       0,     0,     0,  1045,  1055,     0,  1060,  1059,  1062,  1063,
    1061,   655,     0,  1105,  1104,   655,  1071,  1073,  1075,  1076,
       0,  1080,     0,  1084,  1131,   501,     0,     0,     0,     0,
     749,   750,     0,   751,     0,   840,   832,   650,     0,     0,
     519,     0,     0,   520,   523,     0,     0,   580,   584,   620,
     621,   707,     0,   712,   713,   705,     0,   770,   774,     0,
       0,   133,     0,   131,     0,     0,     0,     0,   262,     0,
     232,     0,   216,   219,   220,   225,   226,   227,     0,   479,
       0,   484,     0,     0,   467,   467,     0,     0,   189,    63,
       0,    67,   208,   899,     0,   183,     0,   203,     0,     0,
     384,     0,     0,     0,     0,     0,   325,     0,   328,   941,
     333,   332,   334,     0,   342,   344,     0,     0,   295,   351,
       0,   352,   362,     0,   351,   358,     0,     0,   868,   871,
     886,   881,   557,     0,     0,     0,     0,     0,  1040,     0,
    1022,  1094,  1097,  1099,     0,     0,     0,     0,  1051,  1064,
       0,  1077,  1103,     0,     0,     0,     0,     0,   499,   635,
     636,     0,     0,     0,   572,   522,   532,   531,   521,     0,
     575,   709,     0,     0,     0,   655,   725,   714,   717,   715,
       0,     0,   134,   135,   132,   130,   683,     0,   263,     0,
     228,   221,   257,     0,     0,     0,     0,   258,   230,   261,
     469,     0,   454,   487,     0,   463,   465,   478,   478,   489,
       0,   992,   236,     0,   206,   275,   381,   381,   372,   373,
       0,   364,   388,   172,     0,     0,   200,     0,     0,   289,
       0,   329,     0,     0,   295,   343,     0,     0,   339,   344,
     295,   351,     0,     0,     0,     0,   949,   284,   281,   291,
     282,     0,     0,   582,   827,  1038,     0,  1033,  1036,  1029,
    1042,  1025,  1027,  1046,     0,  1049,  1048,  1047,  1102,  1074,
       0,     0,  1068,     0,     0,     0,  1120,  1109,  1110,   747,
     748,   753,   573,     0,   718,   716,   719,     0,   711,   126,
     129,     0,     0,   256,     0,   259,   276,     0,   485,   462,
       0,   466,   480,   480,     0,     0,   223,   205,   379,   382,
     379,   379,   379,   374,     0,     0,   351,   198,   199,   286,
       0,     0,   330,     0,   295,   345,     0,     0,   340,     0,
     347,     0,   296,   295,     0,     0,     0,     0,     0,     0,
    1032,     0,     0,  1035,     0,  1050,  1078,  1081,  1082,  1115,
    1119,  1118,  1114,  1115,  1113,     0,     0,     0,  1108,  1121,
    1122,  1124,     0,     0,   727,     0,   728,   276,   233,     0,
     254,   470,   464,   481,   482,   482,   178,   222,   236,     0,
       0,     0,     0,   386,   387,   385,     0,     0,   315,   316,
     313,   314,   390,   317,   383,   312,   311,   318,   280,   327,
       0,   335,   341,     0,   337,   295,     0,   295,     0,     0,
     296,   293,   351,   357,     0,   355,   283,   285,   287,   288,
    1034,  1039,  1037,  1026,     0,  1112,  1111,  1127,  1130,  1126,
    1129,  1128,  1123,  1125,     0,     0,   655,   720,   722,   729,
     726,   254,     0,   231,   265,   250,   245,     0,   484,   484,
     224,   378,   376,   377,   375,     0,   297,   331,   296,   338,
     336,   348,     0,     0,   294,     0,     0,  1117,  1116,   723,
     721,   724,   245,     0,   252,   253,   251,   255,     0,   246,
     247,   260,   483,   452,   457,   389,   351,   295,   346,   353,
     356,   264,   234,     0,     0,     0,   249,     0,   248,     0,
     451,   391,     0,   347,   350,   354,   239,   240,     0,     0,
     244,   243,     0,   298,   349,   238,   241,   242,     0,   459,
     458,     0,   460
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1788,  1139, -1788, -1788, -1788, -1788, -1788, -1788,    26, -1197,
   -1788,  1052,    72,  -935, -1788, -1788,   496, -1788,    15, -1788,
      20,   420, -1788,   926, -1788, -1788, -1788,   525, -1788,   747,
       1,  1815, -1788, -1788,    57,     8, -1788, -1788,  1817, -1788,
    1574, -1788, -1788, -1788,  1573,  -362,   992,    47, -1788, -1788,
   -1788,   569,   104, -1788,     5, -1788,  -768,  1273,  -395, -1788,
   -1788, -1788,  -621, -1788,  1988, -1788, -1788,  -109, -1788, -1788,
   -1788,   966,   526, -1788, -1788, -1788, -1788, -1788, -1788, -1563,
   -1788,   382, -1788, -1788, -1788, -1788, -1021,   -40,   -24,   -21,
     -13, -1788,    21, -1788, -1788, -1788,   -34, -1788, -1788,  -200,
    -413, -1788,  -168,   -35, -1788, -1370,  -811, -1788,   336, -1474,
   -1788, -1296,   -25, -1780, -1788,   591, -1788, -1788, -1788, -1788,
   -1788, -1788,   224, -1788,   352, -1788,   229, -1788,   -32, -1788,
   -1788, -1788, -1788,   497,  -725, -1788, -1788, -1788, -1788, -1788,
   -1788,   255,  -842,   253, -1788, -1788, -1788, -1788, -1788,  1604,
     112,  -441,   707,  -380,    24,    32, -1788,  -121, -1788,  1348,
   -1788,  2047,  1896, -1788, -1788, -1788, -1788,   576, -1788,   181,
    -743, -1788, -1788, -1044,   180,   109,  -688,   585,   590, -1788,
   -1788, -1788,  1371,  -656,   663,  -902, -1788,  -321,   666,   998,
    -156, -1788,  1202,  -531,  -880,   845, -1788, -1788,   456,   137,
   -1788,  1623, -1788, -1788,    40,   130, -1788,   836,   114,  1044,
     784,  -414,  1133,  1511, -1788,  -620, -1788,  -916,  -878, -1788,
    -951, -1788,  -297,  1444,  1180, -1788, -1788,  1224,   465,   951,
   -1788, -1788,  -271, -1788, -1788,  1452, -1788,   513, -1788, -1788,
   -1788, -1788,  1472, -1788, -1788,  1470, -1788,  1368,  -269,  -632,
    1445,  -566,  -504, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788,   386, -1788, -1788, -1788, -1788, -1788, -1788,    18, -1788,
    -398, -1788,   740, -1788, -1788,  1446, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788,  -172,  -496,  -517, -1788,  -565, -1788, -1788,
   -1788, -1788,  1212, -1788,  2095, -1788,  1610,   145, -1314, -1788,
    1555, -1788, -1788, -1788,  1211, -1788,  1506, -1788,  1215,  -654,
     565,  -670,  -201, -1788,  -281, -1788,  -293, -1788, -1788,  -285,
    -302,    44, -1788,    -4, -1788, -1325,  -509,    -6,    63, -1788,
   -1788, -1788, -1788, -1788,  -558, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788, -1788, -1788,   424, -1788,   226, -1788, -1788, -1788,
   -1610, -1788,   428,   578, -1788, -1788, -1788, -1788,   759, -1788,
   -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
   -1788, -1788,   422, -1788, -1788, -1788, -1788, -1788, -1788, -1788,
    1569,  -836,   771, -1788,   574, -1788,   770, -1788, -1788,   305,
   -1078, -1788, -1788, -1788, -1788, -1788, -1787,   221, -1788, -1788,
   -1788, -1788, -1788, -1788,   215, -1788, -1788, -1788, -1788
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    33,   229,   179,   178,   180,   181,    34,    35,    36,
      37,   518,   493,    38,    39,    40,    41,  1035,  1527,   293,
    1528,  1529,   796,  1090,  1093,  1495,  1496,  1497,   793,  1319,
    1530,   196,  1040,  1038,  1276,  1531,   207,   208,   197,   198,
     199,   731,   200,   201,   202,   723,   724,  1532,   746,  1062,
    1058,  1059,  1533,    49,   784,   757,   785,   758,   786,    50,
     253,   254,   742,  1334,   255,   256,  1516,  1097,  1098,  1677,
    1327,  1328,  1329,  1476,  1298,  1652,  1653,  1330,  1885,  1654,
    1655,  1765,  1656,  1657,  2023,  1299,  1658,  2090,  2059,  2060,
    2061,  2057,  2026,  1778,  1473,  1779,   527,  1331,   257,   221,
     222,  1511,  1099,   437,    51,  1809,  1829,    52,  1534,  1699,
    2066,  1983,  1972,  1536,  1537,  1538,  1686,  1687,  1901,  1539,
    1691,  1540,  1818,  1819,  1694,  1695,  1816,  1541,  1989,  1542,
    1543,  2084,  1914,  1704,  1109,  1110,    54,   802,  1104,  1680,
    1798,  1799,  1479,  1890,  1801,  1802,  1965,  1896,  1974,   278,
    1544,   818,  1122,   525,  1545,  1546,    58,   428,   429,   430,
    1026,   162,   422,   705,    59,  2080,  2098,  1664,  1784,  1785,
    1070,  1071,   223,  1304,  1954,  2028,  1782,  1484,  1485,    60,
      61,    62,   701,   912,  1191,   777,   365,   778,  1193,   779,
     159,   577,   578,   575,   943,  1237,  1437,  1238,  1623,   224,
     214,   215,   465,    64,  1547,   225,   950,   951,    67,   569,
     865,   366,   645,   646,   944,  1227,  1228,  1242,  1243,  1249,
    1560,  1444,   367,   368,   302,   573,   872,   719,   861,   862,
    1152,   369,   370,   371,   372,   964,   373,   968,   374,   375,
     616,   376,   961,   377,   642,   378,   379,   946,   380,   381,
     382,   383,   384,   385,   386,  1259,  1260,  1453,  1635,  1636,
    1756,  1757,  1758,  1759,  2017,  2018,  1868,   387,   617,   174,
     175,   389,   589,   390,   391,   392,   649,   393,   394,   395,
     396,   397,   634,   924,   629,   631,   559,   852,   886,   853,
    1362,   854,   855,   560,   398,   399,   400,   948,   401,   402,
     880,   403,   715,   937,   930,   931,   637,   638,   934,  1010,
    1128,   869,   226,  1554,  1123,  1137,   404,   563,   564,   405,
    1301,   725,   204,   618,   156,  1491,   227,  1129,   407,    68,
     233,  1322,  1323,  1492,   891,   892,   893,   408,   409,   410,
     411,   412,  1380,  1175,  1568,  1836,  1837,  1923,  1838,  2002,
    1569,  1570,  1571,  1391,  1583,   413,   897,  1178,  1179,  1180,
    1393,  1587,   414,  1396,   415,  1184,  1398,   416,   904,  1186,
    1400,  1596,  1597,  1598,  1599,  1600,  1736,   417,   418,   907,
     901,  1170,   898,  1384,  1385,  1723,  1386,  1387,  1388,  1731,
    1732,  1405,  1406,  1856,  1857,  1933,  1934,  2005,  2048,  1858,
    1931,  1938,  1939,  2012,  1940,  1941,  2011,  2009,   419
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     155,    45,   562,   579,   287,   164,   295,   699,    46,   436,
     565,   431,   176,   155,   561,    42,  1082,   711,   468,   471,
      43,   442,   443,   945,    56,   445,  1072,   216,  1306,   232,
    1240,   885,    57,   889,   173,   289,   296,   716,  1012,   845,
      65,   905,  1019,   894,  1300,   307,  1535,    47,   467,   217,
     614,   909,   307,   195,   307,  1561,  1172,   167,  1173,   844,
    1069,  1224,   595,   870,  1253,  1254,   155,   759,   868,  1187,
    1244,   203,   819,   820,   821,  1300,   615,   619,   217,  1050,
    1051,  1031,  1112,  1113,  1114,  1052,   473,  1399,   727,   459,
    1771,  1633,   641, -1102,   828,   738,   182,   183,   184,   185,
     186,   187,   647,  -782,    48,  1389,  1839,  1401,  -778,  1842,
    -784,  1169,    55,   713,  1626,   953,  1973,   647,  2086,  2087,
    -735,   643,   157,  1095,  1047,  1493,   167,   168,  1561,  -735,
      66,   816,  1804,  -735, -1102,  1793,  1561,    63,  -735,   643,
    1844, -1102,  1467,  1275,   167,   167,   743,  1060,  1036,   154,
    2010,  -735,  1805,   448,   475,   406,   155,   479,   480,  2088,
    1079,   424,   177,    13,  1468,  1943,   744,  1845,  1061,    70,
     476,   -91,   -91,   -91,   -91,   -91,   -91,   388,   745,    45,
      45,    45,    45,  1390,  1096,   211,    46,    46,    46,    46,
    -735,  1944,   160,    42,    42,    42,    42,   158,    43,    43,
      43,    43,    56,    56,    56,    56,  1037,   461,   155,   155,
      57,    57,    57,    57,  1032,   304,   449,  2047,    65,    65,
      65,    65,  1482,  1794,  1821,    47,    47,    47,    47,  1886,
      45,   481,   218,   195,  1209,   155,   833,    46,   648,   827,
     870,   870,   155,   490,    42,   212,   870,   155,   155,    43,
      13,    13,   203,    56,   916,   155,   155,   155,   155,   503,
     155,    57,   831,   155,   155,   155,   155,   155,   516,    65,
     576,   628,   155,   155,   772,   217,    47,   873,   630,   296,
     528,   529,    48,    48,    48,    48,  1973,   699,   879,   879,
      55,    55,    55,    55,   695,   632,   633,   716,  1171,  1493,
    1749,   580,   581,   918,  1424,   420,  1730,  1245,    66,    66,
      66,    66,  1265,   614,  2003,    63,    63,    63,    63,   936,
     492,  1806,   474,   614,  1601,  1267,   799,   829, -1102,   449,
     167,   598,   469,    48,  1141,  1182,   464,   739,   928,   615,
    1905,    55,  1224,  1425,   466,  1162,  1910,    31,  1634,  1188,
    1402,  2089,  1261,  1407,  1263,   875,  1142,   462,   463,    66,
     768,  -471,   759,   722,   878,    31,    63,  1157,  1483,  1115,
     582,   583,   584,  1246,   155,  1042,  1043,  1037,  1285,   956,
     960,   217,  1341,   647,   484,   700,  -782,  1494,   364,   973,
     167,   489,  1828,  -784,  1029,  2030,   494,   495,  1621,  1833,
     307,   567,   167,  1822,   499,   500,   501,   502,  1535,   504,
     213,   558,   511,   512,   513,   514,   515,   364,  1945,   627,
      44,   521,   522,  1946,  -266,   205,   917,   406,   206,   446,
    1982,   717,  1117,  1118,  1119,  1120,   218,  1899,  1077,  1992,
    1734,   167,  1194,  1124,  1125,  1126,  1217,  2096,   155,   388,
    1762,  1230,  1231,  1232,  1354,  1233,  1234,  1853,  1235,   926,
     216,   613,  1358,   562,    69,  1408,   155,   693,   694,  1447,
     155,   565,  1389,  1448,   161,  1053,   568,   647,   614,   195,
     307,  1735,  1649,   167,   612,  1300,  1505,  1650,   797,   155,
     562,  1627,   803,   726,   155,   165,   696,   219,   565,  1631,
     834,   155,  1081,   155,   155,   155,   155,  1913,    13,  1607,
    1608,  2039,  1576,  2041,   155,   155,   155,  1033,   837,   838,
     716,  1039,   826,   661,   562,  1911,   166,  1617,   832,  1136,
     296,   643,   565,   169,  1854,   769,   228,  1855,  1507,   870,
    1712,   562,   594,   647,  1573,   297,  1996,    13,  1998,   565,
    1717,    31,  1236,  1127,   856,  1585,  1763,   787,   788,   789,
     790,  1494,  1592,  1738,   220,  1739,  1030,  1426,  1482,   804,
    1740,   647,  1076,   579,  1750,   697,   263,  1783,  1361,  1037,
    1163,   447,   303,  1296,   299,   300,   301,   697,  2097,    13,
    1192,    53,   780,  2083,  1820,   782,  -266,   733,    44,    44,
      44,    44,  1803,  1074,   305,  1160,  1651,  1862,   698,  1431,
    1078,    31,  1457,  1376,  1195,   767,  1434,  1879,  1218,   771,
     698,  1920,   922,    31,   925,   747,  1355,   749,   750,   751,
     752,   753,   754,  1888,  1359,   755,   264,  1409,   798,   949,
     952,  1078,  1957,   805,   955,  1078,  1198,  1979,  1622,    44,
     810,  1993,   812,   813,   814,   815,  2100,  1642,  1506,   611,
    1904,   947,    31,   823,   824,   825,   306,  1219,  1643,   839,
    1158,  1220,  1139,  1140,   438,   439,  1000,   188,   189,   190,
     191,  1889,  2072,   644,  1577,   406,   265,  1011,  2067,   421,
    1250,  1017,   296,  1251,  1252,  2054,  2055,   927,   266,  1195,
     433,  1223,  1744,  1027,    31,  1256,  -941,   388,   613,  1272,
    -941,  -941,  1713,  -941,  -941,  -941,  -941,  -941,  -941,  -941,
    -941,  -941,  -941,  -941,   910,   477,   155,  2056,   782,   434,
    1394,   612,  1593,  1644,   613,  1409,  1348,  1078,   444,  -941,
    -941,  1001,  1078,  1882,  1883,   915,  1670,   612,   263,  1666,
     283,   267,   268,   269,   270,   271,  1594,   612,   747,   647,
     749,   750,   751,   752,   753,   754,   155,  1618,   755,    53,
      53,    53,    53,  1891,   558,   188,   189,   190,   191,  1670,
    1286,   435,   272,   155,   155,   155,   155,  1935,  1395,  1880,
     192,  1091,   450,  1921,   182,   183,   184,   185,   186,   187,
     155,   274,  1111,  1111,  1111,  1111,   275,   155,   264,  1645,
     168,  1373,   298,  1620,  1958,  1624,  1055,  1470,   562,  1980,
      53,  1889,  -236,  1994,  2024,   938,   565,  2065,  2101,   939,
    1344,  1591,   783,  1471,  1595,  1135,   209,   451,   647,  1649,
     576,   647,   276,  1558,  1650,   277,  1472,   716,  1287,  1169,
    1374,  1145,  1772,   188,   189,   190,   191,  1936,   265,   452,
    1937,  1579,    24,    25, -1089,   210,   454,   716,  1056,  1057,
     266,   580,   562,   562,  1164,  1041,   299,   300,   301,  1311,
     565,   565,   453,   155,  1370,  1371,   193,  -236,  1418,   910,
     455,  1174,   906,   458,   760,  1422, -1067,  1423,  1183,  1580,
    1336,  1581,  1582,   470,   425,  1307,  1138,   426,  1464,  1465,
    1466, -1067,   612,   427,  1017,  1073,   761,  1773,   217,   762,
     763,  1787,  1788,   267,   268,   269,   270,   271,   194,   899,
     472,   900,  1083,  1084,  1085,  1086,   176,   949,   478,  -236,
    1296,  1831,  1241,  1241,  1241,  1832,  1230,  1231,  1232,  1106,
    1233,  1234,  -523,  1235,   272,   485,  1116,   298,  1221,   947,
      24,    25,    14,  1651,  1023,   783,   192,   273,   258,  1774,
     486,  1024,  1025,   274,  1312,  1313,  1314,  1315,   275,  1154,
    1155,  1156,  -236,   487,   193,  -236,    26,  1205,   488,  1207,
     230,   491,    27,    28,   491,  -236,   231,  1340,   496,  1745,
     747,   748,   749,   750,   751,   752,   753,   754,   562,   497,
     755,    30,  1775,  1766,   276,  1776,   565,   277,  1268,  1766,
    1477,   299,   300,   301,  1317,  1777,   498,   506,   432,   505,
    1318,  -941,  1168,   517,   259,   260,   261,   262,    24,    25,
     526,  1282,  1283,   482,   483,   662,  1959,  1236,  1960,  1961,
    1962,  1288,  1289,  1101,  1102,  1290,  1103,   562,   530,  1294,
     155,   580,   193,   531,   176,   565,   590,   591,   592,   593,
    1755,  1226,  1230,  1231,  1232,   532,  1233,  1234,  1225,  1235,
     780,   780,   899,  1316,   900,   635,  1302,   932,  1192,  1192,
    1091,   533,  1332,   507,   508,   509,   510,  1278,  1615,  1279,
    1280,   155,  -192,  1111,   194,   566,  1997,  1281,  1999,   651,
    1690,  -191,   652,   653,   654,   655,   656,   657,   658,   659,
     299,   300,   301,   660,   681,   682,   683,   684,   685,   535,
     536,   537,   929,   651,   932,  1509,   652,   653,   654,   655,
     656,   657,   658,   659,   538,   534,  1628,   660,   539,   540,
     541,   321,   322,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   299,   300,   301,   572,  1693,  1595,  1814,   432,
     970,   971,   972,  1236,  1629,  1630,   551,   552,   553,   574,
     299,   300,   301,   299,   300,   301,  1755,   914,   307,   234,
    1190,  1817,   780,  1814,   523,   524,  1226,  1230,  1231,  1232,
     702,   703,  -891,  1225,  1235,   706,   707,   756,  -765,  1295,
     182,   183,   184,   185,   186,   187,  1241,  1241,   949,   662,
     740,   741,   800,   801,   587,   949,  1692,   235,  1697,  -767,
     236,  -763,   949,   662,   585,  1438,   962,   963,  1064,  1057,
     947,  1440,   952,   632,   633,  1196,  1197,   947,  1269,  1270,
    1339,  1292,  1293,   586,   947,   588,   562,   562,   594,   562,
     597,  1017,   596,  1458,   565,   565,   599,   565,  1702,  1705,
    1808,  1705,  1796,  1797,   600,   237,   601,   238,  -637,   846,
     847,   848,   849,   850,   851,  1082,   602,   239,  1963,  1964,
    2073,  2074,  1469,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,  1512,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,  1490,  1449,   440,
     441,   176,   155,  1498,   687,  1747,   519,   520,   603,  1508,
    1499,  1063,  1065,   296,   155,   604,   469,   605,  1548,  1549,
    2063,  2064,  1430,  1503,   570,   571,   606,  1463,   607,  1555,
     608,  1556,  1226,  1557,   866,   867,   650,   609,  1559,  1225,
     623,   624,  1684,   625,   639,  1562,   640,   688,  1480,  1500,
     689,  1486,   690,  1487,  -704,   691,  2016,   704,   692,   234,
     846,   847,   848,   849,   850,   884,   708,   709,  1586,   710,
     240,   241,   242,   243,   244,   245,  1813,  -550,   718,  1903,
     720,  1130,   246,  1823,  1132,  1133,  1134,   721,   194,   735,
     736,   737,   554,   555,   556,   557,   766,   235,   774,   765,
     236,   770,  1144,  1146,  1147,  1148,  1501,   773,  -550,   949,
     781,   949,   791,   247,  1502,  1490,   792,  1648,  1562,   846,
     847,   848,   849,   850,  1360,   794,  1562,   806,   807,   808,
     809,   947,   249,   947,   662,   250,   811,   251,   817,   822,
     835,  -550,  -550,  -550,   836,   237,   842,   238,  -550,   558,
     871,  1504,   874,   840,   841,   843,   628,   239,   630,   857,
    1681,   858,   859,  1513,   860,  1669,   864,   877,   878,   882,
     887,   883,   895,  -176,   896,   902,   252,  1498,   903,   911,
     923,   913,  1673,   966,  1499,   967,  1002,   363,  1005,  1018,
     296,  1021,  1022,  1003,   643,  1034,  1045,  1044,   949,  1046,
    1048,  1057,  1915,  1049,  -550,   780,   780,  1066,  1068,   677,
     678,   679,   680,   681,   682,   683,   684,   685,  1075,  1080,
     173,  1088,  1659,  1500,  1486,  1486,  1089,  1094,  -550,  1105,
    1087,  1100,  1107,   651,  -550,  -550,   652,   653,   654,   655,
     656,   657,   658,   659,  1131,  1092,  1445,   660,   647,  1143,
    1165,  1153,  1149,  -550,  1722,  1166,  1167,  1949,  1169,  1176,
     240,   241,   242,   243,   244,   245,  1746,  1181,  1185,   298,
    1248,  1203,   246,  1216,  -550,  -550,  -550,  1206,  1214,  1229,
    1501,  1257,   662,  1258,  1204,  1262,  1266,  1264,  1502,  -766,
    -768,  1767,  1768,  -764,  1241,   949,  1195,  1271,  1273,  1275,
    1277,  1490,   562,   247,  1284,  1291,  1303,  1310,  1308,  1096,
     565,  1320,  1321,  1305,  1995,  1325,   248,   947,  1333,  1338,
    -550,  -795,   249,  1342,  1337,   250,  1335,   251,   651,  1345,
    1343,   652,   653,   654,   655,   656,   657,   658,   659,  1786,
    1369,  1446,   660,  1346,  1392,  1399,  1791,  1688,  1347,  2035,
    1349,   652,   653,   654,   655,   656,   657,   658,   659,  1351,
     406,  1810,   660,  -176,  1352,  1350,   252,  1353,  1356,  1357,
    1364,  2042,  2046,  1363,  1365,  1548,  1366,  1367,  1375,  1377,
    1548,  1378,   388,  1379,  1403,  1397,  1404,  1417,  1950,  1562,
    1834,  1420,  1410,  1433,  1411,  1412,  1435,  1427,  1436,   535,
     536,   537,  1428,  1780,  1429,  1439,  1848,  1442,  1443,  1789,
    1790,  1450,  1451,  1452,   538,  1454,  1455,  1462,   539,   540,
     541,   321,   322,   542,   543,   544,   545,   546,   547,   548,
     549,   550,  1459,   562,  1478,  1481,  1461,  1870,  1489,  1488,
    1510,   565,  1514,  1574,  1515,  2070,   551,   552,   553,  1830,
    1517,  1550,   155,  1551,  1563,  1564,  1578,  1588,  1589,  2021,
    1590,  1552,  1602,  1603,  1619,  1604,  1625,  1632,  1637,  1638,
    1639,  1660,  1646,  1640,   621,   622,  1663,  1647,  1641,  1666,
     626,  1667,  1668,  1810,  1675,   636,  1670,  1678,   558,   535,
     536,   537,  1679,  1682,  1683,  1698,  1674,  1548,  1685,  1700,
     580,  1676,  1701,  1869,   538,  1706,  1708,  1709,   539,   540,
     541,   321,   322,   542,   543,   544,   545,   546,   547,   548,
     549,   550,  1710,  1711,  1474,  1475,  1715,  1714,  1720,  1716,
    1930,  1724,  1719,  1725,  1726,  1727,   551,   552,   553,  1728,
    1729,  1737,   660,  1760,  1733,  1199,  1761,   155,  1764,  1769,
    1781,  1507,  1792,  1795,  1800,  1713,  1786,  1807,  1811,   714,
    1956,  1843,  1812,  1824,  1846,  1847,  1852,  1850,   662,  1865,
    1871,  2099,  1548,  1864,  1851,  1866,  1978,  1970,  1872,  1873,
    2102,  1548,  1874,  1867,  1971,  1877,  1548,  1875,  1878,  1881,
    1884,  1968,  1810,  1887,  1810,  1894,  1969,  1897,  2001,  1898,
    1975,  1876,  1895,   714,   644,  1900,  1912,  1906,  1976,  1916,
    1917,  1918,  2008,  1919,  1925,  1927,  1977,  1267,  1924,  1928,
    1951,  1922,  1929,  1932,  1942,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,  2031,  2032,  2033,  2034,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,  1948,  1953,  1966,  1984,  1981,  1121,  1548,  1986,
    1830,  1990,  1830,  2004,  2007,  1991,  1936,  2019,  1548,  2022,
     580,  2020,  2025,  2027,  2036,  2038,  2049,  2040,  2043,  2044,
    2050,  2058,   554,   555,   556,   557,  2062,  2069,  2079,  2068,
    2075,   863,  2077,  2073,  2051,  2074,  1947,  2092,  2093,  2095,
    1324,  1671,  1460,   457,   456,   728,   734,  2053,   294,  1274,
    1054,  1297,  1672,  1770,  2091,  1548,  2078,  1548,  2076,  2071,
    1827,  2082,  2052,  1908,   888,   890,   890,  1815,  1909,  1707,
    1892,  2094,   888,  1893,   890,   163,   732,  1553,  1028,   423,
    1665,  1952,  1548,  1955,  2029,  2085,  1661,  1970,   919,   920,
     921,  1020,  1662,  1606,  1971,  1605,  1309,  1161,  1432,  1548,
    1748,  1968,  1441,  1247,   935,   714,  1969,   764,   876,  1189,
    1975,   954,   554,   555,   556,   557,  1159,  1751,  1976,  1200,
    1368,   969,   969,   969,   969,   965,  1977,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,   975,   974,  1067,   288,  1004,  1009,  1009,  1863,  1208,
     830,   881,  1211,  1841,   933,  1840,  1212,  2000,  1718,  1584,
    1572,  1721,  1575,  1926,  2006,  1849,  2013,     0,     0,     0,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,     0,     0,   319,   320,   908,     0,    77,
      78,     0,     0,    79,   321,   322,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    80,     0,     0,    81,     0,
       0,   323,   324,   325,   326,   327,   328,   329,     0,    82,
       0,     0,   279,   280,   281,     0,     0,     0,     0,   330,
      83,     0,     0,   167,   170,     0,   171,   172,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    84,     0,     0,
      85,     0,     0,    86,     0,     0,     0,     0,     0,    87,
       0,     0,     0,     0,    88,    89,    90,     0,     0,     0,
       0,     0,    91,   331,     0,     0,     0,   332,     0,     0,
      92,   333,     0,    93,     0,    94,    95,    96,     0,     0,
       0,   334,    97,    98,     0,     0,     0,     0,     0,     0,
       0,   335,   336,   337,   338,   339,     0,   340,   341,    99,
     100,   342,   343,   101,   344,   102,   103,   104,   105,   106,
     107,   108,     0,   109,   345,   110,   111,   112,   113,     0,
     114,   346,   115,     0,     0,     0,     0,     0,   116,   610,
       0,   117,   348,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1177,     0,     0,     0,   888,     0,   349,   350,
       0,     0,   890,     0,     0,     0,   714,     0,   351,   352,
     353,     0,     0,     0,     0,   355,     0,     0,     0,     0,
       0,     0,     0,     0,  1210,   118,   119,  1213,     0,     0,
       0,     0,     0,   120,     0,     0,     0,   121,     0,     0,
       0,     0,     0,     0,   122,     0,     0,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,     0,   134,
       0,   714,   714,     0,     0,   135,     0,     0,   136,     0,
       0,     0,   137,     0,     0,   138,   139,     0,   140,     0,
       0,   141,     0,   142,     0,     0,     0,   143,   144,     0,
       0,   611,     0,     0,    31,   356,   357,   358,   359,     0,
       0,  1009,     0,  1009,     0,   149,     0,     0,     0,   360,
       0,     0,     0,   361,   362,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   714,     0,     0,     0,   150,
     151,     0,     0,     0,     0,   152,   153,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   662,   363,     0,   364,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   714,     0,   535,   536,   537,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     538,     0,     0,  1611,   539,   540,   541,   321,   322,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,     0,
       0,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,     0,   551,   552,   553,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,     0,     0,
       0,     0,     0,     0,   863,     0,     0,     0,     0,     0,
       0,     0,     0,   535,   536,   537,     0,     0,     0,     0,
       0,     0,  1372,     0,     0,     0,   890,     0,   538,     0,
       0,  1383,   539,   540,   541,   321,   322,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,     0,    71,    72,
      73,    74,    75,    76,  1413,  1414,  1415,  1416,     0,     0,
     551,   552,   553,     0,   714,    77,    78,     0,     0,    79,
    1421,   714,     0,   714,     0,     0,     0,     0,     0,     0,
       0,    80,     0,     0,    81,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,   167,
     170,   940,   171,   172,     0,     0,     0,     0,     0,     0,
       0,  1009,     0,    84,     0,  1612,    85,     0,     0,    86,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     0,
      88,    89,    90,     0,     0,     0,     0,     0,    91,     0,
       0,     0,     0,     0,     0,     0,    92,     0,     0,    93,
       0,    94,    95,    96,     0,     0,     0,     0,    97,    98,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    99,   100,     0,     0,   101,
       0,   102,   103,   104,   105,   106,   107,   108,     0,   109,
       0,   110,   111,   112,   113,     0,   114,     0,   115,     0,
    1703,     0,     0,     0,   116,  1222,     0,   117,   554,   555,
     556,   557,     0,     0,     0,     0,     0,     3,     4,     5,
       6,     0,     0,     0,  1567,     0,     0,  1383,     0,     0,
       7,     8,     9,    10,     0,  1177,     0,     0,     0,    11,
       0,     0,   888,     0,     0,   888,     0,     0,     0,     0,
       0,   118,   119,     0,   714,   714,   714,   714,     0,   120,
       0,     0,     0,   121,   714,     0,     0,     0,     0,     0,
     122,     0,     0,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,     0,   134,   554,   555,   556,   557,
       0,   135,     0,     0,   136,     0,     0,     0,   137,     0,
       0,   138,   139,     0,   140,     0,     0,   141,     0,   142,
       0,     0,     0,   143,   144,  -229,     0,  1223,     0,     0,
      31,   145,   146,   147,   148,    13,     0,     0,     0,     0,
       0,   149,  -229,     0,     0,     0,     0,  -229,  -229,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   150,   151,     0,     0,     0,
       0,   152,   153,     0,     0,     0,     0,     0,     0,  1696,
       0,     0,     0,     0,     0,     0,     0,     0,  -229,     0,
    -229,   942,    14,     0,     0,     0,     0,     0,     0,     0,
       0,    15,    16,     0,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,     0,    27,    28,     0,     0,     0,     0,     0,     0,
       0,     0,  1383,     0,     0,     0,     0,     0,    29,     0,
       0,    30,  -229,  -229,  -229,     0,     0,     0,     0,     0,
      31,   662,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1741,     0,  -229,  1742,  -229,  1743,
       0,     0,     0,     0,  -229,  -229,     0,     0,    32,     0,
       0,     0,     0,     0,     0,  -229,     0,   863,  -229,     0,
       0,   888,     0,  -229,     0,     0,     0,     0,  -229,     0,
     888,     0,     0,     0,     0,     0,   888,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,     0,     0,
       0,     0,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -229,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1835,  1567,  1567,     0,  1567,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   888,     0,
     319,   320,     0,     0,    77,    78,     0,     0,    79,   321,
     322,     0,     0,     0,     0,     0,     0,   888,     0,     0,
      80,     0,     0,    81,     0,     0,   323,   324,   325,   326,
     327,   328,   329,     0,    82,     0,     0,   279,   280,   281,
       0,     0,     0,     0,   330,    83,     0,     0,     0,   170,
       0,   171,   172,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    84,     0,     0,    85,     0,     0,    86,     0,
       0,     0,  1202,     0,    87,     0,  1902,     0,     0,    88,
      89,    90,  1907,     0,     0,     0,     0,    91,   331,     0,
       0,     0,   332,     0,     0,    92,   333,     0,    93,     0,
      94,    95,    96,     0,     0,     0,   334,    97,    98,     0,
       0,     0,     0,     0,     0,     0,   335,   336,   337,   338,
     339,     0,   340,   341,    99,   100,   342,   343,   101,   344,
     102,   103,   104,   105,   106,   107,   108,     0,   109,   345,
     110,   111,   112,   113,     0,   114,   346,   115,     0,     0,
       0,     0,     0,   116,   347,     0,   117,   348,     0,   957,
     958,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     959,     0,     0,   349,   350,     0,     0,     0,     0,     0,
       0,     0,     0,   351,   352,   353,  1835,     0,     0,  1567,
     355,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     118,   119,     0,     0,     0,     0,     0,   888,   120,     0,
       0,     0,   121,     0,     0,     0,     0,     0,     0,   122,
       0,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,     0,   134,     0,     0,     0,     0,     0,
     135,     0,     0,   136,     0,  2037,     0,   137,     0,     0,
     138,   139,     0,   140,     0,     0,   141,     0,   142,     0,
       0,     0,   143,   144,     0,     0,     0,     0,     0,     0,
     356,   357,   358,   359,     0,     0,     0,     0,     0,     0,
     149,     0,     0,     0,   360,     0,     0,     0,   361,   362,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   150,   151,     0,     0,     0,     0,
     152,   153,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     363,     0,   364,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,     0,     0,   319,   320,     0,
       0,    77,    78,     0,     0,    79,   321,   322,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    80,     0,     0,
      81,     0,     0,   323,   324,   325,   326,   327,   328,   329,
       0,    82,     0,     0,   279,   280,   281,     0,     0,     0,
       0,   330,    83,     0,     0,   167,   170,     0,   171,   172,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    84,
       0,     0,    85,     0,     0,    86,     0,     0,     0,     0,
       0,    87,     0,     0,     0,     0,    88,    89,    90,     0,
       0,     0,     0,     0,    91,   331,     0,     0,     0,   332,
       0,     0,    92,   333,     0,    93,     0,    94,    95,    96,
       0,     0,     0,   334,    97,    98,     0,     0,     0,     0,
       0,     0,     0,   335,   336,   337,   338,   339,     0,   340,
     341,    99,   100,   342,   343,   101,   344,   102,   103,   104,
     105,   106,   107,   108,     0,   109,   345,   110,   111,   112,
     113,     0,   114,   346,   115,     0,     0,     0,     0,     0,
     116,   610,     0,   117,   348,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     349,   350,     0,     0,     0,     0,     0,     0,     0,     0,
     351,   352,   353,     0,     0,     0,     0,   355,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   118,   119,     0,
       0,     0,     0,     0,     0,   120,     0,     0,     0,   121,
       0,     0,     0,     0,     0,     0,   122,     0,     0,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
       0,   134,     0,     0,     0,     0,     0,   135,     0,     0,
     136,     0,     0,     0,   137,     0,     0,   138,   139,     0,
     140,     0,     0,   141,     0,   142,     0,     0,     0,  1689,
     144,     0,     0,     0,     0,     0,    31,   356,   357,   358,
     359,     0,     0,     0,     0,     0,     0,   149,     0,     0,
       0,   360,     0,     0,     0,   361,   362,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   150,   151,     0,     0,     0,     0,   152,   153,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   363,     0,   364,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,     0,     0,   319,   320,     0,     0,    77,    78,
       0,     0,    79,   321,   322,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    80,     0,     0,    81,     0,     0,
     323,   324,   325,   326,   327,   328,   329,     0,    82,     0,
       0,   279,   280,   281,     0,     0,     0,     0,   330,    83,
       0,     0,     0,   170,     0,   171,   172,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    84,     0,     0,    85,
       0,     0,    86,     0,     0,     0,     0,     0,    87,     0,
       0,     0,     0,    88,    89,    90,     0,     0,     0,     0,
       0,    91,   331,     0,     0,     0,   332,     0,     0,    92,
     333,     0,    93,     0,    94,    95,    96,     0,     0,     0,
     334,    97,    98,     0,     0,     0,     0,     0,     0,     0,
     335,   336,   337,   338,   339,     0,   340,   341,    99,   100,
     342,   343,   101,   344,   102,   103,   104,   105,   106,   107,
     108,     0,   109,   345,   110,   111,   112,   113,     0,   114,
     346,   115,     0,     0,     0,     0,     0,   116,   347,     0,
     117,   348,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   349,   350,     0,
       0,     0,     0,     0,     0,     0,     0,   351,   352,   353,
       0,   354,     0,     0,   355,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   118,   119,     0,     0,     0,     0,
       0,     0,   120,     0,     0,     0,   121,     0,     0,     0,
       0,     0,     0,   122,     0,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,     0,   134,     0,
       0,     0,     0,     0,   135,     0,     0,   136,     0,     0,
       0,   137,     0,     0,   138,   139,     0,   140,     0,     0,
     141,     0,   142,     0,     0,     0,   143,   144,     0,     0,
       0,     0,     0,     0,   356,   357,   358,   359,     0,     0,
       0,     0,     0,     0,   149,     0,     0,     0,   360,     0,
       0,     0,   361,   362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   150,   151,
       0,     0,     0,     0,   152,   153,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   363,     0,   364,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,     0,
       0,   319,   320,     0,     0,    77,    78,     0,     0,    79,
     321,   322,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,     0,     0,    81,     0,     0,   323,   324,   325,
     326,   327,   328,   329,     0,    82,     0,     0,   279,   280,
     281,     0,     0,     0,     0,   330,    83,     0,     0,     0,
     170,     0,   171,   172,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    84,     0,     0,    85,     0,     0,    86,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     0,
      88,    89,    90,     0,     0,     0,     0,     0,    91,   331,
       0,     0,     0,   332,     0,     0,    92,   333,     0,    93,
       0,    94,    95,    96,     0,     0,     0,   334,    97,    98,
       0,     0,     0,     0,     0,     0,     0,   335,   336,   337,
     338,   339,     0,   340,   341,    99,   100,   342,   343,   101,
     344,   102,   103,   104,   105,   106,   107,   108,     0,   109,
     345,   110,   111,   112,   113,     0,   114,   346,   115,     0,
       0,     0,     0,     0,   116,   347,     0,   117,   348,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   349,   350,     0,     0,     0,     0,
       0,     0,     0,     0,   351,   352,   353,     0,     0,     0,
       0,   355,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   118,   119,     0,     0,     0,     0,     0,     0,   120,
       0,     0,     0,   121,     0,     0,     0,     0,     0,     0,
     122,     0,     0,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,     0,   134,     0,     0,     0,     0,
       0,   135,     0,     0,   136,     0,     0,     0,   137,     0,
       0,   138,   139,     0,   140,     0,     0,   141,     0,   142,
       0,     0,     0,   143,   144,     0,     0,     0,     0,     0,
       0,   356,   357,   358,   359,     0,     0,     0,     0,     0,
       0,   149,     0,     0,     0,   360,     0,     0,     0,   361,
     362,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   150,   151,     0,     0,     0,
       0,   152,   153,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   363,     0,   364,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,     0,     0,   319,   320,
       0,     0,    77,    78,     0,     0,    79,   321,   322,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    80,     0,
       0,    81,     0,     0,   323,   324,   325,   326,   327,   328,
     329,     0,    82,     0,     0,   279,   280,   281,     0,     0,
       0,     0,   330,    83,     0,     0,     0,   170,     0,   171,
     172,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      84,     0,     0,    85,     0,     0,    86,     0,     0,     0,
       0,     0,    87,     0,     0,     0,     0,    88,    89,    90,
       0,     0,     0,     0,     0,    91,     0,     0,     0,     0,
     332,     0,     0,    92,   333,     0,    93,     0,    94,    95,
      96,     0,     0,     0,   334,    97,    98,     0,     0,     0,
       0,     0,     0,     0,   335,   336,   337,   338,   339,     0,
     340,   341,    99,   100,   342,   343,   101,   344,   102,   103,
     104,   105,   106,   107,   108,     0,   109,   345,   110,   111,
     112,   113,     0,   114,   346,   115,     0,     0,     0,     0,
       0,   116,   620,     0,   117,     0,     0,     0,     0,     0,
    1752,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   349,   350,     0,     0,     0,     0,     0,     0,     0,
       0,   351,   352,   353,     0,     0,     0,     0,   355,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   118,   119,
       0,     0,     0,     0,     0,     0,   120,     0,     0,     0,
     121,     0,     0,     0,     0,     0,     0,   122,     0,     0,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,     0,   134,     0,     0,     0,     0,     0,   135,     0,
       0,   136,     0,     0,     0,   137,     0,     0,   138,   139,
       0,   140,     0,     0,   141,     0,   142,     0,     0,     0,
     143,   144,     0,     0,     0,     0,     0,     0,   356,   357,
     358,   359,     0,     0,     0,     0,     0,     0,   149,     0,
       0,     0,   360,     0,     0,     0,   361,   362,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   150,   151,     0,     0,     0,     0,   152,   153,
       0,     0,     0,     0,     0,     0,  1753,     0,     0,     0,
       0,     0,     0,  1754,     0,     0,     0,     0,     0,     0,
     364,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,     0,     0,   319,   320,     0,     0,    77,
      78,     0,     0,    79,   321,   322,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    80,     0,     0,    81,     0,
       0,   323,   324,   325,   326,   327,   328,   329,     0,    82,
       0,     0,   279,   280,   281,     0,     0,     0,     0,   330,
      83,     0,     0,   167,   170,     0,   171,   172,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    84,     0,     0,
      85,     0,     0,    86,     0,     0,     0,     0,     0,    87,
       0,     0,     0,     0,    88,    89,    90,     0,     0,     0,
       0,     0,    91,     0,     0,     0,     0,   332,     0,     0,
      92,   333,     0,    93,     0,    94,    95,    96,     0,     0,
       0,   334,    97,    98,     0,     0,     0,     0,     0,     0,
       0,   335,   336,   337,   338,   339,     0,   340,   341,    99,
     100,   342,   343,   101,   344,   102,   103,   104,   105,   106,
     107,   108,     0,   109,   345,   110,   111,   112,   113,     0,
     114,   346,   115,     0,     0,     0,     0,     0,   116,   775,
     776,   117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   349,   350,
       0,     0,     0,     0,     0,     0,     0,     0,   351,   352,
     353,     0,     0,     0,     0,   355,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   118,   119,     0,     0,     0,
       0,     0,     0,   120,     0,     0,     0,   121,     0,     0,
       0,     0,     0,     0,   122,     0,     0,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,     0,   134,
       0,     0,     0,     0,     0,   135,     0,     0,   136,     0,
       0,     0,   137,     0,     0,   138,   139,     0,   140,     0,
       0,   141,     0,   142,     0,     0,     0,   143,   144,     0,
       0,     0,     0,     0,     0,   356,   357,   358,   359,     0,
       0,     0,     0,     0,     0,   149,     0,     0,     0,   360,
       0,     0,     0,   361,   362,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   150,
     151,     0,     0,     0,     0,   152,   153,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,     0,
       0,   319,   320,     0,     0,    77,    78,   364,     0,    79,
     321,   322,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,     0,     0,    81,     0,     0,   323,   324,   325,
     326,   327,   328,   329,     0,    82,     0,     0,   279,   280,
     281,     0,     0,     0,     0,   330,    83,     0,     0,     0,
     170,     0,   171,   172,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    84,     0,     0,    85,     0,     0,    86,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     0,
      88,    89,    90,     0,     0,     0,     0,     0,    91,     0,
       0,     0,     0,   332,     0,     0,    92,   333,     0,    93,
       0,    94,    95,    96,     0,     0,     0,   334,    97,    98,
       0,     0,     0,     0,     0,     0,     0,   335,   336,   337,
     338,   339,     0,   340,   341,    99,   100,   342,   343,   101,
     344,   102,   103,   104,   105,   106,   107,   108,     0,   109,
     345,   110,   111,   112,   113,     0,   114,   346,   115,     0,
       0,     0,     0,     0,   116,   620,     0,   117,     0,     0,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   349,   350,     0,     0,     0,     0,
       0,     0,     0,     0,   351,   352,   353,     0,  1007,     0,
       0,   355,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   118,   119,     0,     0,     0,     0,     0,     0,   120,
       0,     0,     0,   121,     0,     0,     0,     0,     0,     0,
     122,     0,     0,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,     0,  1008,     0,     0,     0,     0,
       0,   135,     0,     0,   136,     0,     0,     0,   137,     0,
       0,   138,   139,     0,   140,     0,     0,   141,     0,   142,
       0,     0,     0,   143,   144,     0,     0,     0,     0,     0,
       0,   356,   357,   358,   359,     0,     0,     0,     0,     0,
       0,   149,     0,     0,     0,   360,     0,     0,     0,   361,
     362,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   150,   151,     0,     0,     0,
       0,   152,   153,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,     0,     0,   319,   320,     0,
       0,    77,    78,   364,     0,    79,   321,   322,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    80,     0,     0,
      81,     0,     0,   323,   324,   325,   326,   327,   328,   329,
       0,    82,     0,     0,   279,   280,   281,     0,     0,     0,
       0,   330,    83,     0,     0,     0,   170,     0,   171,   172,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    84,
       0,     0,    85,     0,     0,    86,     0,     0,     0,     0,
       0,    87,     0,     0,     0,     0,    88,    89,    90,     0,
       0,     0,     0,     0,    91,     0,     0,     0,     0,   332,
       0,     0,    92,   333,     0,    93,     0,    94,    95,    96,
       0,     0,     0,   334,    97,    98,     0,     0,     0,     0,
       0,     0,     0,   335,   336,   337,   338,   339,  1566,   340,
     341,    99,   100,   342,   343,   101,   344,   102,   103,   104,
     105,   106,   107,   108,   896,   109,   345,   110,   111,   112,
     113,     0,   114,   346,   115,     0,     0,     0,     0,     0,
     116,   620,     0,   117,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     349,   350,     0,     0,     0,     0,     0,     0,     0,     0,
     351,   352,   353,     0,     0,     0,     0,   355,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   118,   119,     0,
       0,     0,     0,     0,     0,   120,     0,     0,     0,   121,
       0,     0,     0,     0,     0,     0,   122,     0,     0,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
       0,   134,     0,     0,     0,     0,     0,   135,     0,     0,
     136,     0,     0,     0,   137,     0,     0,   138,   139,     0,
     140,     0,     0,   141,     0,   142,     0,     0,     0,   143,
     144,     0,     0,     0,     0,     0,     0,   356,   357,   358,
     359,     0,     0,     0,     0,     0,     0,   149,     0,     0,
       0,   360,     0,     0,     0,   361,   362,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   150,   151,     0,     0,     0,     0,   152,   153,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,     0,     0,   319,   320,     0,     0,    77,    78,   364,
       0,    79,   321,   322,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    80,     0,     0,    81,     0,     0,   323,
     324,   325,   326,   327,   328,   329,     0,    82,     0,     0,
     279,   280,   281,     0,     0,     0,     0,   330,    83,     0,
       0,     0,   170,     0,   171,   172,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    84,     0,     0,    85,     0,
       0,    86,     0,     0,     0,     0,     0,    87,     0,     0,
       0,     0,    88,    89,    90,     0,     0,     0,     0,     0,
      91,     0,     0,     0,     0,   332,     0,     0,    92,   333,
       0,    93,     0,    94,    95,    96,     0,     0,     0,   334,
      97,    98,     0,     0,     0,     0,     0,     0,     0,   335,
     336,   337,   338,   339,     0,   340,   341,    99,   100,   342,
     343,   101,   344,   102,   103,   104,   105,   106,   107,   108,
       0,   109,   345,   110,   111,   112,   113,     0,   114,   346,
     115,     0,     0,     0,     0,     0,   116,   620,     0,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   349,   350,     0,     0,
       0,     0,     0,     0,     0,     0,   351,   352,   353,     0,
       0,     0,     0,   355,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   118,   119,     0,     0,     0,     0,     0,
       0,   120,     0,     0,     0,   121,     0,     0,     0,     0,
       0,     0,   122,     0,     0,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,     0,   134,     0,     0,
       0,     0,     0,   135,     0,     0,   136,     0,     0,     0,
     137,     0,     0,   138,   139,     0,   140,     0,     0,   141,
       0,   142,     0,     0,     0,   143,   144,     0,     0,     0,
       0,     0,     0,   356,   357,   358,   359,     0,     0,     0,
       0,     0,     0,   149,     0,     0,     0,   360,     0,     0,
       0,   361,   362,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   150,   151,     0,
       0,     0,     0,   152,   153,     0,     0,     0,     0,     0,
       0,  1753,     0,     0,     0,     0,     0,     0,  1754,     0,
       0,     0,     0,     0,     0,   364,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,     0,     0,
     319,   320,     0,     0,    77,    78,     0,     0,    79,   321,
     322,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      80,     0,     0,    81,     0,     0,   323,   324,   325,   326,
     327,   328,   329,     0,    82,     0,     0,   279,   280,   281,
       0,     0,     0,     0,   330,    83,     0,     0,     0,   170,
       0,   171,   172,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    84,     0,     0,    85,     0,     0,    86,     0,
       0,     0,     0,     0,    87,     0,     0,     0,     0,    88,
      89,    90,     0,     0,     0,     0,     0,    91,     0,     0,
       0,     0,   332,     0,     0,    92,   333,     0,    93,     0,
      94,    95,    96,     0,     0,     0,   334,    97,    98,     0,
       0,     0,     0,     0,     0,     0,   335,   336,   337,   338,
     339,     0,   340,   341,    99,   100,   342,   343,   101,   344,
     102,   103,   104,   105,   106,   107,   108,     0,   109,   345,
     110,   111,   112,   113,     0,   114,   346,   115,     0,     0,
       0,     0,     0,   116,   620,     0,   117,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   349,   350,     0,     0,     0,     0,     0,
       0,     0,     0,   351,   352,   353,     0,     0,     0,     0,
     355,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     118,   119,     0,     0,     0,     0,     0,     0,   120,     0,
       0,     0,   121,     0,     0,     0,     0,     0,     0,   122,
       0,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,     0,   134,     0,     0,     0,     0,     0,
     135,     0,     0,   136,     0,     0,     0,   137,     0,     0,
     138,   139,     0,   140,     0,     0,   141,     0,   142,     0,
       0,     0,   143,   144,     0,     0,     0,     0,     0,     0,
     356,   357,   358,   359,     0,     0,     0,     0,     0,     0,
     149,     0,     0,     0,   360,     0,     0,     0,   361,   362,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   150,   151,     0,     0,     0,     0,
     152,   153,     0,     0,     0,     0,     0,     0,  2014,     0,
       0,     0,     0,     0,     0,  2015,     0,     0,     0,     0,
       0,     0,   364,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,     0,     0,   319,   320,     0,
       0,    77,    78,     0,     0,    79,   321,   322,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    80,     0,     0,
      81,     0,     0,   323,   324,   325,   326,   327,   328,   329,
       0,    82,     0,     0,   279,   280,   281,     0,     0,     0,
       0,   330,    83,     0,     0,     0,   170,     0,   171,   172,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    84,
       0,     0,    85,     0,     0,    86,     0,     0,     0,     0,
       0,    87,     0,     0,     0,     0,    88,    89,    90,     0,
       0,     0,     0,     0,    91,     0,     0,     0,     0,   332,
       0,     0,    92,   333,     0,    93,     0,    94,    95,    96,
       0,     0,     0,   334,    97,    98,     0,     0,     0,     0,
       0,     0,     0,   335,   336,   337,   338,   339,     0,   340,
     341,    99,   100,   342,   343,   101,   344,   102,   103,   104,
     105,   106,   107,   108,     0,   109,   345,   110,   111,   112,
     113,     0,   114,   346,   115,     0,     0,     0,     0,     0,
     116,   620,     0,   117,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     349,   350,     0,     0,     0,     0,     0,     0,     0,     0,
     351,   352,   353,     0,     0,     0,     0,   355,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   118,   119,     0,
       0,     0,     0,     0,     0,   120,     0,     0,     0,   121,
       0,     0,     0,     0,     0,     0,   122,     0,     0,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
       0,   134,     0,     0,     0,     0,     0,   135,     0,     0,
     136,     0,     0,     0,   137,     0,     0,   138,   139,     0,
     140,     0,     0,   141,     0,   142,     0,     0,     0,   143,
     144,     0,     0,     0,     0,     0,     0,   356,   357,   358,
     359,     0,     0,     0,     0,     0,     0,   149,     0,     0,
       0,   360,   635,     0,     0,   361,   362,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   150,   151,     0,     0,     0,     0,   152,   153,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,     0,     0,   319,   320,     0,     0,    77,    78,   364,
       0,    79,   321,   322,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    80,     0,     0,    81,     0,     0,   323,
     324,   325,   326,   327,   328,   329,     0,    82,     0,     0,
     279,   280,   281,     0,     0,     0,     0,   330,    83,     0,
       0,     0,   170,     0,   171,   172,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    84,     0,     0,    85,     0,
       0,    86,     0,     0,     0,     0,     0,    87,     0,     0,
       0,     0,    88,    89,    90,     0,     0,     0,     0,     0,
      91,     0,     0,     0,     0,   332,     0,     0,    92,   333,
       0,    93,     0,    94,    95,    96,     0,     0,     0,   334,
      97,    98,     0,     0,     0,     0,     0,     0,     0,   335,
     336,   337,   338,   339,     0,   340,   341,    99,   100,   342,
     343,   101,   344,   102,   103,   104,   105,   106,   107,   108,
       0,   109,   345,   110,   111,   112,   113,     0,   114,   346,
     115,     0,     0,     0,     0,     0,   116,   620,   712,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   349,   350,     0,     0,
       0,     0,     0,     0,     0,     0,   351,   352,   353,     0,
       0,     0,     0,   355,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   118,   119,     0,     0,     0,     0,     0,
       0,   120,     0,     0,     0,   121,     0,     0,     0,     0,
       0,     0,   122,     0,     0,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,     0,   134,     0,     0,
       0,     0,     0,   135,     0,     0,   136,     0,     0,     0,
     137,     0,     0,   138,   139,     0,   140,     0,     0,   141,
       0,   142,     0,     0,     0,   143,   144,     0,     0,     0,
       0,     0,     0,   356,   357,   358,   359,     0,     0,     0,
       0,     0,     0,   149,     0,     0,     0,   360,     0,     0,
       0,   361,   362,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   150,   151,     0,
       0,     0,     0,   152,   153,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,     0,     0,   319,
     320,     0,     0,    77,    78,   364,     0,    79,   321,   322,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    80,
       0,     0,    81,     0,     0,   323,   324,   325,   326,   327,
     328,   329,     0,    82,     0,     0,   279,   280,   281,     0,
       0,     0,     0,   330,    83,     0,     0,   167,   170,     0,
     171,   172,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    84,     0,     0,    85,     0,     0,    86,     0,     0,
       0,     0,     0,    87,     0,     0,     0,     0,    88,    89,
      90,     0,     0,     0,     0,     0,    91,     0,     0,     0,
       0,   332,     0,     0,    92,   333,     0,    93,     0,    94,
      95,    96,     0,     0,     0,   334,    97,    98,     0,     0,
       0,     0,     0,     0,     0,   335,   336,   337,   338,   339,
       0,   340,   341,    99,   100,   342,   343,   101,   344,   102,
     103,   104,   105,   106,   107,   108,     0,   109,   345,   110,
     111,   112,   113,     0,   114,   346,   115,     0,     0,     0,
       0,     0,   116,   775,     0,   117,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   349,   350,     0,     0,     0,     0,     0,     0,
       0,     0,   351,   352,   353,     0,     0,     0,     0,   355,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   118,
     119,     0,     0,     0,     0,     0,     0,   120,     0,     0,
       0,   121,     0,     0,     0,     0,     0,     0,   122,     0,
       0,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,     0,   134,     0,     0,     0,     0,     0,   135,
       0,     0,   136,     0,     0,     0,   137,     0,     0,   138,
     139,     0,   140,     0,     0,   141,     0,   142,     0,     0,
       0,   143,   144,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,     0,     0,     0,     0,     0,     0,   149,
       0,     0,     0,   360,     0,     0,     0,   361,   362,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   150,   151,     0,     0,     0,     0,   152,
     153,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,     0,     0,   319,   320,     0,     0,    77,
      78,   364,     0,    79,   321,   322,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    80,     0,     0,    81,     0,
       0,   323,   324,   325,   326,   327,   328,   329,     0,    82,
       0,     0,   279,   280,   281,     0,     0,     0,     0,   330,
      83,     0,     0,     0,   170,     0,   171,   172,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    84,     0,     0,
    1381,     0,     0,    86,     0,     0,     0,     0,     0,    87,
       0,     0,     0,     0,    88,    89,    90,     0,     0,     0,
       0,     0,    91,     0,     0,     0,     0,   332,     0,     0,
      92,   333,     0,    93,     0,    94,    95,    96,     0,     0,
       0,   334,    97,    98,     0,     0,     0,     0,     0,     0,
       0,   335,   336,   337,   338,   339,     0,   340,   341,    99,
     100,   342,   343,   101,   344,   102,   103,   104,   105,   106,
     107,   108,     0,   109,   345,   110,   111,   112,   113,     0,
     114,   346,   115,     0,     0,     0,     0,     0,   116,   620,
       0,   117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   349,   350,
       0,     0,     0,     0,     0,     0,     0,     0,   351,   352,
     353,     0,     0,     0,     0,   355,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   118,   119,     0,     0,     0,
       0,     0,     0,   120,     0,     0,     0,   121,     0,     0,
       0,     0,     0,     0,   122,     0,     0,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,  1382,   134,
       0,     0,     0,     0,     0,   135,     0,     0,   136,     0,
       0,     0,   137,     0,     0,   138,   139,     0,   140,     0,
       0,   141,     0,   142,     0,     0,     0,   143,   144,     0,
       0,     0,     0,     0,     0,   356,   357,   358,   359,     0,
       0,     0,     0,     0,     0,   149,     0,     0,     0,   360,
       0,     0,     0,   361,   362,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   150,
     151,     0,     0,     0,     0,   152,   153,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,     0,
       0,   319,   320,     0,     0,    77,    78,   364,     0,    79,
     321,   322,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,     0,     0,    81,     0,     0,   323,   324,   325,
     326,   327,   328,   329,     0,    82,     0,     0,   279,   280,
     281,     0,     0,     0,     0,   330,    83,     0,     0,     0,
     170,     0,   171,   172,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    84,     0,     0,    85,     0,     0,    86,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     0,
      88,    89,    90,     0,     0,     0,     0,     0,    91,     0,
       0,     0,     0,   332,     0,     0,    92,   333,     0,    93,
       0,    94,    95,    96,     0,     0,     0,   334,    97,    98,
       0,     0,     0,     0,     0,     0,     0,   335,   336,   337,
     338,   339,     0,   340,   341,    99,   100,   342,   343,   101,
     344,   102,   103,   104,   105,   106,   107,   108,     0,   109,
     345,   110,   111,   112,   113,     0,   114,   346,   115,     0,
       0,     0,     0,     0,   116,   620,     0,   117,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   349,   350,     0,     0,     0,     0,
       0,     0,     0,     0,   351,   352,   353,     0,     0,     0,
       0,   355,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   118,   119,     0,     0,     0,     0,     0,     0,   120,
       0,     0,     0,   121,     0,     0,     0,     0,     0,     0,
     122,     0,     0,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,     0,   134,     0,     0,     0,     0,
       0,   135,     0,     0,   136,     0,     0,     0,   137,     0,
       0,   138,   139,     0,   140,     0,     0,   141,     0,   142,
       0,     0,     0,   143,   144,     0,     0,     0,     0,     0,
       0,   356,   357,   358,   359,     0,     0,     0,     0,     0,
       0,   149,     0,     0,     0,   360,  1693,     0,     0,   361,
     362,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   150,   151,     0,     0,     0,
       0,   152,   153,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,     0,     0,   319,   320,     0,
       0,    77,    78,   364,     0,    79,   321,   322,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    80,     0,     0,
      81,     0,     0,   323,   324,   325,   326,   327,   328,   329,
       0,    82,     0,     0,   279,   280,   281,     0,     0,     0,
       0,   330,    83,     0,     0,     0,   170,     0,   171,   172,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    84,
       0,     0,    85,     0,     0,    86,     0,     0,     0,     0,
       0,    87,     0,     0,     0,     0,    88,    89,    90,     0,
       0,     0,     0,     0,    91,     0,     0,     0,     0,   332,
       0,     0,    92,   333,     0,    93,     0,    94,    95,    96,
       0,     0,     0,   334,    97,    98,     0,     0,     0,     0,
       0,     0,     0,   335,   336,   337,   338,   339,  1566,   340,
     341,    99,   100,   342,   343,   101,   344,   102,   103,   104,
     105,   106,   107,   108,     0,   109,   345,   110,   111,   112,
     113,     0,   114,   346,   115,     0,     0,     0,     0,     0,
     116,   620,     0,   117,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     349,   350,     0,     0,     0,     0,     0,     0,     0,     0,
     351,   352,   353,     0,     0,     0,     0,   355,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   118,   119,     0,
       0,     0,     0,     0,     0,   120,     0,     0,     0,   121,
       0,     0,     0,     0,     0,     0,   122,     0,     0,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
       0,   134,     0,     0,     0,     0,     0,   135,     0,     0,
     136,     0,     0,     0,   137,     0,     0,   138,   139,     0,
     140,     0,     0,   141,     0,   142,     0,     0,     0,   143,
     144,     0,     0,     0,     0,     0,     0,   356,   357,   358,
     359,     0,     0,     0,     0,     0,     0,   149,     0,     0,
       0,   360,     0,     0,     0,   361,   362,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   150,   151,     0,     0,     0,     0,   152,   153,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,     0,     0,   319,   320,     0,     0,    77,    78,   364,
       0,    79,   321,   322,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    80,     0,     0,    81,     0,     0,   323,
     324,   325,   326,   327,   328,   329,     0,    82,     0,     0,
     279,   280,   281,     0,     0,     0,     0,   330,    83,     0,
       0,     0,   170,     0,   171,   172,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    84,     0,     0,    85,     0,
       0,    86,     0,     0,     0,     0,     0,    87,     0,     0,
       0,     0,    88,    89,    90,     0,     0,     0,     0,     0,
      91,     0,     0,     0,     0,   332,     0,     0,    92,   333,
       0,    93,     0,    94,    95,    96,     0,     0,     0,   334,
      97,    98,     0,     0,     0,     0,     0,     0,     0,   335,
     336,   337,   338,   339,     0,   340,   341,    99,   100,   342,
     343,   101,   344,   102,   103,   104,   105,   106,   107,   108,
       0,   109,   345,   110,   111,   112,   113,     0,   114,   346,
     115,     0,     0,     0,     0,     0,   116,   620,     0,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   349,   350,     0,     0,
       0,     0,     0,     0,     0,     0,   351,   352,   353,     0,
       0,     0,     0,   355,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   118,   119,     0,     0,     0,     0,     0,
       0,   120,     0,     0,     0,   121,     0,     0,     0,     0,
       0,     0,   122,     0,     0,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,     0,   134,     0,     0,
       0,     0,     0,   135,     0,     0,   136,     0,     0,     0,
     137,     0,     0,   138,   139,     0,   140,     0,     0,   141,
       0,   142,     0,     0,     0,   143,   144,     0,     0,     0,
       0,     0,     0,   356,   357,   358,   359,     0,     0,     0,
       0,     0,     0,   149,     0,     0,     0,   360,     0,     0,
       0,   361,   362,     0,    71,    72,    73,    74,    75,    76,
       0,     0,     0,     0,     0,     0,     0,   150,   151,     0,
       0,    77,    78,   152,   153,    79,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    80,     0,     0,
      81,     0,     0,     0,     0,   364,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,   170,   940,   171,   172,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    84,
       0,     0,    85,     0,     0,    86,     0,     0,     0,     0,
       0,    87,     0,     0,     0,     0,    88,    89,    90,     0,
       0,     0,     0,     0,    91,     0,     0,     0,     0,     0,
       0,     0,    92,     0,     0,    93,     0,    94,    95,    96,
       0,   662,     0,     0,    97,    98,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    99,   100,     0,     0,   101,     0,   102,   103,   104,
     105,   106,   107,   108,     0,   109,     0,   110,   111,   112,
     113,     0,   114,     0,   115,     0,     0,     0,     0,     0,
     116,   941,     0,   117,     0,     0,     0,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,     0,     0,
       0,     0,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   118,   119,     0,
       0,     0,     0,     0,     0,   120,     0,     0,     0,   121,
       0,     0,     0,     0,     0,     0,   122,     0,     0,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
       0,   134,     0,     0,     0,     0,     0,   135,     0,     0,
     136,     0,     0,     0,   137,     0,     0,   138,   139,     0,
     140,     0,     0,   141,     0,   142,     0,     0,     0,   143,
     144,     0,     0,     0,     0,     0,     0,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,   149,    71,    72,
      73,    74,    75,    76,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    77,    78,     0,     0,    79,
       0,   150,   151,     0,     0,     0,     0,   152,   153,     0,
       0,    80,  1215,     0,    81,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,     0,   942,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     3,     4,  1518,
       6,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       7,     8,     9,  1519,     0,     0,    85,     0,     0,  1520,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     0,
      88,    89,    90,     0,     0,     0,     0,     0,    91,     0,
       0,     0,     0,     0,     0,     0,    92,     0,     0,    93,
       0,    94,    95,    96,   662,     0,     0,     0,    97,    98,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    99,   100,     0,     0,   101,
       0,   102,   103,   104,   105,   106,   107,   108,     0,   109,
       0,   110,   111,   112,   113,     0,   114,     0,   115,     0,
       0,     0,     0,     0,   116,     0,     0,   117,     0,     0,
       0,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,     0,     0,     0,     0,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   118,   119,     0,     0,     0,     0,     0,     0,   120,
       0,     0,    14,   121,     0,     0,     0,     0,     0,     0,
     122,    15,  1522,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,     0,   134,    26,     0,     0,     0,
       0,   135,    27,    28,   136,     0,     0,     0,   137,     0,
       0,   138,   139,     0,   140,     0,     0,   141,    29,   142,
    1523,    30,     0,   143,   144,     0,     0,     0,     0,     0,
       0,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,   149,     0,     0,     0,  1524,     0,     0,  1987,     0,
       0,  1525,  1988,  -351,     0,     0,     0,     0,    32,    71,
      72,    73,    74,    75,    76,   150,   151,     0,     0,     0,
       0,   152,   153,     0,     0,  1614,    77,    78,     0,     0,
      79,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    80,     0,     0,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    83,     3,     4,
    1518,     6,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     7,     8,     9,  1519,     0,     0,    85,     0,     0,
    1520,     0,     0,     0,     0,     0,    87,     0,     0,     0,
       0,    88,    89,    90,     0,     0,     0,     0,     0,    91,
       0,     0,     0,     0,     0,     0,     0,    92,     0,     0,
      93,     0,    94,    95,    96,     0,   662,     0,     0,    97,
      98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    99,   100,     0,     0,
     101,     0,   102,   103,   104,   105,   106,   107,   108,     0,
     109,     0,   110,   111,   112,   113,     0,   114,     0,   115,
       0,     0,     0,     0,     0,   116,     0,     0,   117,     0,
       0,     0,     0,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,     0,     0,     0,     0,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   118,   119,     0,     0,     0,     0,     0,     0,
     120,     0,     0,    14,   121,     0,     0,     0,     0,     0,
    1521,   122,    15,  1522,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,     0,   134,    26,     0,     0,
       0,     0,   135,    27,    28,   136,     0,     0,     0,   137,
       0,     0,   138,   139,     0,   140,     0,     0,   141,    29,
     142,  1523,    30,     0,   143,   144,     0,     0,     0,     0,
       0,     0,   145,   146,   147,   148,  1419,     0,     0,     0,
       0,     0,   149,     0,     0,     0,  1524,     0,     0,     0,
       0,     0,  1525,     0,     0,     0,     0,  1526,     0,    32,
      71,    72,    73,    74,    75,    76,   150,   151,     0,     0,
       0,     0,   152,   153,     0,     0,     0,    77,    78,     0,
       0,    79,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    80,     0,     0,    81,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     3,
       4,  1518,     6,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     7,     8,     9,  1519,     0,     0,    85,     0,
       0,  1520,     0,     0,     0,     0,     0,    87,     0,     0,
       0,     0,    88,    89,    90,     0,     0,     0,     0,     0,
      91,     0,     0,     0,     0,     0,     0,     0,    92,     0,
       0,    93,     0,    94,    95,    96,     0,   662,     0,     0,
      97,    98,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    99,   100,     0,
       0,   101,     0,   102,   103,   104,   105,   106,   107,   108,
       0,   109,     0,   110,   111,   112,   113,     0,   114,     0,
     115,     0,     0,     0,     0,     0,   116,     0,     0,   117,
       0,     0,     0,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,     0,     0,     0,     0,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   118,   119,     0,     0,     0,     0,     0,
       0,   120,     0,     0,    14,   121,     0,     0,     0,     0,
       0,  1825,   122,    15,  1522,  1826,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,     0,   134,    26,     0,
       0,     0,     0,   135,    27,    28,   136,     0,     0,     0,
     137,     0,     0,   138,   139,     0,   140,     0,     0,   141,
      29,   142,  1523,    30,     0,   143,   144,     0,     0,     0,
       0,     0,     0,   145,   146,   147,   148,  1985,     0,     0,
       0,     0,     0,   149,     0,     0,     0,  1524,     0,     0,
       0,     0,     0,  1525,     0,     0,     0,     0,  1526,     0,
      32,    71,    72,    73,    74,    75,    76,   150,   151,     0,
       0,     0,     0,   152,   153,     0,     0,     0,    77,    78,
       0,     0,    79,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    80,     0,     0,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    83,
       3,     4,  1518,     6,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     7,     8,     9,  1519,     0,     0,    85,
       0,     0,  1520,     0,     0,     0,     0,     0,    87,     0,
       0,     0,     0,    88,    89,    90,     0,     0,     0,     0,
       0,    91,     0,     0,     0,     0,     0,     0,     0,    92,
       0,     0,    93,     0,    94,    95,    96,     0,     0,   662,
       0,    97,    98,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    99,   100,
       0,     0,   101,     0,   102,   103,   104,   105,   106,   107,
     108,     0,   109,     0,   110,   111,   112,   113,     0,   114,
       0,   115,     0,     0,     0,     0,     0,   116,     0,     0,
     117,     0,     0,     0,     0,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,     0,     0,     0,     0,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   118,   119,     0,     0,     0,     0,
       0,     0,   120,     0,     0,    14,   121,     0,     0,     0,
       0,     0,     0,   122,    15,  1522,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,     0,   134,    26,
       0,     0,     0,     0,   135,    27,    28,   136,     0,     0,
       0,   137,     0,     0,   138,   139,     0,   140,     0,     0,
     141,    29,   142,  1523,    30,     0,   143,   144,     0,     0,
       0,     0,     0,     0,   145,   146,   147,   148,   929,     0,
       0,     0,     0,     0,   149,     0,     0,     0,  1524,     0,
       0,     0,     0,     0,  1525,     0,  -351,     0,     0,     0,
       0,    32,    71,    72,    73,    74,    75,    76,   150,   151,
       0,     0,     0,     0,   152,   153,     0,     0,     0,    77,
      78,     0,     0,    79,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    80,     0,     0,    81,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     3,     4,  1518,     6,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     7,     8,     9,  1519,     0,     0,
      85,     0,     0,  1520,     0,     0,     0,     0,     0,    87,
       0,     0,     0,     0,    88,    89,    90,     0,     0,     0,
       0,     0,    91,     0,     0,     0,     0,     0,     0,     0,
      92,     0,     0,    93,     0,    94,    95,    96,     0,     0,
     662,     0,    97,    98,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    99,
     100,     0,     0,   101,     0,   102,   103,   104,   105,   106,
     107,   108,     0,   109,     0,   110,   111,   112,   113,     0,
     114,     0,   115,     0,     0,     0,     0,     0,   116,     0,
       0,   117,     0,     0,     0,     0,     0,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,     0,     0,     0,
       0,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   118,   119,     0,     0,     0,
       0,     0,     0,   120,     0,     0,    14,   121,     0,     0,
       0,     0,     0,     0,   122,    15,  1522,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,     0,   134,
      26,     0,     0,     0,     0,   135,    27,    28,   136,     0,
       0,     0,   137,     0,     0,   138,   139,     0,   140,     0,
       0,   141,    29,   142,  1523,    30,     0,   143,   144,     0,
       0,     0,     0,     0,     0,   145,   146,   147,   148,  1817,
       0,     0,     0,     0,     0,   149,     0,     0,     0,  1524,
       0,     0,     0,     0,     0,  1525,     0,     0,     0,     0,
       0,  2045,    32,    71,    72,    73,    74,    75,    76,   150,
     151,     0,     0,     0,     0,   152,   153,     0,     0,     0,
      77,    78,     0,     0,    79,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    80,     0,     0,    81,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    83,     3,     4,  1518,     6,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     7,     8,     9,  1519,     0,
       0,    85,     0,     0,  1520,     0,     0,     0,     0,     0,
      87,     0,     0,     0,     0,    88,    89,    90,     0,     0,
       0,     0,     0,    91,     0,     0,     0,     0,     0,     0,
       0,    92,     0,     0,    93,     0,    94,    95,    96,   662,
       0,     0,     0,    97,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      99,   100,     0,     0,   101,     0,   102,   103,   104,   105,
     106,   107,   108,     0,   109,     0,   110,   111,   112,   113,
       0,   114,     0,   115,     0,     0,     0,     0,     0,   116,
       0,     0,   117,     0,     0,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,     0,     0,     0,     0,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   118,   119,     0,     0,
       0,     0,     0,     0,   120,     0,     0,    14,   121,     0,
       0,     0,     0,     0,     0,   122,    15,  1522,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   686,
     134,    26,     0,     0,     0,     0,   135,    27,    28,   136,
       0,     0,     0,   137,     0,     0,   138,   139,     0,   140,
       0,     0,   141,    29,   142,  1523,    30,     0,   143,   144,
       0,     0,     0,     0,     0,     0,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,   149,     0,     0,     0,
    1524,     0,     0,     0,     0,     0,  1525,    71,    72,    73,
      74,    75,    76,    32,     0,     0,     0,     0,     0,     0,
     150,   151,     0,     0,    77,    78,   152,   153,    79,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      80,     0,     0,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    83,     3,     4,  1518,     6,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     7,
       8,     9,  1519,     0,     0,    85,     0,     0,  1520,     0,
       0,     0,     0,     0,    87,     0,  1255,     0,     0,    88,
      89,    90,     0,     0,     0,     0,     0,    91,     0,     0,
       0,     0,     0,     0,     0,    92,     0,     0,    93,     0,
      94,    95,    96,   662,     0,     0,     0,    97,    98,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    99,   100,     0,     0,   101,     0,
     102,   103,   104,   105,   106,   107,   108,     0,   109,     0,
     110,   111,   112,   113,     0,   114,     0,   115,     0,     0,
       0,     0,     0,   116,     0,     0,   117,     0,     0,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
       0,     0,     0,     0,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     118,   119,     0,     0,     0,     0,     0,     0,   120,     0,
       0,     0,   121,     0,     0,     0,     0,     0,     0,   122,
      15,  1522,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,     0,   134,     0,     0,     0,     0,     0,
     135,    27,    28,   136,     0,     0,     0,   137,     0,     0,
     138,   139,     0,   140,     0,     0,   141,    29,   142,  1523,
       0,     0,   143,   144,     0,     0,     0,     0,     0,     0,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
     149,     0,     0,     0,  1524,     0,     0,     0,     0,     0,
    1525,     0,     0,     0,     0,  1967,     0,    32,    71,    72,
      73,    74,    75,    76,   150,   151,     0,     0,     0,     0,
     152,   153,     0,     0,     0,    77,    78,     0,     0,    79,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,     0,     0,    81,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     3,     4,  1518,
       6,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       7,     8,     9,  1519,     0,     0,    85,     0,     0,  1520,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     0,
      88,    89,    90,     0,  1609,     0,     0,     0,    91,     0,
       0,     0,     0,     0,     0,     0,    92,     0,     0,    93,
       0,    94,    95,    96,     0,     0,   662,     0,    97,    98,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    99,   100,     0,     0,   101,
       0,   102,   103,   104,   105,   106,   107,   108,     0,   109,
       0,   110,   111,   112,   113,  1610,   114,     0,   115,     0,
       0,     0,     0,     0,   116,     0,     0,   117,     0,     0,
       0,     0,     0,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,     0,     0,     0,     0,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   118,   119,     0,     0,     0,     0,     0,     0,   120,
       0,     0,     0,   121,     0,     0,     0,     0,     0,     0,
     122,    15,  1522,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,     0,   134,     0,     0,     0,     0,
       0,   135,    27,    28,   136,     0,     0,     0,   137,     0,
       0,   138,   139,     0,   140,     0,     0,   141,    29,   142,
    1523,     0,     0,   143,   144,     0,     0,     0,     0,     0,
       0,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,   149,     0,     0,     0,  1524,     0,     0,     0,     0,
       0,  1525,     0,     0,     0,     0,     0,  2081,    32,     0,
       0,     0,     0,     0,     0,   150,   151,     0,     0,     0,
       0,   152,   153,    71,    72,    73,    74,    75,    76,     0,
       0,     0,     0,     0,     0,   234,     0,     0,     0,     0,
      77,    78,     0,     0,    79,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    80,     0,     0,    81,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,   236,     0,     0,     0,
       0,    83,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    84,     0,
       0,    85,     0,     0,    86,     0,     0,     0,     0,     0,
      87,     0,     0,     0,     0,    88,    89,    90,     0,     0,
       0,     0,     0,    91,     0,     0,     0,     0,     0,     0,
       0,    92,     0,     0,    93,     0,    94,    95,    96,   662,
       0,     0,     0,    97,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      99,   100,     0,     0,   101,     0,   102,   103,   104,   105,
     106,   107,   108,     0,   109,     0,   110,   111,   112,   113,
       0,   114,     0,   115,     0,     0,     0,     0,     0,   116,
       0,     0,   117,     0,     0,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,     0,     0,     0,     0,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,     0,     0,     0,     0,     0,     0,  1150,
    1151,     0,     0,     0,     0,     0,   290,   291,   242,   243,
     244,   245,     0,     0,   120,     0,     0,     0,   121,     0,
       0,     0,     0,     0,     0,   122,     0,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,     0,
     134,     0,     0,     0,     0,     0,   135,     0,     0,   136,
       0,     0,     0,   137,     0,     0,   138,   139,     0,   140,
       0,     0,   141,     0,   142,     0,     0,     0,   292,   144,
       0,     0,     0,     0,     0,     0,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,   149,    71,    72,    73,
      74,    75,    76,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    77,    78,     0,     0,    79,     0,
     150,   151,     0,     0,     0,     0,   152,   153,     0,     0,
      80,     0,     0,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,     0,   279,   280,   281,
       0,     0,     0,     0,     0,   282,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    84,     0,     0,    85,     0,     0,    86,     0,
       0,     0,     0,     0,    87,     0,     0,     0,     0,    88,
      89,    90,     0,     0,     0,     0,     0,    91,     0,     0,
       0,     0,     0,     0,     0,    92,     0,     0,    93,     0,
      94,    95,    96,   662,     0,     0,     0,    97,    98,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    99,   100,     0,     0,   101,     0,
     102,   103,   104,   105,   106,   107,   108,     0,   109,     0,
     110,   111,   112,   113,     0,   114,     0,   115,     0,     0,
       0,  1201,     0,   116,   283,     0,   117,     0,     0,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
       0,     0,     0,     0,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     118,   119,     0,     0,     0,     0,     0,     0,   120,     0,
       0,     0,   121,     0,     0,     0,     0,     0,     0,   122,
       0,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,     0,   134,     0,     0,     0,     0,     0,
     135,     0,     0,   284,     0,     0,     0,   137,     0,     0,
     138,   139,     0,   140,     0,     0,   285,     0,   142,     0,
       0,     0,   143,   144,     0,     0,     0,     0,     0,     0,
     145,   286,   147,   148,     0,     0,     0,     0,     0,     0,
     149,    71,    72,    73,    74,    75,    76,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    77,    78,
       0,     0,    79,     0,   150,   151,     0,     0,     0,     0,
     152,   153,     0,     0,    80,     0,     0,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    83,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    84,     0,     0,    85,
       0,     0,    86,     0,     0,     0,     0,     0,    87,     0,
       0,     0,     0,    88,    89,    90,     0,     0,     0,     0,
       0,    91,     0,     0,     0,     0,     0,     0,     0,    92,
       0,     0,    93,     0,    94,    95,    96,     0,     0,   662,
       0,    97,    98,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    99,   100,
       0,     0,   101,     0,   102,   103,   104,   105,   106,   107,
     108,     0,   109,     0,   110,   111,   112,   113,  1565,   114,
       0,   729,     0,     0,     0,     0,     0,   116,     0,     0,
     117,     0,     0,     0,     0,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,     0,     0,     0,     0,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   118,   119,     0,     0,     0,     0,
       0,     0,   120,     0,     0,     0,   121,   268,   269,   270,
     271,     0,     0,   122,     0,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,     0,   134,     0,
       0,     0,     0,     0,   135,     0,     0,   136,     0,     0,
       0,   137,     0,     0,   138,   139,     0,   140,     0,     0,
     141,     0,   142,     0,     0,     0,   730,   144,     0,     0,
       0,     0,     0,     0,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,   149,    71,    72,    73,  1013,  1014,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    77,    78,     0,     0,    79,     0,   150,   151,
       0,     0,     0,     0,   152,   153,     0,     0,    80,     0,
       0,    81,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    83,     0,     0,     0,   170,     0,   171,
     172,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      84,     0,     0,    85,     0,     0,    86,     0,     0,     0,
       0,     0,    87,     0,     0,     0,     0,    88,    89,    90,
       0,     0,     0,     0,     0,    91,     0,     0,     0,     0,
       0,     0,     0,    92,     0,     0,    93,     0,    94,    95,
      96,   662,     0,     0,     0,    97,    98,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    99,   100,     0,     0,   101,     0,   102,   103,
     104,   105,   106,   107,   108,     0,   109,     0,   110,   111,
     112,   113,     0,   114,     0,   115,     0,     0,     0,     0,
       0,   116,     0,     0,   117,     0,     0,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,     0,     0,
       0,     0,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,  1016,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   118,   119,
       0,     0,     0,     0,     0,     0,   120,     0,     0,     0,
     121,     0,     0,     0,     0,     0,     0,   122,     0,     0,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,     0,   134,     0,     0,     0,     0,     0,   135,     0,
       0,   136,     0,     0,     0,   137,     0,     0,   138,   139,
       0,   140,     0,     0,   141,     0,   142,     0,     0,     0,
     143,   144,     0,     0,     0,     0,     0,     0,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,   149,    71,
      72,    73,    74,    75,    76,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    77,    78,     0,     0,
      79,     0,   150,   151,     0,     0,     0,     0,   152,   153,
       0,     0,    80,     0,     0,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    83,     0,     0,
       0,   170,     0,   171,   172,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    84,     0,     0,    85,     0,     0,
      86,     0,     0,     0,     0,     0,    87,     0,     0,     0,
       0,    88,    89,    90,     0,     0,     0,     0,     0,    91,
       0,     0,     0,     0,     0,     0,     0,    92,     0,     0,
      93,     0,    94,    95,    96,     0,     0,   662,     0,    97,
      98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    99,   100,     0,     0,
     101,     0,   102,   103,   104,   105,   106,   107,   108,     0,
     109,     0,   110,   111,   112,   113,  1613,   114,     0,   115,
       0,     0,     0,     0,     0,   116,   594,     0,   117,     0,
       0,     0,     0,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,     0,     0,     0,     0,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   118,   119,     0,     0,     0,     0,     0,     0,
     120,     0,     0,     0,   121,     0,     0,     0,     0,     0,
       0,   122,     0,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,     0,   134,     0,     0,     0,
       0,     0,   135,     0,     0,   136,     0,     0,     0,   137,
       0,     0,   138,   139,     0,   140,     0,     0,   141,     0,
     142,     0,     0,     0,   143,   144,     0,     0,     0,     0,
       0,     0,   145,   146,   147,   148,     0,     0,     0,     0,
       0,     0,   149,    71,    72,    73,  1013,  1014,  1015,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      77,    78,     0,     0,    79,     0,   150,   151,     0,     0,
       0,     0,   152,   153,     0,     0,    80,     0,     0,    81,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    83,     0,     0,     0,   170,     0,   171,   172,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    84,     0,
       0,    85,     0,     0,    86,     0,     0,     0,     0,     0,
      87,     0,     0,     0,     0,    88,    89,    90,     0,     0,
       0,     0,     0,    91,     0,     0,     0,     0,     0,     0,
       0,    92,     0,     0,    93,     0,    94,    95,    96,     0,
       0,     0,     0,    97,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      99,   100,     0,     0,   101,     0,   102,   103,   104,   105,
     106,   107,   108,     0,   109,     0,   110,   111,   112,   113,
       0,   114,     0,   115,     0,     0,     0,     0,     0,   116,
       0,     0,   117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1456,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   118,   119,     0,     0,
       0,     0,     0,     0,   120,     0,     0,     0,   121,     0,
       0,     0,     0,     0,     0,   122,     0,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,     0,
     134,     0,     0,     0,     0,     0,   135,     0,     0,   136,
       0,     0,     0,   137,     0,     0,   138,   139,     0,   140,
       0,     0,   141,     0,   142,     0,     0,     0,   143,   144,
       0,     0,     0,     0,     0,     0,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,   149,    71,    72,    73,
      74,    75,    76,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    77,    78,     0,     0,    79,     0,
     150,   151,     0,     0,     0,     0,   152,   153,     0,     0,
      80,     0,     0,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    83,     0,     0,     0,   170,
       0,   171,   172,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    84,     0,     0,    85,     0,     0,    86,     0,
       0,     0,     0,     0,    87,     0,     0,     0,     0,    88,
      89,    90,     0,     0,     0,     0,     0,    91,     0,     0,
       0,     0,     0,     0,     0,    92,     0,     0,    93,     0,
      94,    95,    96,     0,     0,   662,     0,    97,    98,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    99,   100,     0,     0,   101,     0,
     102,   103,   104,   105,   106,   107,   108,     0,   109,     0,
     110,   111,   112,   113,  1616,   114,     0,   115,     0,     0,
       0,     0,     0,   116,     0,     0,   117,     0,     0,     0,
       0,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,     0,     0,     0,     0,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     118,   119,     0,     0,     0,     0,     0,     0,   120,     0,
       0,     0,   121,     0,     0,     0,     0,     0,     0,   122,
       0,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,     0,   134,     0,     0,     0,     0,     0,
     135,     0,     0,   136,     0,     0,     0,   137,     0,     0,
     138,   139,     0,   140,     0,     0,   141,     0,   142,     0,
       0,     0,   143,   144,     0,     0,     0,     0,     0,     0,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
     149,    71,    72,    73,  1013,  1014,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    77,    78,
       0,     0,    79,     0,   150,   151,     0,     0,     0,     0,
     152,   153,     0,     0,    80,     0,     0,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    83,
       0,     0,     0,   170,     0,   171,   172,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    84,     0,     0,    85,
       0,     0,    86,     0,     0,     0,     0,     0,    87,     0,
       0,     0,     0,    88,    89,    90,     0,     0,     0,     0,
       0,    91,     0,     0,     0,     0,     0,     0,     0,    92,
       0,     0,    93,     0,    94,    95,    96,     0,     0,   662,
       0,    97,    98,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    99,   100,
       0,     0,   101,     0,   102,   103,   104,   105,   106,   107,
     108,     0,   109,     0,   110,   111,   112,   113,  1859,   114,
       0,   115,     0,     0,     0,     0,     0,   116,     0,     0,
     117,     0,     0,     0,     0,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,     0,     0,     0,     0,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   118,   119,     0,     0,     0,     0,
       0,     0,   120,     0,     0,     0,   121,     0,     0,     0,
       0,     0,     0,   122,     0,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,     0,   134,     0,
       0,     0,     0,     0,   135,     0,     0,   136,     0,     0,
       0,   137,     0,     0,   138,   139,     0,   140,     0,     0,
     141,     0,   142,     0,     0,     0,   143,   144,     0,     0,
       0,     0,     0,     0,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,   149,    71,    72,    73,    74,    75,
      76,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    77,    78,     0,     0,    79,     0,   150,   151,
       0,     0,     0,     0,   152,   153,     0,     0,    80,     0,
       0,    81,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    83,     0,     0,   167,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      84,     0,     0,    85,     0,     0,    86,     0,     0,     0,
       0,     0,    87,     0,     0,     0,     0,    88,    89,    90,
       0,     0,     0,     0,     0,    91,     0,     0,     0,     0,
       0,     0,     0,    92,     0,     0,    93,     0,    94,    95,
      96,     0,     0,   662,     0,    97,    98,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    99,   100,     0,     0,   101,     0,   102,   103,
     104,   105,   106,   107,   108,     0,   109,     0,   110,   111,
     112,   113,  1860,   114,     0,   115,     0,     0,     0,     0,
       0,   116,    13,     0,   117,     0,     0,     0,     0,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
       0,     0,     0,     0,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   118,   119,
       0,     0,     0,     0,     0,     0,   120,     0,     0,     0,
     121,     0,     0,     0,     0,     0,     0,   122,     0,     0,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,     0,   134,     0,     0,     0,     0,     0,   135,     0,
       0,   136,     0,     0,     0,   137,     0,     0,   138,   139,
       0,   140,     0,     0,   141,     0,   142,     0,     0,     0,
     143,   144,     0,     0,     0,     0,     0,     0,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,   149,    71,
      72,    73,    74,    75,    76,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    77,    78,     0,     0,
      79,     0,   150,   151,     0,     0,     0,     0,   152,   153,
       0,     0,    80,     0,     0,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    83,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    84,     0,     0,    85,     0,     0,
      86,     0,     0,     0,     0,     0,    87,     0,     0,     0,
       0,    88,    89,    90,     0,     0,     0,     0,     0,    91,
       0,     0,     0,     0,     0,     0,     0,    92,     0,     0,
      93,     0,    94,    95,    96,     0,     0,     0,     0,    97,
      98,     0,   662,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    99,   100,     0,     0,
     101,     0,   102,   103,   104,   105,   106,   107,   108,     0,
     109,     0,   110,   111,   112,   113,     0,   114,     0,   115,
       0,  1861,     0,     0,     0,   116,     0,     0,   117,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1326,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,     0,
       0,     0,     0,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,     0,     0,     0,     0,
       0,     0,   118,   119,     0,     0,     0,     0,     0,     0,
     120,     0,  1296,     0,   121,     0,     0,     0,     0,     0,
       0,   122,     0,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,     0,   134,     0,     0,     0,
       0,     0,   135,     0,     0,   136,     0,     0,     0,   137,
       0,     0,   138,   139,     0,   140,     0,     0,   141,     0,
     142,     0,     0,     0,   143,   144,     0,     0,     0,     0,
       0,     0,   145,   146,   147,   148,     0,     0,     0,     0,
       0,     0,   149,    71,    72,    73,    74,    75,    76,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      77,    78,     0,     0,    79,     0,   150,   151,     0,     0,
       0,     0,   152,   153,     0,     0,    80,     0,     0,    81,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    83,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    84,     0,
       0,    85,     0,     0,    86,     0,     0,     0,     0,     0,
      87,     0,     0,     0,     0,    88,    89,    90,     0,     0,
       0,     0,     0,    91,     0,     0,     0,     0,     0,     0,
       0,    92,     0,     0,    93,     0,    94,    95,    96,     0,
       0,     0,     0,    97,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      99,   100,     0,     0,   101,     0,   102,   103,   104,   105,
     106,   107,   108,     0,   109,     0,   110,   111,   112,   113,
       0,   114,     0,   115,     0,     0,     0,     0,     0,   116,
       0,     0,   117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   118,   119,     0,     0,
       0,     0,     0,     0,   120,     0,     0,     0,   121,     0,
       0,     0,     0,     0,     0,   122,     0,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,     0,
     134,     0,     0,     0,     0,     0,   135,     0,     0,   136,
       0,     0,     0,   137,     0,     0,   138,   139,     0,   140,
       0,     0,   141,   460,   142,     0,     0,     0,   143,   144,
       0,     0,     0,     0,     0,     0,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,   149,    71,    72,    73,
      74,    75,    76,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    77,    78,     0,     0,    79,     0,
     150,   151,     0,     0,     0,     0,   152,   153,     0,     0,
      80,     0,     0,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    83,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    84,     0,     0,    85,     0,     0,    86,     0,
       0,     0,     0,     0,    87,     0,     0,     0,     0,    88,
      89,    90,     0,     0,     0,     0,     0,    91,     0,     0,
       0,     0,     0,     0,     0,    92,     0,     0,    93,     0,
      94,    95,    96,     0,     0,     0,     0,    97,    98,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    99,   100,     0,     0,   101,     0,
     102,   103,   104,   105,   106,   107,   108,     0,   109,     0,
     110,   111,   112,   113,     0,   114,     0,   115,     0,     0,
       0,     0,     0,   116,   283,     0,   117,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     118,   119,     0,     0,     0,     0,     0,     0,   120,     0,
       0,     0,   121,     0,     0,     0,     0,     0,     0,   122,
       0,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,     0,   134,     0,     0,     0,     0,     0,
     135,     0,     0,   136,     0,     0,     0,   137,     0,     0,
     138,   139,     0,   140,     0,     0,   141,     0,   142,     0,
       0,     0,   143,   144,     0,     0,     0,     0,     0,     0,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
     149,    71,    72,    73,    74,    75,    76,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    77,    78,
       0,     0,    79,     0,   150,   151,     0,     0,     0,     0,
     152,   153,     0,     0,    80,     0,     0,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    83,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    84,     0,     0,    85,
       0,     0,    86,     0,     0,     0,     0,     0,    87,     0,
       0,     0,     0,    88,    89,    90,     0,     0,     0,     0,
       0,    91,     0,     0,     0,     0,     0,     0,     0,    92,
       0,     0,    93,     0,    94,    95,    96,     0,     0,     0,
       0,    97,    98,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    99,   100,
       0,     0,   101,     0,   102,   103,   104,   105,   106,   107,
     108,     0,   109,     0,   110,   111,   112,   113,     0,   114,
       0,   115,     0,     0,     0,     0,     0,   116,     0,     0,
     117,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1108,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   118,   119,     0,     0,     0,     0,
       0,     0,   120,     0,     0,     0,   121,     0,     0,     0,
       0,     0,     0,   122,     0,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,     0,   134,     0,
       0,     0,     0,     0,   135,     0,     0,   136,     0,     0,
       0,   137,     0,     0,   138,   139,     0,   140,     0,     0,
     141,     0,   142,     0,     0,     0,   143,   144,     0,     0,
       0,     0,     0,     0,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,   149,    71,    72,    73,    74,    75,
      76,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    77,    78,     0,     0,    79,     0,   150,   151,
       0,     0,     0,     0,   152,   153,     0,     0,    80,     0,
       0,    81,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    83,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      84,     0,     0,    85,     0,     0,    86,     0,     0,     0,
       0,     0,    87,     0,     0,     0,     0,    88,    89,    90,
       0,     0,     0,     0,     0,    91,     0,     0,     0,     0,
       0,     0,     0,    92,     0,     0,    93,     0,    94,    95,
      96,     0,     0,     0,     0,    97,    98,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    99,   100,     0,     0,   101,     0,   102,   103,
     104,   105,   106,   107,   108,     0,   109,     0,   110,   111,
     112,   113,     0,   114,     0,   115,     0,     0,     0,     0,
       0,   116,     0,     0,   117,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   118,   119,
       0,     0,     0,     0,     0,     0,   120,     0,  1296,     0,
     121,     0,     0,     0,     0,     0,     0,   122,     0,     0,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,     0,   134,     0,     0,     0,     0,     0,   135,     0,
       0,   136,     0,     0,     0,   137,     0,     0,   138,   139,
       0,   140,     0,     0,   141,     0,   142,     0,     0,     0,
     143,   144,     0,     0,     0,     0,     0,     0,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,   149,    71,
      72,    73,    74,    75,    76,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    77,    78,     0,     0,
      79,     0,   150,   151,     0,     0,     0,     0,   152,   153,
       0,     0,    80,     0,     0,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    83,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    84,     0,     0,    85,     0,     0,
      86,     0,     0,     0,     0,     0,    87,     0,     0,     0,
       0,    88,    89,    90,     0,     0,     0,     0,     0,    91,
       0,     0,     0,     0,     0,     0,     0,    92,     0,     0,
      93,     0,    94,    95,    96,     0,     0,     0,     0,    97,
      98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    99,   100,     0,     0,
     101,     0,   102,   103,   104,   105,   106,   107,   108,     0,
     109,     0,   110,   111,   112,   113,     0,   114,     0,   115,
       0,     0,     0,     0,     0,   116,     0,     0,   117,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   118,   119,     0,     0,     0,     0,     0,     0,
     120,     0,     0,     0,   121,     0,     0,     0,     0,     0,
       0,   122,     0,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,     0,   134,     0,     0,     0,
       0,     0,   135,     0,     0,   136,     0,     0,     0,   137,
       0,     0,   138,   139,     0,   140,     0,     0,   141,     0,
     142,     0,     0,     0,   143,   144,     0,     0,     0,     0,
       0,     0,   145,   146,   147,   148,     0,     0,     0,     0,
       0,     0,   149,    71,    72,    73,    74,    75,    76,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      77,    78,     0,     0,    79,     0,   150,   151,     0,     0,
       0,     0,   152,   153,     0,     0,    80,     0,     0,    81,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    83,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    84,     0,
       0,    85,     0,     0,    86,     0,     0,     0,     0,     0,
      87,     0,     0,     0,     0,    88,    89,    90,     0,     0,
       0,     0,     0,    91,     0,     0,     0,     0,     0,     0,
       0,    92,     0,     0,    93,     0,    94,    95,    96,     0,
       0,     0,     0,    97,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      99,   100,     0,     0,   101,     0,   102,   103,   104,   105,
     106,   107,   108,     0,   109,     0,   110,   111,   112,   113,
       0,   114,     0,   115,     0,     0,     0,     0,     0,   116,
       0,     0,   117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   118,   119,     0,     0,
       0,     0,     0,     0,   795,     0,     0,     0,   121,     0,
       0,     0,     0,     0,     0,   122,     0,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,     0,
     134,     0,     0,     0,     0,     0,   135,     0,     0,   136,
       0,     0,     0,   137,     0,     0,   138,   139,     0,   140,
       0,     0,   141,     0,   142,     0,     0,     0,   143,   144,
       0,     0,     0,     0,     0,     0,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,   149,    71,    72,    73,
      74,    75,    76,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    77,    78,     0,     0,    79,     0,
     150,   151,     0,     0,     0,     0,   152,   153,     0,     0,
      80,     0,     0,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    83,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    84,     0,     0,    85,     0,     0,    86,     0,
       0,     0,     0,     0,    87,     0,     0,     0,     0,    88,
      89,    90,     0,     0,     0,     0,     0,    91,     0,     0,
       0,     0,     0,     0,     0,    92,     0,     0,    93,     0,
      94,    95,    96,     0,   -14,     1,     0,    97,    98,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    99,   100,     0,     0,   101,     0,
     102,   103,   104,   105,   106,   107,   108,     0,   109,     0,
     110,   111,   112,   113,     0,   114,     0,   115,     0,     0,
       0,     0,     0,   116,     2,     0,   117,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     3,     4,     5,
       6,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       7,     8,     9,    10,     0,     0,     0,     0,     0,    11,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     118,   119,     0,     0,     0,     0,     0,     0,   120,     0,
       0,     0,   121,     0,     0,     0,     0,     0,     0,   122,
       0,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,     0,   134,     0,    12,     0,     0,     0,
     135,     0,     0,   136,     0,     0,     0,   137,     0,     0,
     138,   139,     0,   140,     0,     0,   141,     0,   142,     0,
       0,     0,   143,   144,     0,     0,     0,     0,     0,     0,
     145,   146,   147,   148,     0,    13,     0,     0,     0,     0,
     149,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   150,  1239,     0,     0,     0,     0,
     152,   153,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    14,     0,     0,     0,     0,     0,     0,     0,
       0,    15,    16,     0,    17,     0,    18,    19,    20,    21,
      22,    23,    24,    25,     0,     0,    26,     0,     0,     0,
       0,     0,    27,    28,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,    30,     0,     0,     0,     0,     0,     0,     0,     0,
      31,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    32
};

static const yytype_int16 yycheck[] =
{
       4,     0,   295,   305,    39,     9,    40,   420,     0,   177,
     295,   167,    16,    17,   295,     0,   784,   431,   218,   220,
       0,   189,   190,   643,     0,   193,   769,    31,  1072,    35,
     946,   596,     0,   599,    16,    39,    40,   435,   692,   556,
       0,   607,   698,   601,  1065,     3,  1342,     0,   216,    10,
     347,   609,     3,    27,     3,  1369,   892,    65,   894,   555,
      15,   941,   331,   572,   966,   967,    70,   462,   572,   905,
     948,    27,   513,   514,   515,  1096,   347,   348,    10,   749,
     750,    13,   807,   808,   809,   755,    26,   103,   450,   210,
    1653,    84,   363,   109,    57,   110,     4,     5,     6,     7,
       8,     9,   186,     3,     0,   266,  1716,  1185,     3,  1719,
       3,   157,     0,   434,  1439,   646,  1896,   186,    41,    42,
     171,   110,   176,   110,   745,  1322,    65,    13,  1442,   171,
       0,   511,    63,   171,   150,    82,  1450,     0,   171,   110,
      82,   157,   252,   110,    65,    65,   254,    66,   286,     4,
    1937,   171,    83,   281,   299,   159,   160,   217,   218,    82,
     781,   165,    17,   171,   274,    82,   274,   109,    87,   110,
     315,     4,     5,     6,     7,     8,     9,   159,   286,   178,
     179,   180,   181,   344,   171,    54,   178,   179,   180,   181,
     171,   108,   262,   178,   179,   180,   181,   251,   178,   179,
     180,   181,   178,   179,   180,   181,   344,   211,   212,   213,
     178,   179,   180,   181,   718,    70,   344,  2004,   178,   179,
     180,   181,   171,   170,  1698,   178,   179,   180,   181,  1792,
     229,   235,   171,   207,   303,   239,   533,   229,   322,   172,
     749,   750,   246,   247,   229,   114,   755,   251,   252,   229,
     171,   171,   208,   229,   172,   259,   260,   261,   262,   263,
     264,   229,   531,   267,   268,   269,   270,   271,   272,   229,
     305,   171,   276,   277,   475,    10,   229,   574,   171,   283,
     284,   285,   178,   179,   180,   181,  2066,   700,   585,   586,
     178,   179,   180,   181,   345,   190,   191,   695,   344,  1496,
    1625,   305,   306,   345,  1220,   160,   322,   345,   178,   179,
     180,   181,   345,   610,  1924,   178,   179,   180,   181,   640,
     248,   252,   262,   620,  1402,   345,   494,   290,   344,   344,
      65,   335,   218,   229,   851,   901,   344,   458,   635,   610,
    1814,   229,  1222,  1221,   214,   876,  1820,   286,   341,   907,
    1186,   274,  1006,  1189,  1008,   344,   852,   212,   213,   229,
     318,   316,   757,   271,   345,   286,   229,   871,   317,   810,
     307,   308,   309,   344,   378,   737,   738,   344,  1048,   650,
     651,    10,  1107,   186,   239,   420,   286,  1322,   349,   660,
      65,   246,   343,   286,   172,  1958,   251,   252,    15,  1713,
       3,   176,    65,  1699,   259,   260,   261,   262,  1704,   264,
     279,   344,   267,   268,   269,   270,   271,   349,   335,   356,
       0,   276,   277,   340,   172,   258,   344,   431,   261,   110,
    1904,   435,   812,   813,   814,   815,   171,  1807,   172,  1913,
     109,    65,   172,   823,   824,   825,   172,   109,   452,   431,
       3,    68,    69,    70,   172,    72,    73,    82,    75,   631,
     464,   347,   172,   756,   132,   172,   470,   404,   405,   172,
     474,   756,   266,   172,    80,   756,   251,   186,   775,   453,
       3,   150,   126,    65,   347,  1506,   172,   131,   492,   493,
     783,  1442,   496,   449,   498,    78,   171,   232,   783,  1450,
     534,   505,   783,   507,   508,   509,   510,   310,   171,  1411,
    1412,  1985,   172,  1987,   518,   519,   520,   718,    20,    21,
     918,   286,   526,   378,   817,  1821,    86,   172,   532,    52,
     534,   110,   817,   186,   159,   472,     0,   162,   286,  1048,
     172,   834,   171,   186,  1380,   132,  1916,   171,  1918,   834,
     344,   286,   169,   834,   558,  1391,   109,   485,   486,   487,
     488,  1496,  1398,   172,   299,   172,   344,  1223,   171,   497,
     172,   186,   773,   875,   172,   250,    54,   172,  1143,   344,
     877,   262,   132,   227,   165,   166,   167,   250,   250,   171,
     911,     0,   478,  2067,   303,    85,   344,   452,   178,   179,
     180,   181,   172,   771,   274,   874,   250,   172,   283,  1229,
     344,   286,  1266,  1171,   344,   470,  1236,   172,   344,   474,
     283,   172,   628,   286,   630,   115,   344,   117,   118,   119,
     120,   121,   122,   279,   344,   125,   114,   344,   493,   643,
     644,   344,   172,   498,   648,   344,   917,   172,   265,   229,
     505,   172,   507,   508,   509,   510,   172,    98,   344,   283,
     303,   643,   286,   518,   519,   520,   345,   938,   109,   171,
     871,   940,   844,   845,   178,   179,   109,    63,    64,    65,
      66,   327,   172,   262,   344,   689,   164,   691,   303,   188,
     961,   695,   696,   964,   965,    38,    39,   634,   176,   344,
     321,   283,  1618,   709,   286,   974,    19,   689,   594,  1030,
      23,    24,   344,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,   610,   229,   730,    70,    85,   171,
      83,   594,   124,   174,   620,   344,  1116,   344,   270,    52,
      53,   174,   344,  1787,  1788,   172,   344,   610,    54,   344,
     171,   229,   230,   231,   232,   233,   148,   620,   115,   186,
     117,   118,   119,   120,   121,   122,   770,   348,   125,   178,
     179,   180,   181,   279,   344,    63,    64,    65,    66,   344,
    1049,   345,   260,   787,   788,   789,   790,    82,   141,   344,
     176,   795,   281,   344,     4,     5,     6,     7,     8,     9,
     804,   279,   806,   807,   808,   809,   284,   811,   114,   250,
     696,   114,   101,  1433,   344,  1435,   227,   253,  1111,   344,
     229,   327,   109,   344,   172,   344,  1111,   172,   344,   348,
    1111,  1397,   322,   269,  1400,   841,    57,   344,   186,   126,
     875,   186,   320,  1360,   131,   323,   282,  1245,  1049,   157,
     153,   857,   109,    63,    64,    65,    66,   152,   164,   265,
     155,   109,   248,   249,   172,    86,   266,  1265,   279,   280,
     176,   875,  1165,  1166,   878,   730,   165,   166,   167,  1080,
    1165,  1166,   344,   887,  1165,  1166,   272,   174,  1209,   775,
     266,   895,   114,    86,   252,  1216,   157,  1218,   902,   147,
    1100,   149,   150,   262,    87,  1073,   843,    90,  1288,  1289,
    1290,   172,   775,    96,   918,   770,   274,   174,    10,   277,
     278,  1664,  1665,   229,   230,   231,   232,   233,   314,   151,
     262,   153,   787,   788,   789,   790,   940,   941,   171,   226,
     227,   235,   946,   947,   948,   239,    68,    69,    70,   804,
      72,    73,    74,    75,   260,   279,   811,   101,   940,   941,
     248,   249,   228,   250,    87,   322,   176,   273,   164,   226,
     279,    94,    95,   279,  1083,  1084,  1085,  1086,   284,   865,
     866,   867,   269,   279,   272,   272,   252,   924,   279,   926,
       4,   307,   258,   259,   307,   282,    10,  1106,   320,  1619,
     115,   116,   117,   118,   119,   120,   121,   122,  1301,   279,
     125,   277,   269,  1645,   320,   272,  1301,   323,  1022,  1651,
    1301,   165,   166,   167,    55,   282,   231,   164,   172,   231,
      61,   344,   887,   307,   230,   231,   232,   233,   248,   249,
     225,  1045,  1046,   217,   218,   133,  1888,   169,  1890,  1891,
    1892,  1055,  1056,    63,    64,  1059,    66,  1350,   297,  1063,
    1064,  1065,   272,   175,  1068,  1350,   326,   327,   328,   329,
    1636,   941,    68,    69,    70,   175,    72,    73,   941,    75,
     966,   967,   151,  1087,   153,   302,  1068,   304,  1409,  1410,
    1094,   175,  1096,   230,   231,   232,   233,  1040,  1419,  1042,
    1043,  1105,   279,  1107,   314,   103,  1917,  1044,  1919,   175,
    1523,   279,   178,   179,   180,   181,   182,   183,   184,   185,
     165,   166,   167,   189,   212,   213,   214,   215,   216,     4,
       5,     6,   302,   175,   304,  1335,   178,   179,   180,   181,
     182,   183,   184,   185,    19,   344,  1443,   189,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,   165,   166,   167,   298,   302,  1733,   304,   172,
     657,   658,   659,   169,  1445,  1446,    51,    52,    53,   285,
     165,   166,   167,   165,   166,   167,  1752,   172,     3,    16,
     172,   302,  1078,   304,    41,    42,  1066,    68,    69,    70,
      81,    82,     3,  1066,    75,    88,    89,   322,   171,  1064,
       4,     5,     6,     7,     8,     9,  1220,  1221,  1222,   133,
     255,   256,   325,   326,    21,  1229,  1523,    54,  1525,   171,
      57,   171,  1236,   133,   171,  1239,    99,   100,   279,   280,
    1222,  1245,  1246,   190,   191,   180,   181,  1229,    92,    93,
    1105,    88,    89,   171,  1236,   171,  1549,  1550,   171,  1552,
     124,  1265,   171,  1267,  1549,  1550,   171,  1552,  1549,  1550,
    1684,  1552,   329,   330,   171,   102,   171,   104,   344,   291,
     292,   293,   294,   295,   296,  2053,   171,   114,   327,   328,
      63,    64,  1296,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,  1337,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,  1321,  1255,   180,
     181,  1325,  1326,  1322,   333,  1622,   274,   275,   171,  1333,
    1322,   762,   763,  1337,  1338,   171,  1222,   171,  1342,  1343,
    2028,  2029,  1228,  1325,   300,   301,   171,  1284,   171,  1355,
     171,  1357,  1222,  1359,   570,   571,   188,   171,  1364,  1222,
     171,   171,  1518,   171,   171,  1369,   171,   345,  1305,  1322,
     344,  1308,   171,  1310,   333,   171,  1942,   281,   171,    16,
     291,   292,   293,   294,   295,   296,    91,    97,  1392,   344,
     217,   218,   219,   220,   221,   222,  1693,   101,   300,  1812,
     132,   836,   229,  1700,   839,   840,   841,   132,   314,   111,
     111,   110,   287,   288,   289,   290,   172,    54,   132,   322,
      57,   262,   857,   858,   859,   860,  1322,   299,   132,  1433,
     286,  1435,   235,   260,  1322,  1439,   286,  1472,  1442,   291,
     292,   293,   294,   295,   296,   174,  1450,   171,   171,   171,
     171,  1433,   279,  1435,   133,   282,   231,   284,   171,   105,
     171,   165,   166,   167,   171,   102,    37,   104,   172,   344,
     299,  1326,   175,   171,   171,   171,   171,   114,   171,   171,
    1514,   171,   171,  1338,   171,  1489,   168,   175,   345,    22,
     111,   172,   236,   320,   154,   236,   323,  1496,     3,   171,
     286,   172,  1506,   171,  1496,   171,   171,   347,   172,   283,
    1514,    81,    78,   204,   110,   241,   281,   257,  1522,   273,
     103,   280,  1824,   286,   228,  1411,  1412,   171,   110,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   315,   286,
    1522,   261,  1479,  1496,  1481,  1482,   105,   225,   252,   265,
     236,   322,   171,   175,   258,   259,   178,   179,   180,   181,
     182,   183,   184,   185,    22,   250,   188,   189,   186,   281,
     322,   103,   344,   277,  1578,   344,   110,  1874,   157,   171,
     217,   218,   219,   220,   221,   222,  1621,   344,   145,   101,
     108,   172,   229,   344,   298,   299,   300,   172,   313,   344,
    1496,   109,   133,   334,   288,   172,   344,   172,  1496,   171,
     171,  1646,  1647,   171,  1618,  1619,   344,    87,   261,   110,
     258,  1625,  1915,   260,   257,    89,   109,   257,   110,   171,
    1915,    19,   268,   316,  1915,   232,   273,  1619,    98,   265,
     344,   281,   279,   172,   324,   282,   322,   284,   175,   172,
     344,   178,   179,   180,   181,   182,   183,   184,   185,  1663,
     171,   188,   189,   172,   322,   103,  1670,  1522,   172,  1966,
     172,   178,   179,   180,   181,   182,   183,   184,   185,   172,
    1684,  1685,   189,   320,   172,   344,   323,   172,   172,   344,
     344,  1988,  1994,   172,   172,  1699,   172,   172,   172,   172,
    1704,   172,  1684,   344,   172,   344,   160,   297,  1876,  1713,
    1714,   313,   171,    74,   171,   171,    74,   172,    71,     4,
       5,     6,   172,  1660,   172,   171,  1730,   103,   107,  1666,
    1667,   103,   172,   101,    19,   172,   172,    15,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,   266,  2046,   322,   110,   266,  1761,   274,   265,
     286,  2046,   171,   250,   265,  2046,    51,    52,    53,  1706,
     172,   234,  1776,   239,   172,   172,   322,   142,   142,  1947,
     172,   234,   281,   172,    74,   172,   171,   103,   172,   172,
     330,   344,   264,   274,   349,   350,   171,   264,   250,   344,
     355,   236,     3,  1807,     3,   360,   344,   226,   344,     4,
       5,     6,   332,    76,   235,   311,   267,  1821,   236,   309,
    1824,   286,   346,  1760,    19,     4,   172,   172,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,   172,   172,   129,   130,   171,   345,   172,   344,
    1854,   265,   344,   265,   265,   265,    51,    52,    53,   172,
     172,   161,   189,   257,   344,   110,   273,  1871,   109,   127,
      82,   286,   171,   266,   111,   344,  1880,   236,   171,   434,
    1884,   109,   171,   171,   109,   109,   172,   265,   133,   338,
     272,  2092,  1896,   327,   265,   338,  1900,  1896,   322,   109,
    2101,  1905,   171,   336,  1896,   344,  1910,   264,   227,     3,
     273,  1896,  1916,   170,  1918,   331,  1896,    84,  1922,    84,
    1896,  1776,   302,   478,   262,   345,   132,   313,  1896,   236,
       4,   236,  1936,     4,   153,   150,  1896,   345,   344,   150,
    1877,   322,   155,     3,   188,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,  1959,  1960,  1961,  1962,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   128,    58,   171,   301,   172,   172,  1982,   313,
    1917,   132,  1919,   158,   155,   313,   152,   339,  1992,   171,
    1994,   327,   112,    59,   311,   132,   327,   301,   313,   313,
     337,   265,   287,   288,   289,   290,    60,   309,   319,   307,
     265,   566,   265,    63,   337,    64,  1871,   171,   132,    40,
    1094,  1496,  1275,   208,   207,   451,   453,  2022,    40,  1037,
     757,  1065,  1506,  1651,  2074,  2039,  2060,  2041,  2059,  2052,
    1704,  2066,  2021,  1819,   599,   600,   601,  1695,  1819,  1552,
    1797,  2083,   607,  1798,   609,     8,   452,  1350,   710,   163,
    1484,  1880,  2066,  1883,  1955,  2069,  1481,  2066,   623,   624,
     625,   700,  1482,  1410,  2066,  1409,  1078,   875,  1233,  2083,
    1624,  2066,  1246,   950,   639,   640,  2066,   464,   577,   909,
    2066,   647,   287,   288,   289,   290,   872,  1632,  2066,   344,
    1149,   656,   657,   658,   659,   653,  2066,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   661,   660,   765,    39,   689,   691,   692,  1752,   927,
     530,   586,   931,  1719,   638,  1717,   931,  1921,  1570,  1390,
    1379,  1577,  1382,  1848,  1933,  1733,  1941,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    17,    18,   608,    -1,    21,
      22,    -1,    -1,    25,    26,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    -1,    51,
      -1,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,    61,
      62,    -1,    -1,    65,    66,    -1,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,
      82,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    -1,    96,    97,    98,    -1,    -1,    -1,
      -1,    -1,   104,   105,    -1,    -1,    -1,   109,    -1,    -1,
     112,   113,    -1,   115,    -1,   117,   118,   119,    -1,    -1,
      -1,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,    -1,    -1,    -1,    -1,    -1,   170,   171,
      -1,   173,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   897,    -1,    -1,    -1,   901,    -1,   190,   191,
      -1,    -1,   907,    -1,    -1,    -1,   911,    -1,   200,   201,
     202,    -1,    -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   929,   217,   218,   932,    -1,    -1,
      -1,    -1,    -1,   225,    -1,    -1,    -1,   229,    -1,    -1,
      -1,    -1,    -1,    -1,   236,    -1,    -1,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,    -1,   251,
      -1,   966,   967,    -1,    -1,   257,    -1,    -1,   260,    -1,
      -1,    -1,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,    -1,    -1,    -1,   279,   280,    -1,
      -1,   283,    -1,    -1,   286,   287,   288,   289,   290,    -1,
      -1,  1006,    -1,  1008,    -1,   297,    -1,    -1,    -1,   301,
      -1,    -1,    -1,   305,   306,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1030,    -1,    -1,    -1,   321,
     322,    -1,    -1,    -1,    -1,   327,   328,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,   347,    -1,   349,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1078,    -1,     4,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,   172,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,    -1,    51,    52,    53,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,    -1,
      -1,    -1,    -1,    -1,  1149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     4,     5,     6,    -1,    -1,    -1,    -1,
      -1,    -1,  1167,    -1,    -1,    -1,  1171,    -1,    19,    -1,
      -1,  1176,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,     4,     5,
       6,     7,     8,     9,  1199,  1200,  1201,  1202,    -1,    -1,
      51,    52,    53,    -1,  1209,    21,    22,    -1,    -1,    25,
    1215,  1216,    -1,  1218,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1266,    -1,    79,    -1,   344,    82,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      96,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   115,
      -1,   117,   118,   119,    -1,    -1,    -1,    -1,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   141,   142,    -1,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
     279,    -1,    -1,    -1,   170,   171,    -1,   173,   287,   288,
     289,   290,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,
      66,    -1,    -1,    -1,  1379,    -1,    -1,  1382,    -1,    -1,
      76,    77,    78,    79,    -1,  1390,    -1,    -1,    -1,    85,
      -1,    -1,  1397,    -1,    -1,  1400,    -1,    -1,    -1,    -1,
      -1,   217,   218,    -1,  1409,  1410,  1411,  1412,    -1,   225,
      -1,    -1,    -1,   229,  1419,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,   251,   287,   288,   289,   290,
      -1,   257,    -1,    -1,   260,    -1,    -1,    -1,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
      -1,    -1,    -1,   279,   280,   109,    -1,   283,    -1,    -1,
     286,   287,   288,   289,   290,   171,    -1,    -1,    -1,    -1,
      -1,   297,   126,    -1,    -1,    -1,    -1,   131,   132,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   321,   322,    -1,    -1,    -1,
      -1,   327,   328,    -1,    -1,    -1,    -1,    -1,    -1,  1524,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,
     174,   347,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   237,   238,    -1,   240,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,   258,   259,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1577,    -1,    -1,    -1,    -1,    -1,   274,    -1,
      -1,   277,   226,   227,   228,    -1,    -1,    -1,    -1,    -1,
     286,   133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1609,    -1,   250,  1612,   252,  1614,
      -1,    -1,    -1,    -1,   258,   259,    -1,    -1,   314,    -1,
      -1,    -1,    -1,    -1,    -1,   269,    -1,  1632,   272,    -1,
      -1,  1636,    -1,   277,    -1,    -1,    -1,    -1,   282,    -1,
    1645,    -1,    -1,    -1,    -1,    -1,  1651,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,    -1,    -1,
      -1,    -1,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1715,  1716,  1717,    -1,  1719,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,  1733,    -1,
      17,    18,    -1,    -1,    21,    22,    -1,    -1,    25,    26,
      27,    -1,    -1,    -1,    -1,    -1,    -1,  1752,    -1,    -1,
      37,    -1,    -1,    40,    -1,    -1,    43,    44,    45,    46,
      47,    48,    49,    -1,    51,    -1,    -1,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      -1,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    -1,
      -1,    -1,   344,    -1,    91,    -1,  1811,    -1,    -1,    96,
      97,    98,  1817,    -1,    -1,    -1,    -1,   104,   105,    -1,
      -1,    -1,   109,    -1,    -1,   112,   113,    -1,   115,    -1,
     117,   118,   119,    -1,    -1,    -1,   123,   124,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,   164,    -1,    -1,
      -1,    -1,    -1,   170,   171,    -1,   173,   174,    -1,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     187,    -1,    -1,   190,   191,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   200,   201,   202,  1921,    -1,    -1,  1924,
     207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,   218,    -1,    -1,    -1,    -1,    -1,  1942,   225,    -1,
      -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,    -1,    -1,   260,    -1,  1980,    -1,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,    -1,   273,    -1,   275,    -1,
      -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,    -1,
     297,    -1,    -1,    -1,   301,    -1,    -1,    -1,   305,   306,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   321,   322,    -1,    -1,    -1,    -1,
     327,   328,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     347,    -1,   349,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    17,    18,    -1,
      -1,    21,    22,    -1,    -1,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    51,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,
      -1,    61,    62,    -1,    -1,    65,    66,    -1,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    -1,    82,    -1,    -1,    85,    -1,    -1,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    -1,    96,    97,    98,    -1,
      -1,    -1,    -1,    -1,   104,   105,    -1,    -1,    -1,   109,
      -1,    -1,   112,   113,    -1,   115,    -1,   117,   118,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,    -1,    -1,    -1,    -1,    -1,
     170,   171,    -1,   173,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     190,   191,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     200,   201,   202,    -1,    -1,    -1,    -1,   207,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,   218,    -1,
      -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,
     260,    -1,    -1,    -1,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,    -1,    -1,    -1,   279,
     280,    -1,    -1,    -1,    -1,    -1,   286,   287,   288,   289,
     290,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,
      -1,   301,    -1,    -1,    -1,   305,   306,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   321,   322,    -1,    -1,    -1,    -1,   327,   328,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,   349,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    17,    18,    -1,    -1,    21,    22,
      -1,    -1,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,
      43,    44,    45,    46,    47,    48,    49,    -1,    51,    -1,
      -1,    54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,
      -1,    -1,    -1,    66,    -1,    68,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    -1,    96,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,   105,    -1,    -1,    -1,   109,    -1,    -1,   112,
     113,    -1,   115,    -1,   117,   118,   119,    -1,    -1,    -1,
     123,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     133,   134,   135,   136,   137,    -1,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,   164,    -1,    -1,    -1,    -1,    -1,   170,   171,    -1,
     173,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   190,   191,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,   201,   202,
      -1,   204,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   217,   218,    -1,    -1,    -1,    -1,
      -1,    -1,   225,    -1,    -1,    -1,   229,    -1,    -1,    -1,
      -1,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,    -1,    -1,   260,    -1,    -1,
      -1,   264,    -1,    -1,   267,   268,    -1,   270,    -1,    -1,
     273,    -1,   275,    -1,    -1,    -1,   279,   280,    -1,    -1,
      -1,    -1,    -1,    -1,   287,   288,   289,   290,    -1,    -1,
      -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,   301,    -1,
      -1,    -1,   305,   306,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,   322,
      -1,    -1,    -1,    -1,   327,   328,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   347,    -1,   349,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    17,    18,    -1,    -1,    21,    22,    -1,    -1,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    -1,    -1,    43,    44,    45,
      46,    47,    48,    49,    -1,    51,    -1,    -1,    54,    55,
      56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,
      66,    -1,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      96,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,   105,
      -1,    -1,    -1,   109,    -1,    -1,   112,   113,    -1,   115,
      -1,   117,   118,   119,    -1,    -1,    -1,   123,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,    -1,
      -1,    -1,    -1,    -1,   170,   171,    -1,   173,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   190,   191,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   200,   201,   202,    -1,    -1,    -1,
      -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,
      -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,    -1,    -1,   260,    -1,    -1,    -1,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
      -1,    -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,
      -1,   287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,
      -1,   297,    -1,    -1,    -1,   301,    -1,    -1,    -1,   305,
     306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   321,   322,    -1,    -1,    -1,
      -1,   327,   328,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   347,    -1,   349,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    17,    18,
      -1,    -1,    21,    22,    -1,    -1,    25,    26,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    -1,    -1,    43,    44,    45,    46,    47,    48,
      49,    -1,    51,    -1,    -1,    54,    55,    56,    -1,    -1,
      -1,    -1,    61,    62,    -1,    -1,    -1,    66,    -1,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    96,    97,    98,
      -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,
     109,    -1,    -1,   112,   113,    -1,   115,    -1,   117,   118,
     119,    -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,   134,   135,   136,   137,    -1,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,    -1,    -1,    -1,    -1,
      -1,   170,   171,    -1,   173,    -1,    -1,    -1,    -1,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   190,   191,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   200,   201,   202,    -1,    -1,    -1,    -1,   207,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,   218,
      -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,
     229,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,
      -1,   260,    -1,    -1,    -1,   264,    -1,    -1,   267,   268,
      -1,   270,    -1,    -1,   273,    -1,   275,    -1,    -1,    -1,
     279,   280,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,
     289,   290,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,
      -1,    -1,   301,    -1,    -1,    -1,   305,   306,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   321,   322,    -1,    -1,    -1,    -1,   327,   328,
      -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,
      -1,    -1,    -1,   342,    -1,    -1,    -1,    -1,    -1,    -1,
     349,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    17,    18,    -1,    -1,    21,
      22,    -1,    -1,    25,    26,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    -1,    51,
      -1,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,    61,
      62,    -1,    -1,    65,    66,    -1,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,
      82,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    -1,    96,    97,    98,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,    -1,    -1,   109,    -1,    -1,
     112,   113,    -1,   115,    -1,   117,   118,   119,    -1,    -1,
      -1,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,    -1,    -1,    -1,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   190,   191,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,   201,
     202,    -1,    -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   217,   218,    -1,    -1,    -1,
      -1,    -1,    -1,   225,    -1,    -1,    -1,   229,    -1,    -1,
      -1,    -1,    -1,    -1,   236,    -1,    -1,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,   260,    -1,
      -1,    -1,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,    -1,    -1,    -1,   279,   280,    -1,
      -1,    -1,    -1,    -1,    -1,   287,   288,   289,   290,    -1,
      -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,   301,
      -1,    -1,    -1,   305,   306,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
     322,    -1,    -1,    -1,    -1,   327,   328,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    17,    18,    -1,    -1,    21,    22,   349,    -1,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    -1,    -1,    43,    44,    45,
      46,    47,    48,    49,    -1,    51,    -1,    -1,    54,    55,
      56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,
      66,    -1,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      96,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,    -1,    -1,   109,    -1,    -1,   112,   113,    -1,   115,
      -1,   117,   118,   119,    -1,    -1,    -1,   123,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,    -1,
      -1,    -1,    -1,    -1,   170,   171,    -1,   173,    -1,    -1,
     176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   190,   191,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   200,   201,   202,    -1,   204,    -1,
      -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,
      -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,    -1,    -1,   260,    -1,    -1,    -1,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
      -1,    -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,
      -1,   287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,
      -1,   297,    -1,    -1,    -1,   301,    -1,    -1,    -1,   305,
     306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   321,   322,    -1,    -1,    -1,
      -1,   327,   328,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    17,    18,    -1,
      -1,    21,    22,   349,    -1,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    51,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,
      -1,    61,    62,    -1,    -1,    -1,    66,    -1,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    -1,    82,    -1,    -1,    85,    -1,    -1,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    -1,    96,    97,    98,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,   109,
      -1,    -1,   112,   113,    -1,   115,    -1,   117,   118,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,    -1,    -1,    -1,    -1,    -1,
     170,   171,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     190,   191,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     200,   201,   202,    -1,    -1,    -1,    -1,   207,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,   218,    -1,
      -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,
     260,    -1,    -1,    -1,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,    -1,    -1,    -1,   279,
     280,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,   289,
     290,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,
      -1,   301,    -1,    -1,    -1,   305,   306,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   321,   322,    -1,    -1,    -1,    -1,   327,   328,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    17,    18,    -1,    -1,    21,    22,   349,
      -1,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    -1,    51,    -1,    -1,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    -1,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    -1,    96,    97,    98,    -1,    -1,    -1,    -1,    -1,
     104,    -1,    -1,    -1,    -1,   109,    -1,    -1,   112,   113,
      -1,   115,    -1,   117,   118,   119,    -1,    -1,    -1,   123,
     124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,    -1,    -1,    -1,    -1,    -1,   170,   171,    -1,   173,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   190,   191,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   200,   201,   202,    -1,
      -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   217,   218,    -1,    -1,    -1,    -1,    -1,
      -1,   225,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,
      -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,    -1,    -1,   260,    -1,    -1,    -1,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,    -1,    -1,    -1,   279,   280,    -1,    -1,    -1,
      -1,    -1,    -1,   287,   288,   289,   290,    -1,    -1,    -1,
      -1,    -1,    -1,   297,    -1,    -1,    -1,   301,    -1,    -1,
      -1,   305,   306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,   322,    -1,
      -1,    -1,    -1,   327,   328,    -1,    -1,    -1,    -1,    -1,
      -1,   335,    -1,    -1,    -1,    -1,    -1,    -1,   342,    -1,
      -1,    -1,    -1,    -1,    -1,   349,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      17,    18,    -1,    -1,    21,    22,    -1,    -1,    25,    26,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    -1,    -1,    43,    44,    45,    46,
      47,    48,    49,    -1,    51,    -1,    -1,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      -1,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,    96,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
      -1,    -1,   109,    -1,    -1,   112,   113,    -1,   115,    -1,
     117,   118,   119,    -1,    -1,    -1,   123,   124,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,   164,    -1,    -1,
      -1,    -1,    -1,   170,   171,    -1,   173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   190,   191,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   200,   201,   202,    -1,    -1,    -1,    -1,
     207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,
      -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,    -1,    -1,   260,    -1,    -1,    -1,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,    -1,   273,    -1,   275,    -1,
      -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,    -1,
     297,    -1,    -1,    -1,   301,    -1,    -1,    -1,   305,   306,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   321,   322,    -1,    -1,    -1,    -1,
     327,   328,    -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,
      -1,    -1,    -1,    -1,    -1,   342,    -1,    -1,    -1,    -1,
      -1,    -1,   349,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    17,    18,    -1,
      -1,    21,    22,    -1,    -1,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    51,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,
      -1,    61,    62,    -1,    -1,    -1,    66,    -1,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    -1,    82,    -1,    -1,    85,    -1,    -1,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    -1,    96,    97,    98,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,   109,
      -1,    -1,   112,   113,    -1,   115,    -1,   117,   118,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,    -1,    -1,    -1,    -1,    -1,
     170,   171,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     190,   191,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     200,   201,   202,    -1,    -1,    -1,    -1,   207,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,   218,    -1,
      -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,
     260,    -1,    -1,    -1,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,    -1,    -1,    -1,   279,
     280,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,   289,
     290,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,
      -1,   301,   302,    -1,    -1,   305,   306,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   321,   322,    -1,    -1,    -1,    -1,   327,   328,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    17,    18,    -1,    -1,    21,    22,   349,
      -1,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    -1,    51,    -1,    -1,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    -1,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    -1,    96,    97,    98,    -1,    -1,    -1,    -1,    -1,
     104,    -1,    -1,    -1,    -1,   109,    -1,    -1,   112,   113,
      -1,   115,    -1,   117,   118,   119,    -1,    -1,    -1,   123,
     124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,    -1,    -1,    -1,    -1,    -1,   170,   171,   172,   173,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   190,   191,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   200,   201,   202,    -1,
      -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   217,   218,    -1,    -1,    -1,    -1,    -1,
      -1,   225,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,
      -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,    -1,    -1,   260,    -1,    -1,    -1,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,    -1,    -1,    -1,   279,   280,    -1,    -1,    -1,
      -1,    -1,    -1,   287,   288,   289,   290,    -1,    -1,    -1,
      -1,    -1,    -1,   297,    -1,    -1,    -1,   301,    -1,    -1,
      -1,   305,   306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,   322,    -1,
      -1,    -1,    -1,   327,   328,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    17,
      18,    -1,    -1,    21,    22,   349,    -1,    25,    26,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    -1,    -1,    43,    44,    45,    46,    47,
      48,    49,    -1,    51,    -1,    -1,    54,    55,    56,    -1,
      -1,    -1,    -1,    61,    62,    -1,    -1,    65,    66,    -1,
      68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    -1,    -1,    82,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,    96,    97,
      98,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,
      -1,   109,    -1,    -1,   112,   113,    -1,   115,    -1,   117,
     118,   119,    -1,    -1,    -1,   123,   124,   125,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,    -1,    -1,    -1,
      -1,    -1,   170,   171,    -1,   173,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   190,   191,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   200,   201,   202,    -1,    -1,    -1,    -1,   207,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,
     218,    -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,
      -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,
      -1,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
      -1,    -1,   260,    -1,    -1,    -1,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,    -1,    -1,
      -1,   279,   280,    -1,    -1,    -1,    -1,    -1,    -1,   287,
     288,   289,   290,    -1,    -1,    -1,    -1,    -1,    -1,   297,
      -1,    -1,    -1,   301,    -1,    -1,    -1,   305,   306,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,   322,    -1,    -1,    -1,    -1,   327,
     328,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    17,    18,    -1,    -1,    21,
      22,   349,    -1,    25,    26,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    -1,    51,
      -1,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,    61,
      62,    -1,    -1,    -1,    66,    -1,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,
      82,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    -1,    96,    97,    98,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,    -1,    -1,   109,    -1,    -1,
     112,   113,    -1,   115,    -1,   117,   118,   119,    -1,    -1,
      -1,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,    -1,    -1,    -1,    -1,    -1,   170,   171,
      -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   190,   191,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,   201,
     202,    -1,    -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   217,   218,    -1,    -1,    -1,
      -1,    -1,    -1,   225,    -1,    -1,    -1,   229,    -1,    -1,
      -1,    -1,    -1,    -1,   236,    -1,    -1,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,   260,    -1,
      -1,    -1,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,    -1,    -1,    -1,   279,   280,    -1,
      -1,    -1,    -1,    -1,    -1,   287,   288,   289,   290,    -1,
      -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,   301,
      -1,    -1,    -1,   305,   306,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
     322,    -1,    -1,    -1,    -1,   327,   328,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    17,    18,    -1,    -1,    21,    22,   349,    -1,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    -1,    -1,    43,    44,    45,
      46,    47,    48,    49,    -1,    51,    -1,    -1,    54,    55,
      56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,
      66,    -1,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      96,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,    -1,    -1,   109,    -1,    -1,   112,   113,    -1,   115,
      -1,   117,   118,   119,    -1,    -1,    -1,   123,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,    -1,
      -1,    -1,    -1,    -1,   170,   171,    -1,   173,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   190,   191,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   200,   201,   202,    -1,    -1,    -1,
      -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,
      -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,    -1,    -1,   260,    -1,    -1,    -1,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
      -1,    -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,
      -1,   287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,
      -1,   297,    -1,    -1,    -1,   301,   302,    -1,    -1,   305,
     306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   321,   322,    -1,    -1,    -1,
      -1,   327,   328,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    17,    18,    -1,
      -1,    21,    22,   349,    -1,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    51,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,
      -1,    61,    62,    -1,    -1,    -1,    66,    -1,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    -1,    82,    -1,    -1,    85,    -1,    -1,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    -1,    96,    97,    98,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,   109,
      -1,    -1,   112,   113,    -1,   115,    -1,   117,   118,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,    -1,    -1,    -1,    -1,    -1,
     170,   171,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     190,   191,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     200,   201,   202,    -1,    -1,    -1,    -1,   207,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,   218,    -1,
      -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,
     260,    -1,    -1,    -1,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,    -1,    -1,    -1,   279,
     280,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,   289,
     290,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,
      -1,   301,    -1,    -1,    -1,   305,   306,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   321,   322,    -1,    -1,    -1,    -1,   327,   328,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    17,    18,    -1,    -1,    21,    22,   349,
      -1,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    -1,    51,    -1,    -1,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    -1,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    -1,    96,    97,    98,    -1,    -1,    -1,    -1,    -1,
     104,    -1,    -1,    -1,    -1,   109,    -1,    -1,   112,   113,
      -1,   115,    -1,   117,   118,   119,    -1,    -1,    -1,   123,
     124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,    -1,    -1,    -1,    -1,    -1,   170,   171,    -1,   173,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   190,   191,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   200,   201,   202,    -1,
      -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   217,   218,    -1,    -1,    -1,    -1,    -1,
      -1,   225,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,
      -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,    -1,    -1,   260,    -1,    -1,    -1,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,    -1,    -1,    -1,   279,   280,    -1,    -1,    -1,
      -1,    -1,    -1,   287,   288,   289,   290,    -1,    -1,    -1,
      -1,    -1,    -1,   297,    -1,    -1,    -1,   301,    -1,    -1,
      -1,   305,   306,    -1,     4,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,   322,    -1,
      -1,    21,    22,   327,   328,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    -1,    -1,    -1,    -1,   349,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    -1,    82,    -1,    -1,    85,    -1,    -1,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    -1,    96,    97,    98,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   112,    -1,    -1,   115,    -1,   117,   118,   119,
      -1,   133,    -1,    -1,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   141,   142,    -1,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,    -1,    -1,
     170,   171,    -1,   173,    -1,    -1,    -1,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,    -1,    -1,
      -1,    -1,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,   218,    -1,
      -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,
     260,    -1,    -1,    -1,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,    -1,    -1,    -1,   279,
     280,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,   289,
     290,    -1,    -1,    -1,    -1,    -1,    -1,   297,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    25,
      -1,   321,   322,    -1,    -1,    -1,    -1,   327,   328,    -1,
      -1,    37,   344,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    51,    -1,   347,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    -1,    -1,    82,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      96,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   115,
      -1,   117,   118,   119,   133,    -1,    -1,    -1,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   141,   142,    -1,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,    -1,    -1,    -1,    -1,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,
      -1,    -1,   228,   229,    -1,    -1,    -1,    -1,    -1,    -1,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,   251,   252,    -1,    -1,    -1,
      -1,   257,   258,   259,   260,    -1,    -1,    -1,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,    -1,   273,   274,   275,
     276,   277,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,
      -1,   287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,
      -1,   297,    -1,    -1,    -1,   301,    -1,    -1,   304,    -1,
      -1,   307,   308,   309,    -1,    -1,    -1,    -1,   314,     4,
       5,     6,     7,     8,     9,   321,   322,    -1,    -1,    -1,
      -1,   327,   328,    -1,    -1,   344,    21,    22,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    -1,    -1,    82,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      -1,    96,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,
     115,    -1,   117,   118,   119,    -1,   133,    -1,    -1,   124,
     125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   141,   142,    -1,    -1,
     145,    -1,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,
      -1,    -1,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,    -1,    -1,    -1,    -1,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   217,   218,    -1,    -1,    -1,    -1,    -1,    -1,
     225,    -1,    -1,   228,   229,    -1,    -1,    -1,    -1,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,   251,   252,    -1,    -1,
      -1,    -1,   257,   258,   259,   260,    -1,    -1,    -1,   264,
      -1,    -1,   267,   268,    -1,   270,    -1,    -1,   273,   274,
     275,   276,   277,    -1,   279,   280,    -1,    -1,    -1,    -1,
      -1,    -1,   287,   288,   289,   290,   303,    -1,    -1,    -1,
      -1,    -1,   297,    -1,    -1,    -1,   301,    -1,    -1,    -1,
      -1,    -1,   307,    -1,    -1,    -1,    -1,   312,    -1,   314,
       4,     5,     6,     7,     8,     9,   321,   322,    -1,    -1,
      -1,    -1,   327,   328,    -1,    -1,    -1,    21,    22,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    -1,    -1,    82,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    -1,    96,    97,    98,    -1,    -1,    -1,    -1,    -1,
     104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,
      -1,   115,    -1,   117,   118,   119,    -1,   133,    -1,    -1,
     124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,   142,    -1,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,   173,
      -1,    -1,    -1,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,    -1,    -1,    -1,    -1,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   217,   218,    -1,    -1,    -1,    -1,    -1,
      -1,   225,    -1,    -1,   228,   229,    -1,    -1,    -1,    -1,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,    -1,
      -1,    -1,    -1,   257,   258,   259,   260,    -1,    -1,    -1,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,    -1,   273,
     274,   275,   276,   277,    -1,   279,   280,    -1,    -1,    -1,
      -1,    -1,    -1,   287,   288,   289,   290,   303,    -1,    -1,
      -1,    -1,    -1,   297,    -1,    -1,    -1,   301,    -1,    -1,
      -1,    -1,    -1,   307,    -1,    -1,    -1,    -1,   312,    -1,
     314,     4,     5,     6,     7,     8,     9,   321,   322,    -1,
      -1,    -1,    -1,   327,   328,    -1,    -1,    -1,    21,    22,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    -1,    -1,    82,
      -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    -1,    96,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,
      -1,    -1,   115,    -1,   117,   118,   119,    -1,    -1,   133,
      -1,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,   142,
      -1,    -1,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,
     173,    -1,    -1,    -1,    -1,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,    -1,    -1,    -1,    -1,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   217,   218,    -1,    -1,    -1,    -1,
      -1,    -1,   225,    -1,    -1,   228,   229,    -1,    -1,    -1,
      -1,    -1,    -1,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   251,   252,
      -1,    -1,    -1,    -1,   257,   258,   259,   260,    -1,    -1,
      -1,   264,    -1,    -1,   267,   268,    -1,   270,    -1,    -1,
     273,   274,   275,   276,   277,    -1,   279,   280,    -1,    -1,
      -1,    -1,    -1,    -1,   287,   288,   289,   290,   302,    -1,
      -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,   301,    -1,
      -1,    -1,    -1,    -1,   307,    -1,   309,    -1,    -1,    -1,
      -1,   314,     4,     5,     6,     7,     8,     9,   321,   322,
      -1,    -1,    -1,    -1,   327,   328,    -1,    -1,    -1,    21,
      22,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    -1,    -1,
      82,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    -1,    96,    97,    98,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     112,    -1,    -1,   115,    -1,   117,   118,   119,    -1,    -1,
     133,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,
     142,    -1,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,    -1,    -1,   170,    -1,
      -1,   173,    -1,    -1,    -1,    -1,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,    -1,    -1,    -1,
      -1,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   217,   218,    -1,    -1,    -1,
      -1,    -1,    -1,   225,    -1,    -1,   228,   229,    -1,    -1,
      -1,    -1,    -1,    -1,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,    -1,   251,
     252,    -1,    -1,    -1,    -1,   257,   258,   259,   260,    -1,
      -1,    -1,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
      -1,   273,   274,   275,   276,   277,    -1,   279,   280,    -1,
      -1,    -1,    -1,    -1,    -1,   287,   288,   289,   290,   302,
      -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,   301,
      -1,    -1,    -1,    -1,    -1,   307,    -1,    -1,    -1,    -1,
      -1,   313,   314,     4,     5,     6,     7,     8,     9,   321,
     322,    -1,    -1,    -1,    -1,   327,   328,    -1,    -1,    -1,
      21,    22,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    -1,
      -1,    82,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    -1,    96,    97,    98,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   112,    -1,    -1,   115,    -1,   117,   118,   119,   133,
      -1,    -1,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     141,   142,    -1,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,    -1,    -1,   170,
      -1,    -1,   173,    -1,    -1,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,    -1,    -1,    -1,    -1,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   217,   218,    -1,    -1,
      -1,    -1,    -1,    -1,   225,    -1,    -1,   228,   229,    -1,
      -1,    -1,    -1,    -1,    -1,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   263,
     251,   252,    -1,    -1,    -1,    -1,   257,   258,   259,   260,
      -1,    -1,    -1,   264,    -1,    -1,   267,   268,    -1,   270,
      -1,    -1,   273,   274,   275,   276,   277,    -1,   279,   280,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,   289,   290,
      -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,
     301,    -1,    -1,    -1,    -1,    -1,   307,     4,     5,     6,
       7,     8,     9,   314,    -1,    -1,    -1,    -1,    -1,    -1,
     321,   322,    -1,    -1,    21,    22,   327,   328,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    -1,    -1,    82,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    91,    -1,   106,    -1,    -1,    96,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   115,    -1,
     117,   118,   119,   133,    -1,    -1,    -1,   124,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   141,   142,    -1,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
      -1,    -1,    -1,    -1,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,
      -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,   259,   260,    -1,    -1,    -1,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,    -1,   273,   274,   275,   276,
      -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,    -1,
     297,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,    -1,
     307,    -1,    -1,    -1,    -1,   312,    -1,   314,     4,     5,
       6,     7,     8,     9,   321,   322,    -1,    -1,    -1,    -1,
     327,   328,    -1,    -1,    -1,    21,    22,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    -1,    -1,    82,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      96,    97,    98,    -1,   111,    -1,    -1,    -1,   104,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   115,
      -1,   117,   118,   119,    -1,    -1,   133,    -1,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   141,   142,    -1,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,   172,   162,    -1,   164,    -1,
      -1,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,
      -1,    -1,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,    -1,    -1,    -1,    -1,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,
      -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,   259,   260,    -1,    -1,    -1,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,    -1,   273,   274,   275,
     276,    -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,
      -1,   287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,
      -1,   297,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,
      -1,   307,    -1,    -1,    -1,    -1,    -1,   313,   314,    -1,
      -1,    -1,    -1,    -1,    -1,   321,   322,    -1,    -1,    -1,
      -1,   327,   328,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,
      21,    22,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    -1,    96,    97,    98,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   112,    -1,    -1,   115,    -1,   117,   118,   119,   133,
      -1,    -1,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     141,   142,    -1,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,    -1,    -1,   170,
      -1,    -1,   173,    -1,    -1,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,    -1,    -1,    -1,    -1,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,    -1,    -1,    -1,    -1,    -1,   223,
     224,    -1,    -1,    -1,    -1,    -1,   217,   218,   219,   220,
     221,   222,    -1,    -1,   225,    -1,    -1,    -1,   229,    -1,
      -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,   260,
      -1,    -1,    -1,   264,    -1,    -1,   267,   268,    -1,   270,
      -1,    -1,   273,    -1,   275,    -1,    -1,    -1,   279,   280,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,   289,   290,
      -1,    -1,    -1,    -1,    -1,    -1,   297,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    25,    -1,
     321,   322,    -1,    -1,    -1,    -1,   327,   328,    -1,    -1,
      37,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    54,    55,    56,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,    96,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   115,    -1,
     117,   118,   119,   133,    -1,    -1,    -1,   124,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   141,   142,    -1,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   181,    -1,   170,   171,    -1,   173,    -1,    -1,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
      -1,    -1,    -1,    -1,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,
      -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,    -1,    -1,   260,    -1,    -1,    -1,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,    -1,   273,    -1,   275,    -1,
      -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,    -1,
     297,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,    22,
      -1,    -1,    25,    -1,   321,   322,    -1,    -1,    -1,    -1,
     327,   328,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    -1,    96,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,
      -1,    -1,   115,    -1,   117,   118,   119,    -1,    -1,   133,
      -1,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,   142,
      -1,    -1,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,   172,   162,
      -1,   164,    -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,
     173,    -1,    -1,    -1,    -1,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,    -1,    -1,    -1,    -1,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   217,   218,    -1,    -1,    -1,    -1,
      -1,    -1,   225,    -1,    -1,    -1,   229,   230,   231,   232,
     233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,    -1,    -1,   260,    -1,    -1,
      -1,   264,    -1,    -1,   267,   268,    -1,   270,    -1,    -1,
     273,    -1,   275,    -1,    -1,    -1,   279,   280,    -1,    -1,
      -1,    -1,    -1,    -1,   287,   288,   289,   290,    -1,    -1,
      -1,    -1,    -1,    -1,   297,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    21,    22,    -1,    -1,    25,    -1,   321,   322,
      -1,    -1,    -1,    -1,   327,   328,    -1,    -1,    37,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    66,    -1,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    96,    97,    98,
      -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,    -1,    -1,   115,    -1,   117,   118,
     119,   133,    -1,    -1,    -1,   124,   125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   141,   142,    -1,    -1,   145,    -1,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,    -1,
      -1,   170,    -1,    -1,   173,    -1,    -1,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,    -1,    -1,
      -1,    -1,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   204,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,   218,
      -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,
     229,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,
      -1,   260,    -1,    -1,    -1,   264,    -1,    -1,   267,   268,
      -1,   270,    -1,    -1,   273,    -1,   275,    -1,    -1,    -1,
     279,   280,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,
     289,   290,    -1,    -1,    -1,    -1,    -1,    -1,   297,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,
      25,    -1,   321,   322,    -1,    -1,    -1,    -1,   327,   328,
      -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,
      -1,    66,    -1,    68,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      -1,    96,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,
     115,    -1,   117,   118,   119,    -1,    -1,   133,    -1,   124,
     125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   141,   142,    -1,    -1,
     145,    -1,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,   172,   162,    -1,   164,
      -1,    -1,    -1,    -1,    -1,   170,   171,    -1,   173,    -1,
      -1,    -1,    -1,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,    -1,    -1,    -1,    -1,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   217,   218,    -1,    -1,    -1,    -1,    -1,    -1,
     225,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,    -1,    -1,   260,    -1,    -1,    -1,   264,
      -1,    -1,   267,   268,    -1,   270,    -1,    -1,   273,    -1,
     275,    -1,    -1,    -1,   279,   280,    -1,    -1,    -1,    -1,
      -1,    -1,   287,   288,   289,   290,    -1,    -1,    -1,    -1,
      -1,    -1,   297,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    22,    -1,    -1,    25,    -1,   321,   322,    -1,    -1,
      -1,    -1,   327,   328,    -1,    -1,    37,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    62,    -1,    -1,    -1,    66,    -1,    68,    69,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    -1,    96,    97,    98,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   112,    -1,    -1,   115,    -1,   117,   118,   119,    -1,
      -1,    -1,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     141,   142,    -1,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,    -1,    -1,   170,
      -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   204,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   217,   218,    -1,    -1,
      -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,   229,    -1,
      -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,   260,
      -1,    -1,    -1,   264,    -1,    -1,   267,   268,    -1,   270,
      -1,    -1,   273,    -1,   275,    -1,    -1,    -1,   279,   280,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,   289,   290,
      -1,    -1,    -1,    -1,    -1,    -1,   297,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    25,    -1,
     321,   322,    -1,    -1,    -1,    -1,   327,   328,    -1,    -1,
      37,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    66,
      -1,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,    96,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   115,    -1,
     117,   118,   119,    -1,    -1,   133,    -1,   124,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   141,   142,    -1,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,   172,   162,    -1,   164,    -1,    -1,
      -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,    -1,
      -1,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,    -1,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,
      -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,    -1,    -1,   260,    -1,    -1,    -1,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,    -1,   273,    -1,   275,    -1,
      -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,    -1,
     297,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,    22,
      -1,    -1,    25,    -1,   321,   322,    -1,    -1,    -1,    -1,
     327,   328,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,
      -1,    -1,    -1,    66,    -1,    68,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    -1,    96,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,
      -1,    -1,   115,    -1,   117,   118,   119,    -1,    -1,   133,
      -1,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,   142,
      -1,    -1,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,   172,   162,
      -1,   164,    -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,
     173,    -1,    -1,    -1,    -1,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,    -1,    -1,    -1,    -1,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   217,   218,    -1,    -1,    -1,    -1,
      -1,    -1,   225,    -1,    -1,    -1,   229,    -1,    -1,    -1,
      -1,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,    -1,    -1,   260,    -1,    -1,
      -1,   264,    -1,    -1,   267,   268,    -1,   270,    -1,    -1,
     273,    -1,   275,    -1,    -1,    -1,   279,   280,    -1,    -1,
      -1,    -1,    -1,    -1,   287,   288,   289,   290,    -1,    -1,
      -1,    -1,    -1,    -1,   297,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    21,    22,    -1,    -1,    25,    -1,   321,   322,
      -1,    -1,    -1,    -1,   327,   328,    -1,    -1,    37,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    96,    97,    98,
      -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,    -1,    -1,   115,    -1,   117,   118,
     119,    -1,    -1,   133,    -1,   124,   125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   141,   142,    -1,    -1,   145,    -1,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,   172,   162,    -1,   164,    -1,    -1,    -1,    -1,
      -1,   170,   171,    -1,   173,    -1,    -1,    -1,    -1,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
      -1,    -1,    -1,    -1,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,   218,
      -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,
     229,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,
      -1,   260,    -1,    -1,    -1,   264,    -1,    -1,   267,   268,
      -1,   270,    -1,    -1,   273,    -1,   275,    -1,    -1,    -1,
     279,   280,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,
     289,   290,    -1,    -1,    -1,    -1,    -1,    -1,   297,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,
      25,    -1,   321,   322,    -1,    -1,    -1,    -1,   327,   328,
      -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      -1,    96,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,
     115,    -1,   117,   118,   119,    -1,    -1,    -1,    -1,   124,
     125,    -1,   133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   141,   142,    -1,    -1,
     145,    -1,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,   172,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   183,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,    -1,
      -1,    -1,    -1,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,    -1,    -1,    -1,
      -1,    -1,   217,   218,    -1,    -1,    -1,    -1,    -1,    -1,
     225,    -1,   227,    -1,   229,    -1,    -1,    -1,    -1,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,    -1,    -1,   260,    -1,    -1,    -1,   264,
      -1,    -1,   267,   268,    -1,   270,    -1,    -1,   273,    -1,
     275,    -1,    -1,    -1,   279,   280,    -1,    -1,    -1,    -1,
      -1,    -1,   287,   288,   289,   290,    -1,    -1,    -1,    -1,
      -1,    -1,   297,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    22,    -1,    -1,    25,    -1,   321,   322,    -1,    -1,
      -1,    -1,   327,   328,    -1,    -1,    37,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    -1,    96,    97,    98,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   112,    -1,    -1,   115,    -1,   117,   118,   119,    -1,
      -1,    -1,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     141,   142,    -1,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,    -1,    -1,   170,
      -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   217,   218,    -1,    -1,
      -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,   229,    -1,
      -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,   260,
      -1,    -1,    -1,   264,    -1,    -1,   267,   268,    -1,   270,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,   279,   280,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,   289,   290,
      -1,    -1,    -1,    -1,    -1,    -1,   297,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    25,    -1,
     321,   322,    -1,    -1,    -1,    -1,   327,   328,    -1,    -1,
      37,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,    96,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   115,    -1,
     117,   118,   119,    -1,    -1,    -1,    -1,   124,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   141,   142,    -1,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,    -1,    -1,   170,   171,    -1,   173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,
      -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,    -1,    -1,   260,    -1,    -1,    -1,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,    -1,   273,    -1,   275,    -1,
      -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,    -1,
     297,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,    22,
      -1,    -1,    25,    -1,   321,   322,    -1,    -1,    -1,    -1,
     327,   328,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    -1,    96,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,
      -1,    -1,   115,    -1,   117,   118,   119,    -1,    -1,    -1,
      -1,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,   142,
      -1,    -1,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,
     173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   204,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   217,   218,    -1,    -1,    -1,    -1,
      -1,    -1,   225,    -1,    -1,    -1,   229,    -1,    -1,    -1,
      -1,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,    -1,    -1,   260,    -1,    -1,
      -1,   264,    -1,    -1,   267,   268,    -1,   270,    -1,    -1,
     273,    -1,   275,    -1,    -1,    -1,   279,   280,    -1,    -1,
      -1,    -1,    -1,    -1,   287,   288,   289,   290,    -1,    -1,
      -1,    -1,    -1,    -1,   297,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    21,    22,    -1,    -1,    25,    -1,   321,   322,
      -1,    -1,    -1,    -1,   327,   328,    -1,    -1,    37,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    96,    97,    98,
      -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,    -1,    -1,   115,    -1,   117,   118,
     119,    -1,    -1,    -1,    -1,   124,   125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   141,   142,    -1,    -1,   145,    -1,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,    -1,
      -1,   170,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,   218,
      -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,   227,    -1,
     229,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,
      -1,   260,    -1,    -1,    -1,   264,    -1,    -1,   267,   268,
      -1,   270,    -1,    -1,   273,    -1,   275,    -1,    -1,    -1,
     279,   280,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,
     289,   290,    -1,    -1,    -1,    -1,    -1,    -1,   297,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,
      25,    -1,   321,   322,    -1,    -1,    -1,    -1,   327,   328,
      -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      -1,    96,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,
     115,    -1,   117,   118,   119,    -1,    -1,    -1,    -1,   124,
     125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   141,   142,    -1,    -1,
     145,    -1,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   217,   218,    -1,    -1,    -1,    -1,    -1,    -1,
     225,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,    -1,    -1,   260,    -1,    -1,    -1,   264,
      -1,    -1,   267,   268,    -1,   270,    -1,    -1,   273,    -1,
     275,    -1,    -1,    -1,   279,   280,    -1,    -1,    -1,    -1,
      -1,    -1,   287,   288,   289,   290,    -1,    -1,    -1,    -1,
      -1,    -1,   297,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    22,    -1,    -1,    25,    -1,   321,   322,    -1,    -1,
      -1,    -1,   327,   328,    -1,    -1,    37,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    -1,    96,    97,    98,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   112,    -1,    -1,   115,    -1,   117,   118,   119,    -1,
      -1,    -1,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     141,   142,    -1,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,    -1,    -1,   170,
      -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   217,   218,    -1,    -1,
      -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,   229,    -1,
      -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,   260,
      -1,    -1,    -1,   264,    -1,    -1,   267,   268,    -1,   270,
      -1,    -1,   273,    -1,   275,    -1,    -1,    -1,   279,   280,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,   289,   290,
      -1,    -1,    -1,    -1,    -1,    -1,   297,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    25,    -1,
     321,   322,    -1,    -1,    -1,    -1,   327,   328,    -1,    -1,
      37,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,    96,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   115,    -1,
     117,   118,   119,    -1,     0,     1,    -1,   124,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   141,   142,    -1,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,    -1,    -1,   170,    50,    -1,   173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,   218,    -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,
      -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,   132,    -1,    -1,    -1,
     257,    -1,    -1,   260,    -1,    -1,    -1,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,    -1,   273,    -1,   275,    -1,
      -1,    -1,   279,   280,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,   289,   290,    -1,   171,    -1,    -1,    -1,    -1,
     297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   321,   322,    -1,    -1,    -1,    -1,
     327,   328,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   237,   238,    -1,   240,    -1,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,   258,   259,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,
      -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   314
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    50,    63,    64,    65,    66,    76,    77,    78,
      79,    85,   132,   171,   228,   237,   238,   240,   242,   243,
     244,   245,   246,   247,   248,   249,   252,   258,   259,   274,
     277,   286,   314,   351,   357,   358,   359,   360,   363,   364,
     365,   366,   368,   370,   371,   380,   385,   397,   402,   403,
     409,   454,   457,   465,   486,   500,   504,   505,   506,   514,
     529,   530,   531,   549,   553,   554,   555,   558,   679,   132,
     110,     4,     5,     6,     7,     8,     9,    21,    22,    25,
      37,    40,    51,    62,    79,    82,    85,    91,    96,    97,
      98,   104,   112,   115,   117,   118,   119,   124,   125,   141,
     142,   145,   147,   148,   149,   150,   151,   152,   153,   155,
     157,   158,   159,   160,   162,   164,   170,   173,   217,   218,
     225,   229,   236,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   251,   257,   260,   264,   267,   268,
     270,   273,   275,   279,   280,   287,   288,   289,   290,   297,
     321,   322,   327,   328,   647,   673,   674,   176,   251,   540,
     262,    80,   511,   511,   673,    78,    86,    65,   558,   186,
      66,    68,    69,   618,   619,   620,   673,   647,   354,   353,
     355,   356,     4,     5,     6,     7,     8,     9,    63,    64,
      65,    66,   176,   272,   314,   358,   381,   388,   389,   390,
     392,   393,   394,   671,   672,   258,   261,   386,   387,    57,
      86,    54,   114,   279,   550,   551,   673,    10,   171,   232,
     299,   449,   450,   522,   549,   555,   662,   676,     0,   352,
       4,    10,   677,   680,    16,    54,    57,   102,   104,   114,
     217,   218,   219,   220,   221,   222,   229,   260,   273,   279,
     282,   284,   323,   410,   411,   414,   415,   448,   164,   230,
     231,   232,   233,    54,   114,   164,   176,   229,   230,   231,
     232,   233,   260,   273,   279,   284,   320,   323,   499,    54,
      55,    56,    62,   171,   260,   273,   288,   453,   644,   673,
     217,   218,   279,   369,   414,   446,   673,   132,   101,   165,
     166,   167,   574,   132,   647,   274,   345,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    17,
      18,    26,    27,    43,    44,    45,    46,    47,    48,    49,
      61,   105,   109,   113,   123,   133,   134,   135,   136,   137,
     139,   140,   143,   144,   146,   156,   163,   171,   174,   190,
     191,   200,   201,   202,   204,   207,   287,   288,   289,   290,
     301,   305,   306,   347,   349,   536,   561,   572,   573,   581,
     582,   583,   584,   586,   588,   589,   591,   593,   595,   596,
     598,   599,   600,   601,   602,   603,   604,   617,   618,   621,
     623,   624,   625,   627,   628,   629,   630,   631,   644,   645,
     646,   648,   649,   651,   666,   669,   673,   678,   687,   688,
     689,   690,   691,   705,   712,   714,   717,   727,   728,   758,
     647,   188,   512,   512,   673,    87,    90,    96,   507,   508,
     509,   540,   172,   321,   171,   345,   452,   453,   366,   366,
     351,   351,   452,   452,   270,   452,   110,   262,   281,   344,
     281,   344,   265,   344,   266,   266,   388,   381,    86,   507,
     274,   673,   647,   647,   344,   552,   555,   452,   449,   558,
     262,   662,   262,    26,   262,   299,   315,   366,   171,   217,
     218,   673,   217,   218,   647,   279,   279,   279,   279,   647,
     673,   307,   362,   362,   647,   647,   320,   279,   231,   647,
     647,   647,   647,   673,   647,   231,   164,   230,   231,   232,
     233,   647,   647,   647,   647,   647,   673,   307,   361,   361,
     361,   647,   647,    41,    42,   503,   225,   446,   673,   673,
     297,   175,   175,   175,   344,     4,     5,     6,    19,    23,
      24,    25,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    51,    52,    53,   287,   288,   289,   290,   344,   636,
     643,   664,   666,   667,   668,   669,   103,   176,   251,   559,
     559,   559,   298,   575,   285,   543,   453,   541,   542,   670,
     673,   673,   678,   678,   678,   171,   171,    21,   171,   622,
     622,   622,   622,   622,   171,   598,   171,   124,   673,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   283,   549,   558,   572,   582,   590,   618,   673,   582,
     171,   600,   600,   171,   171,   171,   600,   678,   171,   634,
     171,   635,   190,   191,   632,   302,   600,   656,   657,   171,
     171,   582,   594,   110,   262,   562,   563,   186,   322,   626,
     188,   175,   178,   179,   180,   181,   182,   183,   184,   185,
     189,   647,   133,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   263,   333,   345,   344,
     171,   171,   171,   678,   678,   345,   171,   250,   283,   450,
     453,   532,    81,    82,   281,   513,    88,    89,    91,    97,
     344,   561,   172,   537,   600,   652,   620,   673,   300,   577,
     132,   132,   271,   395,   396,   671,   671,   395,   390,   164,
     279,   391,   499,   647,   394,   111,   111,   110,   110,   507,
     255,   256,   412,   254,   274,   286,   398,   115,   116,   117,
     118,   119,   120,   121,   122,   125,   322,   405,   407,   408,
     252,   274,   277,   278,   551,   322,   172,   647,   318,   678,
     262,   647,   662,   299,   132,   171,   172,   535,   537,   539,
     558,   286,    85,   322,   404,   406,   408,   362,   362,   362,
     362,   235,   286,   378,   174,   225,   372,   673,   647,   452,
     325,   326,   487,   673,   362,   647,   171,   171,   171,   171,
     647,   231,   647,   647,   647,   647,   503,   171,   501,   501,
     501,   501,   105,   647,   647,   647,   673,   172,    57,   290,
     646,   598,   673,   572,   446,   171,   171,    20,    21,   171,
     171,   171,    37,   171,   634,   635,   291,   292,   293,   294,
     295,   296,   637,   639,   641,   642,   673,   171,   171,   171,
     171,   578,   579,   600,   168,   560,   560,   560,   602,   661,
     676,   299,   576,   572,   175,   344,   563,   175,   345,   572,
     650,   650,    22,   172,   296,   637,   638,   111,   600,   601,
     600,   684,   685,   686,   684,   236,   154,   706,   732,   151,
     153,   730,   236,     3,   718,   601,   114,   729,   730,   684,
     558,   171,   533,   172,   172,   172,   172,   344,   345,   600,
     600,   600,   677,   286,   633,   677,   633,   678,   572,   302,
     654,   655,   304,   656,   658,   600,   537,   653,   344,   348,
      67,   171,   347,   544,   564,   565,   597,   618,   647,   673,
     556,   557,   673,   543,   573,   673,   582,   176,   177,   187,
     582,   592,    99,   100,   585,   585,   171,   171,   587,   600,
     587,   587,   587,   582,   592,   595,   600,   600,   600,   600,
     600,   600,   600,   600,   600,   600,   600,   600,   600,   600,
     600,   600,   600,   600,   600,   600,   600,   600,   600,   600,
     109,   174,   171,   204,   625,   172,   176,   204,   251,   600,
     659,   673,   659,     7,     8,     9,   204,   673,   283,   533,
     532,    81,    78,    87,    94,    95,   510,   677,   509,   172,
     344,    13,   602,   662,   241,   367,   286,   344,   383,   286,
     382,   647,   395,   395,   257,   281,   273,   412,   103,   286,
     661,   661,   661,   664,   407,   227,   279,   280,   400,   401,
      66,    87,   399,   401,   279,   401,   171,   597,   110,    15,
     520,   521,   520,   647,   452,   315,   662,   172,   344,   412,
     286,   664,   406,   647,   647,   647,   647,   236,   261,   105,
     373,   673,   250,   374,   225,   110,   171,   417,   418,   452,
     322,    63,    64,    66,   488,   265,   647,   171,   204,   484,
     485,   673,   484,   484,   484,   501,   647,   503,   503,   503,
     503,   172,   502,   664,   503,   503,   503,   664,   660,   677,
     660,    22,   660,   660,   660,   677,    52,   665,   678,   633,
     633,   635,   634,   281,   660,   677,   660,   660,   660,   344,
     223,   224,   580,   103,   558,   558,   558,   602,   662,   577,
     598,   542,   543,   572,   673,   322,   344,   110,   647,   157,
     731,   344,   731,   731,   673,   693,   171,   600,   707,   708,
     709,   344,   601,   673,   715,   145,   719,   731,   684,   574,
     172,   534,   537,   538,   172,   344,   180,   181,   582,   110,
     344,   181,   344,   172,   288,   678,   172,   678,   642,   303,
     600,   654,   658,   600,   313,   344,   344,   172,   344,   582,
     598,   618,   171,   283,   544,   549,   555,   565,   566,   344,
      68,    69,    70,    72,    73,    75,   169,   545,   547,   322,
     567,   673,   567,   568,   568,   345,   344,   562,   108,   569,
     582,   582,   582,   535,   535,   106,   598,   109,   334,   605,
     606,   659,   172,   659,   172,   345,   344,   345,   673,    92,
      93,    87,   537,   261,   396,   110,   384,   258,   384,   384,
     384,   678,   673,   673,   257,   661,   598,   662,   673,   673,
     673,    89,    88,    89,   673,   647,   227,   421,   424,   435,
     436,   670,   618,   109,   523,   316,   523,   452,   110,   539,
     257,   662,   417,   417,   417,   417,   673,    55,    61,   379,
      19,   268,   681,   682,   373,   232,   183,   420,   421,   422,
     427,   447,   673,    98,   413,   322,   449,   324,   265,   647,
     417,   484,   172,   344,   664,   172,   172,   172,   503,   172,
     344,   172,   172,   172,   172,   344,   172,   344,   172,   344,
     296,   637,   640,   172,   344,   172,   172,   172,   579,   171,
     664,   664,   600,   114,   153,   172,   684,   172,   172,   344,
     692,    82,   250,   600,   733,   734,   736,   737,   738,   266,
     344,   703,   322,   710,    83,   141,   713,   344,   716,   103,
     720,   740,   731,   172,   160,   741,   742,   731,   172,   344,
     171,   171,   171,   600,   600,   600,   600,   297,   537,   303,
     313,   600,   537,   537,   567,   568,   533,   172,   172,   172,
     558,   565,   545,    74,   565,    74,    71,   546,   673,   171,
     673,   557,   103,   107,   571,   188,   188,   172,   172,   678,
     103,   172,   101,   607,   172,   172,   204,   659,   673,   266,
     379,   266,    15,   678,   503,   503,   503,   252,   274,   673,
     253,   269,   282,   444,   129,   130,   423,   664,   322,   492,
     678,   110,   171,   317,   527,   528,   678,   678,   265,   274,
     673,   675,   683,   359,   363,   375,   376,   377,   380,   385,
     397,   402,   500,   618,   647,   172,   344,   286,   673,   449,
     286,   451,   446,   647,   171,   265,   416,   172,    65,    79,
      85,   235,   238,   276,   301,   307,   312,   368,   370,   371,
     380,   385,   397,   402,   458,   461,   463,   464,   465,   469,
     471,   477,   479,   480,   500,   504,   505,   554,   673,   673,
     234,   239,   234,   502,   663,   677,   677,   677,   635,   677,
     570,   648,   673,   172,   172,   172,   138,   600,   694,   700,
     701,   702,   732,   731,   250,   736,   172,   344,   322,   109,
     147,   149,   150,   704,   708,   731,   673,   711,   142,   142,
     172,   601,   731,   124,   148,   601,   721,   722,   723,   724,
     725,   740,   281,   172,   172,   538,   534,   535,   535,   111,
     172,   172,   344,   172,   344,   537,   172,   172,   348,    74,
     565,    15,   265,   548,   565,   171,   675,   570,   572,   582,
     582,   570,   103,    84,   341,   608,   609,   172,   172,   330,
     274,   250,    98,   109,   174,   250,   264,   264,   453,   126,
     131,   250,   425,   426,   429,   430,   432,   433,   436,   678,
     344,   527,   528,   171,   517,   517,   344,   236,     3,   673,
     344,   377,   422,   673,   267,     3,   286,   419,   226,   332,
     489,   446,    76,   235,   540,   236,   466,   467,   647,   279,
     450,   470,   572,   302,   474,   475,   600,   572,   311,   459,
     309,   346,   664,   279,   483,   664,     4,   483,   172,   172,
     172,   172,   172,   344,   345,   171,   344,   344,   703,   344,
     172,   734,   673,   735,   265,   265,   265,   265,   172,   172,
     322,   739,   740,   344,   109,   150,   726,   161,   172,   172,
     172,   600,   600,   600,   567,   565,   453,   572,   548,   675,
     172,   578,   179,   335,   342,   601,   610,   611,   612,   613,
     257,   273,     3,   109,   109,   431,   599,   453,   453,   127,
     431,   429,   109,   174,   226,   269,   272,   282,   443,   445,
     678,    82,   526,   172,   518,   519,   673,   520,   520,   678,
     678,   673,   171,    82,   170,   266,   329,   330,   490,   491,
     111,   494,   495,   172,    63,    83,   252,   236,   561,   455,
     673,   171,   171,   572,   304,   474,   476,   302,   472,   473,
     303,   459,   461,   572,   171,   235,   239,   458,   343,   456,
     678,   235,   239,   648,   673,   600,   695,   696,   698,   700,
     702,   694,   700,   109,    82,   109,   109,   109,   673,   722,
     265,   265,   172,    82,   159,   162,   743,   744,   749,   172,
     172,   172,   172,   611,   327,   338,   338,   336,   616,   678,
     673,   272,   322,   109,   171,   264,   647,   344,   227,   172,
     344,     3,   523,   523,   273,   428,   429,   170,   279,   327,
     493,   279,   493,   491,   331,   302,   497,    84,    84,   455,
     345,   468,   600,   450,   303,   459,   313,   600,   472,   476,
     459,   461,   132,   310,   482,   670,   236,     4,   236,     4,
     172,   344,   322,   697,   344,   153,   739,   150,   150,   155,
     673,   750,     3,   745,   746,    82,   152,   155,   751,   752,
     754,   755,   188,    82,   108,   335,   340,   647,   128,   572,
     452,   678,   519,    58,   524,   524,   673,   172,   344,   492,
     492,   492,   492,   327,   328,   496,   171,   312,   368,   370,
     380,   385,   462,   463,   498,   504,   505,   554,   673,   172,
     344,   172,   459,   461,   301,   303,   313,   304,   308,   478,
     132,   313,   459,   172,   344,   664,   455,   456,   455,   456,
     696,   673,   699,   700,   158,   747,   747,   155,   673,   757,
     746,   756,   753,   754,   335,   342,   601,   614,   615,   339,
     327,   452,   171,   434,   172,   112,   442,    59,   525,   525,
     429,   673,   673,   673,   673,   572,   311,   600,   132,   459,
     301,   459,   572,   313,   313,   313,   670,   746,   748,   327,
     337,   337,   442,   404,    38,    39,    70,   441,   265,   438,
     439,   440,    60,   526,   526,   172,   460,   303,   307,   309,
     664,   440,   172,    63,    64,   265,   439,   265,   438,   319,
     515,   313,   462,   459,   481,   673,    41,    42,    82,   274,
     437,   437,   171,   132,   478,    40,   109,   250,   516,   662,
     172,   344,   662
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   350,   351,   352,   351,   353,   351,   354,   351,   355,
     351,   356,   351,   351,   351,   351,   351,   351,   357,   357,
     358,   358,   359,   360,   360,   361,   361,   362,   362,   363,
     364,   365,   366,   366,   366,   366,   366,   366,   366,   366,
     366,   366,   367,   367,   368,   368,   369,   369,   370,   370,
     370,   370,   370,   370,   370,   370,   371,   371,   372,   372,
     372,   373,   374,   374,   375,   375,   376,   376,   377,   377,
     377,   377,   377,   378,   378,   379,   379,   380,   380,   381,
     381,   382,   382,   383,   383,   384,   384,   385,   385,   386,
     386,   387,   387,   388,   388,   389,   389,   390,   390,   391,
     391,   391,   392,   392,   392,   393,   393,   394,   394,   394,
     394,   394,   394,   395,   395,   396,   396,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   398,   398,   398,
     399,   399,   399,   399,   399,   399,   400,   400,   400,   401,
     401,   402,   402,   402,   402,   402,   402,   402,   402,   403,
     403,   403,   404,   404,   405,   405,   406,   406,   406,   407,
     407,   407,   407,   407,   408,   408,   408,   408,   408,   408,
     408,   408,   409,   410,   410,   410,   410,   411,   411,   412,
     412,   412,   413,   413,   414,   414,   414,   414,   414,   414,
     414,   415,   415,   415,   415,   415,   415,   416,   416,   416,
     416,   417,   417,   418,   419,   419,   419,   420,   420,   421,
     421,   422,   422,   422,   423,   423,   424,   424,   425,   425,
     426,   426,   427,   428,   428,   429,   429,   429,   430,   431,
     432,   433,   433,   434,   434,   435,   436,   436,   437,   437,
     437,   437,   437,   438,   439,   440,   440,   440,   440,   440,
     441,   441,   441,   441,   442,   442,   443,   443,   443,   443,
     443,   443,   444,   444,   444,   445,   446,   446,   447,   448,
     449,   449,   450,   450,   451,   451,   452,   452,   453,   454,
     455,   456,   456,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   458,   458,   458,   459,   459,   460,   460,   461,
     461,   461,   461,   461,   461,   461,   461,   461,   461,   461,
     461,   462,   462,   462,   462,   462,   462,   462,   462,   463,
     463,   463,   463,   463,   463,   464,   465,   466,   467,   468,
     468,   468,   469,   470,   470,   470,   471,   471,   472,   473,
     473,   474,   475,   475,   476,   476,   477,   478,   478,   478,
     479,   480,   480,   481,   481,   482,   482,   483,   483,   484,
     484,   484,   485,   485,   486,   487,   487,   488,   488,   488,
     488,   489,   489,   490,   490,   491,   491,   491,   491,   492,
     492,   493,   493,   494,   495,   495,   496,   496,   497,   497,
     498,   498,   499,   499,   499,   499,   499,   500,   500,   500,
     500,   500,   500,   500,   500,   500,   500,   500,   500,   500,
     501,   501,   501,   502,   502,   503,   503,   503,   366,   366,
     504,   504,   504,   504,   505,   506,   506,   506,   506,   506,
     506,   506,   507,   507,   508,   508,   509,   509,   509,   509,
     510,   510,   510,   510,   511,   511,   512,   512,   512,   513,
     513,   514,   514,   514,   514,   514,   514,   515,   515,   516,
     516,   517,   517,   518,   518,   519,   519,   520,   520,   520,
     520,   521,   521,   522,   522,   522,   522,   522,   523,   523,
     524,   524,   525,   525,   526,   526,   527,   527,   528,   528,
     529,   530,   531,   531,   532,   532,   532,   532,   533,   533,
     534,   534,   535,   535,   536,   537,   538,   539,   539,   540,
     540,   540,   541,   541,   542,   542,   543,   543,   544,   544,
     544,   544,   544,   545,   545,   545,   546,   546,   547,   547,
     547,   548,   548,   366,   549,   550,   550,   551,   552,   366,
     366,   553,   554,   555,   556,   556,   557,   558,   558,   558,
     558,   558,   559,   559,   559,   560,   560,   560,   561,   562,
     563,   563,   564,   564,   565,   565,   565,   565,   565,   565,
     565,   566,   565,   567,   567,   567,   567,   568,   568,   569,
     569,   570,   570,   571,   571,   572,   572,   573,   573,   574,
     574,   575,   575,   575,   576,   576,   576,   577,   577,   577,
     577,   578,   578,   579,   580,   580,   580,   581,   581,   581,
     581,   581,   581,   581,   581,   581,   582,   582,   583,   583,
     584,   584,   585,   585,   585,   586,   586,   586,   586,   587,
     587,   588,   588,   589,   589,   589,   589,   590,   590,   591,
     591,   592,   592,   592,   593,   594,   594,   595,   596,   597,
     597,   597,   598,   598,   598,   599,   599,   599,   599,   599,
     599,   599,   599,   599,   599,   599,   599,   599,   599,   599,
     599,   599,   599,   599,   599,   599,   599,   599,   599,   599,
     599,   599,   599,   600,   600,   601,   601,   601,   601,   601,
     601,   601,   601,   601,   601,   601,   601,   601,   601,   601,
     601,   602,   603,   604,   604,   605,   606,   606,   607,   607,
     608,   608,   609,   609,   610,   610,   611,   611,   611,   612,
     613,   614,   614,   614,   615,   616,   616,   616,   616,   616,
     617,   618,   618,   619,   619,   620,   620,   620,   620,   621,
     621,   621,   621,   621,   621,   622,   622,   623,   623,   623,
     623,   623,   623,   623,   624,   624,   625,   625,   625,   625,
     626,   626,   627,   628,   628,   629,   629,   630,   630,   631,
     631,   631,   631,   631,   631,   631,   632,   632,   632,   633,
     633,   634,   634,   635,   635,   636,   636,   636,   637,   637,
     637,   637,   637,   638,   638,   639,   640,   640,   641,   641,
     642,   642,   643,   644,   644,   644,   645,   645,   645,   645,
     645,   645,   645,   645,   645,   645,   645,   645,   645,   645,
     645,   645,   646,   647,   647,   647,   648,   648,   648,   649,
     649,   650,   651,   651,   651,   651,   652,   652,   653,   653,
     654,   655,   655,   656,   657,   657,   658,   658,   659,   660,
     661,   662,   663,   664,   664,   664,   664,   664,   664,   664,
     664,   664,   664,   664,   664,   664,   664,   664,   664,   664,
     664,   664,   664,   664,   664,   664,   664,   664,   664,   664,
     664,   664,   664,   664,   664,   664,   664,   664,   664,   665,
     665,   666,   667,   667,   668,   668,   668,   669,   669,   670,
     671,   672,   672,   672,   672,   672,   672,   673,   673,   673,
     673,   673,   673,   673,   673,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   674,   674,
     674,   675,   675,   676,   677,   677,   678,   678,   679,   680,
     680,   681,   681,   682,   683,   684,   685,   685,   686,   687,
     687,   687,   687,   687,   687,   687,   687,   687,   687,   688,
     689,   690,   691,   692,   692,   692,   692,   692,   692,   692,
     692,   693,   694,   695,   695,   696,   697,   697,   698,   699,
     700,   701,   701,   702,   703,   703,   704,   704,   704,   704,
     704,   705,   706,   706,   707,   707,   708,   709,   710,   710,
     711,   712,   713,   713,   714,   715,   716,   716,   717,   718,
     719,   719,   720,   721,   721,   722,   722,   723,   724,   725,
     725,   726,   726,   727,   728,   729,   729,   730,   730,   731,
     731,   731,   732,   733,   733,   734,   734,   735,   736,   737,
     738,   738,   739,   739,   740,   740,   741,   741,   742,   743,
     743,   744,   744,   745,   746,   747,   747,   748,   749,   750,
     751,   751,   752,   752,   753,   753,   754,   755,   755,   756,
     757,   758
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     0,     4,     0,     4,     0,     4,     0,
       3,     0,     3,     2,     0,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     0,     2,     0,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     1,     0,     1,     2,     2,     2,     4,     4,     4,
       4,     3,     4,     3,     4,     4,     7,     5,     1,     2,
       3,     1,     0,     4,     0,     1,     1,     2,     1,     1,
       1,     1,     1,     0,     3,     1,     1,     6,     6,     1,
       3,     0,     3,     0,     3,     0,     2,     6,     6,     0,
       3,     0,     3,     1,     3,     1,     3,     2,     2,     2,
       1,     1,     2,     1,     1,     1,     3,     1,     1,     2,
       2,     2,     1,     1,     3,     1,     1,     6,     6,     5,
       5,     6,     6,     6,     4,     6,    10,     4,     3,     7,
       5,     4,     5,     4,     5,     5,     3,     3,     3,     1,
       0,     2,     2,     2,     1,     1,     1,     1,     1,     4,
       3,     4,     1,     2,     1,     2,     2,     3,     1,     2,
       1,     3,     3,     1,     3,     2,     1,     2,     1,     2,
       1,     1,     9,     1,     1,     1,     0,     3,    10,     0,
       1,     1,     0,     3,     5,     6,     5,     5,     5,     7,
       6,     1,     1,     2,     2,     2,     2,     0,     4,     4,
       3,     3,     1,     4,     0,     3,     2,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     3,     2,     0,     1,
       1,     2,     6,     1,     3,     1,     1,     1,     2,     1,
       2,     5,     1,     0,     3,     2,     0,     2,     2,     1,
       1,     2,     2,     3,     3,     0,     1,     1,     2,     2,
       0,     1,     1,     1,     0,     2,     2,     1,     1,     2,
       5,     1,     2,     3,     8,     4,     1,     3,     2,     6,
       1,     3,     1,     1,     0,     3,     0,     1,     3,     6,
       3,     1,     1,    11,     9,    11,    10,    11,    11,     9,
       7,     9,     1,     5,     6,     0,     3,     0,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     4,     1,     0,
       1,     3,     2,     1,     1,     4,     6,     5,     4,     1,
       2,     4,     1,     2,     0,     2,     7,     0,     2,     5,
       8,     0,     2,     0,     1,     2,     4,     4,     1,     1,
       1,     0,     4,     2,     9,     1,     1,     1,     1,     1,
       3,     0,     2,     1,     2,     4,     4,     4,     4,     0,
       1,     0,     1,     3,     0,     3,     1,     1,     0,     4,
       1,     4,     3,     4,     3,     3,     3,     5,     3,     5,
       6,     5,     5,     5,     5,     4,     3,     3,     3,     3,
       0,     3,     2,     1,     3,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     2,     3,     4,     3,
       4,     3,     0,     1,     1,     3,     2,     2,     3,     3,
       2,     2,     2,     1,     1,     0,     2,     3,     0,     0,
       3,    14,    13,     6,     9,     6,     6,     0,     4,     1,
       3,     0,     3,     1,     3,     1,     2,     0,     3,     5,
       7,     0,     1,     0,     2,     2,     4,     4,     0,     3,
       0,     1,     0,     2,     0,     2,     1,     3,     1,     3,
       4,     6,     4,     5,     0,     2,     2,     1,     3,     5,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     0,
       1,     1,     1,     3,     3,     3,     0,     2,     3,     4,
       4,     5,     5,     0,     1,     2,     0,     1,     1,     1,
       1,     2,     2,     1,     3,     3,     1,     4,     1,     1,
       1,     4,     6,     5,     1,     3,     1,     5,     5,     5,
       3,     1,     0,     1,     1,     0,     1,     5,     1,     4,
       0,     2,     1,     3,     2,     2,     3,     2,     3,     1,
       1,     0,     5,     5,     2,     4,     1,     0,     1,     0,
       3,     1,     3,     0,     2,     3,     1,     3,     1,     0,
       3,     0,     2,     2,     0,     2,     2,     0,     2,     2,
       2,     1,     3,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     3,     3,
       6,     6,     0,     1,     1,     3,     3,     3,     3,     1,
       3,     4,     3,     5,     5,     7,     7,     1,     3,     4,
       4,     1,     1,     1,     2,     1,     3,     3,     3,     3,
       4,     3,     3,     4,     3,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     3,     3,
       2,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     5,     3,     1,     3,     0,     3,     0,     3,
       0,     3,     1,     1,     1,     1,     2,     1,     2,     2,
       4,     2,     1,     2,     2,     0,     3,     2,     2,     3,
       2,     3,     4,     1,     3,     1,     1,     1,     1,     6,
       2,     2,     2,     2,     2,     0,     2,     8,     8,     6,
       6,     6,     3,     8,     1,     3,     1,     3,     3,     2,
       0,     2,     1,     1,     3,     1,     3,     1,     3,     4,
       6,     5,     5,     4,     6,     1,     1,     1,     0,     3,
       0,     3,     0,     3,     0,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     2,     2,     2,
       3,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     4,     4,     1,     2,     2,     2,     2,
       1,     1,     4,     1,     3,     5,     1,     3,     5,     6,
       6,     1,     6,     4,     5,     4,     1,     3,     3,     3,
       4,     1,     2,     4,     1,     2,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     4,     4,     1,
       4,     1,     1,     1,     1,     1,     1,     4,     6,     1,
       4,     6,     1,     2,     1,     1,     1,     1,     4,     1,
       4,     6,     1,     4,     1,     4,     6,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     2,     2,     3,
       4,     0,     1,     2,     1,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       5,     5,     7,     0,     2,     4,     6,     4,     2,     4,
       2,     1,     4,     1,     3,     2,     0,     2,     1,     1,
       2,     1,     3,     1,     0,     2,     3,     3,     3,     3,
       4,     7,     0,     2,     1,     3,     2,     1,     0,     2,
       1,     6,     2,     2,     7,     1,     0,     2,     8,     1,
       0,     3,     1,     1,     3,     1,     1,     2,     4,     0,
       1,     3,     3,     5,     6,     1,     1,     1,     1,     0,
       2,     2,     4,     1,     3,     1,     1,     1,     1,     3,
       2,     2,     0,     1,     2,     2,     0,     1,     5,     1,
       1,     3,     3,     1,     1,     0,     2,     1,     2,     1,
       0,     1,     1,     2,     0,     1,     2,     2,     2,     1,
       1,     6
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (m, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, m); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, mvc *m)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (m);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, mvc *m)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, m);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, mvc *m)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], m);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, m); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, mvc *m)
{
  YY_USE (yyvaluep);
  YY_USE (m);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (mvc *m)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, m);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* sqlstmt: sql SCOLON  */
#line 620 "sql_parser.y"
        {
		if (m->sym) {
			append_symbol(m->sym->data.lval, (yyval.sym));
			(yyval.sym) = m->sym;
		} else {
			m->sym = (yyval.sym) = (yyvsp[-1].sym);
		}
		YYACCEPT;
	}
#line 7286 "y.tab.c"
    break;

  case 3: /* $@1: %empty  */
#line 630 "sql_parser.y"
                        {
		  	  m->emode = m_prepare; 
			  m->scanner.as = m->scanner.yycur; 
			  m->scanner.key = 0;
			}
#line 7296 "y.tab.c"
    break;

  case 4: /* sqlstmt: prepare $@1 sql SCOLON  */
#line 635 "sql_parser.y"
                        {
			  if (m->sym) {
				append_symbol(m->sym->data.lval, (yyvsp[-1].sym));
				(yyval.sym) = m->sym;
			  } else {
				m->sym = (yyval.sym) = (yyvsp[-1].sym);
			  }
			  YYACCEPT;
			}
#line 7310 "y.tab.c"
    break;

  case 5: /* $@2: %empty  */
#line 644 "sql_parser.y"
                        {
		  	  m->emode = m_plan;
			  m->scanner.as = m->scanner.yycur; 
			  m->scanner.key = 0;
			}
#line 7320 "y.tab.c"
    break;

  case 6: /* sqlstmt: SQL_PLAN $@2 sql SCOLON  */
#line 649 "sql_parser.y"
                        {
			  if (m->sym) {
				append_symbol(m->sym->data.lval, (yyvsp[-1].sym));
				(yyval.sym) = m->sym;
			  } else {
				m->sym = (yyval.sym) = (yyvsp[-1].sym);
			  }
			  YYACCEPT;
			}
#line 7334 "y.tab.c"
    break;

  case 7: /* $@3: %empty  */
#line 659 "sql_parser.y"
                        {
		  	  m->emod |= mod_explain;
			  m->scanner.as = m->scanner.yycur; 
			  m->scanner.key = 0;
			}
#line 7344 "y.tab.c"
    break;

  case 8: /* sqlstmt: SQL_EXPLAIN $@3 sql SCOLON  */
#line 664 "sql_parser.y"
                        {
			  if (m->sym) {
				append_symbol(m->sym->data.lval, (yyvsp[-1].sym));
				(yyval.sym) = m->sym;
			  } else {
				m->sym = (yyval.sym) = (yyvsp[-1].sym);
			  }
			  YYACCEPT;
			}
#line 7358 "y.tab.c"
    break;

  case 9: /* $@4: %empty  */
#line 674 "sql_parser.y"
                        {
			  if (m->scanner.mode == LINE_1) {
				yyerror(m, "SQL debugging only supported in interactive mode");
				YYABORT;
			  }
		  	  m->emod |= mod_debug;
			  m->scanner.as = m->scanner.yycur; 
			  m->scanner.key = 0;
			}
#line 7372 "y.tab.c"
    break;

  case 10: /* sqlstmt: SQL_DEBUG $@4 sqlstmt  */
#line 683 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); YYACCEPT; }
#line 7378 "y.tab.c"
    break;

  case 11: /* $@5: %empty  */
#line 684 "sql_parser.y"
                        {
		  	  m->emod |= mod_trace;
			  m->scanner.as = m->scanner.yycur; 
			  m->scanner.key = 0;
			}
#line 7388 "y.tab.c"
    break;

  case 12: /* sqlstmt: SQL_TRACE $@5 sqlstmt  */
#line 689 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); YYACCEPT; }
#line 7394 "y.tab.c"
    break;

  case 13: /* sqlstmt: exec SCOLON  */
#line 690 "sql_parser.y"
                        { m->sym = (yyval.sym) = (yyvsp[-1].sym); YYACCEPT; }
#line 7400 "y.tab.c"
    break;

  case 14: /* sqlstmt: %empty  */
#line 691 "sql_parser.y"
                        { m->sym = (yyval.sym) = NULL; YYACCEPT; }
#line 7406 "y.tab.c"
    break;

  case 15: /* sqlstmt: SCOLON  */
#line 692 "sql_parser.y"
                        { m->sym = (yyval.sym) = NULL; YYACCEPT; }
#line 7412 "y.tab.c"
    break;

  case 16: /* sqlstmt: error SCOLON  */
#line 693 "sql_parser.y"
                        { m->sym = (yyval.sym) = NULL; YYACCEPT; }
#line 7418 "y.tab.c"
    break;

  case 17: /* sqlstmt: LEX_ERROR  */
#line 694 "sql_parser.y"
                        { m->sym = (yyval.sym) = NULL; YYABORT; }
#line 7424 "y.tab.c"
    break;

  case 22: /* create: CREATE  */
#line 710 "sql_parser.y"
            { (yyval.bval) = FALSE; }
#line 7430 "y.tab.c"
    break;

  case 24: /* create_or_replace: CREATE OR REPLACE  */
#line 714 "sql_parser.y"
                          { (yyval.bval) = TRUE; }
#line 7436 "y.tab.c"
    break;

  case 25: /* if_exists: %empty  */
#line 718 "sql_parser.y"
                      { (yyval.bval) = FALSE; }
#line 7442 "y.tab.c"
    break;

  case 26: /* if_exists: IF EXISTS  */
#line 719 "sql_parser.y"
                      { (yyval.bval) = TRUE; }
#line 7448 "y.tab.c"
    break;

  case 27: /* if_not_exists: %empty  */
#line 722 "sql_parser.y"
                      { (yyval.bval) = FALSE; }
#line 7454 "y.tab.c"
    break;

  case 28: /* if_not_exists: IF NOT EXISTS  */
#line 723 "sql_parser.y"
                      { (yyval.bval) = TRUE; }
#line 7460 "y.tab.c"
    break;

  case 40: /* sql: ANALYZE qname opt_column_list opt_sample opt_minmax  */
#line 746 "sql_parser.y"
                { dlist *l = L();
		append_list(l, (yyvsp[-3].l));
		append_list(l, (yyvsp[-2].l));
		append_symbol(l, (yyvsp[-1].sym));
		append_int(l, (yyvsp[0].i_val));
		(yyval.sym) = _symbol_create_list( SQL_ANALYZE, l); }
#line 7471 "y.tab.c"
    break;

  case 42: /* opt_minmax: %empty  */
#line 756 "sql_parser.y"
                        { (yyval.i_val) = 0; }
#line 7477 "y.tab.c"
    break;

  case 43: /* opt_minmax: MINMAX  */
#line 757 "sql_parser.y"
                        { (yyval.i_val) = 1; }
#line 7483 "y.tab.c"
    break;

  case 44: /* declare_statement: declare variable_list  */
#line 762 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list( SQL_DECLARE, (yyvsp[0].l)); }
#line 7489 "y.tab.c"
    break;

  case 45: /* declare_statement: declare table_def  */
#line 763 "sql_parser.y"
                          { (yyval.sym) = (yyvsp[0].sym); }
#line 7495 "y.tab.c"
    break;

  case 46: /* variable_list: ident_commalist data_type  */
#line 768 "sql_parser.y"
                { dlist *l = L();
		append_list(l, (yyvsp[-1].l) );
		append_type(l, &(yyvsp[0].type) );
		(yyval.l) = append_symbol(L(), _symbol_create_list( SQL_DECLARE, l)); }
#line 7504 "y.tab.c"
    break;

  case 47: /* variable_list: variable_list ',' ident_commalist data_type  */
#line 773 "sql_parser.y"
                { dlist *l = L();
		append_list(l, (yyvsp[-1].l) );
		append_type(l, &(yyvsp[0].type) );
		(yyval.l) = append_symbol((yyvsp[-3].l), _symbol_create_list( SQL_DECLARE, l)); }
#line 7513 "y.tab.c"
    break;

  case 48: /* set_statement: set ident '=' search_condition  */
#line 782 "sql_parser.y"
                { dlist *l = L();
		append_string(l, (yyvsp[-2].sval) );
		append_symbol(l, (yyvsp[0].sym) );
		(yyval.sym) = _symbol_create_list( SQL_SET, l); }
#line 7522 "y.tab.c"
    break;

  case 49: /* set_statement: set column_commalist_parens '=' subquery  */
#line 787 "sql_parser.y"
                { dlist *l = L();
	  	append_list(l, (yyvsp[-2].l));
	  	append_symbol(l, (yyvsp[0].sym));
	  	(yyval.sym) = _symbol_create_list( SQL_SET, l ); }
#line 7531 "y.tab.c"
    break;

  case 50: /* set_statement: set sqlSESSION AUTHORIZATION ident  */
#line 792 "sql_parser.y"
                { dlist *l = L();
		  sql_subtype t;
	        sql_find_subtype(&t, "char", UTF8_strlen((yyvsp[0].sval)), 0 );
		append_string(l, sa_strdup(SA, "current_user"));
		append_symbol(l,
			_newAtomNode( _atom_string(&t, sql2str((yyvsp[0].sval)))) );
		(yyval.sym) = _symbol_create_list( SQL_SET, l); }
#line 7543 "y.tab.c"
    break;

  case 51: /* set_statement: set SCHEMA ident  */
#line 800 "sql_parser.y"
                { dlist *l = L();
		  sql_subtype t;
		sql_find_subtype(&t, "char", UTF8_strlen((yyvsp[0].sval)), 0 );
		append_string(l, sa_strdup(SA, "current_schema"));
		append_symbol(l,
			_newAtomNode( _atom_string(&t, sql2str((yyvsp[0].sval)))) );
		(yyval.sym) = _symbol_create_list( SQL_SET, l); }
#line 7555 "y.tab.c"
    break;

  case 52: /* set_statement: set user '=' ident  */
#line 808 "sql_parser.y"
                { dlist *l = L();
		  sql_subtype t;
		sql_find_subtype(&t, "char", UTF8_strlen((yyvsp[0].sval)), 0 );
		append_string(l, sa_strdup(SA, "current_user"));
		append_symbol(l,
			_newAtomNode( _atom_string(&t, sql2str((yyvsp[0].sval)))) );
		(yyval.sym) = _symbol_create_list( SQL_SET, l); }
#line 7567 "y.tab.c"
    break;

  case 53: /* set_statement: set ROLE ident  */
#line 816 "sql_parser.y"
                { dlist *l = L();
		  sql_subtype t;
		sql_find_subtype(&t, "char", UTF8_strlen((yyvsp[0].sval)), 0);
		append_string(l, sa_strdup(SA, "current_role"));
		append_symbol(l,
			_newAtomNode( _atom_string(&t, sql2str((yyvsp[0].sval)))) );
		(yyval.sym) = _symbol_create_list( SQL_SET, l); }
#line 7579 "y.tab.c"
    break;

  case 54: /* set_statement: set TIME ZONE LOCAL  */
#line 824 "sql_parser.y"
                { dlist *l = L();
		append_string(l, sa_strdup(SA, "current_timezone"));
		append_symbol(l, _symbol_create_list( SQL_OP, append_list(L(),
			append_string( L(), sa_strdup(SA, "local_timezone")))));
		(yyval.sym) = _symbol_create_list( SQL_SET, l); }
#line 7589 "y.tab.c"
    break;

  case 55: /* set_statement: set TIME ZONE interval_expression  */
#line 830 "sql_parser.y"
                { dlist *l = L();
		append_string(l, sa_strdup(SA, "current_timezone"));
		append_symbol(l, (yyvsp[0].sym) );
		(yyval.sym) = _symbol_create_list( SQL_SET, l); }
#line 7598 "y.tab.c"
    break;

  case 56: /* schema: create SCHEMA if_not_exists schema_name_clause opt_schema_default_char_set opt_path_specification opt_schema_element_list  */
#line 839 "sql_parser.y"
                { dlist *l = L();
		append_list(l, (yyvsp[-3].l));
		append_symbol(l, (yyvsp[-2].sym));
		append_symbol(l, (yyvsp[-1].sym));
		append_list(l, (yyvsp[0].l));
		append_int(l, (yyvsp[-4].bval));
		(yyval.sym) = _symbol_create_list( SQL_CREATE_SCHEMA, l); }
#line 7610 "y.tab.c"
    break;

  case 57: /* schema: drop SCHEMA if_exists qname drop_action  */
#line 847 "sql_parser.y"
                { dlist *l = L();
		append_list(l, (yyvsp[-1].l));
		append_int(l, 1 /*$5 use CASCADE in the release */);
		append_int(l, (yyvsp[-2].bval));
		(yyval.sym) = _symbol_create_list( SQL_DROP_SCHEMA, l); }
#line 7620 "y.tab.c"
    break;

  case 58: /* schema_name_clause: ident  */
#line 856 "sql_parser.y"
        { (yyval.l) = L();
	  append_string((yyval.l), (yyvsp[0].sval) );
	  append_string((yyval.l), NULL ); }
#line 7628 "y.tab.c"
    break;

  case 59: /* schema_name_clause: AUTHORIZATION authorization_identifier  */
#line 860 "sql_parser.y"
        { (yyval.l) = L();
	  append_string((yyval.l), NULL );
	  append_string((yyval.l), (yyvsp[0].sval) ); }
#line 7636 "y.tab.c"
    break;

  case 60: /* schema_name_clause: ident AUTHORIZATION authorization_identifier  */
#line 864 "sql_parser.y"
        { (yyval.l) = L();
	  append_string((yyval.l), (yyvsp[-2].sval) );
	  append_string((yyval.l), (yyvsp[0].sval) ); }
#line 7644 "y.tab.c"
    break;

  case 62: /* opt_schema_default_char_set: %empty  */
#line 873 "sql_parser.y"
                                { (yyval.sym) = NULL; }
#line 7650 "y.tab.c"
    break;

  case 63: /* opt_schema_default_char_set: DEFAULT CHARACTER SET ident  */
#line 874 "sql_parser.y"
                                { (yyval.sym) = _symbol_create( SQL_CHARSET, (yyvsp[0].sval) ); }
#line 7656 "y.tab.c"
    break;

  case 64: /* opt_schema_element_list: %empty  */
#line 878 "sql_parser.y"
                                { (yyval.l) = L(); }
#line 7662 "y.tab.c"
    break;

  case 66: /* schema_element_list: schema_element  */
#line 883 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 7668 "y.tab.c"
    break;

  case 67: /* schema_element_list: schema_element_list schema_element  */
#line 885 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-1].l), (yyvsp[0].sym) ); }
#line 7674 "y.tab.c"
    break;

  case 73: /* opt_grantor: %empty  */
#line 891 "sql_parser.y"
                         { (yyval.i_val) = cur_user; }
#line 7680 "y.tab.c"
    break;

  case 74: /* opt_grantor: WITH ADMIN grantor  */
#line 892 "sql_parser.y"
                         { (yyval.i_val) = (yyvsp[0].i_val); }
#line 7686 "y.tab.c"
    break;

  case 75: /* grantor: CURRENT_USER  */
#line 896 "sql_parser.y"
                        { (yyval.i_val) = cur_user; }
#line 7692 "y.tab.c"
    break;

  case 76: /* grantor: CURRENT_ROLE  */
#line 897 "sql_parser.y"
                        { (yyval.i_val) = cur_role; }
#line 7698 "y.tab.c"
    break;

  case 77: /* grant: GRANT privileges TO grantee_commalist opt_with_grant opt_from_grantor  */
#line 902 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-4].l));
	  append_list(l, (yyvsp[-2].l));
	  append_int(l, (yyvsp[-1].bval));
	  append_int(l, (yyvsp[0].i_val));
	(yyval.sym) = _symbol_create_list( SQL_GRANT, l);
	}
#line 7710 "y.tab.c"
    break;

  case 78: /* grant: GRANT authid_list TO grantee_commalist opt_with_admin opt_from_grantor  */
#line 912 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-4].l));
	  append_list(l, (yyvsp[-2].l));
	  append_int(l, (yyvsp[-1].bval));
	  append_int(l, (yyvsp[0].i_val));
	(yyval.sym) = _symbol_create_list( SQL_GRANT_ROLES, l); }
#line 7721 "y.tab.c"
    break;

  case 79: /* authid_list: authid  */
#line 921 "sql_parser.y"
                        { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 7727 "y.tab.c"
    break;

  case 80: /* authid_list: authid_list ',' authid  */
#line 923 "sql_parser.y"
                        { (yyval.l) = append_string((yyvsp[-2].l), (yyvsp[0].sval)); }
#line 7733 "y.tab.c"
    break;

  case 81: /* opt_with_grant: %empty  */
#line 927 "sql_parser.y"
                                        { (yyval.bval) = 0; }
#line 7739 "y.tab.c"
    break;

  case 82: /* opt_with_grant: WITH GRANT OPTION  */
#line 928 "sql_parser.y"
                                        { (yyval.bval) = 1; }
#line 7745 "y.tab.c"
    break;

  case 83: /* opt_with_admin: %empty  */
#line 932 "sql_parser.y"
                                { (yyval.bval) = 0; }
#line 7751 "y.tab.c"
    break;

  case 84: /* opt_with_admin: WITH ADMIN OPTION  */
#line 933 "sql_parser.y"
                                { (yyval.bval) = 1; }
#line 7757 "y.tab.c"
    break;

  case 85: /* opt_from_grantor: %empty  */
#line 938 "sql_parser.y"
                        { (yyval.i_val) = cur_user; }
#line 7763 "y.tab.c"
    break;

  case 86: /* opt_from_grantor: FROM grantor  */
#line 939 "sql_parser.y"
                        { (yyval.i_val) = (yyvsp[0].i_val); }
#line 7769 "y.tab.c"
    break;

  case 87: /* revoke: REVOKE opt_grant_for privileges FROM grantee_commalist opt_from_grantor  */
#line 944 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-3].l));
	  append_list(l, (yyvsp[-1].l));
	  append_int(l, (yyvsp[-4].bval)); /* GRANT OPTION FOR */
	  append_int(l, 0);
	  append_int(l, (yyvsp[0].i_val));
	(yyval.sym) = _symbol_create_list( SQL_REVOKE, l); }
#line 7781 "y.tab.c"
    break;

  case 88: /* revoke: REVOKE opt_admin_for authid_list FROM grantee_commalist opt_from_grantor  */
#line 952 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-3].l));
	  append_list(l, (yyvsp[-1].l));
	  append_int(l, (yyvsp[-4].bval));
	  append_int(l, (yyvsp[0].i_val));
	(yyval.sym) = _symbol_create_list( SQL_REVOKE_ROLES, l); }
#line 7792 "y.tab.c"
    break;

  case 89: /* opt_grant_for: %empty  */
#line 961 "sql_parser.y"
                                        { (yyval.bval) = 0; }
#line 7798 "y.tab.c"
    break;

  case 90: /* opt_grant_for: GRANT OPTION FOR  */
#line 962 "sql_parser.y"
                                        { (yyval.bval) = 1; }
#line 7804 "y.tab.c"
    break;

  case 91: /* opt_admin_for: %empty  */
#line 966 "sql_parser.y"
                                        { (yyval.bval) = 0; }
#line 7810 "y.tab.c"
    break;

  case 92: /* opt_admin_for: ADMIN OPTION FOR  */
#line 967 "sql_parser.y"
                                        { (yyval.bval) = 1; }
#line 7816 "y.tab.c"
    break;

  case 93: /* privileges: global_privileges  */
#line 972 "sql_parser.y"
        { (yyval.l) = L();
	  append_list((yyval.l), (yyvsp[0].l));
	  append_symbol((yyval.l), _symbol_create(SQL_GRANT, NULL)); }
#line 7824 "y.tab.c"
    break;

  case 94: /* privileges: object_privileges ON object_name  */
#line 976 "sql_parser.y"
        { (yyval.l) = L();
	  append_list((yyval.l), (yyvsp[-2].l));
	  append_symbol((yyval.l), (yyvsp[0].sym)); }
#line 7832 "y.tab.c"
    break;

  case 95: /* global_privileges: global_privilege  */
#line 982 "sql_parser.y"
                        { (yyval.l) = append_int(L(), (yyvsp[0].i_val)); }
#line 7838 "y.tab.c"
    break;

  case 96: /* global_privileges: global_privilege ',' global_privilege  */
#line 984 "sql_parser.y"
                        { (yyval.l) = append_int(append_int(L(), (yyvsp[-2].i_val)), (yyvsp[0].i_val)); }
#line 7844 "y.tab.c"
    break;

  case 97: /* global_privilege: COPY FROM  */
#line 988 "sql_parser.y"
                        { (yyval.i_val) = PRIV_COPYFROMFILE; }
#line 7850 "y.tab.c"
    break;

  case 98: /* global_privilege: COPY INTO  */
#line 989 "sql_parser.y"
                        { (yyval.i_val) = PRIV_COPYINTOFILE; }
#line 7856 "y.tab.c"
    break;

  case 99: /* object_name: TABLE qname  */
#line 993 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list(SQL_TABLE, (yyvsp[0].l)); }
#line 7862 "y.tab.c"
    break;

  case 100: /* object_name: qname  */
#line 994 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list(SQL_NAME, (yyvsp[0].l)); }
#line 7868 "y.tab.c"
    break;

  case 101: /* object_name: routine_designator  */
#line 995 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list(SQL_FUNC, (yyvsp[0].l)); }
#line 7874 "y.tab.c"
    break;

  case 102: /* object_privileges: ALL PRIVILEGES  */
#line 1006 "sql_parser.y"
                                        { (yyval.l) = NULL; }
#line 7880 "y.tab.c"
    break;

  case 103: /* object_privileges: ALL  */
#line 1007 "sql_parser.y"
                                        { (yyval.l) = NULL; }
#line 7886 "y.tab.c"
    break;

  case 105: /* operation_commalist: operation  */
#line 1012 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 7892 "y.tab.c"
    break;

  case 106: /* operation_commalist: operation_commalist ',' operation  */
#line 1014 "sql_parser.y"
                        { (yyval.l) = append_symbol((yyvsp[-2].l), (yyvsp[0].sym)); }
#line 7898 "y.tab.c"
    break;

  case 107: /* operation: INSERT  */
#line 1018 "sql_parser.y"
                                    { (yyval.sym) = _symbol_create(SQL_INSERT,NULL); }
#line 7904 "y.tab.c"
    break;

  case 108: /* operation: sqlDELETE  */
#line 1019 "sql_parser.y"
                                    { (yyval.sym) = _symbol_create(SQL_DELETE,NULL); }
#line 7910 "y.tab.c"
    break;

  case 109: /* operation: UPDATE opt_column_list  */
#line 1020 "sql_parser.y"
                                    { (yyval.sym) = _symbol_create_list(SQL_UPDATE,(yyvsp[0].l)); }
#line 7916 "y.tab.c"
    break;

  case 110: /* operation: SELECT opt_column_list  */
#line 1021 "sql_parser.y"
                                    { (yyval.sym) = _symbol_create_list(SQL_SELECT,(yyvsp[0].l)); }
#line 7922 "y.tab.c"
    break;

  case 111: /* operation: REFERENCES opt_column_list  */
#line 1022 "sql_parser.y"
                                    { (yyval.sym) = _symbol_create_list(SQL_SELECT,(yyvsp[0].l)); }
#line 7928 "y.tab.c"
    break;

  case 112: /* operation: execute  */
#line 1023 "sql_parser.y"
                                    { (yyval.sym) = _symbol_create(SQL_EXECUTE,NULL); }
#line 7934 "y.tab.c"
    break;

  case 113: /* grantee_commalist: grantee  */
#line 1027 "sql_parser.y"
                                { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 7940 "y.tab.c"
    break;

  case 114: /* grantee_commalist: grantee_commalist ',' grantee  */
#line 1029 "sql_parser.y"
                                { (yyval.l) = append_string((yyvsp[-2].l), (yyvsp[0].sval)); }
#line 7946 "y.tab.c"
    break;

  case 115: /* grantee: PUBLIC  */
#line 1033 "sql_parser.y"
                                { (yyval.sval) = NULL; }
#line 7952 "y.tab.c"
    break;

  case 116: /* grantee: authid  */
#line 1034 "sql_parser.y"
                                { (yyval.sval) = (yyvsp[0].sval); }
#line 7958 "y.tab.c"
    break;

  case 117: /* alter_statement: ALTER TABLE qname ADD opt_column add_table_element  */
#line 1042 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-3].l));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_ALTER_TABLE, l ); }
#line 7967 "y.tab.c"
    break;

  case 118: /* alter_statement: ALTER TABLE qname ADD TABLE qname  */
#line 1047 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-3].l));
	  append_symbol(l, _symbol_create_list( SQL_TABLE, (yyvsp[0].l)));
	  (yyval.sym) = _symbol_create_list( SQL_ALTER_TABLE, l ); }
#line 7976 "y.tab.c"
    break;

  case 119: /* alter_statement: ALTER TABLE qname ALTER alter_table_element  */
#line 1052 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-2].l));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_ALTER_TABLE, l ); }
#line 7985 "y.tab.c"
    break;

  case 120: /* alter_statement: ALTER TABLE qname DROP drop_table_element  */
#line 1057 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-2].l));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_ALTER_TABLE, l ); }
#line 7994 "y.tab.c"
    break;

  case 121: /* alter_statement: ALTER TABLE qname SET READ ONLY  */
#line 1062 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-3].l));
	  append_symbol(l, _symbol_create_int(SQL_ALTER_TABLE, tr_readonly));
	  (yyval.sym) = _symbol_create_list( SQL_ALTER_TABLE, l ); }
#line 8003 "y.tab.c"
    break;

  case 122: /* alter_statement: ALTER TABLE qname SET INSERT ONLY  */
#line 1067 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-3].l));
	  append_symbol(l, _symbol_create_int(SQL_ALTER_TABLE, tr_append));
	  (yyval.sym) = _symbol_create_list( SQL_ALTER_TABLE, l ); }
#line 8012 "y.tab.c"
    break;

  case 123: /* alter_statement: ALTER TABLE qname SET READ WRITE  */
#line 1072 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-3].l));
	  append_symbol(l, _symbol_create_int(SQL_ALTER_TABLE, tr_writable));
	  (yyval.sym) = _symbol_create_list( SQL_ALTER_TABLE, l ); }
#line 8021 "y.tab.c"
    break;

  case 124: /* alter_statement: ALTER USER ident passwd_schema  */
#line 1077 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-1].sval));
	  append_list(l, (yyvsp[0].l));
	  (yyval.sym) = _symbol_create_list( SQL_ALTER_USER, l ); }
#line 8030 "y.tab.c"
    break;

  case 125: /* alter_statement: ALTER USER ident RENAME TO ident  */
#line 1082 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-3].sval));
	  append_string(l, (yyvsp[0].sval));
	  (yyval.sym) = _symbol_create_list( SQL_RENAME_USER, l ); }
#line 8039 "y.tab.c"
    break;

  case 126: /* alter_statement: ALTER USER SET opt_encrypted PASSWORD string USING OLD PASSWORD string  */
#line 1087 "sql_parser.y"
        { dlist *l = L();
	  dlist *p = L();
	  append_string(l, NULL);
	  append_string(p, (yyvsp[-4].sval));
	  append_string(p, NULL);
	  append_int(p, (yyvsp[-6].i_val));
	  append_string(p, (yyvsp[0].sval));
	  append_list(l, p);
	  (yyval.sym) = _symbol_create_list( SQL_ALTER_USER, l ); }
#line 8053 "y.tab.c"
    break;

  case 127: /* passwd_schema: WITH opt_encrypted PASSWORD string  */
#line 1099 "sql_parser.y"
                                                { dlist * l = L();
				  append_string(l, (yyvsp[0].sval));
				  append_string(l, NULL);
				  append_int(l, (yyvsp[-2].i_val));
				  append_string(l, NULL);
				  (yyval.l) = l; }
#line 8064 "y.tab.c"
    break;

  case 128: /* passwd_schema: SET SCHEMA ident  */
#line 1105 "sql_parser.y"
                                { dlist * l = L();
				  append_string(l, NULL);
				  append_string(l, (yyvsp[0].sval));
				  append_int(l, 0);
				  append_string(l, NULL);
				  (yyval.l) = l; }
#line 8075 "y.tab.c"
    break;

  case 129: /* passwd_schema: WITH opt_encrypted PASSWORD string SET SCHEMA ident  */
#line 1112 "sql_parser.y"
                                { dlist * l = L();
				  append_string(l, (yyvsp[-3].sval));
				  append_string(l, (yyvsp[0].sval));
				  append_int(l, (yyvsp[-5].i_val));
				  append_string(l, NULL);
				  (yyval.l) = l; }
#line 8086 "y.tab.c"
    break;

  case 130: /* alter_table_element: opt_column ident SET DEFAULT default_value  */
#line 1122 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-3].sval));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_DEFAULT, l); }
#line 8095 "y.tab.c"
    break;

  case 131: /* alter_table_element: opt_column ident SET sqlNULL  */
#line 1127 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-2].sval));
	  (yyval.sym) = _symbol_create_list( SQL_NULL, l); }
#line 8103 "y.tab.c"
    break;

  case 132: /* alter_table_element: opt_column ident SET NOT sqlNULL  */
#line 1131 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-3].sval));
	  (yyval.sym) = _symbol_create_list( SQL_NOT_NULL, l); }
#line 8111 "y.tab.c"
    break;

  case 133: /* alter_table_element: opt_column ident DROP DEFAULT  */
#line 1135 "sql_parser.y"
        { (yyval.sym) = _symbol_create( SQL_DROP_DEFAULT, (yyvsp[-2].sval)); }
#line 8117 "y.tab.c"
    break;

  case 134: /* alter_table_element: opt_column ident SET STORAGE STRING  */
#line 1137 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-3].sval));
	  if (!strlen((yyvsp[0].sval)))
	  	append_string(l, NULL);
	  else
	  	append_string(l, (yyvsp[0].sval));
	  (yyval.sym) = _symbol_create_list( SQL_STORAGE, l); }
#line 8129 "y.tab.c"
    break;

  case 135: /* alter_table_element: opt_column ident SET STORAGE sqlNULL  */
#line 1145 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-3].sval));
	  append_string(l, NULL);
	  (yyval.sym) = _symbol_create_list( SQL_STORAGE, l); }
#line 8138 "y.tab.c"
    break;

  case 136: /* drop_table_element: opt_column ident drop_action  */
#line 1153 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-1].sval) );
	  append_int(l, (yyvsp[0].i_val) );
	  (yyval.sym) = _symbol_create_list( SQL_DROP_COLUMN, l ); }
#line 8147 "y.tab.c"
    break;

  case 137: /* drop_table_element: CONSTRAINT ident drop_action  */
#line 1158 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-1].sval) );
	  append_int(l, (yyvsp[0].i_val) );
	  (yyval.sym) = _symbol_create_list( SQL_DROP_CONSTRAINT, l ); }
#line 8156 "y.tab.c"
    break;

  case 138: /* drop_table_element: TABLE ident drop_action  */
#line 1163 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-1].sval) );
	  append_int(l, (yyvsp[0].i_val) );
	  append_int(l, 0);
	  (yyval.sym) = _symbol_create_list( SQL_DROP_TABLE, l ); }
#line 8166 "y.tab.c"
    break;

  case 139: /* opt_column: COLUMN  */
#line 1171 "sql_parser.y"
                 { (yyval.i_val) = 0; }
#line 8172 "y.tab.c"
    break;

  case 140: /* opt_column: %empty  */
#line 1172 "sql_parser.y"
                 { (yyval.i_val) = 0; }
#line 8178 "y.tab.c"
    break;

  case 141: /* create_statement: create role_def  */
#line 1176 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 8184 "y.tab.c"
    break;

  case 142: /* create_statement: create table_def  */
#line 1177 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 8190 "y.tab.c"
    break;

  case 143: /* create_statement: create view_def  */
#line 1178 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 8196 "y.tab.c"
    break;

  case 149: /* seq_def: create SEQUENCE qname opt_seq_params  */
#line 1200 "sql_parser.y"
        {
		dlist *l = L();
		append_list(l, (yyvsp[-1].l));
		append_list(l, (yyvsp[0].l));
		append_int(l, 0); /* to be dropped */
		(yyval.sym) = _symbol_create_list(SQL_CREATE_SEQ, l);
	}
#line 8208 "y.tab.c"
    break;

  case 150: /* seq_def: drop SEQUENCE qname  */
#line 1211 "sql_parser.y"
        {
		dlist *l = L();
		append_list(l, (yyvsp[0].l));
		(yyval.sym) = _symbol_create_list(SQL_DROP_SEQ, l);
	}
#line 8218 "y.tab.c"
    break;

  case 151: /* seq_def: ALTER SEQUENCE qname opt_alt_seq_params  */
#line 1228 "sql_parser.y"
        {
		dlist *l = L();
		append_list(l, (yyvsp[-1].l));
		append_list(l, (yyvsp[0].l)); 
		(yyval.sym) = _symbol_create_list(SQL_ALTER_SEQ, l);
	}
#line 8229 "y.tab.c"
    break;

  case 152: /* opt_seq_params: opt_seq_param  */
#line 1237 "sql_parser.y"
                                                { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 8235 "y.tab.c"
    break;

  case 153: /* opt_seq_params: opt_seq_params opt_seq_param  */
#line 1238 "sql_parser.y"
                                                { (yyval.l) = append_symbol((yyvsp[-1].l), (yyvsp[0].sym)); }
#line 8241 "y.tab.c"
    break;

  case 154: /* opt_alt_seq_params: opt_alt_seq_param  */
#line 1242 "sql_parser.y"
                                                { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 8247 "y.tab.c"
    break;

  case 155: /* opt_alt_seq_params: opt_alt_seq_params opt_alt_seq_param  */
#line 1243 "sql_parser.y"
                                                { (yyval.l) = append_symbol((yyvsp[-1].l), (yyvsp[0].sym)); }
#line 8253 "y.tab.c"
    break;

  case 156: /* opt_seq_param: AS data_type  */
#line 1247 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_list(SQL_TYPE, append_type(L(),&(yyvsp[0].type))); }
#line 8259 "y.tab.c"
    break;

  case 157: /* opt_seq_param: START WITH poslng  */
#line 1248 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_lng(SQL_START, (yyvsp[0].l_val)); }
#line 8265 "y.tab.c"
    break;

  case 158: /* opt_seq_param: opt_seq_common_param  */
#line 1249 "sql_parser.y"
                                        { (yyval.sym) = (yyvsp[0].sym); }
#line 8271 "y.tab.c"
    break;

  case 159: /* opt_alt_seq_param: AS data_type  */
#line 1253 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_list(SQL_TYPE, append_type(L(),&(yyvsp[0].type))); }
#line 8277 "y.tab.c"
    break;

  case 160: /* opt_alt_seq_param: RESTART  */
#line 1254 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_list(SQL_START, append_int(L(),0)); /* plain restart now */ }
#line 8283 "y.tab.c"
    break;

  case 161: /* opt_alt_seq_param: RESTART WITH poslng  */
#line 1255 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_list(SQL_START, append_lng(append_int(L(),2), (yyvsp[0].l_val)));  }
#line 8289 "y.tab.c"
    break;

  case 162: /* opt_alt_seq_param: RESTART WITH subquery  */
#line 1256 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_list(SQL_START, append_symbol(append_int(L(),1), (yyvsp[0].sym)));  }
#line 8295 "y.tab.c"
    break;

  case 163: /* opt_alt_seq_param: opt_seq_common_param  */
#line 1257 "sql_parser.y"
                                        { (yyval.sym) = (yyvsp[0].sym); }
#line 8301 "y.tab.c"
    break;

  case 164: /* opt_seq_common_param: INCREMENT BY nonzerolng  */
#line 1261 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_lng(SQL_INC, (yyvsp[0].l_val)); }
#line 8307 "y.tab.c"
    break;

  case 165: /* opt_seq_common_param: MINVALUE nonzerolng  */
#line 1262 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_lng(SQL_MINVALUE, (yyvsp[0].l_val)); }
#line 8313 "y.tab.c"
    break;

  case 166: /* opt_seq_common_param: NOMINVALUE  */
#line 1263 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_lng(SQL_MINVALUE, 0); }
#line 8319 "y.tab.c"
    break;

  case 167: /* opt_seq_common_param: MAXVALUE nonzerolng  */
#line 1264 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_lng(SQL_MAXVALUE, (yyvsp[0].l_val)); }
#line 8325 "y.tab.c"
    break;

  case 168: /* opt_seq_common_param: NOMAXVALUE  */
#line 1265 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_lng(SQL_MAXVALUE, 0); }
#line 8331 "y.tab.c"
    break;

  case 169: /* opt_seq_common_param: CACHE nonzerolng  */
#line 1266 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_lng(SQL_CACHE, (yyvsp[0].l_val)); }
#line 8337 "y.tab.c"
    break;

  case 170: /* opt_seq_common_param: CYCLE  */
#line 1267 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_int(SQL_CYCLE, 1); }
#line 8343 "y.tab.c"
    break;

  case 171: /* opt_seq_common_param: NOCYCLE  */
#line 1268 "sql_parser.y"
                                        { (yyval.sym) = _symbol_create_int(SQL_CYCLE, 0); }
#line 8349 "y.tab.c"
    break;

  case 172: /* index_def: create opt_index_type INDEX ident ON qname '(' ident_commalist ')'  */
#line 1276 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-5].sval));
	  append_int(l, (yyvsp[-7].i_val));
	  append_list(l, (yyvsp[-3].l));
	  append_list(l, (yyvsp[-1].l));
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_INDEX, l); }
#line 8360 "y.tab.c"
    break;

  case 173: /* opt_index_type: UNIQUE  */
#line 1285 "sql_parser.y"
                        { (yyval.i_val) = hash_idx; }
#line 8366 "y.tab.c"
    break;

  case 174: /* opt_index_type: ORDERED  */
#line 1286 "sql_parser.y"
                        { (yyval.i_val) = ordered_idx; }
#line 8372 "y.tab.c"
    break;

  case 175: /* opt_index_type: IMPRINTS  */
#line 1287 "sql_parser.y"
                        { (yyval.i_val) = imprints_idx; }
#line 8378 "y.tab.c"
    break;

  case 176: /* opt_index_type: %empty  */
#line 1288 "sql_parser.y"
                        { (yyval.i_val) = hash_idx; }
#line 8384 "y.tab.c"
    break;

  case 177: /* role_def: ROLE ident opt_grantor  */
#line 1309 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-1].sval));
	  append_int(l, (yyvsp[0].i_val));
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_ROLE, l ); }
#line 8393 "y.tab.c"
    break;

  case 178: /* role_def: USER ident WITH opt_encrypted PASSWORD string sqlNAME string SCHEMA ident  */
#line 1314 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-8].sval));
	  append_string(l, (yyvsp[-4].sval));
	  append_string(l, (yyvsp[-2].sval));
	  append_string(l, (yyvsp[0].sval));
	  append_int(l, (yyvsp[-6].i_val));
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_USER, l ); }
#line 8405 "y.tab.c"
    break;

  case 179: /* opt_encrypted: %empty  */
#line 1324 "sql_parser.y"
                        { (yyval.i_val) = SQL_PW_UNENCRYPTED; }
#line 8411 "y.tab.c"
    break;

  case 180: /* opt_encrypted: UNENCRYPTED  */
#line 1325 "sql_parser.y"
                        { (yyval.i_val) = SQL_PW_UNENCRYPTED; }
#line 8417 "y.tab.c"
    break;

  case 181: /* opt_encrypted: ENCRYPTED  */
#line 1326 "sql_parser.y"
                        { (yyval.i_val) = SQL_PW_ENCRYPTED; }
#line 8423 "y.tab.c"
    break;

  case 182: /* table_opt_storage: %empty  */
#line 1330 "sql_parser.y"
                         { (yyval.l) = NULL; }
#line 8429 "y.tab.c"
    break;

  case 183: /* table_opt_storage: STORAGE ident STRING  */
#line 1331 "sql_parser.y"
                         { (yyval.l) = append_string(append_string(L(), (yyvsp[-1].sval)), (yyvsp[0].sval)); }
#line 8435 "y.tab.c"
    break;

  case 184: /* table_def: TABLE if_not_exists qname table_content_source table_opt_storage  */
#line 1336 "sql_parser.y"
        { int commit_action = CA_COMMIT;
	  dlist *l = L();

	  append_int(l, SQL_PERSIST);
	  append_list(l, (yyvsp[-2].l));
	  append_symbol(l, (yyvsp[-1].sym));
	  append_int(l, commit_action);
	  append_string(l, NULL);
	  append_int(l, (yyvsp[-3].bval));
	  append_list(l, (yyvsp[0].l));
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_TABLE, l ); }
#line 8451 "y.tab.c"
    break;

  case 185: /* table_def: TABLE if_not_exists qname FROM sqlLOADER func_ref  */
#line 1348 "sql_parser.y"
    {
      dlist *l = L();
      append_list(l, (yyvsp[-3].l));
      append_symbol(l, (yyvsp[0].sym));
      (yyval.sym) = _symbol_create_list( SQL_CREATE_TABLE_LOADER, l);
    }
#line 8462 "y.tab.c"
    break;

  case 186: /* table_def: STREAM TABLE if_not_exists qname table_content_source  */
#line 1355 "sql_parser.y"
        { int commit_action = CA_COMMIT, tpe = SQL_STREAM;
	  dlist *l = L();

	  append_int(l, tpe);
	  append_list(l, (yyvsp[-1].l));
	  append_symbol(l, (yyvsp[0].sym));
	  append_int(l, commit_action);
	  append_string(l, NULL);
	  append_int(l, (yyvsp[-2].bval));
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_TABLE, l ); }
#line 8477 "y.tab.c"
    break;

  case 187: /* table_def: MERGE TABLE if_not_exists qname table_content_source  */
#line 1366 "sql_parser.y"
        { int commit_action = CA_COMMIT, tpe = SQL_MERGE_TABLE;
	  dlist *l = L();

	  append_int(l, tpe);
	  append_list(l, (yyvsp[-1].l));
	  append_symbol(l, (yyvsp[0].sym));
	  append_int(l, commit_action);
	  append_string(l, NULL);
	  append_int(l, (yyvsp[-2].bval));
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_TABLE, l ); }
#line 8492 "y.tab.c"
    break;

  case 188: /* table_def: REPLICA TABLE if_not_exists qname table_content_source  */
#line 1377 "sql_parser.y"
        { int commit_action = CA_COMMIT, tpe = SQL_REPLICA_TABLE;
	  dlist *l = L();

	  append_int(l, tpe);
	  append_list(l, (yyvsp[-1].l));
	  append_symbol(l, (yyvsp[0].sym));
	  append_int(l, commit_action);
	  append_string(l, NULL);
	  append_int(l, (yyvsp[-2].bval));
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_TABLE, l ); }
#line 8507 "y.tab.c"
    break;

  case 189: /* table_def: REMOTE TABLE if_not_exists qname table_content_source ON STRING  */
#line 1391 "sql_parser.y"
        { int commit_action = CA_COMMIT, tpe = SQL_REMOTE;
	  dlist *l = L();

	  append_int(l, tpe);
	  append_list(l, (yyvsp[-3].l));
	  append_symbol(l, (yyvsp[-2].sym));
	  append_int(l, commit_action);
	  append_string(l, (yyvsp[0].sval));
	  append_int(l, (yyvsp[-4].bval));
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_TABLE, l ); }
#line 8522 "y.tab.c"
    break;

  case 190: /* table_def: opt_temp TABLE if_not_exists qname table_content_source opt_on_commit  */
#line 1402 "sql_parser.y"
        { int commit_action = CA_COMMIT;
	  dlist *l = L();

	  append_int(l, (yyvsp[-5].i_val));
	  append_list(l, (yyvsp[-2].l));
	  append_symbol(l, (yyvsp[-1].sym));
	  if ((yyvsp[-5].i_val) != SQL_PERSIST)
		commit_action = (yyvsp[0].i_val);
	  append_int(l, commit_action);
	  append_string(l, NULL);
	  append_int(l, (yyvsp[-3].bval));
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_TABLE, l ); }
#line 8539 "y.tab.c"
    break;

  case 191: /* opt_temp: TEMPORARY  */
#line 1417 "sql_parser.y"
                        { (yyval.i_val) = SQL_LOCAL_TEMP; }
#line 8545 "y.tab.c"
    break;

  case 192: /* opt_temp: TEMP  */
#line 1418 "sql_parser.y"
                        { (yyval.i_val) = SQL_LOCAL_TEMP; }
#line 8551 "y.tab.c"
    break;

  case 193: /* opt_temp: LOCAL TEMPORARY  */
#line 1419 "sql_parser.y"
                        { (yyval.i_val) = SQL_LOCAL_TEMP; }
#line 8557 "y.tab.c"
    break;

  case 194: /* opt_temp: LOCAL TEMP  */
#line 1420 "sql_parser.y"
                        { (yyval.i_val) = SQL_LOCAL_TEMP; }
#line 8563 "y.tab.c"
    break;

  case 195: /* opt_temp: GLOBAL TEMPORARY  */
#line 1421 "sql_parser.y"
                        { (yyval.i_val) = SQL_GLOBAL_TEMP; }
#line 8569 "y.tab.c"
    break;

  case 196: /* opt_temp: GLOBAL TEMP  */
#line 1422 "sql_parser.y"
                        { (yyval.i_val) = SQL_GLOBAL_TEMP; }
#line 8575 "y.tab.c"
    break;

  case 197: /* opt_on_commit: %empty  */
#line 1426 "sql_parser.y"
                                 { (yyval.i_val) = CA_COMMIT; }
#line 8581 "y.tab.c"
    break;

  case 198: /* opt_on_commit: ON COMMIT sqlDELETE ROWS  */
#line 1427 "sql_parser.y"
                                 { (yyval.i_val) = CA_DELETE; }
#line 8587 "y.tab.c"
    break;

  case 199: /* opt_on_commit: ON COMMIT PRESERVE ROWS  */
#line 1428 "sql_parser.y"
                                 { (yyval.i_val) = CA_PRESERVE; }
#line 8593 "y.tab.c"
    break;

  case 200: /* opt_on_commit: ON COMMIT DROP  */
#line 1429 "sql_parser.y"
                                 { (yyval.i_val) = CA_DROP; }
#line 8599 "y.tab.c"
    break;

  case 201: /* table_content_source: '(' table_element_list ')'  */
#line 1433 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list( SQL_CREATE_TABLE, (yyvsp[-1].l)); }
#line 8605 "y.tab.c"
    break;

  case 202: /* table_content_source: as_subquery_clause  */
#line 1434 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list( SQL_SELECT, (yyvsp[0].l)); }
#line 8611 "y.tab.c"
    break;

  case 203: /* as_subquery_clause: opt_column_list AS query_expression_def with_or_without_data  */
#line 1442 "sql_parser.y"
                        { (yyval.l) = append_list(L(), (yyvsp[-3].l));
			  append_symbol((yyval.l), (yyvsp[-1].sym)); 
			  append_int((yyval.l), (yyvsp[0].i_val)); }
#line 8619 "y.tab.c"
    break;

  case 204: /* with_or_without_data: %empty  */
#line 1448 "sql_parser.y"
                        { (yyval.i_val) = 1; }
#line 8625 "y.tab.c"
    break;

  case 205: /* with_or_without_data: WITH NO DATA  */
#line 1449 "sql_parser.y"
                        { (yyval.i_val) = 0; }
#line 8631 "y.tab.c"
    break;

  case 206: /* with_or_without_data: WITH DATA  */
#line 1450 "sql_parser.y"
                        { (yyval.i_val) = 1; }
#line 8637 "y.tab.c"
    break;

  case 207: /* table_element_list: table_element  */
#line 1455 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 8643 "y.tab.c"
    break;

  case 208: /* table_element_list: table_element_list ',' table_element  */
#line 1457 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-2].l), (yyvsp[0].sym) ); }
#line 8649 "y.tab.c"
    break;

  case 214: /* serial_or_bigserial: SERIAL  */
#line 1464 "sql_parser.y"
                     { (yyval.i_val) = 0; }
#line 8655 "y.tab.c"
    break;

  case 215: /* serial_or_bigserial: BIGSERIAL  */
#line 1465 "sql_parser.y"
                     { (yyval.i_val) = 1; }
#line 8661 "y.tab.c"
    break;

  case 216: /* column_def: column data_type opt_column_def_opt_list  */
#line 1470 "sql_parser.y"
                {
			dlist *l = L();
			append_string(l, (yyvsp[-2].sval));
			append_type(l, &(yyvsp[-1].type));
			append_list(l, (yyvsp[0].l));
			(yyval.sym) = _symbol_create_list(SQL_COLUMN, l);
		}
#line 8673 "y.tab.c"
    break;

  case 217: /* column_def: column serial_or_bigserial  */
#line 1478 "sql_parser.y"
                { /* SERIAL = INTEGER GENERATED ALWAYS AS IDENTITY PRIMARY KEY */
			/* handle multi-statements by wrapping them in a list */
			sql_subtype it;
			dlist* stmts;
			/* note: sql_next_seq_name uses sa_alloc */
			str sn = sql_next_seq_name(m);
			dlist *p; /* primary key */
			/* sequence generation code */
			dlist *l = L();
			/* finally all the options */
			dlist *o = L();

			/* the name of the sequence */
			dlist *seqn1 = L(), *seqn2 = L();

			if (m->scanner.schema)
				append_string(seqn1, m->scanner.schema);
			append_list(l, append_string(seqn1, sn));
			if ((yyvsp[0].i_val) == 1)
				sql_find_subtype(&it, "bigint", 64, 0);
			else
				sql_find_subtype(&it, "int", 32, 0);
    			append_symbol(o, _symbol_create_list(SQL_TYPE, append_type(L(),&it)));
			append_list(l, o);
			append_int(l, 1); /* to be dropped */

			if (m->sym) {
				stmts = m->sym->data.lval;
			} else {
				stmts = L();
				m->sym = _symbol_create_list(SQL_MULSTMT, stmts);
			}	
			append_symbol(stmts, _symbol_create_list(SQL_CREATE_SEQ, l));

			l = L();
			append_string(l, (yyvsp[-1].sval));
			append_type(l, &it);
			o = L();
			if (m->scanner.schema)
				append_string(seqn2, m->scanner.schema);
			append_string(seqn2, sn);
			append_symbol(o, _symbol_create_symbol(SQL_DEFAULT, _symbol_create_list(SQL_NEXT, seqn2)));
			p = L();
			append_string(p, NULL);
			append_symbol(p, _symbol_create(SQL_PRIMARY_KEY, NULL));
			append_symbol(o, _symbol_create_list(SQL_CONSTRAINT, p));
			append_list(l, o);
			(yyval.sym) = _symbol_create_list(SQL_COLUMN, l);
		}
#line 8727 "y.tab.c"
    break;

  case 218: /* opt_column_def_opt_list: %empty  */
#line 1530 "sql_parser.y"
                                { (yyval.l) = NULL; }
#line 8733 "y.tab.c"
    break;

  case 220: /* column_def_opt_list: column_option  */
#line 1536 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym) ); }
#line 8739 "y.tab.c"
    break;

  case 221: /* column_def_opt_list: column_def_opt_list column_option  */
#line 1538 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-1].l), (yyvsp[0].sym) ); }
#line 8745 "y.tab.c"
    break;

  case 222: /* column_options: ident WITH OPTIONS '(' column_option_list ')'  */
#line 1544 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-5].sval) );
	  append_list(l, (yyvsp[-1].l) );
	  (yyval.sym) = _symbol_create_list( SQL_COLUMN_OPTIONS, l ); }
#line 8754 "y.tab.c"
    break;

  case 223: /* column_option_list: column_option  */
#line 1552 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym) ); }
#line 8760 "y.tab.c"
    break;

  case 224: /* column_option_list: column_option_list ',' column_option  */
#line 1554 "sql_parser.y"
                        { (yyval.l) = append_symbol((yyvsp[-2].l), (yyvsp[0].sym) ); }
#line 8766 "y.tab.c"
    break;

  case 228: /* default: DEFAULT default_value  */
#line 1560 "sql_parser.y"
                          { (yyval.sym) = _symbol_create_symbol(SQL_DEFAULT, (yyvsp[0].sym)); }
#line 8772 "y.tab.c"
    break;

  case 229: /* default_value: simple_scalar_exp  */
#line 1564 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 8778 "y.tab.c"
    break;

  case 230: /* column_constraint: opt_constraint_name column_constraint_type  */
#line 1570 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-1].sval) );
	  append_symbol(l, (yyvsp[0].sym) );
	  (yyval.sym) = _symbol_create_list( SQL_CONSTRAINT, l ); }
#line 8787 "y.tab.c"
    break;

  case 231: /* generated_column: GENERATED ALWAYS AS IDENTITY serial_opt_params  */
#line 1578 "sql_parser.y"
        {
		/* handle multi-statements by wrapping them in a list */
		sql_subtype it;
		dlist* stmts;
		/* note: sql_next_seq_name uses sa_alloc */
		str sn = sql_next_seq_name(m);
		/* sequence generation code */
		dlist *l = L();
		/* the name of the sequence */
		append_list(l, append_string(L(), sn));
		if (!(yyvsp[0].l))
			(yyvsp[0].l) = L();
		sql_find_subtype(&it, "int", 32, 0);
    		append_symbol((yyvsp[0].l), _symbol_create_list(SQL_TYPE, append_type(L(),&it)));

		/* finally all the options */
		append_list(l, (yyvsp[0].l));
		append_int(l, 0); /* to be dropped */
		(yyval.sym) = _symbol_create_symbol(SQL_DEFAULT, _symbol_create_list(SQL_NEXT, append_string(L(), sn)));

		if (m->sym) {
			stmts = m->sym->data.lval;
		} else {
			stmts = L();
			m->sym = _symbol_create_list(SQL_MULSTMT, stmts);
		}	
		append_symbol(stmts, _symbol_create_list(SQL_CREATE_SEQ, l));
	}
#line 8820 "y.tab.c"
    break;

  case 232: /* generated_column: AUTO_INCREMENT  */
#line 1607 "sql_parser.y"
        {
		/* handle multi-statements by wrapping them in a list */
		sql_subtype it;
		dlist* stmts;
		/* note: sql_next_seq_name uses sa_alloc */
		str sn = sql_next_seq_name(m);
		/* sequence generation code */
		dlist *l = L();
		/* finally all the options */
		dlist *o = L();

		/* the name of the sequence */
		dlist *seqn1 = L(), *seqn2 = L();

		if (m->scanner.schema)
			append_string(seqn1, m->scanner.schema);
		append_list(l, append_string(seqn1, sn));
		sql_find_subtype(&it, "int", 32, 0);
    		append_symbol(o, _symbol_create_list(SQL_TYPE, append_type(L(),&it)));
		append_list(l, o);
		append_int(l, 0); /* to be dropped */
		if (m->scanner.schema)
			append_string(seqn2, m->scanner.schema);
		append_string(seqn2, sn);
		(yyval.sym) = _symbol_create_symbol(SQL_DEFAULT, _symbol_create_list(SQL_NEXT, seqn2));

		if (m->sym) {
			stmts = m->sym->data.lval;
		} else {
			stmts = L();
			m->sym = _symbol_create_list(SQL_MULSTMT, stmts);
		}	
		append_symbol(stmts, _symbol_create_list(SQL_CREATE_SEQ, l));
	}
#line 8859 "y.tab.c"
    break;

  case 233: /* serial_opt_params: %empty  */
#line 1644 "sql_parser.y"
                                                { (yyval.l) = NULL; }
#line 8865 "y.tab.c"
    break;

  case 234: /* serial_opt_params: '(' opt_seq_params ')'  */
#line 1645 "sql_parser.y"
                                                { (yyval.l) = (yyvsp[-1].l); }
#line 8871 "y.tab.c"
    break;

  case 235: /* table_constraint: opt_constraint_name table_constraint_type  */
#line 1652 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-1].sval) );
	  append_symbol(l, (yyvsp[0].sym) );
	  (yyval.sym) = _symbol_create_list( SQL_CONSTRAINT, l ); }
#line 8880 "y.tab.c"
    break;

  case 236: /* opt_constraint_name: %empty  */
#line 1661 "sql_parser.y"
                                { (yyval.sval) = NULL; }
#line 8886 "y.tab.c"
    break;

  case 237: /* opt_constraint_name: CONSTRAINT ident  */
#line 1662 "sql_parser.y"
                                { (yyval.sval) = (yyvsp[0].sval); }
#line 8892 "y.tab.c"
    break;

  case 238: /* ref_action: NO ACTION  */
#line 1666 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 8898 "y.tab.c"
    break;

  case 239: /* ref_action: CASCADE  */
#line 1667 "sql_parser.y"
                                { (yyval.i_val) = 1; }
#line 8904 "y.tab.c"
    break;

  case 240: /* ref_action: RESTRICT  */
#line 1668 "sql_parser.y"
                                { (yyval.i_val) = 2; }
#line 8910 "y.tab.c"
    break;

  case 241: /* ref_action: SET sqlNULL  */
#line 1669 "sql_parser.y"
                                { (yyval.i_val) = 3; }
#line 8916 "y.tab.c"
    break;

  case 242: /* ref_action: SET DEFAULT  */
#line 1670 "sql_parser.y"
                                { (yyval.i_val) = 4; }
#line 8922 "y.tab.c"
    break;

  case 243: /* ref_on_update: ON UPDATE ref_action  */
#line 1674 "sql_parser.y"
                                { (yyval.i_val) = ((yyvsp[0].i_val) << 8); }
#line 8928 "y.tab.c"
    break;

  case 244: /* ref_on_delete: ON sqlDELETE ref_action  */
#line 1678 "sql_parser.y"
                                { (yyval.i_val) = (yyvsp[0].i_val); }
#line 8934 "y.tab.c"
    break;

  case 245: /* opt_ref_action: %empty  */
#line 1682 "sql_parser.y"
                                        { (yyval.i_val) = (2 << 8) + 2; /* defaults are RESTRICT */ }
#line 8940 "y.tab.c"
    break;

  case 246: /* opt_ref_action: ref_on_update  */
#line 1683 "sql_parser.y"
                                        { (yyval.i_val) = (yyvsp[0].i_val); }
#line 8946 "y.tab.c"
    break;

  case 247: /* opt_ref_action: ref_on_delete  */
#line 1684 "sql_parser.y"
                                        { (yyval.i_val) = (yyvsp[0].i_val); }
#line 8952 "y.tab.c"
    break;

  case 248: /* opt_ref_action: ref_on_delete ref_on_update  */
#line 1685 "sql_parser.y"
                                        { (yyval.i_val) = (yyvsp[-1].i_val) + (yyvsp[0].i_val); }
#line 8958 "y.tab.c"
    break;

  case 249: /* opt_ref_action: ref_on_update ref_on_delete  */
#line 1686 "sql_parser.y"
                                        { (yyval.i_val) = (yyvsp[-1].i_val) + (yyvsp[0].i_val); }
#line 8964 "y.tab.c"
    break;

  case 250: /* opt_match_type: %empty  */
#line 1690 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 8970 "y.tab.c"
    break;

  case 251: /* opt_match_type: FULL  */
#line 1691 "sql_parser.y"
                                { (yyval.i_val) = 1; }
#line 8976 "y.tab.c"
    break;

  case 252: /* opt_match_type: PARTIAL  */
#line 1692 "sql_parser.y"
                                { (yyval.i_val) = 2; }
#line 8982 "y.tab.c"
    break;

  case 253: /* opt_match_type: SIMPLE  */
#line 1693 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 8988 "y.tab.c"
    break;

  case 254: /* opt_match: %empty  */
#line 1697 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 8994 "y.tab.c"
    break;

  case 255: /* opt_match: MATCH opt_match_type  */
#line 1698 "sql_parser.y"
                                { (yyval.i_val) = (yyvsp[0].i_val); }
#line 9000 "y.tab.c"
    break;

  case 256: /* column_constraint_type: NOT sqlNULL  */
#line 1702 "sql_parser.y"
                { (yyval.sym) = _symbol_create( SQL_NOT_NULL, NULL); }
#line 9006 "y.tab.c"
    break;

  case 257: /* column_constraint_type: sqlNULL  */
#line 1703 "sql_parser.y"
                { (yyval.sym) = _symbol_create( SQL_NULL, NULL); }
#line 9012 "y.tab.c"
    break;

  case 258: /* column_constraint_type: UNIQUE  */
#line 1704 "sql_parser.y"
                { (yyval.sym) = _symbol_create( SQL_UNIQUE, NULL ); }
#line 9018 "y.tab.c"
    break;

  case 259: /* column_constraint_type: PRIMARY KEY  */
#line 1705 "sql_parser.y"
                { (yyval.sym) = _symbol_create( SQL_PRIMARY_KEY, NULL ); }
#line 9024 "y.tab.c"
    break;

  case 260: /* column_constraint_type: REFERENCES qname opt_column_list opt_match opt_ref_action  */
#line 1708 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, (yyvsp[-3].l) );
			  append_list(l, (yyvsp[-2].l) );
			  append_int(l, (yyvsp[-1].i_val) );
			  append_int(l, (yyvsp[0].i_val) );
			  (yyval.sym) = _symbol_create_list( SQL_FOREIGN_KEY, l); }
#line 9035 "y.tab.c"
    break;

  case 262: /* table_constraint_type: UNIQUE column_commalist_parens  */
#line 1721 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_UNIQUE, (yyvsp[0].l)); }
#line 9041 "y.tab.c"
    break;

  case 263: /* table_constraint_type: PRIMARY KEY column_commalist_parens  */
#line 1723 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_PRIMARY_KEY, (yyvsp[0].l)); }
#line 9047 "y.tab.c"
    break;

  case 264: /* table_constraint_type: FOREIGN KEY column_commalist_parens REFERENCES qname opt_column_list opt_match opt_ref_action  */
#line 1727 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, (yyvsp[-3].l) );
			  append_list(l, (yyvsp[-5].l) );
			  append_list(l, (yyvsp[-2].l) );
			  append_int(l, (yyvsp[-1].i_val) );
			  append_int(l, (yyvsp[0].i_val) );
			  (yyval.sym) = _symbol_create_list( SQL_FOREIGN_KEY, l); }
#line 9059 "y.tab.c"
    break;

  case 265: /* domain_constraint_type: CHECK '(' search_condition ')'  */
#line 1739 "sql_parser.y"
                                   { (yyval.sym) = NULL; }
#line 9065 "y.tab.c"
    break;

  case 266: /* ident_commalist: ident  */
#line 1744 "sql_parser.y"
                        { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 9071 "y.tab.c"
    break;

  case 267: /* ident_commalist: ident_commalist ',' ident  */
#line 1746 "sql_parser.y"
                        { (yyval.l) = append_string( (yyvsp[-2].l), (yyvsp[0].sval) ); }
#line 9077 "y.tab.c"
    break;

  case 268: /* like_table: LIKE qname  */
#line 1750 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_LIKE, (yyvsp[0].l) ); }
#line 9083 "y.tab.c"
    break;

  case 269: /* view_def: VIEW qname opt_column_list AS query_expression_def opt_with_check_option  */
#line 1755 "sql_parser.y"
        {  dlist *l = L();
	  append_list(l, (yyvsp[-4].l));
	  append_list(l, (yyvsp[-3].l));
	  append_symbol(l, (yyvsp[-1].sym));
	  append_int(l, (yyvsp[0].bval));
	  append_int(l, TRUE);	/* persistent view */
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_VIEW, l ); 
	}
#line 9096 "y.tab.c"
    break;

  case 271: /* query_expression_def: '(' query_expression_def ')'  */
#line 1767 "sql_parser.y"
                                        { (yyval.sym) = (yyvsp[-1].sym); }
#line 9102 "y.tab.c"
    break;

  case 274: /* opt_with_check_option: %empty  */
#line 1776 "sql_parser.y"
                                { (yyval.bval) = FALSE; }
#line 9108 "y.tab.c"
    break;

  case 275: /* opt_with_check_option: WITH CHECK OPTION  */
#line 1777 "sql_parser.y"
                                { (yyval.bval) = TRUE; }
#line 9114 "y.tab.c"
    break;

  case 276: /* opt_column_list: %empty  */
#line 1781 "sql_parser.y"
                                { (yyval.l) = NULL; }
#line 9120 "y.tab.c"
    break;

  case 278: /* column_commalist_parens: '(' ident_commalist ')'  */
#line 1786 "sql_parser.y"
                                { (yyval.l) = (yyvsp[-1].l); }
#line 9126 "y.tab.c"
    break;

  case 279: /* type_def: create TYPE qname EXTERNAL sqlNAME ident  */
#line 1791 "sql_parser.y"
                        { dlist *l = L();
				append_list(l, (yyvsp[-3].l));
				append_string(l, (yyvsp[0].sval));
			  (yyval.sym) = _symbol_create_list( SQL_CREATE_TYPE, l ); }
#line 9135 "y.tab.c"
    break;

  case 280: /* external_function_name: ident '.' ident  */
#line 1798 "sql_parser.y"
                        { (yyval.l) = append_string(append_string(L(), (yyvsp[-2].sval)), (yyvsp[0].sval)); }
#line 9141 "y.tab.c"
    break;

  case 283: /* func_def: create_or_replace FUNCTION qname '(' opt_paramlist ')' RETURNS func_data_type EXTERNAL sqlNAME external_function_name  */
#line 1813 "sql_parser.y"
                        { dlist *f = L();
				append_list(f, (yyvsp[-8].l));
				append_list(f, (yyvsp[-6].l));
				append_symbol(f, (yyvsp[-3].sym));
				append_list(f, (yyvsp[0].l));
				append_list(f, NULL);
				append_int(f, F_FUNC);
				append_int(f, FUNC_LANG_MAL);
				append_int(f, (yyvsp[-10].bval));
			  (yyval.sym) = _symbol_create_list( SQL_CREATE_FUNC, f ); }
#line 9156 "y.tab.c"
    break;

  case 284: /* func_def: create_or_replace FUNCTION qname '(' opt_paramlist ')' RETURNS func_data_type routine_body  */
#line 1827 "sql_parser.y"
                        { dlist *f = L();
				append_list(f, (yyvsp[-6].l));
				append_list(f, (yyvsp[-4].l));
				append_symbol(f, (yyvsp[-1].sym));
				append_list(f, NULL);
				append_list(f, (yyvsp[0].l));
				append_int(f, F_FUNC);
				append_int(f, FUNC_LANG_SQL);
				append_int(f, (yyvsp[-8].bval));
			  (yyval.sym) = _symbol_create_list( SQL_CREATE_FUNC, f ); }
#line 9171 "y.tab.c"
    break;

  case 285: /* func_def: create_or_replace FUNCTION qname '(' opt_paramlist ')' RETURNS func_data_type LANGUAGE IDENT function_body  */
#line 1841 "sql_parser.y"
                {
			int lang = 0;
			dlist *f = L();
			char l = *(yyvsp[-1].sval);

			if (l == 'R' || l == 'r')
				lang = FUNC_LANG_R;
			else if (l == 'P' || l == 'p') {
				// code does not get cleaner than this people
				if (strcasecmp((yyvsp[-1].sval), "PYTHON_MAP") == 0) {
					lang = FUNC_LANG_MAP_PY;
				} else if (strcasecmp((yyvsp[-1].sval), "PYTHON3_MAP") == 0) {
					lang = FUNC_LANG_MAP_PY3;
				} else if (strcasecmp((yyvsp[-1].sval), "PYTHON3") == 0) {
					lang = FUNC_LANG_PY3;
				} else if (strcasecmp((yyvsp[-1].sval), "PYTHON2_MAP") == 0) {
					lang = FUNC_LANG_MAP_PY2;
				} else if (strcasecmp((yyvsp[-1].sval), "PYTHON2") == 0) {
					lang = FUNC_LANG_PY2;
				} else {
					lang = FUNC_LANG_PY;
				}
			} else if (l == 'C' || l == 'c')
				lang = FUNC_LANG_C;
			else if (l == 'J' || l == 'j')
				lang = FUNC_LANG_J;
			else {
				char *msg = sql_message("Language name R, C, PYTHON[3], PYTHON[3]_MAP or J(avascript):expected, received '%c'", l);
				yyerror(m, msg);
				_DELETE(msg);
			}

			append_list(f, (yyvsp[-8].l));
			append_list(f, (yyvsp[-6].l));
			append_symbol(f, (yyvsp[-3].sym));
			append_list(f, NULL);
			append_list(f, append_string(L(), (yyvsp[0].sval)));
			append_int(f, F_FUNC);
			append_int(f, lang);
			append_int(f, (yyvsp[-10].bval));
			(yyval.sym) = _symbol_create_list( SQL_CREATE_FUNC, f );
		}
#line 9218 "y.tab.c"
    break;

  case 286: /* func_def: create_or_replace FILTER FUNCTION qname '(' opt_paramlist ')' EXTERNAL sqlNAME external_function_name  */
#line 1886 "sql_parser.y"
                        { dlist *f = L();
				append_list(f, (yyvsp[-6].l));
				append_list(f, (yyvsp[-4].l)); 
				/* no returns - use OID */
				append_symbol(f, NULL); 
				append_list(f, (yyvsp[0].l));
				append_list(f, NULL);
				append_int(f, F_FILT);
				append_int(f, FUNC_LANG_MAL);
				append_int(f, (yyvsp[-9].bval));
			  (yyval.sym) = _symbol_create_list( SQL_CREATE_FUNC, f ); }
#line 9234 "y.tab.c"
    break;

  case 287: /* func_def: create_or_replace AGGREGATE qname '(' opt_paramlist ')' RETURNS func_data_type EXTERNAL sqlNAME external_function_name  */
#line 1901 "sql_parser.y"
                        { dlist *f = L();
				append_list(f, (yyvsp[-8].l));
				append_list(f, (yyvsp[-6].l));
				append_symbol(f, (yyvsp[-3].sym));
				append_list(f, (yyvsp[0].l));
				append_list(f, NULL);
				append_int(f, F_AGGR);
				append_int(f, FUNC_LANG_MAL);
				append_int(f, (yyvsp[-10].bval));
			  (yyval.sym) = _symbol_create_list( SQL_CREATE_FUNC, f ); }
#line 9249 "y.tab.c"
    break;

  case 288: /* func_def: create_or_replace AGGREGATE qname '(' opt_paramlist ')' RETURNS func_data_type LANGUAGE IDENT function_body  */
#line 1915 "sql_parser.y"
                {
			int lang = 0;
			dlist *f = L();
			char l = *(yyvsp[-1].sval);

			if (l == 'R' || l == 'r')
				lang = FUNC_LANG_R;
			else if (l == 'P' || l == 'p') {
				if (strcasecmp((yyvsp[-1].sval), "PYTHON_MAP") == 0) {
					lang = FUNC_LANG_MAP_PY;
				} else if (strcasecmp((yyvsp[-1].sval), "PYTHON3_MAP") == 0) {
					lang = FUNC_LANG_MAP_PY3;
				} else if (strcasecmp((yyvsp[-1].sval), "PYTHON3") == 0) {
					lang = FUNC_LANG_PY3;
				} else if (strcasecmp((yyvsp[-1].sval), "PYTHON2_MAP") == 0) {
					lang = FUNC_LANG_MAP_PY2;
				} else if (strcasecmp((yyvsp[-1].sval), "PYTHON2") == 0) {
					lang = FUNC_LANG_PY2;
				} else {
					lang = FUNC_LANG_PY;
				}
			} else if (l == 'C' || l == 'c')
				lang = FUNC_LANG_C;
			else if (l == 'J' || l == 'j')
				lang = FUNC_LANG_J;
			else {
				char *msg = sql_message("Language name R, C, PYTHON[3], PYTHON[3]_MAP or J(avascript):expected, received '%c'", l);
				yyerror(m, msg);
				_DELETE(msg);
			}

			append_list(f, (yyvsp[-8].l));
			append_list(f, (yyvsp[-6].l));
			append_symbol(f, (yyvsp[-3].sym));
			append_list(f, NULL);
			append_list(f, append_string(L(), (yyvsp[0].sval)));
			append_int(f, F_AGGR);
			append_int(f, lang);
			append_int(f, (yyvsp[-10].bval));
			(yyval.sym) = _symbol_create_list( SQL_CREATE_FUNC, f ); }
#line 9294 "y.tab.c"
    break;

  case 289: /* func_def: create_or_replace PROCEDURE qname '(' opt_paramlist ')' EXTERNAL sqlNAME external_function_name  */
#line 1959 "sql_parser.y"
                        { dlist *f = L();
				append_list(f, (yyvsp[-6].l));
				append_list(f, (yyvsp[-4].l));
				append_symbol(f, NULL); /* no result */
				append_list(f, (yyvsp[0].l));
				append_list(f, NULL);
				append_int(f, F_PROC);
				append_int(f, FUNC_LANG_MAL);
				append_int(f, (yyvsp[-8].bval));
			  (yyval.sym) = _symbol_create_list( SQL_CREATE_FUNC, f ); }
#line 9309 "y.tab.c"
    break;

  case 290: /* func_def: create_or_replace PROCEDURE qname '(' opt_paramlist ')' routine_body  */
#line 1972 "sql_parser.y"
                        { dlist *f = L();
				append_list(f, (yyvsp[-4].l));
				append_list(f, (yyvsp[-2].l));
				append_symbol(f, NULL); /* no result */
				append_list(f, NULL); 
				append_list(f, (yyvsp[0].l));
				append_int(f, F_PROC);
				append_int(f, FUNC_LANG_SQL);
				append_int(f, (yyvsp[-6].bval));
			  (yyval.sym) = _symbol_create_list( SQL_CREATE_FUNC, f ); }
#line 9324 "y.tab.c"
    break;

  case 291: /* func_def: create_or_replace sqlLOADER qname '(' opt_paramlist ')' LANGUAGE IDENT function_body  */
#line 1984 "sql_parser.y"
                                 { 
			int lang = 0;
			dlist *f = L();
			char l = *(yyvsp[-1].sval);
			/* other languages here if we ever get to it */
			if (l == 'P' || l == 'p') {
				lang = FUNC_LANG_PY;
			} else
				yyerror(m, sql_message("Language name P(ython) expected, received '%c'", l));

			append_list(f, (yyvsp[-6].l));
			append_list(f, (yyvsp[-4].l));
			append_symbol(f, NULL);
			append_list(f, NULL); 
			append_list(f, append_string(L(), (yyvsp[0].sval)));
			append_int(f, F_LOADER);
			append_int(f, lang);
			append_int(f, (yyvsp[-8].bval));
			(yyval.sym) = _symbol_create_list( SQL_CREATE_FUNC, f ); }
#line 9348 "y.tab.c"
    break;

  case 292: /* routine_body: procedure_statement  */
#line 2007 "sql_parser.y"
                { (yyval.l) = L(); append_symbol( (yyval.l), (yyvsp[0].sym)); }
#line 9354 "y.tab.c"
    break;

  case 293: /* routine_body: BEGIN procedure_statement_list procedure_statement SCOLON END  */
#line 2011 "sql_parser.y"
                { (yyval.l) = append_symbol((yyvsp[-3].l),(yyvsp[-2].sym)); }
#line 9360 "y.tab.c"
    break;

  case 294: /* routine_body: BEGIN ATOMIC procedure_statement_list procedure_statement SCOLON END  */
#line 2015 "sql_parser.y"
                { (yyval.l) = append_symbol((yyvsp[-3].l),(yyvsp[-2].sym)); }
#line 9366 "y.tab.c"
    break;

  case 295: /* procedure_statement_list: %empty  */
#line 2030 "sql_parser.y"
                 { (yyval.l) = L(); }
#line 9372 "y.tab.c"
    break;

  case 296: /* procedure_statement_list: procedure_statement_list procedure_statement SCOLON  */
#line 2032 "sql_parser.y"
                                { (yyval.l) = append_symbol((yyvsp[-2].l),(yyvsp[-1].sym));}
#line 9378 "y.tab.c"
    break;

  case 297: /* trigger_procedure_statement_list: %empty  */
#line 2036 "sql_parser.y"
                 { (yyval.l) = L(); }
#line 9384 "y.tab.c"
    break;

  case 298: /* trigger_procedure_statement_list: trigger_procedure_statement_list trigger_procedure_statement SCOLON  */
#line 2038 "sql_parser.y"
                                        { (yyval.l) = append_symbol((yyvsp[-2].l),(yyvsp[-1].sym));}
#line 9390 "y.tab.c"
    break;

  case 325: /* call_statement: CALL routine_invocation  */
#line 2086 "sql_parser.y"
                                        { (yyval.sym) = (yyvsp[0].sym); }
#line 9396 "y.tab.c"
    break;

  case 326: /* call_procedure_statement: CALL func_ref  */
#line 2090 "sql_parser.y"
                                        {(yyval.sym) = _symbol_create_symbol(SQL_CALL, (yyvsp[0].sym));}
#line 9402 "y.tab.c"
    break;

  case 327: /* routine_invocation: routine_name '(' argument_list ')'  */
#line 2095 "sql_parser.y"
                { dlist *l = L(); 
		  append_list( l, (yyvsp[-3].l));
		  append_list( l, (yyvsp[-1].l));
		  assert(0);
		  (yyval.sym) = _symbol_create_list( SQL_FUNC, l);
		}
#line 9413 "y.tab.c"
    break;

  case 329: /* argument_list: %empty  */
#line 2106 "sql_parser.y"
                        {(yyval.l) = L();}
#line 9419 "y.tab.c"
    break;

  case 330: /* argument_list: scalar_exp  */
#line 2107 "sql_parser.y"
                        { (yyval.l) = append_symbol( L(), (yyvsp[0].sym)); }
#line 9425 "y.tab.c"
    break;

  case 331: /* argument_list: argument_list ',' scalar_exp  */
#line 2109 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-2].l), (yyvsp[0].sym)); }
#line 9431 "y.tab.c"
    break;

  case 332: /* return_statement: RETURN return_value  */
#line 2114 "sql_parser.y"
                            { (yyval.sym) = _symbol_create_symbol(SQL_RETURN, (yyvsp[0].sym)); }
#line 9437 "y.tab.c"
    break;

  case 335: /* return_value: TABLE '(' query_expression ')'  */
#line 2121 "sql_parser.y"
                { (yyval.sym) = _symbol_create_symbol(SQL_TABLE, (yyvsp[-1].sym)); }
#line 9443 "y.tab.c"
    break;

  case 336: /* case_statement: CASE scalar_exp when_statements case_opt_else_statement END CASE  */
#line 2126 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list(SQL_CASE,
		   append_list(
		    append_list(
		     append_symbol(
		      L(),(yyvsp[-4].sym)),(yyvsp[-3].l)),(yyvsp[-2].l))); }
#line 9453 "y.tab.c"
    break;

  case 337: /* case_statement: CASE when_search_statements case_opt_else_statement END CASE  */
#line 2132 "sql_parser.y"
                 { (yyval.sym) = _symbol_create_list(SQL_CASE,
		   append_list(
		    append_list(
		     L(),(yyvsp[-3].l)),(yyvsp[-2].l))); }
#line 9462 "y.tab.c"
    break;

  case 338: /* when_statement: WHEN scalar_exp THEN procedure_statement_list  */
#line 2140 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_WHEN,
			   append_list(
			    append_symbol(
			     L(), (yyvsp[-2].sym)),(yyvsp[0].l))); }
#line 9471 "y.tab.c"
    break;

  case 339: /* when_statements: when_statement  */
#line 2148 "sql_parser.y"
                        { (yyval.l) = append_symbol( L(), (yyvsp[0].sym));}
#line 9477 "y.tab.c"
    break;

  case 340: /* when_statements: when_statements when_statement  */
#line 2150 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-1].l), (yyvsp[0].sym)); }
#line 9483 "y.tab.c"
    break;

  case 341: /* when_search_statement: WHEN search_condition THEN procedure_statement_list  */
#line 2155 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_WHEN,
			   append_list(
			    append_symbol(
			     L(), (yyvsp[-2].sym)),(yyvsp[0].l))); }
#line 9492 "y.tab.c"
    break;

  case 342: /* when_search_statements: when_search_statement  */
#line 2163 "sql_parser.y"
                        { (yyval.l) = append_symbol( L(), (yyvsp[0].sym)); }
#line 9498 "y.tab.c"
    break;

  case 343: /* when_search_statements: when_search_statements when_search_statement  */
#line 2165 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-1].l), (yyvsp[0].sym)); }
#line 9504 "y.tab.c"
    break;

  case 344: /* case_opt_else_statement: %empty  */
#line 2169 "sql_parser.y"
                                        { (yyval.l) = NULL; }
#line 9510 "y.tab.c"
    break;

  case 345: /* case_opt_else_statement: ELSE procedure_statement_list  */
#line 2170 "sql_parser.y"
                                        { (yyval.l) = (yyvsp[0].l); }
#line 9516 "y.tab.c"
    break;

  case 346: /* if_statement: IF search_condition THEN procedure_statement_list if_opt_else END IF  */
#line 2180 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-5].sym));
		  append_list(l, (yyvsp[-3].l));
		  append_symbol(l, (yyvsp[-2].sym));
		  (yyval.sym) = _symbol_create_list(SQL_IF, l);
		}
#line 9527 "y.tab.c"
    break;

  case 347: /* if_opt_else: %empty  */
#line 2191 "sql_parser.y"
                { (yyval.sym) = NULL; }
#line 9533 "y.tab.c"
    break;

  case 348: /* if_opt_else: ELSE procedure_statement_list  */
#line 2193 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list(SQL_ELSE, (yyvsp[0].l)); }
#line 9539 "y.tab.c"
    break;

  case 349: /* if_opt_else: ELSEIF search_condition THEN procedure_statement_list if_opt_else  */
#line 2196 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-3].sym));
		  append_list(l, (yyvsp[-1].l));
		  append_symbol(l, (yyvsp[0].sym));
		  { (yyval.sym) = _symbol_create_list(SQL_IF, l); }
		}
#line 9550 "y.tab.c"
    break;

  case 350: /* while_statement: opt_begin_label WHILE search_condition DO procedure_statement_list END WHILE opt_end_label  */
#line 2210 "sql_parser.y"
                { dlist *l;
		  char *label = (yyvsp[-7].sval)?(yyvsp[-7].sval):(yyvsp[0].sval);
		  if ((yyvsp[-7].sval) && (yyvsp[0].sval) && strcmp((yyvsp[-7].sval), (yyvsp[0].sval)) != 0) {
			(yyval.sym) = NULL;
			yyerror(m, "WHILE: labels should match");
			YYABORT;
		  }
 		  l = L();
		  append_symbol(l, (yyvsp[-5].sym)); /* condition */
		  append_list(l, (yyvsp[-3].l));	/* statements */
		  append_string(l, label);
		  (yyval.sym) = _symbol_create_list(SQL_WHILE, l);
		}
#line 9568 "y.tab.c"
    break;

  case 351: /* opt_begin_label: %empty  */
#line 2226 "sql_parser.y"
                        { (yyval.sval) = NULL; }
#line 9574 "y.tab.c"
    break;

  case 353: /* opt_end_label: %empty  */
#line 2231 "sql_parser.y"
                        { (yyval.sval) = NULL; }
#line 9580 "y.tab.c"
    break;

  case 355: /* table_function_column_list: column data_type  */
#line 2237 "sql_parser.y"
                                { (yyval.l) = L();
				  append_string((yyval.l), (yyvsp[-1].sval));
			  	  append_type((yyval.l), &(yyvsp[0].type));
				}
#line 9589 "y.tab.c"
    break;

  case 356: /* table_function_column_list: table_function_column_list ',' column data_type  */
#line 2242 "sql_parser.y"
                                { 
				  append_string((yyval.l), (yyvsp[-1].sval));
			  	  append_type((yyval.l), &(yyvsp[0].type));
				}
#line 9598 "y.tab.c"
    break;

  case 357: /* func_data_type: TABLE '(' table_function_column_list ')'  */
#line 2250 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list(SQL_TABLE, (yyvsp[-1].l)); }
#line 9604 "y.tab.c"
    break;

  case 358: /* func_data_type: data_type  */
#line 2252 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list(SQL_TYPE, append_type(L(),&(yyvsp[0].type))); }
#line 9610 "y.tab.c"
    break;

  case 360: /* opt_paramlist: '*'  */
#line 2257 "sql_parser.y"
                        { dlist *vararg = L();
			  append_string(vararg, "*");
			  append_type(vararg, NULL);
			  (yyval.l) = append_list(L(), vararg); }
#line 9619 "y.tab.c"
    break;

  case 361: /* opt_paramlist: %empty  */
#line 2261 "sql_parser.y"
                        { (yyval.l) = NULL; }
#line 9625 "y.tab.c"
    break;

  case 362: /* paramlist: paramlist ',' ident data_type  */
#line 2266 "sql_parser.y"
                        { dlist *p = L();
			  append_string(p, (yyvsp[-1].sval));
			  append_type(p, &(yyvsp[0].type));
			  (yyval.l) = append_list((yyvsp[-3].l), p); }
#line 9634 "y.tab.c"
    break;

  case 363: /* paramlist: ident data_type  */
#line 2271 "sql_parser.y"
                        { dlist *l = L();
			  dlist *p = L();
			  append_string(p, (yyvsp[-1].sval));
			  append_type(p, &(yyvsp[0].type));
			  (yyval.l) = append_list(l, p); }
#line 9644 "y.tab.c"
    break;

  case 364: /* trigger_def: create TRIGGER qname trigger_action_time trigger_event ON qname opt_referencing_list triggered_action  */
#line 2321 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-6].l));
	  append_int(l, (yyvsp[-5].i_val));
	  append_symbol(l, (yyvsp[-4].sym));
	  append_list(l, (yyvsp[-2].l));
	  append_list(l, (yyvsp[-1].l));
	  append_list(l, (yyvsp[0].l));
	  (yyval.sym) = _symbol_create_list(SQL_CREATE_TRIGGER, l); 
	}
#line 9658 "y.tab.c"
    break;

  case 365: /* trigger_action_time: BEFORE  */
#line 2333 "sql_parser.y"
                { (yyval.i_val) = 0; }
#line 9664 "y.tab.c"
    break;

  case 366: /* trigger_action_time: AFTER  */
#line 2334 "sql_parser.y"
                { (yyval.i_val) = 1; }
#line 9670 "y.tab.c"
    break;

  case 367: /* trigger_event: INSERT  */
#line 2339 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list(SQL_INSERT, NULL); }
#line 9676 "y.tab.c"
    break;

  case 368: /* trigger_event: sqlDELETE  */
#line 2340 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list(SQL_DELETE, NULL); }
#line 9682 "y.tab.c"
    break;

  case 369: /* trigger_event: UPDATE  */
#line 2341 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list(SQL_UPDATE, NULL); }
#line 9688 "y.tab.c"
    break;

  case 370: /* trigger_event: UPDATE OF ident_commalist  */
#line 2342 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list(SQL_UPDATE, (yyvsp[0].l)); }
#line 9694 "y.tab.c"
    break;

  case 371: /* opt_referencing_list: %empty  */
#line 2346 "sql_parser.y"
                                                { (yyval.l) = NULL; }
#line 9700 "y.tab.c"
    break;

  case 372: /* opt_referencing_list: REFERENCING old_or_new_values_alias_list  */
#line 2347 "sql_parser.y"
                                                { (yyval.l) = (yyvsp[0].l); }
#line 9706 "y.tab.c"
    break;

  case 373: /* old_or_new_values_alias_list: old_or_new_values_alias  */
#line 2351 "sql_parser.y"
                                { (yyval.l) = append_list(L(), (yyvsp[0].l)); }
#line 9712 "y.tab.c"
    break;

  case 374: /* old_or_new_values_alias_list: old_or_new_values_alias_list old_or_new_values_alias  */
#line 2353 "sql_parser.y"
                                { (yyval.l) = append_list((yyvsp[-1].l), (yyvsp[0].l)); }
#line 9718 "y.tab.c"
    break;

  case 375: /* old_or_new_values_alias: OLD opt_row opt_as ident  */
#line 2358 "sql_parser.y"
                                { (yyval.l) = append_string(append_int(L(), 0), (yyvsp[0].sval)); }
#line 9724 "y.tab.c"
    break;

  case 376: /* old_or_new_values_alias: sqlNEW opt_row opt_as ident  */
#line 2359 "sql_parser.y"
                                { (yyval.l) = append_string(append_int(L(), 1), (yyvsp[0].sval)); }
#line 9730 "y.tab.c"
    break;

  case 377: /* old_or_new_values_alias: OLD TABLE opt_as ident  */
#line 2360 "sql_parser.y"
                                { (yyval.l) = append_string(append_int(L(), 0), (yyvsp[0].sval)); }
#line 9736 "y.tab.c"
    break;

  case 378: /* old_or_new_values_alias: sqlNEW TABLE opt_as ident  */
#line 2361 "sql_parser.y"
                                { (yyval.l) = append_string(append_int(L(), 1), (yyvsp[0].sval)); }
#line 9742 "y.tab.c"
    break;

  case 383: /* triggered_action: opt_for_each opt_when triggered_statement  */
#line 2376 "sql_parser.y"
        { (yyval.l) = L();
	  append_int((yyval.l), (yyvsp[-2].i_val));
	  append_symbol((yyval.l), (yyvsp[-1].sym));
	  append_list((yyval.l), (yyvsp[0].l));
	}
#line 9752 "y.tab.c"
    break;

  case 384: /* opt_for_each: %empty  */
#line 2383 "sql_parser.y"
                                        { (yyval.i_val) = 1; }
#line 9758 "y.tab.c"
    break;

  case 385: /* opt_for_each: FOR EACH row_or_statement  */
#line 2384 "sql_parser.y"
                                        { (yyval.i_val) = (yyvsp[0].i_val); }
#line 9764 "y.tab.c"
    break;

  case 386: /* row_or_statement: ROW  */
#line 2388 "sql_parser.y"
                { (yyval.i_val) = 0; }
#line 9770 "y.tab.c"
    break;

  case 387: /* row_or_statement: STATEMENT  */
#line 2389 "sql_parser.y"
                { (yyval.i_val) = 1; }
#line 9776 "y.tab.c"
    break;

  case 388: /* opt_when: %empty  */
#line 2393 "sql_parser.y"
                                        { (yyval.sym) = NULL; }
#line 9782 "y.tab.c"
    break;

  case 389: /* opt_when: WHEN '(' search_condition ')'  */
#line 2394 "sql_parser.y"
                                        { (yyval.sym) = (yyvsp[-1].sym); }
#line 9788 "y.tab.c"
    break;

  case 390: /* triggered_statement: trigger_procedure_statement  */
#line 2399 "sql_parser.y"
                                { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 9794 "y.tab.c"
    break;

  case 391: /* triggered_statement: BEGIN ATOMIC trigger_procedure_statement_list END  */
#line 2402 "sql_parser.y"
                                { (yyval.l) = (yyvsp[-1].l); }
#line 9800 "y.tab.c"
    break;

  case 392: /* routine_designator: FUNCTION qname opt_typelist  */
#line 2407 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );	
	  append_list(l, (yyvsp[0].l) );
	  append_int(l, F_FUNC );
	  (yyval.l) = l; }
#line 9810 "y.tab.c"
    break;

  case 393: /* routine_designator: FILTER FUNCTION qname opt_typelist  */
#line 2413 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );	
	  append_list(l, (yyvsp[0].l) );
	  append_int(l, F_FILT );
	  (yyval.l) = l; }
#line 9820 "y.tab.c"
    break;

  case 394: /* routine_designator: AGGREGATE qname opt_typelist  */
#line 2419 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );	
	  append_list(l, (yyvsp[0].l) );
	  append_int(l, F_AGGR );
	  (yyval.l) = l; }
#line 9830 "y.tab.c"
    break;

  case 395: /* routine_designator: PROCEDURE qname opt_typelist  */
#line 2425 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );	
	  append_list(l, (yyvsp[0].l) );
	  append_int(l, F_PROC );
	  (yyval.l) = l; }
#line 9840 "y.tab.c"
    break;

  case 396: /* routine_designator: sqlLOADER qname opt_typelist  */
#line 2431 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );	
	  append_list(l, (yyvsp[0].l) );
	  append_int(l, F_LOADER );
	  (yyval.l) = l; }
#line 9850 "y.tab.c"
    break;

  case 397: /* drop_statement: drop TABLE if_exists qname drop_action  */
#line 2440 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );
	  append_int(l, (yyvsp[0].i_val) );
	  append_int(l, (yyvsp[-2].bval));
	  (yyval.sym) = _symbol_create_list( SQL_DROP_TABLE, l ); }
#line 9860 "y.tab.c"
    break;

  case 398: /* drop_statement: drop routine_designator drop_action  */
#line 2446 "sql_parser.y"
        { dlist *l = (yyvsp[-1].l);
	  append_int(l, 0 ); /* not all */
	  append_int(l, (yyvsp[0].i_val) );
	  (yyval.sym) = _symbol_create_list( SQL_DROP_FUNC, l ); }
#line 9869 "y.tab.c"
    break;

  case 399: /* drop_statement: drop ALL FUNCTION qname drop_action  */
#line 2451 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );
	  append_list(l, NULL );
	  append_int(l, F_FUNC );
	  append_int(l, 1 );
	  append_int(l, (yyvsp[0].i_val) );
	  (yyval.sym) = _symbol_create_list( SQL_DROP_FUNC, l ); }
#line 9881 "y.tab.c"
    break;

  case 400: /* drop_statement: drop ALL FILTER FUNCTION qname drop_action  */
#line 2459 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );
	  append_list(l, NULL );
	  append_int(l, F_FILT );
	  append_int(l, 1 );
	  append_int(l, (yyvsp[0].i_val) );
	  (yyval.sym) = _symbol_create_list( SQL_DROP_FUNC, l ); }
#line 9893 "y.tab.c"
    break;

  case 401: /* drop_statement: drop ALL AGGREGATE qname drop_action  */
#line 2467 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );
	  append_list(l, NULL );
	  append_int(l, F_AGGR );
	  append_int(l, 1 );
	  append_int(l, (yyvsp[0].i_val) );
	  (yyval.sym) = _symbol_create_list( SQL_DROP_FUNC, l ); }
#line 9905 "y.tab.c"
    break;

  case 402: /* drop_statement: drop ALL PROCEDURE qname drop_action  */
#line 2475 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );
	  append_list(l, NULL );
	  append_int(l, F_PROC );
	  append_int(l, 1 );
	  append_int(l, (yyvsp[0].i_val) );
	  (yyval.sym) = _symbol_create_list( SQL_DROP_FUNC, l ); }
#line 9917 "y.tab.c"
    break;

  case 403: /* drop_statement: drop ALL sqlLOADER qname drop_action  */
#line 2483 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );
	  append_list(l, NULL );
	  append_int(l, F_LOADER );
	  append_int(l, 1 );
	  append_int(l, (yyvsp[0].i_val) );
	  (yyval.sym) = _symbol_create_list( SQL_DROP_FUNC, l ); }
#line 9929 "y.tab.c"
    break;

  case 404: /* drop_statement: drop VIEW if_exists qname drop_action  */
#line 2491 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );
	  append_int(l, (yyvsp[0].i_val) );
	  append_int(l, (yyvsp[-2].bval) );
	  (yyval.sym) = _symbol_create_list( SQL_DROP_VIEW, l ); }
#line 9939 "y.tab.c"
    break;

  case 405: /* drop_statement: drop TYPE qname drop_action  */
#line 2497 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l) );
	  append_int(l, (yyvsp[0].i_val) );
	  (yyval.sym) = _symbol_create_list( SQL_DROP_TYPE, l ); }
#line 9948 "y.tab.c"
    break;

  case 406: /* drop_statement: drop ROLE ident  */
#line 2501 "sql_parser.y"
                          { (yyval.sym) = _symbol_create( SQL_DROP_ROLE, (yyvsp[0].sval) ); }
#line 9954 "y.tab.c"
    break;

  case 407: /* drop_statement: drop USER ident  */
#line 2502 "sql_parser.y"
                          { (yyval.sym) = _symbol_create( SQL_DROP_USER, (yyvsp[0].sval) ); }
#line 9960 "y.tab.c"
    break;

  case 408: /* drop_statement: drop INDEX qname  */
#line 2503 "sql_parser.y"
                          { (yyval.sym) = _symbol_create_list( SQL_DROP_INDEX, (yyvsp[0].l) ); }
#line 9966 "y.tab.c"
    break;

  case 409: /* drop_statement: drop TRIGGER qname  */
#line 2504 "sql_parser.y"
                          { (yyval.sym) = _symbol_create_list( SQL_DROP_TRIGGER, (yyvsp[0].l) ); }
#line 9972 "y.tab.c"
    break;

  case 410: /* opt_typelist: %empty  */
#line 2508 "sql_parser.y"
                        {(yyval.l) = NULL;}
#line 9978 "y.tab.c"
    break;

  case 411: /* opt_typelist: '(' typelist ')'  */
#line 2509 "sql_parser.y"
                        {(yyval.l) = (yyvsp[-1].l);}
#line 9984 "y.tab.c"
    break;

  case 412: /* opt_typelist: '(' ')'  */
#line 2510 "sql_parser.y"
                        {(yyval.l) = L(); }
#line 9990 "y.tab.c"
    break;

  case 413: /* typelist: data_type  */
#line 2514 "sql_parser.y"
                                { dlist *l = L();
				  append_type(l, &(yyvsp[0].type) );
				  (yyval.l)= l; }
#line 9998 "y.tab.c"
    break;

  case 414: /* typelist: data_type ',' typelist  */
#line 2517 "sql_parser.y"
                                { append_type((yyvsp[0].l), &(yyvsp[-2].type));
				  (yyval.l) = (yyvsp[0].l); }
#line 10005 "y.tab.c"
    break;

  case 415: /* drop_action: %empty  */
#line 2522 "sql_parser.y"
                        { (yyval.i_val) = 0; }
#line 10011 "y.tab.c"
    break;

  case 416: /* drop_action: RESTRICT  */
#line 2523 "sql_parser.y"
                        { (yyval.i_val) = 0; }
#line 10017 "y.tab.c"
    break;

  case 417: /* drop_action: CASCADE  */
#line 2524 "sql_parser.y"
                        { (yyval.i_val) = 1; }
#line 10023 "y.tab.c"
    break;

  case 424: /* transaction_statement: _transaction_stmt  */
#line 2543 "sql_parser.y"
        {
	  (yyval.sym) = (yyvsp[0].sym);
	  m->type = Q_TRANS;					}
#line 10031 "y.tab.c"
    break;

  case 425: /* _transaction_stmt: COMMIT opt_work opt_chain  */
#line 2550 "sql_parser.y"
                { (yyval.sym) = _symbol_create_int( TR_COMMIT, (yyvsp[0].bval));  }
#line 10037 "y.tab.c"
    break;

  case 426: /* _transaction_stmt: SAVEPOINT ident  */
#line 2552 "sql_parser.y"
                { (yyval.sym) = _symbol_create( TR_SAVEPOINT, (yyvsp[0].sval)); }
#line 10043 "y.tab.c"
    break;

  case 427: /* _transaction_stmt: RELEASE SAVEPOINT ident  */
#line 2554 "sql_parser.y"
                { (yyval.sym) = _symbol_create( TR_RELEASE, (yyvsp[0].sval)); }
#line 10049 "y.tab.c"
    break;

  case 428: /* _transaction_stmt: ROLLBACK opt_work opt_chain opt_to_savepoint  */
#line 2556 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list( TR_ROLLBACK,
		   append_string(
			append_int(L(), (yyvsp[-1].bval)), (yyvsp[0].sval) )); }
#line 10057 "y.tab.c"
    break;

  case 429: /* _transaction_stmt: START TRANSACTION transaction_mode_list  */
#line 2560 "sql_parser.y"
                { (yyval.sym) = _symbol_create_int( TR_START, (yyvsp[0].i_val)); }
#line 10063 "y.tab.c"
    break;

  case 430: /* _transaction_stmt: SET LOCAL TRANSACTION transaction_mode_list  */
#line 2562 "sql_parser.y"
                { (yyval.sym) = _symbol_create_int( TR_MODE, (yyvsp[0].i_val)); }
#line 10069 "y.tab.c"
    break;

  case 431: /* _transaction_stmt: SET TRANSACTION transaction_mode_list  */
#line 2564 "sql_parser.y"
                { (yyval.sym) = _symbol_create_int( TR_MODE, (yyvsp[0].i_val)); }
#line 10075 "y.tab.c"
    break;

  case 432: /* transaction_mode_list: %empty  */
#line 2568 "sql_parser.y"
                                { (yyval.i_val) = tr_none; }
#line 10081 "y.tab.c"
    break;

  case 434: /* _transaction_mode_list: transaction_mode  */
#line 2574 "sql_parser.y"
                { (yyval.i_val) = (yyvsp[0].i_val); }
#line 10087 "y.tab.c"
    break;

  case 435: /* _transaction_mode_list: _transaction_mode_list ',' transaction_mode  */
#line 2576 "sql_parser.y"
                { (yyval.i_val) = ((yyvsp[-2].i_val) | (yyvsp[0].i_val)); }
#line 10093 "y.tab.c"
    break;

  case 436: /* transaction_mode: READ ONLY  */
#line 2581 "sql_parser.y"
                                        { (yyval.i_val) = tr_readonly; }
#line 10099 "y.tab.c"
    break;

  case 437: /* transaction_mode: READ WRITE  */
#line 2582 "sql_parser.y"
                                        { (yyval.i_val) = tr_writable; }
#line 10105 "y.tab.c"
    break;

  case 438: /* transaction_mode: ISOLATION LEVEL iso_level  */
#line 2583 "sql_parser.y"
                                        { (yyval.i_val) = tr_serializable; }
#line 10111 "y.tab.c"
    break;

  case 439: /* transaction_mode: DIAGNOSTICS sqlSIZE intval  */
#line 2584 "sql_parser.y"
                                        { (yyval.i_val) = tr_none; /* not supported */ }
#line 10117 "y.tab.c"
    break;

  case 444: /* opt_work: WORK  */
#line 2595 "sql_parser.y"
                        { (yyval.bval) = 0; }
#line 10123 "y.tab.c"
    break;

  case 445: /* opt_work: %empty  */
#line 2596 "sql_parser.y"
                        { (yyval.bval) = 0; }
#line 10129 "y.tab.c"
    break;

  case 446: /* opt_chain: AND CHAIN  */
#line 2600 "sql_parser.y"
                        { (yyval.bval) = 1; }
#line 10135 "y.tab.c"
    break;

  case 447: /* opt_chain: AND NO CHAIN  */
#line 2601 "sql_parser.y"
                        { (yyval.bval) = 0; }
#line 10141 "y.tab.c"
    break;

  case 448: /* opt_chain: %empty  */
#line 2602 "sql_parser.y"
                        { (yyval.bval) = 0; }
#line 10147 "y.tab.c"
    break;

  case 449: /* opt_to_savepoint: %empty  */
#line 2606 "sql_parser.y"
                        { (yyval.sval) = NULL; }
#line 10153 "y.tab.c"
    break;

  case 450: /* opt_to_savepoint: TO SAVEPOINT ident  */
#line 2607 "sql_parser.y"
                        { (yyval.sval) = (yyvsp[0].sval); }
#line 10159 "y.tab.c"
    break;

  case 451: /* copyfrom_stmt: COPY opt_nr INTO qname opt_column_list FROM string_commalist opt_header_list opt_seps opt_null_string opt_locked opt_best_effort opt_constraint opt_fwf_widths  */
#line 2612 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-10].l));
	  append_list(l, (yyvsp[-9].l));
	  append_list(l, (yyvsp[-7].l));
	  append_list(l, (yyvsp[-6].l));
	  append_list(l, (yyvsp[-5].l));
	  append_list(l, (yyvsp[-12].l));
	  append_string(l, (yyvsp[-4].sval));
	  append_int(l, (yyvsp[-3].bval));
	  append_int(l, (yyvsp[-2].bval));
	  append_int(l, (yyvsp[-1].bval));
	  append_list(l, (yyvsp[0].l));
	  (yyval.sym) = _symbol_create_list( SQL_COPYFROM, l ); }
#line 10177 "y.tab.c"
    break;

  case 452: /* copyfrom_stmt: COPY opt_nr INTO qname opt_column_list FROM STDIN opt_header_list opt_seps opt_null_string opt_locked opt_best_effort opt_constraint  */
#line 2626 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-9].l));
	  append_list(l, (yyvsp[-8].l));
	  append_list(l, NULL);
	  append_list(l, (yyvsp[-5].l));
	  append_list(l, (yyvsp[-4].l));
	  append_list(l, (yyvsp[-11].l));
	  append_string(l, (yyvsp[-3].sval));
	  append_int(l, (yyvsp[-2].bval));
	  append_int(l, (yyvsp[-1].bval));
	  append_int(l, (yyvsp[0].bval));
	  append_list(l, NULL);
	  (yyval.sym) = _symbol_create_list( SQL_COPYFROM, l ); }
#line 10195 "y.tab.c"
    break;

  case 453: /* copyfrom_stmt: COPY sqlLOADER INTO qname FROM func_ref  */
#line 2640 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-2].l));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_COPYLOADER, l ); }
#line 10204 "y.tab.c"
    break;

  case 454: /* copyfrom_stmt: COPY opt_nr BINARY INTO qname opt_column_list FROM string_commalist opt_constraint  */
#line 2645 "sql_parser.y"
        { dlist *l = L();
	  if ((yyvsp[-7].l) != NULL) {
	  	yyerror(m, "COPY INTO: cannot pass number of records when using binary COPY INTO");
		YYABORT;
	  }
	  append_list(l, (yyvsp[-4].l));
	  append_list(l, (yyvsp[-3].l));
	  append_list(l, (yyvsp[-1].l));
	  append_int(l, (yyvsp[0].bval));
	  (yyval.sym) = _symbol_create_list( SQL_BINCOPYFROM, l ); }
#line 10219 "y.tab.c"
    break;

  case 455: /* copyfrom_stmt: COPY query_expression_def INTO string opt_seps opt_null_string  */
#line 2656 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-4].sym));
	  append_string(l, (yyvsp[-2].sval));
	  append_list(l, (yyvsp[-1].l));
	  append_string(l, (yyvsp[0].sval));
	  (yyval.sym) = _symbol_create_list( SQL_COPYTO, l ); }
#line 10230 "y.tab.c"
    break;

  case 456: /* copyfrom_stmt: COPY query_expression_def INTO STDOUT opt_seps opt_null_string  */
#line 2663 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-4].sym));
	  append_string(l, NULL);
	  append_list(l, (yyvsp[-1].l));
	  append_string(l, (yyvsp[0].sval));
	  (yyval.sym) = _symbol_create_list( SQL_COPYTO, l ); }
#line 10241 "y.tab.c"
    break;

  case 457: /* opt_fwf_widths: %empty  */
#line 2674 "sql_parser.y"
                                { (yyval.l) = NULL; }
#line 10247 "y.tab.c"
    break;

  case 458: /* opt_fwf_widths: FWF '(' fwf_widthlist ')'  */
#line 2675 "sql_parser.y"
                            { (yyval.l) = (yyvsp[-1].l); }
#line 10253 "y.tab.c"
    break;

  case 459: /* fwf_widthlist: poslng  */
#line 2680 "sql_parser.y"
                        { (yyval.l) = append_lng(L(), (yyvsp[0].l_val)); }
#line 10259 "y.tab.c"
    break;

  case 460: /* fwf_widthlist: fwf_widthlist ',' poslng  */
#line 2682 "sql_parser.y"
                        { (yyval.l) = append_lng((yyvsp[-2].l), (yyvsp[0].l_val)); }
#line 10265 "y.tab.c"
    break;

  case 461: /* opt_header_list: %empty  */
#line 2687 "sql_parser.y"
                                { (yyval.l) = NULL; }
#line 10271 "y.tab.c"
    break;

  case 462: /* opt_header_list: '(' header_list ')'  */
#line 2688 "sql_parser.y"
                                { (yyval.l) = (yyvsp[-1].l); }
#line 10277 "y.tab.c"
    break;

  case 463: /* header_list: header  */
#line 2692 "sql_parser.y"
                                { (yyval.l) = append_list(L(), (yyvsp[0].l)); }
#line 10283 "y.tab.c"
    break;

  case 464: /* header_list: header_list ',' header  */
#line 2693 "sql_parser.y"
                                { (yyval.l) = append_list((yyvsp[-2].l), (yyvsp[0].l)); }
#line 10289 "y.tab.c"
    break;

  case 465: /* header: ident  */
#line 2698 "sql_parser.y"
                        { dlist *l = L();
			  append_string(l, (yyvsp[0].sval) );
			  (yyval.l) = l; }
#line 10297 "y.tab.c"
    break;

  case 466: /* header: ident STRING  */
#line 2702 "sql_parser.y"
                        { dlist *l = L();
			  append_string(l, (yyvsp[-1].sval) );
			  append_string(l, (yyvsp[0].sval) );
			  (yyval.l) = l; }
#line 10306 "y.tab.c"
    break;

  case 467: /* opt_seps: %empty  */
#line 2710 "sql_parser.y"
                                { dlist *l = L();
				  append_string(l, sa_strdup(SA, "|"));
				  append_string(l, sa_strdup(SA, "\\n"));
				  (yyval.l) = l; }
#line 10315 "y.tab.c"
    break;

  case 468: /* opt_seps: opt_using DELIMITERS string  */
#line 2715 "sql_parser.y"
                                { dlist *l = L();
				  append_string(l, (yyvsp[0].sval));
				  append_string(l, sa_strdup(SA, "\\n"));
				  (yyval.l) = l; }
#line 10324 "y.tab.c"
    break;

  case 469: /* opt_seps: opt_using DELIMITERS string ',' string  */
#line 2720 "sql_parser.y"
                                { dlist *l = L();
				  append_string(l, (yyvsp[-2].sval));
				  append_string(l, (yyvsp[0].sval));
				  (yyval.l) = l; }
#line 10333 "y.tab.c"
    break;

  case 470: /* opt_seps: opt_using DELIMITERS string ',' string ',' string  */
#line 2725 "sql_parser.y"
                                { dlist *l = L();
				  append_string(l, (yyvsp[-4].sval));
				  append_string(l, (yyvsp[-2].sval));
				  append_string(l, sql2str((yyvsp[0].sval)));
				  (yyval.l) = l; }
#line 10343 "y.tab.c"
    break;

  case 471: /* opt_using: %empty  */
#line 2733 "sql_parser.y"
                                { (yyval.sval) = NULL; }
#line 10349 "y.tab.c"
    break;

  case 472: /* opt_using: USING  */
#line 2734 "sql_parser.y"
                                { (yyval.sval) = NULL; }
#line 10355 "y.tab.c"
    break;

  case 473: /* opt_nr: %empty  */
#line 2738 "sql_parser.y"
                                { (yyval.l) = NULL; }
#line 10361 "y.tab.c"
    break;

  case 474: /* opt_nr: poslng RECORDS  */
#line 2739 "sql_parser.y"
                                { (yyval.l) = append_lng(append_lng(L(), (yyvsp[-1].l_val)), 0); }
#line 10367 "y.tab.c"
    break;

  case 475: /* opt_nr: OFFSET poslng  */
#line 2740 "sql_parser.y"
                                { (yyval.l) = append_lng(append_lng(L(), -1), (yyvsp[0].l_val)); }
#line 10373 "y.tab.c"
    break;

  case 476: /* opt_nr: poslng OFFSET poslng RECORDS  */
#line 2742 "sql_parser.y"
                                { (yyval.l) = append_lng(append_lng(L(), (yyvsp[-3].l_val)), (yyvsp[-1].l_val)); }
#line 10379 "y.tab.c"
    break;

  case 477: /* opt_nr: poslng RECORDS OFFSET poslng  */
#line 2744 "sql_parser.y"
                                { (yyval.l) = append_lng(append_lng(L(), (yyvsp[-3].l_val)), (yyvsp[0].l_val)); }
#line 10385 "y.tab.c"
    break;

  case 478: /* opt_null_string: %empty  */
#line 2748 "sql_parser.y"
                                { (yyval.sval) = NULL; }
#line 10391 "y.tab.c"
    break;

  case 479: /* opt_null_string: sqlNULL opt_as string  */
#line 2749 "sql_parser.y"
                                { (yyval.sval) = (yyvsp[0].sval); }
#line 10397 "y.tab.c"
    break;

  case 480: /* opt_locked: %empty  */
#line 2753 "sql_parser.y"
                        { (yyval.bval) = FALSE; }
#line 10403 "y.tab.c"
    break;

  case 481: /* opt_locked: LOCKED  */
#line 2754 "sql_parser.y"
                        { (yyval.bval) = TRUE; }
#line 10409 "y.tab.c"
    break;

  case 482: /* opt_best_effort: %empty  */
#line 2758 "sql_parser.y"
                        { (yyval.bval) = FALSE; }
#line 10415 "y.tab.c"
    break;

  case 483: /* opt_best_effort: BEST EFFORT  */
#line 2759 "sql_parser.y"
                        { (yyval.bval) = TRUE; }
#line 10421 "y.tab.c"
    break;

  case 484: /* opt_constraint: %empty  */
#line 2763 "sql_parser.y"
                        { (yyval.bval) = TRUE; }
#line 10427 "y.tab.c"
    break;

  case 485: /* opt_constraint: NO CONSTRAINT  */
#line 2764 "sql_parser.y"
                        { (yyval.bval) = FALSE; }
#line 10433 "y.tab.c"
    break;

  case 486: /* string_commalist: string_commalist_contents  */
#line 2768 "sql_parser.y"
                                           { (yyval.l) = (yyvsp[0].l); }
#line 10439 "y.tab.c"
    break;

  case 487: /* string_commalist: '(' string_commalist_contents ')'  */
#line 2769 "sql_parser.y"
                                           { (yyval.l) = (yyvsp[-1].l); }
#line 10445 "y.tab.c"
    break;

  case 488: /* string_commalist_contents: string  */
#line 2773 "sql_parser.y"
                        { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 10451 "y.tab.c"
    break;

  case 489: /* string_commalist_contents: string_commalist_contents ',' string  */
#line 2775 "sql_parser.y"
                        { (yyval.l) = append_string((yyvsp[-2].l), (yyvsp[0].sval)); }
#line 10457 "y.tab.c"
    break;

  case 490: /* delete_stmt: sqlDELETE FROM qname opt_where_clause  */
#line 2781 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_DELETE, l ); }
#line 10466 "y.tab.c"
    break;

  case 491: /* update_stmt: UPDATE qname SET assignment_commalist opt_from_clause opt_where_clause  */
#line 2790 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-4].l));
	  append_list(l, (yyvsp[-2].l));
	  append_symbol(l, (yyvsp[-1].sym));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_UPDATE, l ); }
#line 10477 "y.tab.c"
    break;

  case 492: /* insert_stmt: INSERT INTO qname values_or_query_spec  */
#line 2832 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-1].l));
	  append_list(l, NULL);
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_INSERT, l ); }
#line 10487 "y.tab.c"
    break;

  case 493: /* insert_stmt: INSERT INTO qname column_commalist_parens values_or_query_spec  */
#line 2840 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-2].l));
	  append_list(l, (yyvsp[-1].l));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_INSERT, l ); }
#line 10497 "y.tab.c"
    break;

  case 494: /* values_or_query_spec: %empty  */
#line 2849 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list( SQL_VALUES, L()); }
#line 10503 "y.tab.c"
    break;

  case 495: /* values_or_query_spec: DEFAULT VALUES  */
#line 2851 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list( SQL_VALUES, L()); }
#line 10509 "y.tab.c"
    break;

  case 496: /* values_or_query_spec: VALUES row_commalist  */
#line 2853 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list( SQL_VALUES, (yyvsp[0].l)); }
#line 10515 "y.tab.c"
    break;

  case 498: /* row_commalist: '(' atom_commalist ')'  */
#line 2859 "sql_parser.y"
                                { (yyval.l) = append_list(L(), (yyvsp[-1].l)); }
#line 10521 "y.tab.c"
    break;

  case 499: /* row_commalist: row_commalist ',' '(' atom_commalist ')'  */
#line 2861 "sql_parser.y"
                                { (yyval.l) = append_list((yyvsp[-4].l), (yyvsp[-1].l)); }
#line 10527 "y.tab.c"
    break;

  case 500: /* atom_commalist: insert_atom  */
#line 2865 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 10533 "y.tab.c"
    break;

  case 501: /* atom_commalist: atom_commalist ',' insert_atom  */
#line 2867 "sql_parser.y"
                        { (yyval.l) = append_symbol((yyvsp[-2].l), (yyvsp[0].sym)); }
#line 10539 "y.tab.c"
    break;

  case 502: /* value_commalist: value  */
#line 2871 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 10545 "y.tab.c"
    break;

  case 503: /* value_commalist: value_commalist ',' value  */
#line 2873 "sql_parser.y"
                        { (yyval.l) = append_symbol((yyvsp[-2].l), (yyvsp[0].sym)); }
#line 10551 "y.tab.c"
    break;

  case 504: /* null: sqlNULL  */
#line 2878 "sql_parser.y"
         { 
	  if (m->emode == m_normal && m->caching) {
		/* replace by argument */
		atom *a = atom_general(SA, sql_bind_localtype("void"), NULL);

		sql_add_arg( m, a);
		(yyval.sym) = _symbol_create_list( SQL_COLUMN,
			append_int(L(), m->argc-1));
	   } else {
		(yyval.sym) = _symbol_create(SQL_NULL, NULL );
	   }
	}
#line 10568 "y.tab.c"
    break;

  case 509: /* opt_distinct: %empty  */
#line 2907 "sql_parser.y"
                        { (yyval.bval) = FALSE; }
#line 10574 "y.tab.c"
    break;

  case 510: /* opt_distinct: ALL  */
#line 2908 "sql_parser.y"
                        { (yyval.bval) = FALSE; }
#line 10580 "y.tab.c"
    break;

  case 511: /* opt_distinct: DISTINCT  */
#line 2909 "sql_parser.y"
                        { (yyval.bval) = TRUE; }
#line 10586 "y.tab.c"
    break;

  case 512: /* assignment_commalist: assignment  */
#line 2913 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym) ); }
#line 10592 "y.tab.c"
    break;

  case 513: /* assignment_commalist: assignment_commalist ',' assignment  */
#line 2915 "sql_parser.y"
                        { (yyval.l) = append_symbol((yyvsp[-2].l), (yyvsp[0].sym) ); }
#line 10598 "y.tab.c"
    break;

  case 514: /* assignment: column '=' search_condition  */
#line 2920 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[0].sym) );
	  append_string(l, (yyvsp[-2].sval));
	  (yyval.sym) = _symbol_create_list( SQL_ASSIGN, l); }
#line 10607 "y.tab.c"
    break;

  case 515: /* assignment: column_commalist_parens '=' subquery  */
#line 2925 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[0].sym));
	  append_list(l, (yyvsp[-2].l));
	  (yyval.sym) = _symbol_create_list( SQL_ASSIGN, l ); }
#line 10616 "y.tab.c"
    break;

  case 516: /* opt_where_clause: %empty  */
#line 2932 "sql_parser.y"
                                { (yyval.sym) = NULL; }
#line 10622 "y.tab.c"
    break;

  case 517: /* opt_where_clause: WHERE search_condition  */
#line 2933 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[0].sym); }
#line 10628 "y.tab.c"
    break;

  case 518: /* joined_table: '(' joined_table ')'  */
#line 2940 "sql_parser.y"
        { (yyval.sym) = (yyvsp[-1].sym); }
#line 10634 "y.tab.c"
    break;

  case 519: /* joined_table: table_ref CROSS JOIN table_ref  */
#line 2942 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-3].sym));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_CROSS, l); }
#line 10643 "y.tab.c"
    break;

  case 520: /* joined_table: table_ref UNIONJOIN table_ref join_spec  */
#line 2947 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-3].sym));
	  append_int(l, 0);
	  append_int(l, 4);
	  append_symbol(l, (yyvsp[-1].sym));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_UNIONJOIN, l); }
#line 10655 "y.tab.c"
    break;

  case 521: /* joined_table: table_ref join_type JOIN table_ref join_spec  */
#line 2955 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-4].sym));
	  append_int(l, 0);
	  append_int(l, (yyvsp[-3].i_val));
	  append_symbol(l, (yyvsp[-1].sym));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_JOIN, l); }
#line 10667 "y.tab.c"
    break;

  case 522: /* joined_table: table_ref NATURAL join_type JOIN table_ref  */
#line 2963 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-4].sym));
	  append_int(l, 1);
	  append_int(l, (yyvsp[-2].i_val));
	  append_symbol(l, (yyvsp[0].sym));
	  append_symbol(l, NULL);
	  (yyval.sym) = _symbol_create_list( SQL_JOIN, l); }
#line 10679 "y.tab.c"
    break;

  case 523: /* join_type: %empty  */
#line 2973 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 10685 "y.tab.c"
    break;

  case 524: /* join_type: INNER  */
#line 2974 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 10691 "y.tab.c"
    break;

  case 525: /* join_type: outer_join_type opt_outer  */
#line 2975 "sql_parser.y"
                                { (yyval.i_val) = 1 + (yyvsp[-1].i_val); }
#line 10697 "y.tab.c"
    break;

  case 526: /* opt_outer: %empty  */
#line 2979 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 10703 "y.tab.c"
    break;

  case 527: /* opt_outer: OUTER  */
#line 2980 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 10709 "y.tab.c"
    break;

  case 528: /* outer_join_type: LEFT  */
#line 2984 "sql_parser.y"
                        { (yyval.i_val) = 0; }
#line 10715 "y.tab.c"
    break;

  case 529: /* outer_join_type: RIGHT  */
#line 2985 "sql_parser.y"
                        { (yyval.i_val) = 1; }
#line 10721 "y.tab.c"
    break;

  case 530: /* outer_join_type: FULL  */
#line 2986 "sql_parser.y"
                        { (yyval.i_val) = 2; }
#line 10727 "y.tab.c"
    break;

  case 531: /* join_spec: ON search_condition  */
#line 2990 "sql_parser.y"
                                        { (yyval.sym) = (yyvsp[0].sym); }
#line 10733 "y.tab.c"
    break;

  case 532: /* join_spec: USING column_commalist_parens  */
#line 2992 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list( SQL_USING, (yyvsp[0].l)); }
#line 10739 "y.tab.c"
    break;

  case 534: /* with_query: WITH with_list with_query_expression  */
#line 3016 "sql_parser.y"
        {
		dlist *l = L();
	  	append_list(l, (yyvsp[-1].l));
	  	append_symbol(l, (yyvsp[0].sym));
	  	(yyval.sym) = _symbol_create_list( SQL_WITH, l ); 
	}
#line 10750 "y.tab.c"
    break;

  case 535: /* with_list: with_list ',' with_list_element  */
#line 3025 "sql_parser.y"
                                         { (yyval.l) = append_symbol((yyvsp[-2].l), (yyvsp[0].sym)); }
#line 10756 "y.tab.c"
    break;

  case 536: /* with_list: with_list_element  */
#line 3026 "sql_parser.y"
                                         { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 10762 "y.tab.c"
    break;

  case 537: /* with_list_element: ident opt_column_list AS subquery_with_orderby  */
#line 3031 "sql_parser.y"
        {  dlist *l = L();
	  append_list(l, append_string(L(), (yyvsp[-3].sval)));
	  append_list(l, (yyvsp[-2].l));
	  append_symbol(l, (yyvsp[0].sym));
	  append_int(l, FALSE);	/* no with check */
	  append_int(l, FALSE);	/* inlined view  (ie not persistent) */
	  (yyval.sym) = _symbol_create_list( SQL_CREATE_VIEW, l ); 
	}
#line 10775 "y.tab.c"
    break;

  case 541: /* simple_select: SELECT opt_distinct selection table_exp  */
#line 3054 "sql_parser.y"
        { (yyval.sym) = newSelectNode( SA, (yyvsp[-2].bval), (yyvsp[-1].l), NULL,
		(yyvsp[0].l)->h->data.sym,
		(yyvsp[0].l)->h->next->data.sym,
		(yyvsp[0].l)->h->next->next->data.sym,
		(yyvsp[0].l)->h->next->next->next->data.sym,
		NULL, NULL, NULL, NULL, NULL);
	}
#line 10787 "y.tab.c"
    break;

  case 542: /* select_statement_single_row: SELECT opt_distinct selection INTO select_target_list table_exp  */
#line 3065 "sql_parser.y"
        { (yyval.sym) = newSelectNode( SA, (yyvsp[-4].bval), (yyvsp[-3].l), (yyvsp[-1].l),
		(yyvsp[0].l)->h->data.sym,
		(yyvsp[0].l)->h->next->data.sym,
		(yyvsp[0].l)->h->next->next->data.sym,
		(yyvsp[0].l)->h->next->next->next->data.sym,
		NULL, NULL, NULL, NULL, NULL);
	}
#line 10799 "y.tab.c"
    break;

  case 543: /* select_no_parens_orderby: select_no_parens opt_order_by_clause opt_limit opt_offset opt_sample  */
#line 3076 "sql_parser.y"
         { 
	  (yyval.sym) = (yyvsp[-4].sym);
	  if ((yyvsp[-3].sym) || (yyvsp[-2].sym) || (yyvsp[-1].sym) || (yyvsp[0].sym)) {
	  	if ((yyvsp[-4].sym) != NULL &&
		    ((yyvsp[-4].sym)->token == SQL_SELECT ||
		     (yyvsp[-4].sym)->token == SQL_UNION  ||
		     (yyvsp[-4].sym)->token == SQL_EXCEPT ||
		     (yyvsp[-4].sym)->token == SQL_INTERSECT)) {
			if ((yyvsp[-4].sym)->token == SQL_SELECT) {
	 			SelectNode *s = (SelectNode*)(yyvsp[-4].sym);
	
	  			s -> orderby = (yyvsp[-3].sym);
	  			s -> limit = (yyvsp[-2].sym);
	  			s -> offset = (yyvsp[-1].sym);
	  			s -> sample = (yyvsp[0].sym);
			} else { /* Add extra select * from .. in case of UNION, EXCEPT, INTERSECT */
				(yyval.sym) = newSelectNode( 
					SA, 0, 
					append_symbol(L(), _symbol_create_list(SQL_TABLE, append_string(append_string(L(),NULL),NULL))), NULL,
					_symbol_create_list( SQL_FROM, append_symbol(L(), (yyvsp[-4].sym))), NULL, NULL, NULL, (yyvsp[-3].sym), _symbol_create_list(SQL_NAME, append_list(append_string(L(),"inner"),NULL)), (yyvsp[-2].sym), (yyvsp[-1].sym), (yyvsp[0].sym));
			}
	  	} else {
			yyerror(m, "missing SELECT operator");
			YYABORT;
	  	}
	 } 
	}
#line 10831 "y.tab.c"
    break;

  case 544: /* select_target_list: target_specification  */
#line 3106 "sql_parser.y"
                                { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 10837 "y.tab.c"
    break;

  case 545: /* select_target_list: select_target_list ',' target_specification  */
#line 3108 "sql_parser.y"
                                { (yyval.l) = append_string((yyvsp[-2].l), (yyvsp[0].sval)); }
#line 10843 "y.tab.c"
    break;

  case 547: /* select_no_parens: select_no_parens UNION set_distinct opt_corresponding select_no_parens  */
#line 3118 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-4].sym));
	  append_int(l, (yyvsp[-2].bval));
	  append_list(l, (yyvsp[-1].l));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_UNION, l); }
#line 10854 "y.tab.c"
    break;

  case 548: /* select_no_parens: select_no_parens EXCEPT set_distinct opt_corresponding select_no_parens  */
#line 3127 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-4].sym));
	  append_int(l, (yyvsp[-2].bval));
	  append_list(l, (yyvsp[-1].l));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_EXCEPT, l); }
#line 10865 "y.tab.c"
    break;

  case 549: /* select_no_parens: select_no_parens INTERSECT set_distinct opt_corresponding select_no_parens  */
#line 3136 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-4].sym));
	  append_int(l, (yyvsp[-2].bval));
	  append_list(l, (yyvsp[-1].l));
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list( SQL_INTERSECT, l); }
#line 10876 "y.tab.c"
    break;

  case 550: /* select_no_parens: '(' select_no_parens ')'  */
#line 3142 "sql_parser.y"
                             { (yyval.sym) = (yyvsp[-1].sym); }
#line 10882 "y.tab.c"
    break;

  case 552: /* set_distinct: %empty  */
#line 3147 "sql_parser.y"
                        { (yyval.bval) = TRUE; }
#line 10888 "y.tab.c"
    break;

  case 553: /* set_distinct: ALL  */
#line 3148 "sql_parser.y"
                        { (yyval.bval) = FALSE; }
#line 10894 "y.tab.c"
    break;

  case 554: /* set_distinct: DISTINCT  */
#line 3149 "sql_parser.y"
                        { (yyval.bval) = TRUE; }
#line 10900 "y.tab.c"
    break;

  case 555: /* opt_corresponding: %empty  */
#line 3154 "sql_parser.y"
                        { (yyval.l) = NULL; }
#line 10906 "y.tab.c"
    break;

  case 556: /* opt_corresponding: CORRESPONDING  */
#line 3156 "sql_parser.y"
                        { (yyval.l) = L(); }
#line 10912 "y.tab.c"
    break;

  case 557: /* opt_corresponding: CORRESPONDING BY '(' column_ref_commalist ')'  */
#line 3158 "sql_parser.y"
                        { (yyval.l) = (yyvsp[-1].l); }
#line 10918 "y.tab.c"
    break;

  case 559: /* table_exp: opt_from_clause opt_where_clause opt_group_by_clause opt_having_clause  */
#line 3168 "sql_parser.y"
        { (yyval.l) = L();
	  append_symbol((yyval.l), (yyvsp[-3].sym));
	  append_symbol((yyval.l), (yyvsp[-2].sym));
	  append_symbol((yyval.l), (yyvsp[-1].sym));
	  append_symbol((yyval.l), (yyvsp[0].sym)); }
#line 10928 "y.tab.c"
    break;

  case 560: /* opt_from_clause: %empty  */
#line 3176 "sql_parser.y"
                                 { (yyval.sym) = NULL; }
#line 10934 "y.tab.c"
    break;

  case 561: /* opt_from_clause: FROM table_ref_commalist  */
#line 3177 "sql_parser.y"
                                 { (yyval.sym) = _symbol_create_list( SQL_FROM, (yyvsp[0].l)); }
#line 10940 "y.tab.c"
    break;

  case 562: /* table_ref_commalist: table_ref  */
#line 3181 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 10946 "y.tab.c"
    break;

  case 563: /* table_ref_commalist: table_ref_commalist ',' table_ref  */
#line 3183 "sql_parser.y"
                        { (yyval.l) = append_symbol((yyvsp[-2].l), (yyvsp[0].sym)); }
#line 10952 "y.tab.c"
    break;

  case 564: /* table_ref: qname opt_table_name  */
#line 3187 "sql_parser.y"
                                { dlist *l = L();
		  		  append_list(l, (yyvsp[-1].l));
		  	  	  append_symbol(l, (yyvsp[0].sym));
		  		  (yyval.sym) = _symbol_create_list(SQL_NAME, l); }
#line 10961 "y.tab.c"
    break;

  case 565: /* table_ref: func_ref opt_table_name  */
#line 3192 "sql_parser.y"
                                { dlist *l = L();
		  		  append_symbol(l, (yyvsp[-1].sym));
		  	  	  append_symbol(l, (yyvsp[0].sym));
		  	  	  append_int(l, 0);
		  		  (yyval.sym) = _symbol_create_list(SQL_TABLE, l); }
#line 10971 "y.tab.c"
    break;

  case 566: /* table_ref: LATERAL func_ref opt_table_name  */
#line 3198 "sql_parser.y"
                                { dlist *l = L();
		  		  append_symbol(l, (yyvsp[-1].sym));
		  	  	  append_symbol(l, (yyvsp[0].sym));
		  	  	  append_int(l, 1);
		  		  (yyval.sym) = _symbol_create_list(SQL_TABLE, l); }
#line 10981 "y.tab.c"
    break;

  case 567: /* table_ref: subquery_with_orderby table_name  */
#line 3204 "sql_parser.y"
                                {
				  (yyval.sym) = (yyvsp[-1].sym);
				  if ((yyval.sym)->token == SQL_SELECT) {
				  	SelectNode *sn = (SelectNode*)(yyvsp[-1].sym);
				  	sn->name = (yyvsp[0].sym);
				  } else {
				  	append_symbol((yyvsp[-1].sym)->data.lval, (yyvsp[0].sym));
				  }
				}
#line 10995 "y.tab.c"
    break;

  case 568: /* table_ref: LATERAL subquery table_name  */
#line 3214 "sql_parser.y"
                                {
				  (yyval.sym) = (yyvsp[-1].sym);
				  if ((yyval.sym)->token == SQL_SELECT) {
				  	SelectNode *sn = (SelectNode*)(yyvsp[-1].sym);
				  	sn->name = (yyvsp[0].sym);
					sn->lateral = 1;
				  } else {
				  	append_symbol((yyvsp[-1].sym)->data.lval, (yyvsp[0].sym));
	  				append_int((yyvsp[-1].sym)->data.lval, 1);
				  }
				}
#line 11011 "y.tab.c"
    break;

  case 569: /* table_ref: subquery_with_orderby  */
#line 3226 "sql_parser.y"
                                { (yyval.sym) = NULL;
				  yyerror(m, "subquery table reference needs alias, use AS xxx");
				  YYABORT;
				}
#line 11020 "y.tab.c"
    break;

  case 570: /* table_ref: joined_table  */
#line 3230 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[0].sym);
				  append_symbol((yyvsp[0].sym)->data.lval, NULL); }
#line 11027 "y.tab.c"
    break;

  case 571: /* $@6: %empty  */
#line 3234 "sql_parser.y"
        { m->caching = 0; }
#line 11033 "y.tab.c"
    break;

  case 572: /* table_ref: '[' $@6 select_no_parens ']' table_name  */
#line 3236 "sql_parser.y"
        {
		dlist *op = L();

 	  	append_symbol(op, (yyvsp[-2].sym));
		append_symbol(op, (yyvsp[0].sym));
		(yyval.sym) = _symbol_create_list(SQL_TABLE_OPERATOR, op); 
	}
#line 11045 "y.tab.c"
    break;

  case 573: /* table_name: AS ident '(' name_commalist ')'  */
#line 3247 "sql_parser.y"
                                { dlist *l = L();
		  		  append_string(l, (yyvsp[-3].sval));
		  	  	  append_list(l, (yyvsp[-1].l));
		  		  (yyval.sym) = _symbol_create_list(SQL_NAME, l); }
#line 11054 "y.tab.c"
    break;

  case 574: /* table_name: AS ident  */
#line 3252 "sql_parser.y"
                                { dlist *l = L();
		  		  append_string(l, (yyvsp[0].sval));
		  	  	  append_list(l, NULL);
		  		  (yyval.sym) = _symbol_create_list(SQL_NAME, l); }
#line 11063 "y.tab.c"
    break;

  case 575: /* table_name: ident '(' name_commalist ')'  */
#line 3257 "sql_parser.y"
                                { dlist *l = L();
		  		  append_string(l, (yyvsp[-3].sval));
		  	  	  append_list(l, (yyvsp[-1].l));
		  		  (yyval.sym) = _symbol_create_list(SQL_NAME, l); }
#line 11072 "y.tab.c"
    break;

  case 576: /* table_name: ident  */
#line 3262 "sql_parser.y"
                                { dlist *l = L();
		  		  append_string(l, (yyvsp[0].sval));
		  	  	  append_list(l, NULL);
		  		  (yyval.sym) = _symbol_create_list(SQL_NAME, l); }
#line 11081 "y.tab.c"
    break;

  case 577: /* opt_table_name: %empty  */
#line 3269 "sql_parser.y"
                                { (yyval.sym) = NULL; }
#line 11087 "y.tab.c"
    break;

  case 578: /* opt_table_name: table_name  */
#line 3270 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[0].sym); }
#line 11093 "y.tab.c"
    break;

  case 579: /* opt_group_by_clause: %empty  */
#line 3274 "sql_parser.y"
                                  { (yyval.sym) = NULL; }
#line 11099 "y.tab.c"
    break;

  case 580: /* opt_group_by_clause: sqlGROUP BY column_ref_commalist  */
#line 3275 "sql_parser.y"
                                     { (yyval.sym) = _symbol_create_list( SQL_GROUPBY, (yyvsp[0].l) );}
#line 11105 "y.tab.c"
    break;

  case 581: /* column_ref_commalist: column_ref  */
#line 3279 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(),
			       _symbol_create_list(SQL_COLUMN,(yyvsp[0].l))); }
#line 11112 "y.tab.c"
    break;

  case 582: /* column_ref_commalist: column_ref_commalist ',' column_ref  */
#line 3282 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-2].l),
			       _symbol_create_list(SQL_COLUMN,(yyvsp[0].l))); }
#line 11119 "y.tab.c"
    break;

  case 583: /* opt_having_clause: %empty  */
#line 3287 "sql_parser.y"
                                 { (yyval.sym) = NULL; }
#line 11125 "y.tab.c"
    break;

  case 584: /* opt_having_clause: HAVING search_condition  */
#line 3288 "sql_parser.y"
                                 { (yyval.sym) = (yyvsp[0].sym); }
#line 11131 "y.tab.c"
    break;

  case 585: /* search_condition: search_condition OR and_exp  */
#line 3294 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-2].sym));
		  append_symbol(l, (yyvsp[0].sym));
		  (yyval.sym) = _symbol_create_list(SQL_OR, l ); }
#line 11140 "y.tab.c"
    break;

  case 586: /* search_condition: and_exp  */
#line 3298 "sql_parser.y"
                { (yyval.sym) = (yyvsp[0].sym); }
#line 11146 "y.tab.c"
    break;

  case 587: /* and_exp: and_exp AND pred_exp  */
#line 3303 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-2].sym));
		  append_symbol(l, (yyvsp[0].sym));
		  (yyval.sym) = _symbol_create_list(SQL_AND, l ); }
#line 11155 "y.tab.c"
    break;

  case 588: /* and_exp: pred_exp  */
#line 3307 "sql_parser.y"
                { (yyval.sym) = (yyvsp[0].sym); }
#line 11161 "y.tab.c"
    break;

  case 589: /* opt_order_by_clause: %empty  */
#line 3311 "sql_parser.y"
                                          { (yyval.sym) = NULL; }
#line 11167 "y.tab.c"
    break;

  case 590: /* opt_order_by_clause: ORDER BY sort_specification_list  */
#line 3313 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list( SQL_ORDERBY, (yyvsp[0].l)); }
#line 11173 "y.tab.c"
    break;

  case 591: /* opt_limit: %empty  */
#line 3317 "sql_parser.y"
                        { (yyval.sym) = NULL; }
#line 11179 "y.tab.c"
    break;

  case 592: /* opt_limit: LIMIT nonzerolng  */
#line 3318 "sql_parser.y"
                        { 
		  	  sql_subtype *t = sql_bind_localtype("lng");
			  (yyval.sym) = _newAtomNode( atom_int(SA, t, (yyvsp[0].l_val))); 
			}
#line 11188 "y.tab.c"
    break;

  case 593: /* opt_limit: LIMIT param  */
#line 3322 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 11194 "y.tab.c"
    break;

  case 594: /* opt_offset: %empty  */
#line 3326 "sql_parser.y"
                        { (yyval.sym) = NULL; }
#line 11200 "y.tab.c"
    break;

  case 595: /* opt_offset: OFFSET poslng  */
#line 3327 "sql_parser.y"
                        { 
		  	  sql_subtype *t = sql_bind_localtype("lng");
			  (yyval.sym) = _newAtomNode( atom_int(SA, t, (yyvsp[0].l_val))); 
			}
#line 11209 "y.tab.c"
    break;

  case 596: /* opt_offset: OFFSET param  */
#line 3331 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 11215 "y.tab.c"
    break;

  case 597: /* opt_sample: %empty  */
#line 3335 "sql_parser.y"
                        { (yyval.sym) = NULL; }
#line 11221 "y.tab.c"
    break;

  case 598: /* opt_sample: SAMPLE poslng  */
#line 3336 "sql_parser.y"
                        {
		  	  sql_subtype *t = sql_bind_localtype("lng");
			  (yyval.sym) = _newAtomNode( atom_int(SA, t, (yyvsp[0].l_val)));
			}
#line 11230 "y.tab.c"
    break;

  case 599: /* opt_sample: SAMPLE INTNUM  */
#line 3340 "sql_parser.y"
                        {
		  	  sql_subtype *t = sql_bind_localtype("dbl");
			  (yyval.sym) = _newAtomNode( atom_float(SA, t, strtod((yyvsp[0].sval),NULL)));
			}
#line 11239 "y.tab.c"
    break;

  case 600: /* opt_sample: SAMPLE param  */
#line 3344 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 11245 "y.tab.c"
    break;

  case 601: /* sort_specification_list: ordering_spec  */
#line 3348 "sql_parser.y"
                         { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 11251 "y.tab.c"
    break;

  case 602: /* sort_specification_list: sort_specification_list ',' ordering_spec  */
#line 3350 "sql_parser.y"
                         { (yyval.l) = append_symbol( (yyvsp[-2].l), (yyvsp[0].sym) ); }
#line 11257 "y.tab.c"
    break;

  case 603: /* ordering_spec: scalar_exp opt_asc_desc  */
#line 3355 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-1].sym));
	  append_int(l, (yyvsp[0].bval));
	  (yyval.sym) = _symbol_create_list(SQL_COLUMN, l ); }
#line 11266 "y.tab.c"
    break;

  case 604: /* opt_asc_desc: %empty  */
#line 3363 "sql_parser.y"
                        { (yyval.bval) = TRUE; }
#line 11272 "y.tab.c"
    break;

  case 605: /* opt_asc_desc: ASC  */
#line 3364 "sql_parser.y"
                        { (yyval.bval) = TRUE; }
#line 11278 "y.tab.c"
    break;

  case 606: /* opt_asc_desc: DESC  */
#line 3365 "sql_parser.y"
                        { (yyval.bval) = FALSE; }
#line 11284 "y.tab.c"
    break;

  case 616: /* pred_exp: NOT pred_exp  */
#line 3382 "sql_parser.y"
                { (yyval.sym) = (yyvsp[0].sym);

		  if ((yyval.sym)->token == SQL_EXISTS)
			(yyval.sym)->token = SQL_NOT_EXISTS;
		  else if ((yyval.sym)->token == SQL_NOT_EXISTS)
			(yyval.sym)->token = SQL_EXISTS;
		  else if ((yyval.sym)->token == SQL_NOT_BETWEEN)
			(yyval.sym)->token = SQL_BETWEEN;
		  else if ((yyval.sym)->token == SQL_BETWEEN)
			(yyval.sym)->token = SQL_NOT_BETWEEN;
		  else if ((yyval.sym)->token == SQL_NOT_LIKE)
			(yyval.sym)->token = SQL_LIKE;
		  else if ((yyval.sym)->token == SQL_LIKE)
			(yyval.sym)->token = SQL_NOT_LIKE;
		  else
			(yyval.sym) = _symbol_create_symbol(SQL_NOT, (yyvsp[0].sym)); }
#line 11305 "y.tab.c"
    break;

  case 617: /* pred_exp: predicate  */
#line 3398 "sql_parser.y"
                { (yyval.sym) = (yyvsp[0].sym); }
#line 11311 "y.tab.c"
    break;

  case 618: /* comparison_predicate: pred_exp COMPARISON pred_exp  */
#line 3403 "sql_parser.y"
                { dlist *l = L();

		  append_symbol(l, (yyvsp[-2].sym));
		  append_string(l, (yyvsp[-1].sval));
		  append_symbol(l, (yyvsp[0].sym));
		  (yyval.sym) = _symbol_create_list(SQL_COMPARE, l ); }
#line 11322 "y.tab.c"
    break;

  case 619: /* comparison_predicate: pred_exp '=' pred_exp  */
#line 3410 "sql_parser.y"
                { dlist *l = L();

		  append_symbol(l, (yyvsp[-2].sym));
		  append_string(l, sa_strdup(SA, "="));
		  append_symbol(l, (yyvsp[0].sym));
		  (yyval.sym) = _symbol_create_list(SQL_COMPARE, l ); }
#line 11333 "y.tab.c"
    break;

  case 620: /* between_predicate: pred_exp NOT_BETWEEN opt_bounds pred_exp AND pred_exp  */
#line 3420 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-5].sym));
		  append_int(l, (yyvsp[-3].i_val));
		  append_symbol(l, (yyvsp[-2].sym));
		  append_symbol(l, (yyvsp[0].sym));
		  (yyval.sym) = _symbol_create_list(SQL_NOT_BETWEEN, l ); }
#line 11344 "y.tab.c"
    break;

  case 621: /* between_predicate: pred_exp BETWEEN opt_bounds pred_exp AND pred_exp  */
#line 3427 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-5].sym));
		  append_int(l, (yyvsp[-3].i_val));
		  append_symbol(l, (yyvsp[-2].sym));
		  append_symbol(l, (yyvsp[0].sym));
		  (yyval.sym) = _symbol_create_list(SQL_BETWEEN, l ); }
#line 11355 "y.tab.c"
    break;

  case 622: /* opt_bounds: %empty  */
#line 3436 "sql_parser.y"
                { (yyval.i_val) = 0; }
#line 11361 "y.tab.c"
    break;

  case 623: /* opt_bounds: ASYMMETRIC  */
#line 3437 "sql_parser.y"
                { (yyval.i_val) = 0; }
#line 11367 "y.tab.c"
    break;

  case 624: /* opt_bounds: SYMMETRIC  */
#line 3438 "sql_parser.y"
                { (yyval.i_val) = 1; }
#line 11373 "y.tab.c"
    break;

  case 625: /* like_predicate: pred_exp NOT_LIKE like_exp  */
#line 3443 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-2].sym));
		  append_symbol(l, (yyvsp[0].sym));
		  append_int(l, FALSE);  /* case sensitive */
		  append_int(l, TRUE);  /* anti */
		  (yyval.sym) = _symbol_create_list( SQL_LIKE, l ); }
#line 11384 "y.tab.c"
    break;

  case 626: /* like_predicate: pred_exp NOT_ILIKE like_exp  */
#line 3450 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-2].sym));
		  append_symbol(l, (yyvsp[0].sym));
		  append_int(l, TRUE);  /* case insensitive */
		  append_int(l, TRUE);  /* anti */
		  (yyval.sym) = _symbol_create_list( SQL_LIKE, l ); }
#line 11395 "y.tab.c"
    break;

  case 627: /* like_predicate: pred_exp LIKE like_exp  */
#line 3457 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-2].sym));
		  append_symbol(l, (yyvsp[0].sym));
		  append_int(l, FALSE);  /* case sensitive */
		  append_int(l, FALSE);  /* anti */
		  (yyval.sym) = _symbol_create_list( SQL_LIKE, l ); }
#line 11406 "y.tab.c"
    break;

  case 628: /* like_predicate: pred_exp ILIKE like_exp  */
#line 3464 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-2].sym));
		  append_symbol(l, (yyvsp[0].sym));
		  append_int(l, TRUE);  /* case insensitive */
		  append_int(l, FALSE);  /* anti */
		  (yyval.sym) = _symbol_create_list( SQL_LIKE, l ); }
#line 11417 "y.tab.c"
    break;

  case 629: /* like_exp: scalar_exp  */
#line 3474 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[0].sym));
	  (yyval.sym) = _symbol_create_list(SQL_ESCAPE, l ); }
#line 11425 "y.tab.c"
    break;

  case 630: /* like_exp: scalar_exp ESCAPE string  */
#line 3478 "sql_parser.y"
        { const char *s = sql2str((yyvsp[0].sval));
	  if (_strlen(s) != 1) {
		yyerror(m, "\b22025!ESCAPE must be one character");
		(yyval.sym) = NULL;
		YYABORT;
	  } else {
		dlist *l = L();
		append_symbol(l, (yyvsp[-2].sym));
		append_string(l, s);
		(yyval.sym) = _symbol_create_list(SQL_ESCAPE, l);
	  }
	}
#line 11442 "y.tab.c"
    break;

  case 631: /* test_for_null: scalar_exp IS NOT sqlNULL  */
#line 3493 "sql_parser.y"
                              { (yyval.sym) = _symbol_create_symbol( SQL_IS_NOT_NULL, (yyvsp[-3].sym) );}
#line 11448 "y.tab.c"
    break;

  case 632: /* test_for_null: scalar_exp IS sqlNULL  */
#line 3494 "sql_parser.y"
                              { (yyval.sym) = _symbol_create_symbol( SQL_IS_NULL, (yyvsp[-2].sym) ); }
#line 11454 "y.tab.c"
    break;

  case 633: /* in_predicate: pred_exp NOT_IN '(' value_commalist ')'  */
#line 3499 "sql_parser.y"
                { dlist *l = L();

		  append_symbol(l, (yyvsp[-4].sym));
		  append_list(l, (yyvsp[-1].l));
		  (yyval.sym) = _symbol_create_list(SQL_NOT_IN, l ); }
#line 11464 "y.tab.c"
    break;

  case 634: /* in_predicate: pred_exp sqlIN '(' value_commalist ')'  */
#line 3505 "sql_parser.y"
                { dlist *l = L();

		  append_symbol(l, (yyvsp[-4].sym));
		  append_list(l, (yyvsp[-1].l));
		  (yyval.sym) = _symbol_create_list(SQL_IN, l ); }
#line 11474 "y.tab.c"
    break;

  case 635: /* in_predicate: '(' pred_exp_list ')' NOT_IN '(' value_commalist ')'  */
#line 3511 "sql_parser.y"
                { dlist *l = L();
		  append_list(l, (yyvsp[-5].l));
		  append_list(l, (yyvsp[-1].l));
		  (yyval.sym) = _symbol_create_list(SQL_NOT_IN, l ); }
#line 11483 "y.tab.c"
    break;

  case 636: /* in_predicate: '(' pred_exp_list ')' sqlIN '(' value_commalist ')'  */
#line 3516 "sql_parser.y"
                { dlist *l = L();
		  append_list(l, (yyvsp[-5].l));
		  append_list(l, (yyvsp[-1].l));
		  (yyval.sym) = _symbol_create_list(SQL_IN, l ); }
#line 11492 "y.tab.c"
    break;

  case 637: /* pred_exp_list: pred_exp  */
#line 3524 "sql_parser.y"
                        { (yyval.l) = append_symbol( L(), (yyvsp[0].sym));}
#line 11498 "y.tab.c"
    break;

  case 638: /* pred_exp_list: pred_exp_list ',' pred_exp  */
#line 3526 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-2].l), (yyvsp[0].sym)); }
#line 11504 "y.tab.c"
    break;

  case 639: /* all_or_any_predicate: pred_exp COMPARISON any_all_some subquery  */
#line 3532 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-3].sym));
		  append_string(l, (yyvsp[-2].sval));
		  append_symbol(l, (yyvsp[0].sym));
		  append_int(l, (yyvsp[-1].i_val));
		  (yyval.sym) = _symbol_create_list(SQL_COMPARE, l ); }
#line 11515 "y.tab.c"
    break;

  case 640: /* all_or_any_predicate: pred_exp '=' any_all_some pred_exp  */
#line 3539 "sql_parser.y"
                { dlist *l = L();
		  append_symbol(l, (yyvsp[-3].sym));
		  append_string(l, sa_strdup(SA, "="));
		  append_symbol(l, (yyvsp[0].sym));
		  append_int(l, (yyvsp[-1].i_val));
		  (yyval.sym) = _symbol_create_list(SQL_COMPARE, l ); }
#line 11526 "y.tab.c"
    break;

  case 641: /* any_all_some: ANY  */
#line 3548 "sql_parser.y"
                { (yyval.i_val) = 0; }
#line 11532 "y.tab.c"
    break;

  case 642: /* any_all_some: SOME  */
#line 3549 "sql_parser.y"
                { (yyval.i_val) = 0; }
#line 11538 "y.tab.c"
    break;

  case 643: /* any_all_some: ALL  */
#line 3550 "sql_parser.y"
                { (yyval.i_val) = 1; }
#line 11544 "y.tab.c"
    break;

  case 644: /* existence_test: EXISTS subquery  */
#line 3554 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_symbol( SQL_EXISTS, (yyvsp[0].sym) ); }
#line 11550 "y.tab.c"
    break;

  case 645: /* filter_arg_list: pred_exp  */
#line 3558 "sql_parser.y"
                                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 11556 "y.tab.c"
    break;

  case 646: /* filter_arg_list: filter_arg_list ',' pred_exp  */
#line 3559 "sql_parser.y"
                                        { (yyval.l) = append_symbol((yyvsp[-2].l), (yyvsp[0].sym));  }
#line 11562 "y.tab.c"
    break;

  case 647: /* filter_args: '[' filter_arg_list ']'  */
#line 3563 "sql_parser.y"
                                        { (yyval.l) = (yyvsp[-1].l); }
#line 11568 "y.tab.c"
    break;

  case 648: /* filter_exp: filter_args qname filter_args  */
#line 3568 "sql_parser.y"
                { dlist *l = L();
		  append_list(l, (yyvsp[-2].l));
		  append_list(l, (yyvsp[-1].l));
		  append_list(l, (yyvsp[0].l));
		  (yyval.sym) = _symbol_create_list(SQL_FILTER, l ); }
#line 11578 "y.tab.c"
    break;

  case 649: /* subquery_with_orderby: '(' select_no_parens_orderby ')'  */
#line 3577 "sql_parser.y"
                                        { (yyval.sym) = (yyvsp[-1].sym); }
#line 11584 "y.tab.c"
    break;

  case 650: /* subquery_with_orderby: '(' VALUES row_commalist ')'  */
#line 3579 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list( SQL_VALUES, (yyvsp[-1].l)); }
#line 11590 "y.tab.c"
    break;

  case 651: /* subquery_with_orderby: '(' with_query ')'  */
#line 3581 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[-1].sym); }
#line 11596 "y.tab.c"
    break;

  case 652: /* subquery: '(' select_no_parens ')'  */
#line 3585 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[-1].sym); }
#line 11602 "y.tab.c"
    break;

  case 653: /* subquery: '(' VALUES row_commalist ')'  */
#line 3587 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list( SQL_VALUES, (yyvsp[-1].l)); }
#line 11608 "y.tab.c"
    break;

  case 654: /* subquery: '(' with_query ')'  */
#line 3589 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[-1].sym); }
#line 11614 "y.tab.c"
    break;

  case 656: /* simple_scalar_exp: scalar_exp '+' scalar_exp  */
#line 3596 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "sql_add")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11625 "y.tab.c"
    break;

  case 657: /* simple_scalar_exp: scalar_exp '-' scalar_exp  */
#line 3603 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "sql_sub")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11636 "y.tab.c"
    break;

  case 658: /* simple_scalar_exp: scalar_exp '*' scalar_exp  */
#line 3610 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "sql_mul")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11647 "y.tab.c"
    break;

  case 659: /* simple_scalar_exp: scalar_exp '/' scalar_exp  */
#line 3617 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "sql_div")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11658 "y.tab.c"
    break;

  case 660: /* simple_scalar_exp: scalar_exp '%' scalar_exp  */
#line 3624 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "mod")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11669 "y.tab.c"
    break;

  case 661: /* simple_scalar_exp: scalar_exp '^' scalar_exp  */
#line 3631 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "bit_xor")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11680 "y.tab.c"
    break;

  case 662: /* simple_scalar_exp: scalar_exp '&' scalar_exp  */
#line 3638 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "bit_and")));
	  		  append_symbol(l, (yyvsp[-2].sym));
			  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11691 "y.tab.c"
    break;

  case 663: /* simple_scalar_exp: scalar_exp GEOM_OVERLAP scalar_exp  */
#line 3645 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(L(), sa_strdup(SA, "mbr_overlap")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11702 "y.tab.c"
    break;

  case 664: /* simple_scalar_exp: scalar_exp GEOM_OVERLAP_OR_LEFT scalar_exp  */
#line 3652 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(L(), sa_strdup(SA, "mbr_overlap_or_left")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11713 "y.tab.c"
    break;

  case 665: /* simple_scalar_exp: scalar_exp GEOM_OVERLAP_OR_RIGHT scalar_exp  */
#line 3659 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(L(), sa_strdup(SA, "mbr_overlap_or_right")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11724 "y.tab.c"
    break;

  case 666: /* simple_scalar_exp: scalar_exp GEOM_OVERLAP_OR_BELOW scalar_exp  */
#line 3666 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(L(), sa_strdup(SA, "mbr_overlap_or_below")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11735 "y.tab.c"
    break;

  case 667: /* simple_scalar_exp: scalar_exp GEOM_BELOW scalar_exp  */
#line 3673 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, append_string(L(), sa_strdup(SA, "mbr_below")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11745 "y.tab.c"
    break;

  case 668: /* simple_scalar_exp: scalar_exp GEOM_OVERLAP_OR_ABOVE scalar_exp  */
#line 3679 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(L(), sa_strdup(SA, "mbr_overlap_or_above")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11756 "y.tab.c"
    break;

  case 669: /* simple_scalar_exp: scalar_exp GEOM_ABOVE scalar_exp  */
#line 3686 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(L(), sa_strdup(SA, "mbr_above")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11767 "y.tab.c"
    break;

  case 670: /* simple_scalar_exp: scalar_exp GEOM_DIST scalar_exp  */
#line 3693 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(L(), sa_strdup(SA, "mbr_distance")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11778 "y.tab.c"
    break;

  case 671: /* simple_scalar_exp: scalar_exp AT scalar_exp  */
#line 3700 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(L(), sa_strdup(SA, "mbr_contained")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11789 "y.tab.c"
    break;

  case 672: /* simple_scalar_exp: scalar_exp '|' scalar_exp  */
#line 3707 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "bit_or")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11800 "y.tab.c"
    break;

  case 673: /* simple_scalar_exp: scalar_exp '~' scalar_exp  */
#line 3714 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(L(), sa_strdup(SA, "mbr_contains")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11811 "y.tab.c"
    break;

  case 674: /* simple_scalar_exp: scalar_exp GEOM_MBR_EQUAL scalar_exp  */
#line 3721 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(L(), sa_strdup(SA, "mbr_equal")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11822 "y.tab.c"
    break;

  case 675: /* simple_scalar_exp: '~' scalar_exp  */
#line 3728 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "bit_not")));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_UNOP, l ); }
#line 11832 "y.tab.c"
    break;

  case 676: /* simple_scalar_exp: scalar_exp LEFT_SHIFT scalar_exp  */
#line 3734 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "left_shift")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11843 "y.tab.c"
    break;

  case 677: /* simple_scalar_exp: scalar_exp RIGHT_SHIFT scalar_exp  */
#line 3741 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "right_shift")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11854 "y.tab.c"
    break;

  case 678: /* simple_scalar_exp: scalar_exp LEFT_SHIFT_ASSIGN scalar_exp  */
#line 3748 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "left_shift_assign")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11865 "y.tab.c"
    break;

  case 679: /* simple_scalar_exp: scalar_exp RIGHT_SHIFT_ASSIGN scalar_exp  */
#line 3755 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l, 
			  	append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "right_shift_assign")));
	  		  append_symbol(l, (yyvsp[-2].sym));
	  		  append_symbol(l, (yyvsp[0].sym));
	  		  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 11876 "y.tab.c"
    break;

  case 680: /* simple_scalar_exp: '+' scalar_exp  */
#line 3762 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 11882 "y.tab.c"
    break;

  case 681: /* simple_scalar_exp: '-' scalar_exp  */
#line 3764 "sql_parser.y"
                        { 
 			  (yyval.sym) = NULL;
			  assert((yyvsp[0].sym)->token != SQL_COLUMN || (yyvsp[0].sym)->data.lval->h->type != type_lng);
			  if ((yyvsp[0].sym)->token == SQL_COLUMN && (yyvsp[0].sym)->data.lval->h->type == type_int) {
				atom *a = sql_bind_arg(m, (yyvsp[0].sym)->data.lval->h->data.i_val);
				if (!atom_neg(a)) {
					(yyval.sym) = (yyvsp[0].sym);
				} else {
					yyerror(m, "\b22003!value too large or not a number");
					(yyval.sym) = NULL;
					YYABORT;
				}
			  } 
			  if (!(yyval.sym)) {
				dlist *l = L();
			  	append_list(l, 
			  		append_string(append_string(L(), sa_strdup(SA, "sys")), sa_strdup(SA, "sql_neg")));
	  		  	append_symbol(l, (yyvsp[0].sym));
	  		  	(yyval.sym) = _symbol_create_list( SQL_UNOP, l ); 
			  }
			}
#line 11908 "y.tab.c"
    break;

  case 682: /* simple_scalar_exp: '(' search_condition ')'  */
#line 3785 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[-1].sym); }
#line 11914 "y.tab.c"
    break;

  case 683: /* scalar_exp: simple_scalar_exp  */
#line 3789 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 11920 "y.tab.c"
    break;

  case 686: /* value_exp: user  */
#line 3795 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_COLUMN, 
			  append_string(L(), sa_strdup(SA, "current_user"))); }
#line 11927 "y.tab.c"
    break;

  case 687: /* value_exp: CURRENT_ROLE  */
#line 3797 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_COLUMN, 
			  append_string(L(), sa_strdup(SA, "current_role"))); }
#line 11934 "y.tab.c"
    break;

  case 689: /* value_exp: column_ref  */
#line 3800 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_COLUMN, (yyvsp[0].l)); }
#line 11940 "y.tab.c"
    break;

  case 693: /* value_exp: NEXT VALUE FOR qname  */
#line 3804 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list( SQL_NEXT, (yyvsp[0].l)); }
#line 11946 "y.tab.c"
    break;

  case 701: /* param: '?'  */
#line 3816 "sql_parser.y"
        { 
	  int nr = (m->params)?list_length(m->params):0;

	  sql_add_param(m, NULL, NULL);
	  (yyval.sym) = _symbol_create_int( SQL_PARAMETER, nr ); 
	}
#line 11957 "y.tab.c"
    break;

  case 702: /* window_function: window_function_type OVER '(' window_specification ')'  */
#line 3886 "sql_parser.y"
        { (yyval.sym) = _symbol_create_list( SQL_RANK, 
		append_list(append_symbol(L(), (yyvsp[-4].sym)), (yyvsp[-1].l))); }
#line 11964 "y.tab.c"
    break;

  case 703: /* window_function_type: qrank '(' ')'  */
#line 3891 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_RANK, (yyvsp[-2].l) ); }
#line 11970 "y.tab.c"
    break;

  case 705: /* window_specification: window_partition_clause window_order_clause window_frame_clause  */
#line 3897 "sql_parser.y"
        { (yyval.l) = append_symbol(append_symbol(append_symbol(L(), (yyvsp[-2].sym)), (yyvsp[-1].sym)), (yyvsp[0].sym)); }
#line 11976 "y.tab.c"
    break;

  case 706: /* window_partition_clause: %empty  */
#line 3901 "sql_parser.y"
                        { (yyval.sym) = NULL; }
#line 11982 "y.tab.c"
    break;

  case 707: /* window_partition_clause: PARTITION BY column_ref_commalist  */
#line 3903 "sql_parser.y"
        { (yyval.sym) = _symbol_create_list( SQL_GROUPBY, (yyvsp[0].l) ); }
#line 11988 "y.tab.c"
    break;

  case 708: /* window_order_clause: %empty  */
#line 3907 "sql_parser.y"
                        { (yyval.sym) = NULL; }
#line 11994 "y.tab.c"
    break;

  case 709: /* window_order_clause: ORDER BY sort_specification_list  */
#line 3909 "sql_parser.y"
        { (yyval.sym) = _symbol_create_list( SQL_ORDERBY, (yyvsp[0].l) ); }
#line 12000 "y.tab.c"
    break;

  case 710: /* window_frame_clause: %empty  */
#line 3913 "sql_parser.y"
                        { (yyval.sym) = NULL; }
#line 12006 "y.tab.c"
    break;

  case 711: /* window_frame_clause: window_frame_units window_frame_extent window_frame_exclusion  */
#line 3915 "sql_parser.y"
        { (yyval.sym) = _symbol_create_list( SQL_FRAME, append_int(append_int((yyvsp[-1].l), (yyvsp[-2].i_val)), (yyvsp[0].i_val))); }
#line 12012 "y.tab.c"
    break;

  case 712: /* window_frame_units: ROWS  */
#line 3919 "sql_parser.y"
                        { (yyval.i_val) = FRAME_ROWS; }
#line 12018 "y.tab.c"
    break;

  case 713: /* window_frame_units: RANGE  */
#line 3920 "sql_parser.y"
                        { (yyval.i_val) = FRAME_RANGE; }
#line 12024 "y.tab.c"
    break;

  case 714: /* window_frame_extent: window_frame_start  */
#line 3924 "sql_parser.y"
                                { (yyval.l) = append_symbol(append_symbol(L(), (yyvsp[0].sym)), _symbol_create_int(SQL_FRAME, -1)); }
#line 12030 "y.tab.c"
    break;

  case 715: /* window_frame_extent: window_frame_between  */
#line 3925 "sql_parser.y"
                                { (yyval.l) = (yyvsp[0].l); }
#line 12036 "y.tab.c"
    break;

  case 716: /* window_frame_start: UNBOUNDED PRECEDING  */
#line 3929 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_int(SQL_FRAME, -1); }
#line 12042 "y.tab.c"
    break;

  case 717: /* window_frame_start: window_frame_preceding  */
#line 3930 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[0].sym); }
#line 12048 "y.tab.c"
    break;

  case 718: /* window_frame_start: CURRENT ROW  */
#line 3931 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_int(SQL_FRAME, 0); }
#line 12054 "y.tab.c"
    break;

  case 719: /* window_frame_preceding: value_exp PRECEDING  */
#line 3935 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[-1].sym); }
#line 12060 "y.tab.c"
    break;

  case 720: /* window_frame_between: BETWEEN window_frame_start AND window_frame_end  */
#line 3940 "sql_parser.y"
                                { (yyval.l) = append_symbol(append_symbol(L(), (yyvsp[-2].sym)), (yyvsp[0].sym)); }
#line 12066 "y.tab.c"
    break;

  case 721: /* window_frame_end: UNBOUNDED FOLLOWING  */
#line 3944 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_int(SQL_FRAME, -1); }
#line 12072 "y.tab.c"
    break;

  case 722: /* window_frame_end: window_frame_following  */
#line 3945 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[0].sym); }
#line 12078 "y.tab.c"
    break;

  case 723: /* window_frame_end: CURRENT ROW  */
#line 3946 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_int(SQL_FRAME, 0); }
#line 12084 "y.tab.c"
    break;

  case 724: /* window_frame_following: value_exp FOLLOWING  */
#line 3950 "sql_parser.y"
                                { (yyval.sym) = (yyvsp[-1].sym); }
#line 12090 "y.tab.c"
    break;

  case 725: /* window_frame_exclusion: %empty  */
#line 3954 "sql_parser.y"
                                { (yyval.i_val) = EXCLUDE_NONE; }
#line 12096 "y.tab.c"
    break;

  case 726: /* window_frame_exclusion: EXCLUDE CURRENT ROW  */
#line 3955 "sql_parser.y"
                                { (yyval.i_val) = EXCLUDE_CURRENT_ROW; }
#line 12102 "y.tab.c"
    break;

  case 727: /* window_frame_exclusion: EXCLUDE sqlGROUP  */
#line 3956 "sql_parser.y"
                                { (yyval.i_val) = EXCLUDE_GROUP; }
#line 12108 "y.tab.c"
    break;

  case 728: /* window_frame_exclusion: EXCLUDE TIES  */
#line 3957 "sql_parser.y"
                                { (yyval.i_val) = EXCLUDE_TIES; }
#line 12114 "y.tab.c"
    break;

  case 729: /* window_frame_exclusion: EXCLUDE NO OTHERS  */
#line 3958 "sql_parser.y"
                                { (yyval.i_val) = EXCLUDE_NO_OTHERS; }
#line 12120 "y.tab.c"
    break;

  case 730: /* var_ref: AT ident  */
#line 3962 "sql_parser.y"
                        { (yyval.sym) = _symbol_create( SQL_NAME, (yyvsp[0].sval) ); }
#line 12126 "y.tab.c"
    break;

  case 731: /* func_ref: qfunc '(' ')'  */
#line 3967 "sql_parser.y"
        { dlist *l = L();
  	  append_list(l, (yyvsp[-2].l));
	  (yyval.sym) = _symbol_create_list( SQL_OP, l ); }
#line 12134 "y.tab.c"
    break;

  case 732: /* func_ref: qfunc '(' scalar_exp_list ')'  */
#line 3971 "sql_parser.y"
        { dlist *l = L();
  	  append_list(l, (yyvsp[-3].l));
	  if (dlist_length((yyvsp[-1].l)) == 1) {
  	  	append_symbol(l, (yyvsp[-1].l)->h->data.sym);
	  	(yyval.sym) = _symbol_create_list( SQL_UNOP, l ); 
	  } else if (dlist_length((yyvsp[-1].l)) == 2) {
  	  	append_symbol(l, (yyvsp[-1].l)->h->data.sym);
  	  	append_symbol(l, (yyvsp[-1].l)->h->next->data.sym);
	  	(yyval.sym) = _symbol_create_list( SQL_BINOP, l ); 
	  } else {
  	  	append_list(l, (yyvsp[-1].l));
	  	(yyval.sym) = _symbol_create_list( SQL_NOP, l ); 
	  }
	}
#line 12153 "y.tab.c"
    break;

  case 733: /* qfunc: func_ident  */
#line 3998 "sql_parser.y"
                                { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 12159 "y.tab.c"
    break;

  case 734: /* qfunc: ident '.' func_ident  */
#line 3999 "sql_parser.y"
                                { (yyval.l) = append_string(
					append_string(L(), (yyvsp[-2].sval)), (yyvsp[0].sval));}
#line 12166 "y.tab.c"
    break;

  case 735: /* func_ident: ident  */
#line 4004 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 12172 "y.tab.c"
    break;

  case 736: /* func_ident: LEFT  */
#line 4005 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "left"); }
#line 12178 "y.tab.c"
    break;

  case 737: /* func_ident: RIGHT  */
#line 4006 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "right"); }
#line 12184 "y.tab.c"
    break;

  case 738: /* func_ident: INSERT  */
#line 4007 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "insert"); }
#line 12190 "y.tab.c"
    break;

  case 739: /* datetime_funcs: EXTRACT '(' datetime_field FROM scalar_exp ')'  */
#line 4012 "sql_parser.y"
                        { dlist *l = L();
			  const char *ident = datetime_field((itype)(yyvsp[-3].i_val));
			  append_list(l,
  		  	  	append_string(L(), sa_strdup(SA, ident)));
  		  	  append_symbol(l, (yyvsp[-1].sym));
		  	  (yyval.sym) = _symbol_create_list( SQL_UNOP, l ); }
#line 12201 "y.tab.c"
    break;

  case 740: /* datetime_funcs: CURRENT_DATE opt_brackets  */
#line 4019 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l,
			  	append_string(L(), sa_strdup(SA, "current_date")));
	  		  (yyval.sym) = _symbol_create_list( SQL_OP, l ); }
#line 12210 "y.tab.c"
    break;

  case 741: /* datetime_funcs: CURRENT_TIME opt_brackets  */
#line 4024 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l,
			  	append_string(L(), sa_strdup(SA, "current_time")));
	  		  (yyval.sym) = _symbol_create_list( SQL_OP, l ); }
#line 12219 "y.tab.c"
    break;

  case 742: /* datetime_funcs: CURRENT_TIMESTAMP opt_brackets  */
#line 4029 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l,
			  	append_string(L(), sa_strdup(SA, "current_timestamp")));
	  		  (yyval.sym) = _symbol_create_list( SQL_OP, l ); }
#line 12228 "y.tab.c"
    break;

  case 743: /* datetime_funcs: LOCALTIME opt_brackets  */
#line 4034 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l,
			  	append_string(L(), sa_strdup(SA, "localtime")));
	  		  (yyval.sym) = _symbol_create_list( SQL_OP, l ); }
#line 12237 "y.tab.c"
    break;

  case 744: /* datetime_funcs: LOCALTIMESTAMP opt_brackets  */
#line 4039 "sql_parser.y"
                        { dlist *l = L();
			  append_list(l,
			  	append_string(L(), sa_strdup(SA, "localtimestamp")));
	  		  (yyval.sym) = _symbol_create_list( SQL_OP, l ); }
#line 12246 "y.tab.c"
    break;

  case 745: /* opt_brackets: %empty  */
#line 4046 "sql_parser.y"
                { (yyval.bval) = 0; }
#line 12252 "y.tab.c"
    break;

  case 746: /* opt_brackets: '(' ')'  */
#line 4047 "sql_parser.y"
                { (yyval.bval) = 1; }
#line 12258 "y.tab.c"
    break;

  case 747: /* string_funcs: SUBSTRING '(' scalar_exp FROM scalar_exp FOR scalar_exp ')'  */
#line 4052 "sql_parser.y"
                        { dlist *l = L();
			  dlist *ops = L();
  		  	  append_list(l,
				append_string(L(), sa_strdup(SA, "substring")));
  		  	  append_symbol(ops, (yyvsp[-5].sym));
  		  	  append_symbol(ops, (yyvsp[-3].sym));
  		  	  append_symbol(ops, (yyvsp[-1].sym));
			  append_list(l, ops);
		  	  (yyval.sym) = _symbol_create_list( SQL_NOP, l ); }
#line 12272 "y.tab.c"
    break;

  case 748: /* string_funcs: SUBSTRING '(' scalar_exp ',' scalar_exp ',' scalar_exp ')'  */
#line 4062 "sql_parser.y"
                        { dlist *l = L();
			  dlist *ops = L();
  		  	  append_list(l,
  		  	  	append_string(L(), sa_strdup(SA, "substring")));
  		  	  append_symbol(ops, (yyvsp[-5].sym));
  		  	  append_symbol(ops, (yyvsp[-3].sym));
  		  	  append_symbol(ops, (yyvsp[-1].sym));
			  append_list(l, ops);
		  	  (yyval.sym) = _symbol_create_list( SQL_NOP, l ); }
#line 12286 "y.tab.c"
    break;

  case 749: /* string_funcs: SUBSTRING '(' scalar_exp FROM scalar_exp ')'  */
#line 4072 "sql_parser.y"
                        { dlist *l = L();
  		  	  append_list(l,
  		  	  	append_string(L(), sa_strdup(SA, "substring")));
  		  	  append_symbol(l, (yyvsp[-3].sym));
  		  	  append_symbol(l, (yyvsp[-1].sym));
		  	  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 12297 "y.tab.c"
    break;

  case 750: /* string_funcs: SUBSTRING '(' scalar_exp ',' scalar_exp ')'  */
#line 4079 "sql_parser.y"
                        { dlist *l = L();
  		  	  append_list(l,
  		  	  	append_string(L(), sa_strdup(SA, "substring")));
  		  	  append_symbol(l, (yyvsp[-3].sym));
  		  	  append_symbol(l, (yyvsp[-1].sym));
		  	  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 12308 "y.tab.c"
    break;

  case 751: /* string_funcs: POSITION '(' scalar_exp sqlIN scalar_exp ')'  */
#line 4086 "sql_parser.y"
                        { dlist *l = L();
  		  	  append_list(l,
  		  	  	append_string(L(), sa_strdup(SA, "locate")));
  		  	  append_symbol(l, (yyvsp[-3].sym));
  		  	  append_symbol(l, (yyvsp[-1].sym));
		  	  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 12319 "y.tab.c"
    break;

  case 752: /* string_funcs: scalar_exp CONCATSTRING scalar_exp  */
#line 4093 "sql_parser.y"
                        { dlist *l = L();
  		  	  append_list(l,
  		  	  	append_string(L(), sa_strdup(SA, "concat")));
  		  	  append_symbol(l, (yyvsp[-2].sym));
  		  	  append_symbol(l, (yyvsp[0].sym));
		  	  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 12330 "y.tab.c"
    break;

  case 753: /* string_funcs: SPLIT_PART '(' scalar_exp ',' scalar_exp ',' scalar_exp ')'  */
#line 4100 "sql_parser.y"
                        { dlist *l = L();
			  dlist *ops = L();
  		  	  append_list(l,
				append_string(L(), sa_strdup(SA, "splitpart")));
  		  	  append_symbol(ops, (yyvsp[-5].sym));
  		  	  append_symbol(ops, (yyvsp[-3].sym));
  		  	  append_symbol(ops, (yyvsp[-1].sym));
			  append_list(l, ops);
		  	  (yyval.sym) = _symbol_create_list( SQL_NOP, l ); }
#line 12344 "y.tab.c"
    break;

  case 754: /* column_exp_commalist: column_exp  */
#line 4112 "sql_parser.y"
                        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym) ); }
#line 12350 "y.tab.c"
    break;

  case 755: /* column_exp_commalist: column_exp_commalist ',' column_exp  */
#line 4114 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-2].l), (yyvsp[0].sym) ); }
#line 12356 "y.tab.c"
    break;

  case 756: /* column_exp: '*'  */
#line 4119 "sql_parser.y"
                { dlist *l = L();
  		  append_string(l, NULL);
  		  append_string(l, NULL);
  		  (yyval.sym) = _symbol_create_list( SQL_TABLE, l ); }
#line 12365 "y.tab.c"
    break;

  case 757: /* column_exp: ident '.' '*'  */
#line 4124 "sql_parser.y"
                { dlist *l = L();
  		  append_string(l, (yyvsp[-2].sval));
  		  append_string(l, NULL);
  		  (yyval.sym) = _symbol_create_list( SQL_TABLE, l ); }
#line 12374 "y.tab.c"
    break;

  case 758: /* column_exp: func_ref '.' '*'  */
#line 4129 "sql_parser.y"
                { dlist *l = L();
  		  append_symbol(l, (yyvsp[-2].sym));
  		  append_string(l, NULL);
  		  (yyval.sym) = _symbol_create_list( SQL_TABLE, l ); }
#line 12383 "y.tab.c"
    break;

  case 759: /* column_exp: search_condition opt_alias_name  */
#line 4134 "sql_parser.y"
                { dlist *l = L();
  		  append_symbol(l, (yyvsp[-1].sym));
  		  append_string(l, (yyvsp[0].sval));
  		  (yyval.sym) = _symbol_create_list( SQL_COLUMN, l ); }
#line 12392 "y.tab.c"
    break;

  case 760: /* opt_alias_name: %empty  */
#line 4141 "sql_parser.y"
                { (yyval.sval) = NULL; }
#line 12398 "y.tab.c"
    break;

  case 761: /* opt_alias_name: AS ident  */
#line 4142 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 12404 "y.tab.c"
    break;

  case 762: /* atom: literal  */
#line 4147 "sql_parser.y"
        { 
	  if (m->emode == m_normal && m->caching) { 
	  	/* replace by argument */
	  	AtomNode *an = (AtomNode*)(yyvsp[0].sym);
	
	  	sql_add_arg( m, an->a);
		an->a = NULL;
	  	/* we miss use SQL_COLUMN also for param's, maybe
	     		change SQL_COLUMN to SQL_IDENT */
 	  	(yyval.sym) = _symbol_create_list( SQL_COLUMN,
			append_int(L(), m->argc-1));
	   } else {
	  	AtomNode *an = (AtomNode*)(yyvsp[0].sym);
		atom *a = an->a; 
		an->a = atom_dup(SA, a); 
		(yyval.sym) = (yyvsp[0].sym);
	   }
	}
#line 12427 "y.tab.c"
    break;

  case 763: /* qrank: RANK  */
#line 4168 "sql_parser.y"
                        { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 12433 "y.tab.c"
    break;

  case 764: /* qrank: ident '.' RANK  */
#line 4169 "sql_parser.y"
                        { (yyval.l) = append_string(
			  append_string(L(), (yyvsp[-2].sval)), (yyvsp[0].sval));}
#line 12440 "y.tab.c"
    break;

  case 765: /* qaggr: AGGR  */
#line 4174 "sql_parser.y"
                        { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 12446 "y.tab.c"
    break;

  case 766: /* qaggr: ident '.' AGGR  */
#line 4175 "sql_parser.y"
                        { (yyval.l) = append_string(
			  append_string(L(), (yyvsp[-2].sval)), (yyvsp[0].sval));}
#line 12453 "y.tab.c"
    break;

  case 767: /* qaggr2: AGGR2  */
#line 4180 "sql_parser.y"
                        { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 12459 "y.tab.c"
    break;

  case 768: /* qaggr2: ident '.' AGGR2  */
#line 4181 "sql_parser.y"
                        { (yyval.l) = append_string(
			  append_string(L(), (yyvsp[-2].sval)), (yyvsp[0].sval));}
#line 12466 "y.tab.c"
    break;

  case 769: /* aggr_ref: qaggr '(' '*' ')'  */
#line 4188 "sql_parser.y"
                { dlist *l = L();
  		  append_list(l, (yyvsp[-3].l));
  		  append_int(l, FALSE);
  		  append_symbol(l, NULL);
		  (yyval.sym) = _symbol_create_list( SQL_AGGR, l ); }
#line 12476 "y.tab.c"
    break;

  case 770: /* aggr_ref: qaggr '(' ident '.' '*' ')'  */
#line 4194 "sql_parser.y"
                { dlist *l = L();
  		  append_list(l, (yyvsp[-5].l));
  		  append_int(l, FALSE);
  		  append_symbol(l, NULL);
		  (yyval.sym) = _symbol_create_list( SQL_AGGR, l ); }
#line 12486 "y.tab.c"
    break;

  case 771: /* aggr_ref: qaggr '(' DISTINCT case_scalar_exp ')'  */
#line 4200 "sql_parser.y"
                { dlist *l = L();
  		  append_list(l, (yyvsp[-4].l));
  		  append_int(l, TRUE);
  		  append_symbol(l, (yyvsp[-1].sym));
		  (yyval.sym) = _symbol_create_list( SQL_AGGR, l ); }
#line 12496 "y.tab.c"
    break;

  case 772: /* aggr_ref: qaggr '(' ALL case_scalar_exp ')'  */
#line 4206 "sql_parser.y"
                { dlist *l = L();
  		  append_list(l, (yyvsp[-4].l));
  		  append_int(l, FALSE);
  		  append_symbol(l, (yyvsp[-1].sym));
		  (yyval.sym) = _symbol_create_list( SQL_AGGR, l ); }
#line 12506 "y.tab.c"
    break;

  case 773: /* aggr_ref: qaggr '(' case_scalar_exp ')'  */
#line 4212 "sql_parser.y"
                { dlist *l = L();
  		  append_list(l, (yyvsp[-3].l));
  		  append_int(l, FALSE);
  		  append_symbol(l, (yyvsp[-1].sym));
		  (yyval.sym) = _symbol_create_list( SQL_AGGR, l ); }
#line 12516 "y.tab.c"
    break;

  case 774: /* aggr_ref: qaggr2 '(' case_scalar_exp ',' case_scalar_exp ')'  */
#line 4218 "sql_parser.y"
                { dlist *l = L();
  		  append_list(l, (yyvsp[-5].l));
  		  append_int(l, FALSE);
  		  append_symbol(l, (yyvsp[-3].sym));
  		  append_symbol(l, (yyvsp[-1].sym));
		  (yyval.sym) = _symbol_create_list( SQL_AGGR, l ); }
#line 12527 "y.tab.c"
    break;

  case 776: /* opt_sign: '+'  */
#line 4228 "sql_parser.y"
                { (yyval.i_val) = 1; }
#line 12533 "y.tab.c"
    break;

  case 777: /* opt_sign: '-'  */
#line 4229 "sql_parser.y"
                { (yyval.i_val) = -1; }
#line 12539 "y.tab.c"
    break;

  case 778: /* opt_sign: %empty  */
#line 4230 "sql_parser.y"
                { (yyval.i_val) = 1; }
#line 12545 "y.tab.c"
    break;

  case 779: /* tz: WITH TIME ZONE  */
#line 4234 "sql_parser.y"
                        { (yyval.bval) = 1; }
#line 12551 "y.tab.c"
    break;

  case 780: /* tz: %empty  */
#line 4235 "sql_parser.y"
                        { (yyval.bval) = 0; }
#line 12557 "y.tab.c"
    break;

  case 781: /* time_precision: '(' intval ')'  */
#line 4246 "sql_parser.y"
                        { (yyval.i_val) = (yyvsp[-1].i_val)+1; }
#line 12563 "y.tab.c"
    break;

  case 782: /* time_precision: %empty  */
#line 4248 "sql_parser.y"
                        { (yyval.i_val) = 0+1; }
#line 12569 "y.tab.c"
    break;

  case 783: /* timestamp_precision: '(' intval ')'  */
#line 4252 "sql_parser.y"
                        { (yyval.i_val) = (yyvsp[-1].i_val)+1; }
#line 12575 "y.tab.c"
    break;

  case 784: /* timestamp_precision: %empty  */
#line 4254 "sql_parser.y"
                        { (yyval.i_val) = 6+1; }
#line 12581 "y.tab.c"
    break;

  case 785: /* datetime_type: sqlDATE  */
#line 4258 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "date", 0, 0); }
#line 12587 "y.tab.c"
    break;

  case 786: /* datetime_type: TIME time_precision tz  */
#line 4260 "sql_parser.y"
                        { if ((yyvsp[0].bval))
				sql_find_subtype(&(yyval.type), "timetz", (yyvsp[-1].i_val), 0); 
			  else
				sql_find_subtype(&(yyval.type), "time", (yyvsp[-1].i_val), 0); 
			}
#line 12597 "y.tab.c"
    break;

  case 787: /* datetime_type: TIMESTAMP timestamp_precision tz  */
#line 4266 "sql_parser.y"
                        { if ((yyvsp[0].bval))
				sql_find_subtype(&(yyval.type), "timestamptz", (yyvsp[-1].i_val), 0); 
			  else
				sql_find_subtype(&(yyval.type), "timestamp", (yyvsp[-1].i_val), 0); 
			}
#line 12607 "y.tab.c"
    break;

  case 788: /* non_second_datetime_field: YEAR  */
#line 4274 "sql_parser.y"
                        { (yyval.i_val) = iyear; }
#line 12613 "y.tab.c"
    break;

  case 789: /* non_second_datetime_field: MONTH  */
#line 4275 "sql_parser.y"
                        { (yyval.i_val) = imonth; }
#line 12619 "y.tab.c"
    break;

  case 790: /* non_second_datetime_field: DAY  */
#line 4276 "sql_parser.y"
                        { (yyval.i_val) = iday; }
#line 12625 "y.tab.c"
    break;

  case 791: /* non_second_datetime_field: HOUR  */
#line 4277 "sql_parser.y"
                        { (yyval.i_val) = ihour; }
#line 12631 "y.tab.c"
    break;

  case 792: /* non_second_datetime_field: MINUTE  */
#line 4278 "sql_parser.y"
                        { (yyval.i_val) = imin; }
#line 12637 "y.tab.c"
    break;

  case 794: /* datetime_field: SECOND  */
#line 4283 "sql_parser.y"
                        { (yyval.i_val) = isec; }
#line 12643 "y.tab.c"
    break;

  case 795: /* start_field: non_second_datetime_field time_precision  */
#line 4288 "sql_parser.y"
                { (yyval.l) = append_int(
			 	append_int( L(), (yyvsp[-1].i_val)), (yyvsp[0].i_val)-1);  }
#line 12650 "y.tab.c"
    break;

  case 796: /* end_field: non_second_datetime_field  */
#line 4294 "sql_parser.y"
                { (yyval.l) = append_int(
			 	append_int( L(), (yyvsp[0].i_val)), 0);  }
#line 12657 "y.tab.c"
    break;

  case 797: /* end_field: SECOND timestamp_precision  */
#line 4297 "sql_parser.y"
                { (yyval.l) = append_int(
			 	append_int( L(), isec), (yyvsp[0].i_val)-1);  }
#line 12664 "y.tab.c"
    break;

  case 798: /* single_datetime_field: non_second_datetime_field time_precision  */
#line 4303 "sql_parser.y"
                { (yyval.l) = append_int(
			 	append_int( L(), (yyvsp[-1].i_val)), (yyvsp[0].i_val)-1);  }
#line 12671 "y.tab.c"
    break;

  case 799: /* single_datetime_field: SECOND timestamp_precision  */
#line 4306 "sql_parser.y"
                { (yyval.l) = append_int(
			 	append_int( L(), isec), (yyvsp[0].i_val)-1);  }
#line 12678 "y.tab.c"
    break;

  case 800: /* interval_qualifier: start_field TO end_field  */
#line 4312 "sql_parser.y"
        { (yyval.l) =  append_list(
			append_list( L(), (yyvsp[-2].l)), (yyvsp[0].l) ); }
#line 12685 "y.tab.c"
    break;

  case 801: /* interval_qualifier: single_datetime_field  */
#line 4315 "sql_parser.y"
        { (yyval.l) =  append_list( L(), (yyvsp[0].l)); }
#line 12691 "y.tab.c"
    break;

  case 802: /* interval_type: INTERVAL interval_qualifier  */
#line 4319 "sql_parser.y"
                                {
		int sk, ek, sp, ep;
	  	int tpe;

		(yyval.type).type = NULL;
	  	if ( (tpe = parse_interval_qualifier( m, (yyvsp[0].l), &sk, &ek, &sp, &ep )) < 0){
			yyerror(m, "\b22006!incorrect interval");
			YYABORT;
	  	} else {
			int d = inttype2digits(sk, ek);
			if (tpe == 0){
				sql_find_subtype(&(yyval.type), "month_interval", d, 0);
			} else {
				sql_find_subtype(&(yyval.type), "sec_interval", d, 0);
			}
	  	}
	}
#line 12713 "y.tab.c"
    break;

  case 806: /* literal: string  */
#line 4345 "sql_parser.y"
                { const char *s = sql2str((yyvsp[0].sval));
		  int len = UTF8_strlen(s);
		  sql_subtype t;
		  sql_find_subtype(&t, "char", len, 0 );
		  (yyval.sym) = _newAtomNode( _atom_string(&t, s)); }
#line 12723 "y.tab.c"
    break;

  case 807: /* literal: HEXADECIMAL  */
#line 4351 "sql_parser.y"
                { int len = _strlen((yyvsp[0].sval)), i = 2, err = 0;
		  char * hexa = (yyvsp[0].sval);
	 	  sql_subtype t;
#ifdef HAVE_HGE
		  hge res = 0;
#else
		  lng res = 0;
#endif
		  /* skip leading '0' */
		  while (i < len && hexa[i] == '0')
		  	i++;

		  /* we only support positive values that fit in a signed 128-bit type,
		   * i.e., max. 63/127 bit => < 2^63/2^127 => < 0x800...
		   * (leading sign (-0x...) is handled separately elsewhere)
		   */
		  if (len - i < MAX_HEX_DIGITS || (len - i == MAX_HEX_DIGITS && hexa[i] < '8'))
		  	while (err == 0 && i < len)
		  	{
				res <<= 4;
				if ('0'<= hexa[i] && hexa[i] <= '9')
					res = res + (hexa[i] - '0');
				else if ('A' <= hexa[i] && hexa[i] <= 'F')
					res = res + (hexa[i] - 'A' + 10);
				else if ('a' <= hexa[i] && hexa[i] <= 'f')
					res = res + (hexa[i] - 'a' + 10);
				else
					err = 1;
		  		i++;
			}
		  else
			err = 1;

		  if (err == 0) {
		  	assert(res >= 0);

		  	/* use smallest type that can accommodate the given value */
			if (res <= GDK_bte_max)
				sql_find_subtype(&t, "tinyint", 8, 0 );
			else if (res <= GDK_sht_max)
				sql_find_subtype(&t, "smallint", 16, 0 );
		  	else if (res <= GDK_int_max)
				sql_find_subtype(&t, "int", 32, 0 );
			else if (res <= GDK_lng_max)
				sql_find_subtype(&t, "bigint", 64, 0 );
#ifdef HAVE_HGE
			else if (res <= GDK_hge_max && have_hge)
				sql_find_subtype(&t, "hugeint", 128, 0 );
#endif
			else
				err = 1;
		  }

		  if (err != 0) {
			char *msg = sql_message("\b22003!invalid hexadecimal number or hexadecimal too large (%s)", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			(yyval.sym) = NULL;
			YYABORT;
		  } else {
			(yyval.sym) = _newAtomNode( atom_int(SA, &t, res));
		  }
		}
#line 12792 "y.tab.c"
    break;

  case 808: /* literal: OIDNUM  */
#line 4416 "sql_parser.y"
                { int err = 0, len = sizeof(lng);
		  lng value, *p = &value;
		  sql_subtype t;

		  lngFromStr((yyvsp[0].sval), &len, &p);
		  if (value == lng_nil)
		  	err = 2;

		  if (!err) {
		    if ((value > GDK_lng_min && value <= GDK_lng_max))
#if SIZEOF_OID == SIZEOF_INT
		  	  sql_find_subtype(&t, "oid", 31, 0 );
#else
		  	  sql_find_subtype(&t, "oid", 63, 0 );
#endif
		    else
			  err = 1;
		  }

		  if (err) {
			char *msg = sql_message("\b22003!OID value too large or not a number (%s)", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			(yyval.sym) = NULL;
			YYABORT;
		  } else {
		  	(yyval.sym) = _newAtomNode( atom_int(SA, &t, value));
		  }
		}
#line 12827 "y.tab.c"
    break;

  case 809: /* literal: sqlINT  */
#line 4447 "sql_parser.y"
                { int digits = _strlen((yyvsp[0].sval)), err = 0;
#ifdef HAVE_HGE
		  hge value, *p = &value;
		  int len = sizeof(hge);
		  const hge one = 1;
#else
		  lng value, *p = &value;
		  int len = sizeof(lng);
		  const lng one = 1;
#endif
		  sql_subtype t;

#ifdef HAVE_HGE
		  hgeFromStr((yyvsp[0].sval), &len, &p);
		  if (value == hge_nil)
		  	err = 2;
#else
		  lngFromStr((yyvsp[0].sval), &len, &p);
		  if (value == lng_nil)
		  	err = 2;
#endif

		  /* find the most suitable data type for the given number */
		  if (!err) {
		    int bits = digits2bits(digits), obits = bits;

		    while (bits > 0 &&
			   (bits == sizeof(value) * 8 ||
			    (one << (bits - 1)) > value))
			  bits--;

 		    if (bits != obits &&
		       (bits == 8 || bits == 16 || bits == 32 || bits == 64))
				bits++;
		
		    if (value > GDK_bte_min && value <= GDK_bte_max)
		  	  sql_find_subtype(&t, "tinyint", bits, 0 );
		    else if (value > GDK_sht_min && value <= GDK_sht_max)
		  	  sql_find_subtype(&t, "smallint", bits, 0 );
		    else if (value > GDK_int_min && value <= GDK_int_max)
		  	  sql_find_subtype(&t, "int", bits, 0 );
		    else if (value > GDK_lng_min && value <= GDK_lng_max)
		  	  sql_find_subtype(&t, "bigint", bits, 0 );
#ifdef HAVE_HGE
		    else if (value > GDK_hge_min && value <= GDK_hge_max && have_hge)
		  	  sql_find_subtype(&t, "hugeint", bits, 0 );
#endif
		    else
			  err = 1;
		  }

		  if (err) {
			char *msg = sql_message("\b22003!integer value too large or not a number (%s)", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			(yyval.sym) = NULL;
			YYABORT;
		  } else {
		  	(yyval.sym) = _newAtomNode( atom_int(SA, &t, value));
		  }
		}
#line 12894 "y.tab.c"
    break;

  case 810: /* literal: INTNUM  */
#line 4510 "sql_parser.y"
                { char *s = strip_extra_zeros(sa_strdup(SA, (yyvsp[0].sval)));
		  char *dot = strchr(s, '.');
		  int digits = _strlen(s) - 1;
		  int scale = digits - (int) (dot-s);
		  sql_subtype t;

		  if (digits <= 0)
			digits = 1;
		  if (digits <= MAX_DEC_DIGITS) {
		  	double val = strtod((yyvsp[0].sval),NULL);
#ifdef HAVE_HGE
		  	hge value = decimal_from_str(s, NULL);
#else
		  	lng value = decimal_from_str(s, NULL);
#endif

		  	if (*s == '+' || *s == '-')
				digits --;
		  	sql_find_subtype(&t, "decimal", digits, scale );
		  	(yyval.sym) = _newAtomNode( atom_dec(SA, &t, value, val));
		   } else {
			char *p = (yyvsp[0].sval);
			double val;

			errno = 0;
			val = strtod((yyvsp[0].sval),&p);
			if (p == (yyvsp[0].sval) || val == dbl_nil || (errno == ERANGE && (val < -1 || val > 1))) {
				char *msg = sql_message("\b22003!double value too large or not a number (%s)", (yyvsp[0].sval));

				yyerror(m, msg);
				_DELETE(msg);
				(yyval.sym) = NULL;
				YYABORT;
			}
		  	sql_find_subtype(&t, "double", 51, 0 );
		  	(yyval.sym) = _newAtomNode(atom_float(SA, &t, val));
		   }
		}
#line 12937 "y.tab.c"
    break;

  case 811: /* literal: APPROXNUM  */
#line 4549 "sql_parser.y"
                { sql_subtype t;
  		  char *p = (yyvsp[0].sval);
		  double val;

		  errno = 0;
 		  val = strtod((yyvsp[0].sval),&p);
		  if (p == (yyvsp[0].sval) || val == dbl_nil || (errno == ERANGE && (val < -1 || val > 1))) {
			char *msg = sql_message("\b22003!double value too large or not a number (%s)", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			(yyval.sym) = NULL;
			YYABORT;
		  }
		  sql_find_subtype(&t, "double", 51, 0 );
		  (yyval.sym) = _newAtomNode(atom_float(SA, &t, val)); }
#line 12958 "y.tab.c"
    break;

  case 812: /* literal: sqlDATE string  */
#line 4566 "sql_parser.y"
                { sql_subtype t;
		  atom *a;
		  int r;

 		  r = sql_find_subtype(&t, "date", 0, 0 );
		  if (!r || (a = atom_general(SA, &t, (yyvsp[0].sval))) == NULL) {
			char *msg = sql_message("\b22007!incorrect date value (%s)", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			(yyval.sym) = NULL;
			YYABORT;
		  } else {
		  	(yyval.sym) = _newAtomNode(a);
		} }
#line 12978 "y.tab.c"
    break;

  case 813: /* literal: TIME time_precision tz string  */
#line 4582 "sql_parser.y"
                { sql_subtype t;
		  atom *a;
		  int r;

	          r = sql_find_subtype(&t, ((yyvsp[-1].bval))?"timetz":"time", (yyvsp[-2].i_val), 0);
		  if (!r || (a = atom_general(SA, &t, (yyvsp[0].sval))) == NULL) {
			char *msg = sql_message("\b22007!incorrect time value (%s)", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			(yyval.sym) = NULL;
			YYABORT;
		  } else {
		  	(yyval.sym) = _newAtomNode(a);
		} }
#line 12998 "y.tab.c"
    break;

  case 814: /* literal: TIMESTAMP timestamp_precision tz string  */
#line 4598 "sql_parser.y"
                { sql_subtype t;
		  atom *a;
		  int r;

 		  r = sql_find_subtype(&t, ((yyvsp[-1].bval))?"timestamptz":"timestamp",(yyvsp[-2].i_val),0);
		  if (!r || (a = atom_general(SA, &t, (yyvsp[0].sval))) == NULL) {
			char *msg = sql_message("\b22007!incorrect timestamp value (%s)", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			(yyval.sym) = NULL;
			YYABORT;
		  } else {
		  	(yyval.sym) = _newAtomNode(a);
		} }
#line 13018 "y.tab.c"
    break;

  case 816: /* literal: blob string  */
#line 4615 "sql_parser.y"
                { sql_subtype t;
		  atom *a= 0;
		  int r;

		  (yyval.sym) = NULL;
 		  r = sql_find_subtype(&t, "blob", 0, 0);
	          if (r && (a = atom_general(SA, &t, (yyvsp[0].sval))) != NULL)
			(yyval.sym) = _newAtomNode(a);
		  if (!(yyval.sym)) {
			char *msg = sql_message("\b22M28!incorrect blob %s", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			YYABORT;
		  }
		}
#line 13039 "y.tab.c"
    break;

  case 817: /* literal: aTYPE string  */
#line 4632 "sql_parser.y"
                { sql_subtype t;
		  atom *a= 0;
		  int r;

		  (yyval.sym) = NULL;
		  r = sql_find_subtype(&t, (yyvsp[-1].sval), 0, 0);
	          if (r && (a = atom_general(SA, &t, (yyvsp[0].sval))) != NULL)
			(yyval.sym) = _newAtomNode(a);
		  if (!(yyval.sym)) {
			char *msg = sql_message("\b22000!incorrect %s %s", (yyvsp[-1].sval), (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			YYABORT;
		  }
		}
#line 13060 "y.tab.c"
    break;

  case 818: /* literal: type_alias string  */
#line 4649 "sql_parser.y"
                { sql_subtype t; 
		  atom *a = 0;
		  int r;

		  (yyval.sym) = NULL;
		  r = sql_find_subtype(&t, (yyvsp[-1].sval), 0, 0);
	          if (r && (a = atom_general(SA, &t, (yyvsp[0].sval))) != NULL)
			(yyval.sym) = _newAtomNode(a);
		  if (!(yyval.sym)) {
			char *msg = sql_message("\b22000!incorrect %s %s", (yyvsp[-1].sval), (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			YYABORT;
		  }
		}
#line 13081 "y.tab.c"
    break;

  case 819: /* literal: IDENT string  */
#line 4666 "sql_parser.y"
                {
		  sql_type *t = mvc_bind_type(m, (yyvsp[-1].sval));
		  atom *a;

		  (yyval.sym) = NULL;
		  if (t) {
		  	sql_subtype tpe;
			sql_init_subtype(&tpe, t, 0, 0);
			a = atom_general(SA, &tpe, (yyvsp[0].sval));
			if (a)
				(yyval.sym) = _newAtomNode(a);
		  }
		  if (!t || !(yyval.sym)) {
			char *msg = sql_message("\b22000!type (%s) unknown", (yyvsp[-1].sval));

			yyerror(m, msg);
			_DELETE(msg);
			YYABORT;
		  }
		}
#line 13106 "y.tab.c"
    break;

  case 820: /* literal: BOOL_FALSE  */
#line 4687 "sql_parser.y"
                { sql_subtype t;
		  sql_find_subtype(&t, "boolean", 0, 0 );
		  (yyval.sym) = _newAtomNode( atom_bool(SA, &t, FALSE)); }
#line 13114 "y.tab.c"
    break;

  case 821: /* literal: BOOL_TRUE  */
#line 4691 "sql_parser.y"
                { sql_subtype t;
		  sql_find_subtype(&t, "boolean", 0, 0 );
		  (yyval.sym) = _newAtomNode( atom_bool(SA, &t, TRUE)); }
#line 13122 "y.tab.c"
    break;

  case 822: /* interval_expression: INTERVAL opt_sign string interval_qualifier  */
#line 4697 "sql_parser.y"
                                               { 
		sql_subtype t;
		int sk, ek, sp, ep, tpe;
	  	lng i = 0;
		int r = 0;

		(yyval.sym) = NULL;
	  	if ( (tpe = parse_interval_qualifier( m, (yyvsp[0].l), &sk, &ek, &sp, &ep )) < 0){
			yyerror(m, "incorrect interval");
			YYABORT;
	  	} else {
			int d = inttype2digits(sk, ek);
			if (tpe == 0){
				r=sql_find_subtype(&t, "month_interval", d, 0);
			} else {
				r=sql_find_subtype(&t, "sec_interval", d, 0);
			}
	  	}
	  	if (!r || (tpe = parse_interval( m, (yyvsp[-2].i_val), (yyvsp[-1].sval), sk, ek, sp, ep, &i)) < 0) { 
			yyerror(m, "incorrect interval");
			(yyval.sym) = NULL;
			YYABORT;
	  	} else {
			/* count the number of digits in the input */
/*
			lng cpyval = i, inlen = 1;

			cpyval /= qualifier2multiplier(ek);
			while (cpyval /= 10)
				inlen++;
		    	if (inlen > t.digits) {
				char *msg = sql_message("\b22006!incorrect interval (" LLFMT " > %d)", inlen, t.digits);
				yyerror(m, msg);
				$$ = NULL;
				YYABORT;
			}
*/
	  		(yyval.sym) = _newAtomNode( atom_int(SA, &t, i));
	  	}
	}
#line 13167 "y.tab.c"
    break;

  case 823: /* qname: ident  */
#line 4742 "sql_parser.y"
                                { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 13173 "y.tab.c"
    break;

  case 824: /* qname: ident '.' ident  */
#line 4743 "sql_parser.y"
                                {
				  m->scanner.schema = (yyvsp[-2].sval);
				  (yyval.l) = append_string(
					append_string(L(), (yyvsp[-2].sval)), (yyvsp[0].sval));}
#line 13182 "y.tab.c"
    break;

  case 825: /* qname: ident '.' ident '.' ident  */
#line 4747 "sql_parser.y"
                                {
				  m->scanner.schema = (yyvsp[-4].sval);
				  (yyval.l) = append_string(
					append_string(
						append_string(L(), (yyvsp[-4].sval)), 
						(yyvsp[-2].sval)), 
					(yyvsp[0].sval))
				;}
#line 13195 "y.tab.c"
    break;

  case 826: /* column_ref: ident  */
#line 4758 "sql_parser.y"
                        { (yyval.l) = append_string(
				L(), (yyvsp[0].sval)); }
#line 13202 "y.tab.c"
    break;

  case 827: /* column_ref: ident '.' ident  */
#line 4761 "sql_parser.y"
                        { (yyval.l) = append_string(
				append_string(
				 L(), (yyvsp[-2].sval)), (yyvsp[0].sval));}
#line 13210 "y.tab.c"
    break;

  case 828: /* column_ref: ident '.' ident '.' ident  */
#line 4766 "sql_parser.y"
                        { (yyval.l) = append_string(
				append_string(
				 append_string(
				  L(), (yyvsp[-4].sval)), (yyvsp[-2].sval)), (yyvsp[0].sval));}
#line 13219 "y.tab.c"
    break;

  case 829: /* cast_exp: CAST '(' cast_value AS data_type ')'  */
#line 4774 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-3].sym));
	  append_type(l, &(yyvsp[-1].type));
	  (yyval.sym) = _symbol_create_list( SQL_CAST, l ); }
#line 13228 "y.tab.c"
    break;

  case 830: /* cast_exp: CONVERT '(' cast_value ',' data_type ')'  */
#line 4780 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-3].sym));
	  append_type(l, &(yyvsp[-1].type));
	  (yyval.sym) = _symbol_create_list( SQL_CAST, l ); }
#line 13237 "y.tab.c"
    break;

  case 832: /* case_exp: NULLIF '(' scalar_exp ',' scalar_exp ')'  */
#line 4792 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list(SQL_NULLIF,
		   append_symbol(
		    append_symbol(
		     L(), (yyvsp[-3].sym)), (yyvsp[-1].sym))); }
#line 13246 "y.tab.c"
    break;

  case 833: /* case_exp: COALESCE '(' case_scalar_exp_list ')'  */
#line 4797 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list(SQL_COALESCE, (yyvsp[-1].l)); }
#line 13252 "y.tab.c"
    break;

  case 834: /* case_exp: CASE scalar_exp when_value_list case_opt_else END  */
#line 4799 "sql_parser.y"
                { (yyval.sym) = _symbol_create_list(SQL_CASE,
		   append_symbol(
		    append_list(
		     append_symbol(
		      L(),(yyvsp[-3].sym)),(yyvsp[-2].l)),(yyvsp[-1].sym))); }
#line 13262 "y.tab.c"
    break;

  case 835: /* case_exp: CASE when_search_list case_opt_else END  */
#line 4805 "sql_parser.y"
                 { (yyval.sym) = _symbol_create_list(SQL_CASE,
		   append_symbol(
		    append_list(
		     L(),(yyvsp[-2].l)),(yyvsp[-1].sym))); }
#line 13271 "y.tab.c"
    break;

  case 836: /* scalar_exp_list: simple_atom  */
#line 4813 "sql_parser.y"
                        { (yyval.l) = append_symbol( L(), (yyvsp[0].sym)); }
#line 13277 "y.tab.c"
    break;

  case 837: /* scalar_exp_list: scalar_exp_list ',' simple_atom  */
#line 4815 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-2].l), (yyvsp[0].sym)); }
#line 13283 "y.tab.c"
    break;

  case 838: /* case_scalar_exp_list: simple_atom ',' simple_atom  */
#line 4820 "sql_parser.y"
                        { (yyval.l) = append_symbol( L(), (yyvsp[-2].sym));
			  (yyval.l) = append_symbol( (yyval.l), (yyvsp[0].sym));
			}
#line 13291 "y.tab.c"
    break;

  case 839: /* case_scalar_exp_list: case_scalar_exp_list ',' simple_atom  */
#line 4824 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-2].l), (yyvsp[0].sym)); }
#line 13297 "y.tab.c"
    break;

  case 840: /* when_value: WHEN scalar_exp THEN simple_atom  */
#line 4830 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_WHEN,
			   append_symbol(
			    append_symbol(
			     L(), (yyvsp[-2].sym)),(yyvsp[0].sym))); }
#line 13306 "y.tab.c"
    break;

  case 841: /* when_value_list: when_value  */
#line 4838 "sql_parser.y"
                        { (yyval.l) = append_symbol( L(), (yyvsp[0].sym));}
#line 13312 "y.tab.c"
    break;

  case 842: /* when_value_list: when_value_list when_value  */
#line 4840 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-1].l), (yyvsp[0].sym)); }
#line 13318 "y.tab.c"
    break;

  case 843: /* when_search: WHEN search_condition THEN simple_atom  */
#line 4845 "sql_parser.y"
                        { (yyval.sym) = _symbol_create_list( SQL_WHEN,
			   append_symbol(
			    append_symbol(
			     L(), (yyvsp[-2].sym)),(yyvsp[0].sym))); }
#line 13327 "y.tab.c"
    break;

  case 844: /* when_search_list: when_search  */
#line 4853 "sql_parser.y"
                        { (yyval.l) = append_symbol( L(), (yyvsp[0].sym)); }
#line 13333 "y.tab.c"
    break;

  case 845: /* when_search_list: when_search_list when_search  */
#line 4855 "sql_parser.y"
                        { (yyval.l) = append_symbol( (yyvsp[-1].l), (yyvsp[0].sym)); }
#line 13339 "y.tab.c"
    break;

  case 846: /* case_opt_else: %empty  */
#line 4859 "sql_parser.y"
                        { (yyval.sym) = NULL; }
#line 13345 "y.tab.c"
    break;

  case 847: /* case_opt_else: ELSE scalar_exp  */
#line 4860 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 13351 "y.tab.c"
    break;

  case 849: /* nonzero: intval  */
#line 4870 "sql_parser.y"
                { (yyval.i_val) = (yyvsp[0].i_val);
		  if ((yyval.i_val) <= 0) {
			(yyval.i_val) = -1;
			yyerror(m, "Positive value greater than 0 expected");
			YYABORT;
		  }
		}
#line 13363 "y.tab.c"
    break;

  case 850: /* nonzerolng: lngval  */
#line 4881 "sql_parser.y"
                { (yyval.l_val) = (yyvsp[0].l_val);
		  if ((yyval.l_val) <= 0) {
			(yyval.l_val) = -1;
			yyerror(m, "Positive value greater than 0 expected");
			YYABORT;
		  }
		}
#line 13375 "y.tab.c"
    break;

  case 851: /* poslng: lngval  */
#line 4891 "sql_parser.y"
                { (yyval.l_val) = (yyvsp[0].l_val);
		  if ((yyval.l_val) < 0) {
			(yyval.l_val) = -1;
			yyerror(m, "Positive value expected");
			YYABORT;
		  }
		}
#line 13387 "y.tab.c"
    break;

  case 852: /* posint: intval  */
#line 4901 "sql_parser.y"
                { (yyval.i_val) = (yyvsp[0].i_val);
		  if ((yyval.i_val) < 0) {
			(yyval.i_val) = -1;
			yyerror(m, "Positive value expected");
			YYABORT;
		  }
		}
#line 13399 "y.tab.c"
    break;

  case 853: /* data_type: CHARACTER  */
#line 4912 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "char", 1, 0); }
#line 13405 "y.tab.c"
    break;

  case 854: /* data_type: varchar  */
#line 4914 "sql_parser.y"
                        { (yyval.type).type = NULL;
			  yyerror(m, "CHARACTER VARYING needs a mandatory length specification");
			  YYABORT;
			}
#line 13414 "y.tab.c"
    break;

  case 855: /* data_type: clob  */
#line 4918 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "clob", 0, 0); }
#line 13420 "y.tab.c"
    break;

  case 856: /* data_type: CHARACTER '(' nonzero ')'  */
#line 4920 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "char", (yyvsp[-1].i_val), 0); }
#line 13426 "y.tab.c"
    break;

  case 857: /* data_type: varchar '(' nonzero ')'  */
#line 4922 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "varchar", (yyvsp[-1].i_val), 0); }
#line 13432 "y.tab.c"
    break;

  case 858: /* data_type: clob '(' nonzero ')'  */
#line 4924 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "clob", (yyvsp[-1].i_val), 0);
			  /* NOTE: CLOB may be called as CLOB(2K) which is equivalent
			   *       to CLOB(2048).  Due to 'nonzero' it is not possible
			   *       to enter this as the parser rejects it.  However it
			   *       might be a ToDo for the future.
			   *       See p. 125 SQL-99
			   */
			}
#line 13445 "y.tab.c"
    break;

  case 859: /* data_type: blob  */
#line 4932 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "blob", 0, 0); }
#line 13451 "y.tab.c"
    break;

  case 860: /* data_type: blob '(' nonzero ')'  */
#line 4934 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "blob", (yyvsp[-1].i_val), 0);
			  /* NOTE: BLOB may be called as BLOB(2K) which is equivalent
			   *       to BLOB(2048).  Due to 'nonzero' it is not possible
			   *       to enter this as the parser rejects it.  However it
			   *       might be a ToDo for the future.
			   *       See p. 85 SQL-99
			   */
			}
#line 13464 "y.tab.c"
    break;

  case 861: /* data_type: TINYINT  */
#line 4942 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "tinyint", 0, 0); }
#line 13470 "y.tab.c"
    break;

  case 862: /* data_type: SMALLINT  */
#line 4943 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "smallint", 0, 0); }
#line 13476 "y.tab.c"
    break;

  case 863: /* data_type: sqlINTEGER  */
#line 4944 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "int", 0, 0); }
#line 13482 "y.tab.c"
    break;

  case 864: /* data_type: BIGINT  */
#line 4945 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "bigint", 0, 0); }
#line 13488 "y.tab.c"
    break;

  case 865: /* data_type: HUGEINT  */
#line 4946 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "hugeint", 0, 0); }
#line 13494 "y.tab.c"
    break;

  case 866: /* data_type: sqlDECIMAL  */
#line 4948 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "decimal", 18, 3); }
#line 13500 "y.tab.c"
    break;

  case 867: /* data_type: sqlDECIMAL '(' nonzero ')'  */
#line 4950 "sql_parser.y"
                        { 
			  int d = (yyvsp[-1].i_val);
			  if (d > MAX_DEC_DIGITS) {
				char *msg = sql_message("\b22003!decimal of %d digits are not supported", d);
				yyerror(m, msg);
				_DELETE(msg);
				(yyval.type).type = NULL;
				YYABORT;
			  } else {
			        sql_find_subtype(&(yyval.type), "decimal", d, 0); 
			  }
			}
#line 13517 "y.tab.c"
    break;

  case 868: /* data_type: sqlDECIMAL '(' nonzero ',' posint ')'  */
#line 4963 "sql_parser.y"
                        { 
			  int d = (yyvsp[-3].i_val);
			  int s = (yyvsp[-1].i_val);
			  if (s > d || d > MAX_DEC_DIGITS) {
				char *msg = NULL;
				if (s > d)
					msg = sql_message("\b22003!scale (%d) should be less or equal to the precision (%d)", s, d);
				else
					msg = sql_message("\b22003!decimal(%d,%d) isn't supported because P=%d > %d", d, s, d, MAX_DEC_DIGITS);
				yyerror(m, msg);
				_DELETE(msg);
				(yyval.type).type = NULL;
				YYABORT;
			  } else {
				sql_find_subtype(&(yyval.type), "decimal", d, s);
			  }
			}
#line 13539 "y.tab.c"
    break;

  case 869: /* data_type: sqlFLOAT  */
#line 4980 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "double", 0, 0); }
#line 13545 "y.tab.c"
    break;

  case 870: /* data_type: sqlFLOAT '(' nonzero ')'  */
#line 4982 "sql_parser.y"
                        { if ((yyvsp[-1].i_val) > 0 && (yyvsp[-1].i_val) <= 24) {
				sql_find_subtype(&(yyval.type), "real", (yyvsp[-1].i_val), 0);
			  } else if ((yyvsp[-1].i_val) > 24 && (yyvsp[-1].i_val) <= 53) {
				sql_find_subtype(&(yyval.type), "double", (yyvsp[-1].i_val), 0);
			  } else {
				char *msg = sql_message("\b22003!number of digits for FLOAT values should be between 1 and 53");

				yyerror(m, msg);
				_DELETE(msg);
				(yyval.type).type = NULL;
				YYABORT;
			  }
			}
#line 13563 "y.tab.c"
    break;

  case 871: /* data_type: sqlFLOAT '(' intval ',' intval ')'  */
#line 4996 "sql_parser.y"
                        { if ((yyvsp[-1].i_val) >= (yyvsp[-3].i_val)) {
				char *msg = sql_message("\b22003!precision(%d) should be less than number of digits(%d)", (yyvsp[-1].i_val), (yyvsp[-3].i_val));

				yyerror(m, msg);
				_DELETE(msg);
				(yyval.type).type = NULL;
				YYABORT;
			  } else if ((yyvsp[-3].i_val) > 0 && (yyvsp[-3].i_val) <= 24) {
				sql_find_subtype(&(yyval.type), "real", (yyvsp[-3].i_val), (yyvsp[-1].i_val));
			  } else if ((yyvsp[-3].i_val) > 24 && (yyvsp[-3].i_val) <= 53) {
				sql_find_subtype(&(yyval.type), "double", (yyvsp[-3].i_val), (yyvsp[-1].i_val));
			  } else {
				char *msg = sql_message("\b22003!number of digits for FLOAT values should be between 1 and 53");
				yyerror(m, msg);
				_DELETE(msg);
				(yyval.type).type = NULL;
				YYABORT;
			  }
			}
#line 13587 "y.tab.c"
    break;

  case 872: /* data_type: sqlDOUBLE  */
#line 5015 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "double", 0, 0); }
#line 13593 "y.tab.c"
    break;

  case 873: /* data_type: sqlDOUBLE PRECISION  */
#line 5016 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "double", 0, 0); }
#line 13599 "y.tab.c"
    break;

  case 874: /* data_type: sqlREAL  */
#line 5017 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), "real", 0, 0); }
#line 13605 "y.tab.c"
    break;

  case 877: /* data_type: aTYPE  */
#line 5020 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), (yyvsp[0].sval), 0, 0); }
#line 13611 "y.tab.c"
    break;

  case 878: /* data_type: aTYPE '(' nonzero ')'  */
#line 5022 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), (yyvsp[-3].sval), (yyvsp[-1].i_val), 0); }
#line 13617 "y.tab.c"
    break;

  case 879: /* data_type: type_alias  */
#line 5023 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), (yyvsp[0].sval), 0, 0); }
#line 13623 "y.tab.c"
    break;

  case 880: /* data_type: type_alias '(' nonzero ')'  */
#line 5025 "sql_parser.y"
                        { sql_find_subtype(&(yyval.type), (yyvsp[-3].sval), (yyvsp[-1].i_val), 0); }
#line 13629 "y.tab.c"
    break;

  case 881: /* data_type: type_alias '(' intval ',' intval ')'  */
#line 5027 "sql_parser.y"
                        { if ((yyvsp[-1].i_val) >= (yyvsp[-3].i_val)) {
				char *msg = sql_message("\b22003!precision(%d) should be less than number of digits(%d)", (yyvsp[-1].i_val), (yyvsp[-3].i_val));

				yyerror(m, msg);
				_DELETE(msg);
				(yyval.type).type = NULL;
				YYABORT;
			  } else {
			 	sql_find_subtype(&(yyval.type), (yyvsp[-5].sval), (yyvsp[-3].i_val), (yyvsp[-1].i_val));
			  }
			}
#line 13645 "y.tab.c"
    break;

  case 882: /* data_type: IDENT  */
#line 5038 "sql_parser.y"
                        {
			  sql_type *t = mvc_bind_type(m, (yyvsp[0].sval));
			  if (!t) {
				char *msg = sql_message("\b22000!type (%s) unknown", (yyvsp[0].sval));

				yyerror(m, msg);
				_DELETE(msg);
				(yyval.type).type = NULL;
				YYABORT;
			  } else {
				sql_init_subtype(&(yyval.type), t, 0, 0);
			  }
			}
#line 13663 "y.tab.c"
    break;

  case 883: /* data_type: IDENT '(' nonzero ')'  */
#line 5053 "sql_parser.y"
                        {
			  sql_type *t = mvc_bind_type(m, (yyvsp[-3].sval));
			  if (!t) {
				char *msg = sql_message("\b22000!type (%s) unknown", (yyvsp[-3].sval));

				yyerror(m, msg);
				_DELETE(msg);
				(yyval.type).type = NULL;
				YYABORT;
			  } else {
				sql_init_subtype(&(yyval.type), t, (yyvsp[-1].i_val), 0);
			  }
			}
#line 13681 "y.tab.c"
    break;

  case 884: /* data_type: GEOMETRY  */
#line 5066 "sql_parser.y"
           {
		if (!sql_find_subtype(&(yyval.type), "geometry", 0, 0 )) {
			yyerror(m, "\b22000!type (geometry) unknown");
			(yyval.type).type = NULL;
			YYABORT;
		}
	}
#line 13693 "y.tab.c"
    break;

  case 885: /* data_type: GEOMETRY '(' subgeometry_type ')'  */
#line 5073 "sql_parser.y"
                                    {
		int geoSubType = (yyvsp[-1].i_val); 

		if(geoSubType == 0) {
			(yyval.type).type = NULL;
			YYABORT;
		} else if (!sql_find_subtype(&(yyval.type), "geometry", geoSubType, 0 )) {
			char *msg = sql_message("\b22000!type (%s) unknown", (yyvsp[-3].sval));
			yyerror(m, msg);
			_DELETE(msg);
			(yyval.type).type = NULL;
			YYABORT;
		}
		
	}
#line 13713 "y.tab.c"
    break;

  case 886: /* data_type: GEOMETRY '(' subgeometry_type ',' intval ')'  */
#line 5088 "sql_parser.y"
                                               {
		int geoSubType = (yyvsp[-3].i_val); 
		int srid = (yyvsp[-1].i_val); 

		if(geoSubType == 0) {
			(yyval.type).type = NULL;
			YYABORT;
		} else if (!sql_find_subtype(&(yyval.type), "geometry", geoSubType, srid )) {
			char *msg = sql_message("\b22000!type (%s) unknown", (yyvsp[-5].sval));
			yyerror(m, msg);
			_DELETE(msg);
			(yyval.type).type = NULL;
			YYABORT;
		}
	}
#line 13733 "y.tab.c"
    break;

  case 887: /* data_type: GEOMETRYA  */
#line 5103 "sql_parser.y"
            {
		if (!sql_find_subtype(&(yyval.type), "geometrya", 0, 0 )) {
			yyerror(m, "\b22000!type (geometrya) unknown");
			(yyval.type).type = NULL;
			YYABORT;
		}
	}
#line 13745 "y.tab.c"
    break;

  case 888: /* data_type: GEOMETRYSUBTYPE  */
#line 5110 "sql_parser.y"
                  {
	int geoSubType = find_subgeometry_type((yyvsp[0].sval));

	if(geoSubType == 0) {
		char *msg = sql_message("\b22000!type (%s) unknown", (yyvsp[0].sval));
		(yyval.type).type = NULL;
		yyerror(m, msg);
		_DELETE(msg);
		YYABORT;
	} else if (geoSubType == -1) {
		char *msg = sql_message("allocation failure");
		(yyval.type).type = NULL;
		yyerror(m, msg);
		_DELETE(msg);
		YYABORT;
	}  else if (!sql_find_subtype(&(yyval.type), "geometry", geoSubType, 0 )) {
		char *msg = sql_message("\b22000!type (%s) unknown", (yyvsp[0].sval));
		yyerror(m, msg);
		_DELETE(msg);
		(yyval.type).type = NULL;
		YYABORT;
	}
}
#line 13773 "y.tab.c"
    break;

  case 889: /* subgeometry_type: GEOMETRYSUBTYPE  */
#line 5136 "sql_parser.y"
                  {
	int subtype = find_subgeometry_type((yyvsp[0].sval));
	char* geoSubType = (yyvsp[0].sval);

	if(subtype == 0) {
		char *msg = sql_message("\b22000!type (%s) unknown", geoSubType);
		yyerror(m, msg);
		_DELETE(msg);
		YYABORT;
	} else if(subtype == -1) {
		char *msg = sql_message("allocation failure");
		yyerror(m, msg);
		_DELETE(msg);
		YYABORT;
	} 
	(yyval.i_val) = subtype;	
}
#line 13795 "y.tab.c"
    break;

  case 890: /* subgeometry_type: string  */
#line 5153 "sql_parser.y"
         {
	int subtype = find_subgeometry_type((yyvsp[0].sval));
	char* geoSubType = (yyvsp[0].sval);

	if(subtype == 0) {
		char *msg = sql_message("\b22000!type (%s) unknown", geoSubType);
		yyerror(m, msg);
		_DELETE(msg);
		YYABORT;
	} else if (subtype == -1) {
		char *msg = sql_message("allocation failure");
		yyerror(m, msg);
		_DELETE(msg);
		YYABORT;
	} 
	(yyval.i_val) = subtype;	
}
#line 13817 "y.tab.c"
    break;

  case 891: /* type_alias: ALIAS  */
#line 5174 "sql_parser.y"
        { 	char *t = sql_bind_alias((yyvsp[0].sval));
	  	if (!t) {
			char *msg = sql_message("\b22000!type (%s) unknown", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			(yyval.sval) = NULL;
			YYABORT;
		}
		(yyval.sval) = t;
	}
#line 13833 "y.tab.c"
    break;

  case 892: /* varchar: VARCHAR  */
#line 5188 "sql_parser.y"
                                        { (yyval.sval) = (yyvsp[0].sval); }
#line 13839 "y.tab.c"
    break;

  case 893: /* varchar: CHARACTER VARYING  */
#line 5189 "sql_parser.y"
                                        { (yyval.sval) = (yyvsp[-1].sval); }
#line 13845 "y.tab.c"
    break;

  case 894: /* clob: CLOB  */
#line 5193 "sql_parser.y"
                                        { (yyval.sval) = (yyvsp[0].sval); }
#line 13851 "y.tab.c"
    break;

  case 895: /* clob: sqlTEXT  */
#line 5194 "sql_parser.y"
                                        { (yyval.sval) = (yyvsp[0].sval); }
#line 13857 "y.tab.c"
    break;

  case 896: /* clob: CHARACTER LARGE OBJECT  */
#line 5195 "sql_parser.y"
                                        { (yyval.sval) = (yyvsp[-2].sval); }
#line 13863 "y.tab.c"
    break;

  case 897: /* blob: sqlBLOB  */
#line 5198 "sql_parser.y"
                                        { (yyval.sval) = (yyvsp[0].sval); }
#line 13869 "y.tab.c"
    break;

  case 898: /* blob: BINARY LARGE OBJECT  */
#line 5199 "sql_parser.y"
                                        { (yyval.sval) = (yyvsp[-2].sval); }
#line 13875 "y.tab.c"
    break;

  case 901: /* restricted_ident: IDENT  */
#line 5207 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13881 "y.tab.c"
    break;

  case 902: /* restricted_ident: aTYPE  */
#line 5208 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13887 "y.tab.c"
    break;

  case 903: /* restricted_ident: ALIAS  */
#line 5209 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13893 "y.tab.c"
    break;

  case 904: /* restricted_ident: AGGR  */
#line 5210 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13899 "y.tab.c"
    break;

  case 905: /* restricted_ident: AGGR2  */
#line 5211 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13905 "y.tab.c"
    break;

  case 906: /* restricted_ident: RANK  */
#line 5212 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13911 "y.tab.c"
    break;

  case 907: /* ident: IDENT  */
#line 5216 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13917 "y.tab.c"
    break;

  case 908: /* ident: aTYPE  */
#line 5217 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13923 "y.tab.c"
    break;

  case 909: /* ident: FILTER_FUNC  */
#line 5218 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13929 "y.tab.c"
    break;

  case 910: /* ident: ALIAS  */
#line 5219 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13935 "y.tab.c"
    break;

  case 911: /* ident: AGGR  */
#line 5220 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13941 "y.tab.c"
    break;

  case 912: /* ident: AGGR2  */
#line 5221 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13947 "y.tab.c"
    break;

  case 913: /* ident: RANK  */
#line 5222 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 13953 "y.tab.c"
    break;

  case 915: /* non_reserved_word: LARGE  */
#line 5227 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "large"); }
#line 13959 "y.tab.c"
    break;

  case 916: /* non_reserved_word: sqlNAME  */
#line 5228 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "name"); }
#line 13965 "y.tab.c"
    break;

  case 917: /* non_reserved_word: OBJECT  */
#line 5229 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "object"); }
#line 13971 "y.tab.c"
    break;

  case 918: /* non_reserved_word: PASSWORD  */
#line 5230 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "password"); }
#line 13977 "y.tab.c"
    break;

  case 919: /* non_reserved_word: PATH  */
#line 5231 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "path"); }
#line 13983 "y.tab.c"
    break;

  case 920: /* non_reserved_word: PRECISION  */
#line 5232 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "precision"); }
#line 13989 "y.tab.c"
    break;

  case 921: /* non_reserved_word: PRIVILEGES  */
#line 5233 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "privileges"); }
#line 13995 "y.tab.c"
    break;

  case 922: /* non_reserved_word: ROLE  */
#line 5234 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "role"); }
#line 14001 "y.tab.c"
    break;

  case 923: /* non_reserved_word: sqlSIZE  */
#line 5235 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "size"); }
#line 14007 "y.tab.c"
    break;

  case 924: /* non_reserved_word: TYPE  */
#line 5236 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "type"); }
#line 14013 "y.tab.c"
    break;

  case 925: /* non_reserved_word: RELEASE  */
#line 5237 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "release"); }
#line 14019 "y.tab.c"
    break;

  case 926: /* non_reserved_word: VALUE  */
#line 5238 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "value"); }
#line 14025 "y.tab.c"
    break;

  case 927: /* non_reserved_word: ZONE  */
#line 5239 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "zone"); }
#line 14031 "y.tab.c"
    break;

  case 928: /* non_reserved_word: ACTION  */
#line 5241 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "action"); }
#line 14037 "y.tab.c"
    break;

  case 929: /* non_reserved_word: AS  */
#line 5242 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "as"); }
#line 14043 "y.tab.c"
    break;

  case 930: /* non_reserved_word: AUTHORIZATION  */
#line 5243 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "authorization"); }
#line 14049 "y.tab.c"
    break;

  case 931: /* non_reserved_word: COLUMN  */
#line 5244 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "column"); }
#line 14055 "y.tab.c"
    break;

  case 932: /* non_reserved_word: CYCLE  */
#line 5245 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "cycle"); }
#line 14061 "y.tab.c"
    break;

  case 933: /* non_reserved_word: DISTINCT  */
#line 5246 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "distinct"); }
#line 14067 "y.tab.c"
    break;

  case 934: /* non_reserved_word: INCREMENT  */
#line 5247 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "increment"); }
#line 14073 "y.tab.c"
    break;

  case 935: /* non_reserved_word: MAXVALUE  */
#line 5248 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "maxvalue"); }
#line 14079 "y.tab.c"
    break;

  case 936: /* non_reserved_word: MINVALUE  */
#line 5249 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "minvalue"); }
#line 14085 "y.tab.c"
    break;

  case 937: /* non_reserved_word: SQL_PLAN  */
#line 5250 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "plan"); }
#line 14091 "y.tab.c"
    break;

  case 938: /* non_reserved_word: SCHEMA  */
#line 5251 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "schema"); }
#line 14097 "y.tab.c"
    break;

  case 939: /* non_reserved_word: START  */
#line 5252 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "start"); }
#line 14103 "y.tab.c"
    break;

  case 940: /* non_reserved_word: STATEMENT  */
#line 5253 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "statement"); }
#line 14109 "y.tab.c"
    break;

  case 941: /* non_reserved_word: TABLE  */
#line 5254 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "table"); }
#line 14115 "y.tab.c"
    break;

  case 942: /* non_reserved_word: CACHE  */
#line 5256 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "cache"); }
#line 14121 "y.tab.c"
    break;

  case 943: /* non_reserved_word: DATA  */
#line 5257 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "data"); }
#line 14127 "y.tab.c"
    break;

  case 944: /* non_reserved_word: DIAGNOSTICS  */
#line 5258 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "diagnostics"); }
#line 14133 "y.tab.c"
    break;

  case 945: /* non_reserved_word: MATCH  */
#line 5259 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "match"); }
#line 14139 "y.tab.c"
    break;

  case 946: /* non_reserved_word: OPTIONS  */
#line 5260 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "options"); }
#line 14145 "y.tab.c"
    break;

  case 947: /* non_reserved_word: ROW  */
#line 5261 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "row"); }
#line 14151 "y.tab.c"
    break;

  case 948: /* non_reserved_word: KEY  */
#line 5262 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "key"); }
#line 14157 "y.tab.c"
    break;

  case 949: /* non_reserved_word: LANGUAGE  */
#line 5263 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "language"); }
#line 14163 "y.tab.c"
    break;

  case 950: /* non_reserved_word: LEVEL  */
#line 5264 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "level"); }
#line 14169 "y.tab.c"
    break;

  case 951: /* non_reserved_word: sqlSESSION  */
#line 5265 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "session"); }
#line 14175 "y.tab.c"
    break;

  case 952: /* non_reserved_word: sqlDATE  */
#line 5266 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "date"); }
#line 14181 "y.tab.c"
    break;

  case 953: /* non_reserved_word: TIME  */
#line 5267 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "time"); }
#line 14187 "y.tab.c"
    break;

  case 954: /* non_reserved_word: TIMESTAMP  */
#line 5268 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "timestamp"); }
#line 14193 "y.tab.c"
    break;

  case 955: /* non_reserved_word: INTERVAL  */
#line 5269 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "interval"); }
#line 14199 "y.tab.c"
    break;

  case 956: /* non_reserved_word: IMPRINTS  */
#line 5270 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "imprints"); }
#line 14205 "y.tab.c"
    break;

  case 957: /* non_reserved_word: PREP  */
#line 5272 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "prep"); }
#line 14211 "y.tab.c"
    break;

  case 958: /* non_reserved_word: PREPARE  */
#line 5273 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "prepare"); }
#line 14217 "y.tab.c"
    break;

  case 959: /* non_reserved_word: EXEC  */
#line 5274 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "exec"); }
#line 14223 "y.tab.c"
    break;

  case 960: /* non_reserved_word: EXECUTE  */
#line 5275 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "execute"); }
#line 14229 "y.tab.c"
    break;

  case 961: /* non_reserved_word: SQL_EXPLAIN  */
#line 5276 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "explain"); }
#line 14235 "y.tab.c"
    break;

  case 962: /* non_reserved_word: SQL_DEBUG  */
#line 5277 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "debug"); }
#line 14241 "y.tab.c"
    break;

  case 963: /* non_reserved_word: SQL_TRACE  */
#line 5278 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "trace"); }
#line 14247 "y.tab.c"
    break;

  case 964: /* non_reserved_word: sqlTEXT  */
#line 5279 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "text"); }
#line 14253 "y.tab.c"
    break;

  case 965: /* non_reserved_word: AUTO_COMMIT  */
#line 5280 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "auto_commit"); }
#line 14259 "y.tab.c"
    break;

  case 966: /* non_reserved_word: NO  */
#line 5281 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "no"); }
#line 14265 "y.tab.c"
    break;

  case 967: /* non_reserved_word: STRIP  */
#line 5283 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "strip"); }
#line 14271 "y.tab.c"
    break;

  case 968: /* non_reserved_word: WHITESPACE  */
#line 5284 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "whitespace"); }
#line 14277 "y.tab.c"
    break;

  case 969: /* non_reserved_word: PASSING  */
#line 5285 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "passing"); }
#line 14283 "y.tab.c"
    break;

  case 970: /* non_reserved_word: NIL  */
#line 5286 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "nil"); }
#line 14289 "y.tab.c"
    break;

  case 971: /* non_reserved_word: REF  */
#line 5287 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "ref"); }
#line 14295 "y.tab.c"
    break;

  case 972: /* non_reserved_word: ABSENT  */
#line 5288 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "absent"); }
#line 14301 "y.tab.c"
    break;

  case 973: /* non_reserved_word: EMPTY  */
#line 5289 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "empty"); }
#line 14307 "y.tab.c"
    break;

  case 974: /* non_reserved_word: DOCUMENT  */
#line 5290 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "document"); }
#line 14313 "y.tab.c"
    break;

  case 975: /* non_reserved_word: ELEMENT  */
#line 5291 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "element"); }
#line 14319 "y.tab.c"
    break;

  case 976: /* non_reserved_word: CONTENT  */
#line 5292 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "content"); }
#line 14325 "y.tab.c"
    break;

  case 977: /* non_reserved_word: NAMESPACE  */
#line 5293 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "namespace"); }
#line 14331 "y.tab.c"
    break;

  case 978: /* non_reserved_word: RETURNING  */
#line 5294 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "returning"); }
#line 14337 "y.tab.c"
    break;

  case 979: /* non_reserved_word: LOCATION  */
#line 5295 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "location"); }
#line 14343 "y.tab.c"
    break;

  case 980: /* non_reserved_word: ID  */
#line 5296 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "id"); }
#line 14349 "y.tab.c"
    break;

  case 981: /* non_reserved_word: ACCORDING  */
#line 5297 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "according"); }
#line 14355 "y.tab.c"
    break;

  case 982: /* non_reserved_word: URI  */
#line 5298 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "uri"); }
#line 14361 "y.tab.c"
    break;

  case 983: /* non_reserved_word: FILTER  */
#line 5299 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "filter"); }
#line 14367 "y.tab.c"
    break;

  case 984: /* non_reserved_word: TEMPORARY  */
#line 5300 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "temporary"); }
#line 14373 "y.tab.c"
    break;

  case 985: /* non_reserved_word: TEMP  */
#line 5301 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "temp"); }
#line 14379 "y.tab.c"
    break;

  case 986: /* non_reserved_word: ANALYZE  */
#line 5302 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "analyze"); }
#line 14385 "y.tab.c"
    break;

  case 987: /* non_reserved_word: MINMAX  */
#line 5303 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "MinMax"); }
#line 14391 "y.tab.c"
    break;

  case 988: /* non_reserved_word: STORAGE  */
#line 5304 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "storage"); }
#line 14397 "y.tab.c"
    break;

  case 989: /* non_reserved_word: GEOMETRY  */
#line 5305 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "geometry"); }
#line 14403 "y.tab.c"
    break;

  case 990: /* non_reserved_word: REPLACE  */
#line 5306 "sql_parser.y"
                { (yyval.sval) = sa_strdup(SA, "replace"); }
#line 14409 "y.tab.c"
    break;

  case 991: /* name_commalist: ident  */
#line 5310 "sql_parser.y"
                { (yyval.l) = append_string(L(), (yyvsp[0].sval)); }
#line 14415 "y.tab.c"
    break;

  case 992: /* name_commalist: name_commalist ',' ident  */
#line 5312 "sql_parser.y"
                        { (yyval.l) = append_string((yyvsp[-2].l), (yyvsp[0].sval)); }
#line 14421 "y.tab.c"
    break;

  case 993: /* lngval: sqlINT  */
#line 5317 "sql_parser.y"
                {
		  char *end = NULL, *s = (yyvsp[0].sval);
		  int l = _strlen(s);
		  // errno might be non-zero due to other people's code
		  errno = 0;
		  if (l <= 19) {
		  	(yyval.l_val) = strtoll(s,&end,10);
		  } else {
			(yyval.l_val) = 0;
		  }
		  if (s+l != end || errno == ERANGE) {
			char *msg = sql_message("\b22003!integer value too large or not a number (%s)", (yyvsp[0].sval));

			errno = 0;
			yyerror(m, msg);
			_DELETE(msg);
			(yyval.l_val) = 0;
			YYABORT;
		  }
		}
#line 14446 "y.tab.c"
    break;

  case 994: /* intval: sqlINT  */
#line 5340 "sql_parser.y"
                {
		  char *end = NULL, *s = (yyvsp[0].sval);
		  int l = _strlen(s);
		  // errno might be non-zero due to other people's code
		  errno = 0;
		  if (l <= 10) {
		  	(yyval.i_val) = strtol(s,&end,10);
		  } else {
			(yyval.i_val) = 0;
		  }
		  if (s+l != end || errno == ERANGE) {
			char *msg = sql_message("\b22003!integer value too large or not a number (%s)", (yyvsp[0].sval));

			errno = 0;
			yyerror(m, msg);
			_DELETE(msg);
			(yyval.i_val) = 0;
			YYABORT;
		  }
		}
#line 14471 "y.tab.c"
    break;

  case 995: /* intval: IDENT  */
#line 5360 "sql_parser.y"
                {
		  char *name = (yyvsp[0].sval);
		  sql_subtype *tpe;

		  if (!stack_find_var(m, name)) {
			char *msg = sql_message("\b22000!constant (%s) unknown", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			(yyval.i_val) = 0;
			YYABORT;
		  }
		  tpe = stack_find_type(m, name);
		  if (tpe->type->localtype == TYPE_lng ||
		      tpe->type->localtype == TYPE_int ||
		      tpe->type->localtype == TYPE_sht ||
		      tpe->type->localtype == TYPE_bte ) {
			lng sgn = stack_get_number(m, name);
			assert((lng) GDK_int_min < sgn && sgn <= (lng) GDK_int_max);
			(yyval.i_val) = (int) sgn;
		  } else {
			char *msg = sql_message("\b22000!constant (%s) has wrong type (number expected)", (yyvsp[0].sval));

			yyerror(m, msg);
			_DELETE(msg);
			(yyval.i_val) = 0;
			YYABORT;
		  }
		}
#line 14505 "y.tab.c"
    break;

  case 996: /* string: STRING  */
#line 5393 "sql_parser.y"
                { (yyval.sval) = (yyvsp[0].sval); }
#line 14511 "y.tab.c"
    break;

  case 997: /* string: STRING string  */
#line 5395 "sql_parser.y"
                { char *s = strconcat((yyvsp[-1].sval),(yyvsp[0].sval)); 
	 	  (yyval.sval) = sa_strdup(SA, s);	
		  _DELETE(s);
		}
#line 14520 "y.tab.c"
    break;

  case 998: /* exec: execute exec_ref  */
#line 5403 "sql_parser.y"
                {
		  m->emode = m_execute;
		  (yyval.sym) = (yyvsp[0].sym); }
#line 14528 "y.tab.c"
    break;

  case 999: /* exec_ref: intval '(' ')'  */
#line 5410 "sql_parser.y"
        { dlist *l = L();
  	  append_int(l, (yyvsp[-2].i_val));
  	  append_list(l, NULL);
	  (yyval.sym) = _symbol_create_list( SQL_NOP, l ); }
#line 14537 "y.tab.c"
    break;

  case 1000: /* exec_ref: intval '(' value_commalist ')'  */
#line 5415 "sql_parser.y"
        { dlist *l = L();
  	  append_int(l, (yyvsp[-3].i_val));
  	  append_list(l, (yyvsp[-1].l));
	  (yyval.sym) = _symbol_create_list( SQL_NOP, l ); }
#line 14546 "y.tab.c"
    break;

  case 1001: /* opt_path_specification: %empty  */
#line 5429 "sql_parser.y"
                        { (yyval.sym) = NULL; }
#line 14552 "y.tab.c"
    break;

  case 1003: /* path_specification: PATH schema_name_list  */
#line 5434 "sql_parser.y"
                                { (yyval.sym) = _symbol_create_list( SQL_PATH, (yyvsp[0].l)); }
#line 14558 "y.tab.c"
    break;

  case 1006: /* XML_value_expression_list: XML_value_expression  */
#line 5445 "sql_parser.y"
                { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 14564 "y.tab.c"
    break;

  case 1007: /* XML_value_expression_list: XML_value_expression_list ',' XML_value_expression  */
#line 5447 "sql_parser.y"
                { (yyval.l) = append_symbol((yyvsp[-2].l), (yyvsp[0].sym)); }
#line 14570 "y.tab.c"
    break;

  case 1019: /* XML_comment: XMLCOMMENT '(' value_exp opt_XML_returning_clause ')'  */
#line 5469 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-2].sym));
	  append_int(l, (yyvsp[-1].i_val));
	  (yyval.sym) = _symbol_create_list( SQL_XMLCOMMENT, l); }
#line 14579 "y.tab.c"
    break;

  case 1020: /* XML_concatenation: XMLCONCAT '(' XML_value_expression_list opt_XML_returning_clause ')'  */
#line 5477 "sql_parser.y"
        { dlist *l = L();
	  append_list(l, (yyvsp[-2].l));
	  append_int(l, (yyvsp[-1].i_val));
	  (yyval.sym) = _symbol_create_list( SQL_XMLCONCAT, l); }
#line 14588 "y.tab.c"
    break;

  case 1021: /* XML_document: XMLDOCUMENT '(' XML_value_expression opt_XML_returning_clause ')'  */
#line 5485 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-2].sym));
	  append_int(l, (yyvsp[-1].i_val));
	  (yyval.sym) = _symbol_create_list( SQL_XMLDOCUMENT, l); }
#line 14597 "y.tab.c"
    break;

  case 1022: /* XML_element: XMLELEMENT '(' sqlNAME XML_element_name opt_comma_XML_namespace_declaration_attributes_element_content opt_XML_returning_clause ')'  */
#line 5495 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-3].sval));
	  append_list(l, (yyvsp[-2].l));
	  append_int(l, (yyvsp[-1].i_val));
	  (yyval.sym) = _symbol_create_list( SQL_XMLELEMENT, l);
	}
#line 14608 "y.tab.c"
    break;

  case 1023: /* opt_comma_XML_namespace_declaration_attributes_element_content: %empty  */
#line 5505 "sql_parser.y"
        { (yyval.l) = NULL; }
#line 14614 "y.tab.c"
    break;

  case 1024: /* opt_comma_XML_namespace_declaration_attributes_element_content: ',' XML_namespace_declaration  */
#line 5507 "sql_parser.y"
        { (yyval.l) = append_symbol(L(), (yyvsp[0].sym));
	  (yyval.l) = append_symbol((yyval.l), NULL);
	  (yyval.l) = append_list((yyval.l), NULL); }
#line 14622 "y.tab.c"
    break;

  case 1025: /* opt_comma_XML_namespace_declaration_attributes_element_content: ',' XML_namespace_declaration ',' XML_attributes  */
#line 5511 "sql_parser.y"
        { (yyval.l) = append_symbol(L(), (yyvsp[-2].sym));
	  (yyval.l) = append_symbol((yyval.l), (yyvsp[0].sym));
	  (yyval.l) = append_list((yyval.l), NULL); }
#line 14630 "y.tab.c"
    break;

  case 1026: /* opt_comma_XML_namespace_declaration_attributes_element_content: ',' XML_namespace_declaration ',' XML_attributes ',' XML_element_content_and_option  */
#line 5515 "sql_parser.y"
        { (yyval.l) = append_symbol(L(), (yyvsp[-4].sym));
	  (yyval.l) = append_symbol((yyval.l), (yyvsp[-2].sym));
	  (yyval.l) = append_list((yyval.l), (yyvsp[0].l)); }
#line 14638 "y.tab.c"
    break;

  case 1027: /* opt_comma_XML_namespace_declaration_attributes_element_content: ',' XML_namespace_declaration ',' XML_element_content_and_option  */
#line 5519 "sql_parser.y"
        { (yyval.l) = append_symbol(L(), (yyvsp[-2].sym));
	  (yyval.l) = append_symbol((yyval.l), NULL);
	  (yyval.l) = append_list((yyval.l), (yyvsp[0].l)); }
#line 14646 "y.tab.c"
    break;

  case 1028: /* opt_comma_XML_namespace_declaration_attributes_element_content: ',' XML_attributes  */
#line 5523 "sql_parser.y"
        { (yyval.l) = append_symbol(L(), NULL);
	  (yyval.l) = append_symbol((yyval.l), (yyvsp[0].sym));
	  (yyval.l) = append_list((yyval.l), NULL); }
#line 14654 "y.tab.c"
    break;

  case 1029: /* opt_comma_XML_namespace_declaration_attributes_element_content: ',' XML_attributes ',' XML_element_content_and_option  */
#line 5527 "sql_parser.y"
        { (yyval.l) = append_symbol(L(), NULL);
	  (yyval.l) = append_symbol((yyval.l), (yyvsp[-2].sym));
	  (yyval.l) = append_list((yyval.l), (yyvsp[0].l)); }
#line 14662 "y.tab.c"
    break;

  case 1030: /* opt_comma_XML_namespace_declaration_attributes_element_content: ',' XML_element_content_and_option  */
#line 5531 "sql_parser.y"
        { (yyval.l) = append_symbol(L(), NULL);
	  (yyval.l) = append_symbol((yyval.l), NULL);
	  (yyval.l) = append_list((yyval.l), (yyvsp[0].l)); }
#line 14670 "y.tab.c"
    break;

  case 1032: /* XML_attributes: XMLATTRIBUTES '(' XML_attribute_list ')'  */
#line 5541 "sql_parser.y"
                                                { (yyval.sym) = (yyvsp[-1].sym); }
#line 14676 "y.tab.c"
    break;

  case 1033: /* XML_attribute_list: XML_attribute  */
#line 5545 "sql_parser.y"
                                                { (yyval.sym) = (yyvsp[0].sym); }
#line 14682 "y.tab.c"
    break;

  case 1034: /* XML_attribute_list: XML_attribute_list ',' XML_attribute  */
#line 5547 "sql_parser.y"
                { dlist *l = L();
		  append_list(l, 
		  	append_string(L(), sa_strdup(SA, "concat")));
	  	  append_symbol(l, (yyvsp[-2].sym));
	  	  append_symbol(l, (yyvsp[0].sym));
	  	  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 14693 "y.tab.c"
    break;

  case 1035: /* XML_attribute: XML_attribute_value opt_XML_attribute_name  */
#line 5557 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[0].sval));
	  append_symbol(l, (yyvsp[-1].sym));
	  (yyval.sym) = _symbol_create_list( SQL_XMLATTRIBUTE, l ); }
#line 14702 "y.tab.c"
    break;

  case 1036: /* opt_XML_attribute_name: %empty  */
#line 5564 "sql_parser.y"
                                                { (yyval.sval) = NULL; }
#line 14708 "y.tab.c"
    break;

  case 1037: /* opt_XML_attribute_name: AS XML_attribute_name  */
#line 5565 "sql_parser.y"
                                                { (yyval.sval) = (yyvsp[0].sval); }
#line 14714 "y.tab.c"
    break;

  case 1040: /* XML_element_content_and_option: XML_element_content_list opt_XML_content_option  */
#line 5578 "sql_parser.y"
                { (yyval.l) = L();
		  (yyval.l) = append_list((yyval.l), (yyvsp[-1].l));
		  (yyval.l) = append_int((yyval.l), (yyvsp[0].i_val)); 	}
#line 14722 "y.tab.c"
    break;

  case 1041: /* XML_element_content_list: XML_element_content  */
#line 5585 "sql_parser.y"
                { (yyval.l) = append_symbol(L(), (yyvsp[0].sym)); }
#line 14728 "y.tab.c"
    break;

  case 1042: /* XML_element_content_list: XML_element_content_list ',' XML_element_content  */
#line 5587 "sql_parser.y"
                { (yyval.l) = append_symbol((yyvsp[-2].l), (yyvsp[0].sym)); }
#line 14734 "y.tab.c"
    break;

  case 1044: /* opt_XML_content_option: %empty  */
#line 5595 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 14740 "y.tab.c"
    break;

  case 1045: /* opt_XML_content_option: OPTION XML_content_option  */
#line 5596 "sql_parser.y"
                                { (yyval.i_val) = (yyvsp[0].i_val); }
#line 14746 "y.tab.c"
    break;

  case 1046: /* XML_content_option: sqlNULL ON sqlNULL  */
#line 5600 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 14752 "y.tab.c"
    break;

  case 1047: /* XML_content_option: EMPTY ON sqlNULL  */
#line 5601 "sql_parser.y"
                                { (yyval.i_val) = 1; }
#line 14758 "y.tab.c"
    break;

  case 1048: /* XML_content_option: ABSENT ON sqlNULL  */
#line 5602 "sql_parser.y"
                                { (yyval.i_val) = 2; }
#line 14764 "y.tab.c"
    break;

  case 1049: /* XML_content_option: NIL ON sqlNULL  */
#line 5603 "sql_parser.y"
                                { (yyval.i_val) = 3; }
#line 14770 "y.tab.c"
    break;

  case 1050: /* XML_content_option: NIL ON NO CONTENT  */
#line 5604 "sql_parser.y"
                                { (yyval.i_val) = 4; }
#line 14776 "y.tab.c"
    break;

  case 1051: /* XML_forest: XMLFOREST '(' opt_XML_namespace_declaration_and_comma forest_element_list opt_XML_content_option opt_XML_returning_clause ')'  */
#line 5611 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-4].sym));
	  append_list(l, (yyvsp[-3].l));
	  append_int(l, (yyvsp[-2].i_val));
	  append_int(l, (yyvsp[-1].i_val));
	  (yyval.sym) = _symbol_create_list( SQL_XMLFOREST, l);
	}
#line 14788 "y.tab.c"
    break;

  case 1052: /* opt_XML_namespace_declaration_and_comma: %empty  */
#line 5621 "sql_parser.y"
                                        { (yyval.sym) = NULL; }
#line 14794 "y.tab.c"
    break;

  case 1053: /* opt_XML_namespace_declaration_and_comma: XML_namespace_declaration ','  */
#line 5622 "sql_parser.y"
                                        { (yyval.sym) = (yyvsp[-1].sym); }
#line 14800 "y.tab.c"
    break;

  case 1054: /* forest_element_list: forest_element  */
#line 5627 "sql_parser.y"
                { (yyval.l) = append_list(L(), (yyvsp[0].l)); }
#line 14806 "y.tab.c"
    break;

  case 1055: /* forest_element_list: forest_element_list ',' forest_element  */
#line 5629 "sql_parser.y"
                { (yyval.l) = append_list((yyvsp[-2].l), (yyvsp[0].l)); }
#line 14812 "y.tab.c"
    break;

  case 1056: /* forest_element: forest_element_value opt_forest_element_name  */
#line 5634 "sql_parser.y"
                { (yyval.l) = append_symbol(L(), (yyvsp[-1].sym));
		  (yyval.l) = append_string((yyval.l), (yyvsp[0].sval)); }
#line 14819 "y.tab.c"
    break;

  case 1057: /* forest_element_value: scalar_exp  */
#line 5639 "sql_parser.y"
                { (yyval.sym) = (yyvsp[0].sym); }
#line 14825 "y.tab.c"
    break;

  case 1058: /* opt_forest_element_name: %empty  */
#line 5643 "sql_parser.y"
                                { (yyval.sval) = NULL; }
#line 14831 "y.tab.c"
    break;

  case 1059: /* opt_forest_element_name: AS forest_element_name  */
#line 5644 "sql_parser.y"
                                { (yyval.sval) = (yyvsp[0].sval); }
#line 14837 "y.tab.c"
    break;

  case 1060: /* forest_element_name: ident  */
#line 5648 "sql_parser.y"
                                { (yyval.sval) = (yyvsp[0].sval); }
#line 14843 "y.tab.c"
    break;

  case 1061: /* XML_parse: XMLPARSE '(' document_or_content value_exp XML_whitespace_option ')'  */
#line 5655 "sql_parser.y"
        { dlist *l = L();
	  append_int(l, (yyvsp[-3].i_val) );
	  append_symbol(l, (yyvsp[-2].sym));
	  append_int(l, (yyvsp[-1].i_val));
	  (yyval.sym) = _symbol_create_list( SQL_XMLPARSE, l); }
#line 14853 "y.tab.c"
    break;

  case 1062: /* XML_whitespace_option: PRESERVE WHITESPACE  */
#line 5662 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 14859 "y.tab.c"
    break;

  case 1063: /* XML_whitespace_option: STRIP WHITESPACE  */
#line 5663 "sql_parser.y"
                                { (yyval.i_val) = 1; }
#line 14865 "y.tab.c"
    break;

  case 1064: /* XML_PI: XMLPI '(' sqlNAME XML_PI_target opt_comma_string_value_expression opt_XML_returning_clause ')'  */
#line 5670 "sql_parser.y"
        { dlist *l = L();
	  append_string(l, (yyvsp[-3].sval));
	  append_symbol(l, (yyvsp[-2].sym));
	  append_int(l, (yyvsp[-1].i_val));
	  (yyval.sym) = _symbol_create_list( SQL_XMLPI, l); }
#line 14875 "y.tab.c"
    break;

  case 1066: /* opt_comma_string_value_expression: %empty  */
#line 5682 "sql_parser.y"
                        { (yyval.sym) = NULL; }
#line 14881 "y.tab.c"
    break;

  case 1067: /* opt_comma_string_value_expression: ',' value_exp  */
#line 5684 "sql_parser.y"
                        { (yyval.sym) = (yyvsp[0].sym); }
#line 14887 "y.tab.c"
    break;

  case 1068: /* XML_query: XMLQUERY '(' XQuery_expression opt_XML_query_argument_list opt_XML_returning_clause opt_XML_query_returning_mechanism XML_query_empty_handling_option ')'  */
#line 5695 "sql_parser.y"
        { (yyval.sym) = NULL; }
#line 14893 "y.tab.c"
    break;

  case 1083: /* XML_text: XMLTEXT '(' value_exp opt_XML_returning_clause ')'  */
#line 5741 "sql_parser.y"
        { dlist *l = L();
	  append_symbol(l, (yyvsp[-2].sym));
	  append_int(l, (yyvsp[-1].i_val));
	  (yyval.sym) = _symbol_create_list( SQL_XMLTEXT, l); }
#line 14902 "y.tab.c"
    break;

  case 1084: /* XML_validate: XMLVALIDATE '(' document_or_content_or_sequence XML_value_expression opt_XML_valid_according_to_clause ')'  */
#line 5752 "sql_parser.y"
        { (yyval.sym) = NULL; }
#line 14908 "y.tab.c"
    break;

  case 1086: /* document_or_content_or_sequence: SEQUENCE  */
#line 5757 "sql_parser.y"
                        { (yyval.i_val) = 2; }
#line 14914 "y.tab.c"
    break;

  case 1087: /* document_or_content: DOCUMENT  */
#line 5761 "sql_parser.y"
                        { (yyval.i_val) = 0; }
#line 14920 "y.tab.c"
    break;

  case 1088: /* document_or_content: CONTENT  */
#line 5762 "sql_parser.y"
                        { (yyval.i_val) = 1; }
#line 14926 "y.tab.c"
    break;

  case 1089: /* opt_XML_returning_clause: %empty  */
#line 5766 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 14932 "y.tab.c"
    break;

  case 1090: /* opt_XML_returning_clause: RETURNING CONTENT  */
#line 5767 "sql_parser.y"
                                { (yyval.i_val) = 0; }
#line 14938 "y.tab.c"
    break;

  case 1091: /* opt_XML_returning_clause: RETURNING SEQUENCE  */
#line 5768 "sql_parser.y"
                                { (yyval.i_val) = 1; }
#line 14944 "y.tab.c"
    break;

  case 1092: /* XML_namespace_declaration: XMLNAMESPACES '(' XML_namespace_declaration_item_list ')'  */
#line 5783 "sql_parser.y"
                                                                { (yyval.sym) = (yyvsp[-1].sym); }
#line 14950 "y.tab.c"
    break;

  case 1093: /* XML_namespace_declaration_item_list: XML_namespace_declaration_item  */
#line 5787 "sql_parser.y"
                                        { (yyval.sym) = (yyvsp[0].sym); }
#line 14956 "y.tab.c"
    break;

  case 1094: /* XML_namespace_declaration_item_list: XML_namespace_declaration_item_list ',' XML_namespace_declaration_item  */
#line 5789 "sql_parser.y"
                { dlist *l = L();
		  append_list(l, 
		  	append_string(L(), sa_strdup(SA, "concat")));
	  	  append_symbol(l, (yyvsp[-2].sym));
	  	  append_symbol(l, (yyvsp[0].sym));
	  	  (yyval.sym) = _symbol_create_list( SQL_BINOP, l ); }
#line 14967 "y.tab.c"
    break;

  case 1099: /* XML_regular_namespace_declaration_item: XML_namespace_URI AS XML_namespace_prefix  */
#line 5812 "sql_parser.y"
                                { char *s = strconcat("xmlns:", (yyvsp[0].sval));
				  dlist *l = L();
	  			  append_string(l, sa_strdup(SA, s));
				  _DELETE(s);
	  			  append_symbol(l, (yyvsp[-2].sym));
	  			  (yyval.sym) = _symbol_create_list( SQL_XMLATTRIBUTE, l ); }
#line 14978 "y.tab.c"
    break;

  case 1100: /* XML_default_namespace_declaration_item: DEFAULT XML_namespace_URI  */
#line 5821 "sql_parser.y"
                                { dlist *l = L();
	  			  append_string(l, sa_strdup(SA, "xmlns" ));
	  			  append_symbol(l, (yyvsp[0].sym));
	  			  (yyval.sym) = _symbol_create_list( SQL_XMLATTRIBUTE, l ); }
#line 14987 "y.tab.c"
    break;

  case 1101: /* XML_default_namespace_declaration_item: NO DEFAULT  */
#line 5825 "sql_parser.y"
                                { (yyval.sym) = NULL; }
#line 14993 "y.tab.c"
    break;

  case 1131: /* XML_aggregate: XMLAGG '(' XML_value_expression opt_order_by_clause opt_XML_returning_clause ')'  */
#line 5921 "sql_parser.y"
        { 
          dlist *aggr = L();

          if ((yyvsp[-2].sym)) {
	  	if ((yyvsp[-3].sym) != NULL && (yyvsp[-3].sym)->token == SQL_SELECT) {
			SelectNode *s = (SelectNode*)(yyvsp[-3].sym);
	
			s->orderby = (yyvsp[-2].sym);
	  	} else {
			yyerror(m, "ORDER BY: missing select operator");
			YYABORT;
		}
	  }
          append_list(aggr, append_string(append_string(L(), "sys"), "xmlagg"));
  	  append_int(aggr, FALSE);
	  append_symbol(aggr, (yyvsp[-3].sym));
	  /* int returning not used */
	  (yyval.sym) = _symbol_create_list( SQL_AGGR, aggr);
	}
#line 15017 "y.tab.c"
    break;


#line 15021 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (m, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, m);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, m);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (m, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, m);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, m);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 5942 "sql_parser.y"

int find_subgeometry_type(char* geoSubType) {
	int subType = 0;
	if(strcmp(geoSubType, "point") == 0 )
		subType = (1 << 2);
	else if(strcmp(geoSubType, "linestring") == 0)
		subType = (2 << 2);
	else if(strcmp(geoSubType, "polygon") == 0)
		subType = (4 << 2);
	else if(strcmp(geoSubType, "multipoint") == 0)
		subType = (5 << 2);
	else if(strcmp(geoSubType, "multilinestring") == 0)
		subType = (6 << 2);
	else if(strcmp(geoSubType, "multipolygon") == 0)
		subType = (7 << 2);
	else if(strcmp(geoSubType, "geometrycollection") == 0)
		subType = (8 << 2);
	else {
		size_t strLength = strlen(geoSubType);
		if(strLength > 0 ) {
			char *typeSubStr = GDKmalloc(strLength);
			char flag = geoSubType[strLength-1]; 

			if (typeSubStr == NULL) {
				return -1;
			}
			memcpy(typeSubStr, geoSubType, strLength-1);
			typeSubStr[strLength-1]='\0';
			if(flag == 'z' || flag == 'm' ) {
				subType = find_subgeometry_type(typeSubStr);
				if (subType == -1) {
					GDKfree(typeSubStr);
					return -1;
				}
				if(flag == 'z')
					SET_Z(subType);
				if(flag == 'm')
					SET_M(subType);
			}
			GDKfree(typeSubStr);
		}

	}
	return subType;	
}

char *token2string(int token)
{
	switch (token) {
#define SQL(TYPE) case SQL_##TYPE : return #TYPE
	SQL(CREATE_SCHEMA);
	SQL(CREATE_TABLE);
	SQL(CREATE_VIEW);
	SQL(CREATE_INDEX);
	SQL(CREATE_ROLE);
	SQL(CREATE_USER);
	SQL(CREATE_TYPE);
	SQL(CREATE_FUNC);
	SQL(CREATE_SEQ);
	SQL(CREATE_TRIGGER);
	SQL(DROP_SCHEMA);
	SQL(DROP_TABLE);
	SQL(DROP_VIEW);
	SQL(DROP_INDEX);
	SQL(DROP_ROLE);
	SQL(DROP_USER);
	SQL(DROP_TYPE);
	SQL(DROP_FUNC);
	SQL(DROP_SEQ);
	SQL(DROP_TRIGGER);
	SQL(ALTER_TABLE);
	SQL(ALTER_SEQ);
	SQL(ALTER_USER);
	SQL(DROP_COLUMN);
	SQL(DROP_CONSTRAINT);
	SQL(DROP_DEFAULT);
	SQL(DECLARE);
	SQL(SET);
	SQL(PREP);
	SQL(PREPARE);
	SQL(NAME);
	SQL(USER);
	SQL(PATH);
	SQL(CHARSET);
	SQL(SCHEMA);
	SQL(TABLE);
	SQL(TYPE);
	SQL(CASE);
	SQL(CAST);
	SQL(RETURN);
	SQL(IF);
	SQL(ELSE);
	SQL(WHILE);
	SQL(COLUMN);
	SQL(COLUMN_OPTIONS);
	SQL(COALESCE);
	SQL(CONSTRAINT);
	SQL(CHECK);
	SQL(DEFAULT);
	SQL(NOT_NULL);
	SQL(NULL);
	SQL(NULLIF);
	SQL(UNIQUE);
	SQL(PRIMARY_KEY);
	SQL(FOREIGN_KEY);
	SQL(BEGIN);
#define TR(TYPE) case TR_##TYPE : return #TYPE
	TR(COMMIT);
	TR(ROLLBACK);
	TR(SAVEPOINT);
	TR(RELEASE);
	TR(START);
	TR(MODE);
	SQL(INSERT);
	SQL(DELETE);
	SQL(UPDATE);
	SQL(CROSS);
	SQL(JOIN);
	SQL(SELECT);
	SQL(WHERE);
	SQL(FROM);
	SQL(UNIONJOIN);
	SQL(UNION);
	SQL(EXCEPT);
	SQL(INTERSECT);
	SQL(VALUES);
	SQL(ASSIGN);
	SQL(ORDERBY);
	SQL(GROUPBY);
	SQL(DESC);
	SQL(AND);
	SQL(OR);
	SQL(NOT);
	SQL(EXISTS);
	SQL(NOT_EXISTS);
	SQL(OP);
	SQL(UNOP);
	SQL(BINOP);
	SQL(NOP);
	SQL(BETWEEN);
	SQL(NOT_BETWEEN);
	SQL(LIKE);
	SQL(IN);
	SQL(NOT_IN);
	SQL(GRANT);
	SQL(GRANT_ROLES);
	SQL(REVOKE);
	SQL(REVOKE_ROLES);
	SQL(EXEC);
	SQL(EXECUTE);
	SQL(PRIVILEGES);
	SQL(ROLE);
	SQL(PARAMETER);
	SQL(FUNC);
	SQL(AGGR);
	SQL(RANK);
	SQL(FRAME);
	SQL(COMPARE);
	SQL(FILTER);
	SQL(TEMP_LOCAL);
	SQL(TEMP_GLOBAL);
	SQL(INT_VALUE);
	SQL(ATOM);
	SQL(USING);
	SQL(WHEN);
	SQL(ESCAPE);
	SQL(COPYFROM);
	SQL(BINCOPYFROM);
	SQL(COPYTO);
	SQL(EXPORT);
	SQL(NEXT);
	SQL(MULSTMT);
	SQL(WITH);
	SQL(XMLCOMMENT);
	SQL(XMLCONCAT);
	SQL(XMLDOCUMENT);
	SQL(XMLELEMENT);
	SQL(XMLATTRIBUTE);
	SQL(XMLFOREST);
	SQL(XMLPARSE);
	SQL(XMLPI);
	SQL(XMLQUERY);
	SQL(XMLTEXT);
	SQL(XMLVALIDATE);
	SQL(XMLNAMESPACES);
	}
	return "unknown";	/* just needed for broken compilers ! */
}

void *sql_error( mvc * sql, int error_code, char *format, ... )
{
	va_list	ap;

	va_start (ap,format);
	if (sql->errstr[0] == '\0') 
		vsnprintf(sql->errstr, ERRSIZE-1, _(format), ap);
	if (!sql->session->status)
		sql->session->status = -error_code;
	va_end (ap);
	return NULL;
}

int sqlerror(mvc * c, const char *err)
{
	char *sqlstate = "42000!";
	if (err && *err == '\b') {
		sqlstate = "";
		err++;
	}
	if (c->scanner.errstr) {
		if (c->scanner.errstr[0] == '!')
			(void)sql_error(c, 4,
					"!%s%s: %s\n",
					sqlstate, err, c->scanner.errstr + 1);
		else
			(void)sql_error(c, 4,
					"!%s%s: %s in \"%.80s\"\n",
					sqlstate, err, c->scanner.errstr,
					QUERY(c->scanner));
	} else
		(void)sql_error(c, 4,
				"!%s%s in: \"%.80s\"\n",
				sqlstate, err, QUERY(c->scanner));
	return 1;
}

